/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs
#define yylval          cf_lval
#define yychar          cf_char

/* First part of user prologue.  */
#line 50 "conf/gen_parser.m4"

#line 9 "conf/confbase.Y"
/* Headers from conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/bfd.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from conf/confbase.Y */

static void
check_u16(uint val)
{
  if (val > 0xFFFF)
    cf_error("Value %u out of range (0-65535)", val);
}

#define cf_assert(cond, ...) do { if (!(cond)) cf_error(__VA_ARGS__); } while (0)
static inline void cf_assert_symbol(const struct symbol *sym, uint class) {
  switch (class) {
    case SYM_PROTO: cf_assert(sym->class == SYM_PROTO, "Protocol name required"); break;
    case SYM_TEMPLATE: cf_assert(sym->class == SYM_TEMPLATE, "Protocol template name required"); break;
    case SYM_FUNCTION: cf_assert(sym->class == SYM_FUNCTION, "Function name required"); break;
    case SYM_FILTER: cf_assert(sym->class == SYM_FILTER, "Filter name required"); break;
    case SYM_TABLE: cf_assert(sym->class == SYM_TABLE, "Table name required"); break;
    case SYM_ATTRIBUTE: cf_assert(sym->class == SYM_ATTRIBUTE, "Custom attribute name required"); break;
    case SYM_VARIABLE: cf_assert((sym->class & ~0xff) == SYM_VARIABLE, "Variable name required"); break;
    case SYM_CONSTANT: cf_assert((sym->class & ~0xff) == SYM_CONSTANT, "Constant name required"); break;
    default: bug("This shall not happen");
  }
}

#line 9 "conf/flowspec.Y"
/* Headers from conf/flowspec.Y */

#define PARSER 1

#include "nest/bird.h"
#include "lib/flowspec.h"


/* Defines from conf/flowspec.Y */

struct flow_builder *this_flow;


#line 11 "filter/config.Y"
/* Headers from filter/config.Y */

#include "filter/f-inst.h"
#include "filter/data.h"

/* Defines from filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }

#define f_generate_complex(fi_code, da, arg) \
  f_new_inst(FI_EA_SET, f_new_inst(fi_code, f_new_inst(FI_EA_GET, da), arg), da)

static int
f_new_var(struct sym_scope *s)
{
  /*
   * - A variable is an offset on vstack from vbase.
   * - Vbase is set on filter start / function call.
   * - Scopes contain (non-frame) block scopes inside filter/function scope
   * - Each scope knows number of vars in that scope
   * - Offset is therefore a sum of 'slots' up to filter/function scope
   * - New variables are added on top of vstk, so intermediate values cannot
   *   be there during FI_VAR_INIT. I.e. no 'var' inside 'term'.
   * - Also, each f_line must always have its scope, otherwise a variable may
   *   be defined but not initialized if relevant f_line is not executed.
   */

  int offset = s->slots++;

  while (s->block)
  {
    s = s->next;
    ASSERT(s);
    offset += s->slots;
  }

  if (offset >= 0xff)
    cf_error("Too many variables, at most 255 allowed");

  return offset;
}

/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
  case T_RD:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_dynamic_attr dyn)
{
  struct f_val empty;

  switch (dyn.type & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      empty = f_const_empty_path;
      break;
    case EAF_TYPE_INT_SET:
      empty = f_const_empty_clist;
      break;
    case EAF_TYPE_EC_SET:
      empty = f_const_empty_eclist;
      break;
    case EAF_TYPE_LC_SET:
      empty = f_const_empty_lclist;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  return f_new_inst(FI_EA_SET, f_new_inst(FI_CONSTANT, empty), dyn);
}

/*
 * Remove all new lines and doubled whitespaces
 * and convert all tabulators to spaces
 * and return a copy of string
 */
char *
assert_copy_expr(const char *start, size_t len)
{
  /* XXX: Allocates maybe a little more memory than we really finally need */
  char *str = cfg_alloc(len + 1);

  char *dst = str;
  const char *src = start - 1;
  const char *end = start + len;
  while (++src < end)
  {
    if (*src == '\n')
      continue;

    /* Skip doubled whitespaces */
    if (src != start)
    {
      const char *prev = src - 1;
      if ((*src == ' ' || *src == '\t') && (*prev == ' ' || *prev == '\t'))
	continue;
    }

    if (*src == '\t')
      *dst = ' ';
    else
      *dst = *src;

    dst++;
  }
  *dst = '\0';

  return str;
}

/*
 * assert_done - create f_instruction of bt_assert
 * @expr: expression in bt_assert()
 * @start: pointer to first char of test expression
 * @end: pointer to the last char of test expression
 */
static struct f_inst *
assert_done(struct f_inst *expr, const char *start, const char *end)
{
  return f_new_inst(FI_ASSERT, expr,
    (end >= start) ?
      assert_copy_expr(start, end - start + 1)
    : "???");
}

static struct f_inst *
assert_assign(struct f_lval *lval, struct f_inst *expr, const char *start, const char *end)
{
  struct f_inst *setter, *getter, *checker;
  switch (lval->type) {
    case F_LVAL_VARIABLE:
      setter = f_new_inst(FI_VAR_SET, expr, lval->sym);
      getter = f_new_inst(FI_VAR_GET, lval->sym);
      break;
    case F_LVAL_SA:
      setter = f_new_inst(FI_RTA_SET, expr, lval->sa);
      getter = f_new_inst(FI_RTA_GET, lval->sa);
      break;
    case F_LVAL_EA:
      setter = f_new_inst(FI_EA_SET, expr, lval->da);
      getter = f_new_inst(FI_EA_GET, lval->da);
      break;
    default:
      bug("Unknown lval type");
  }

  checker = f_new_inst(FI_EQ, expr, getter);
  setter->next = checker;

  return assert_done(setter, start, end);
}

#line 10 "nest/config.Y"
/* Headers from nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from nest/config.Y */

static struct rtable_config *this_table;
static struct proto_config *this_proto;
static struct channel_config *this_channel;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
/* static struct roa_table_config *this_roa_table; */
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;
static struct bfd_options *this_bfd_opts;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->prefix.type)
      cf_error("Interface name/mask expected, not IP prefix");
}

static inline void
init_password_list(void)
{
   if (!this_p_list) {
      this_p_list = cfg_allocz(sizeof(list));
      init_list(this_p_list);
      password_id = 1;
   }
}

static inline void
init_password(const void *key, uint length, uint id)
{
   this_p_item = cfg_allocz(sizeof (struct password_item));
   this_p_item->password = key;
   this_p_item->length = length;
   this_p_item->genfrom = 0;
   this_p_item->gento = TIME_INFINITY;
   this_p_item->accfrom = 0;
   this_p_item->accto = TIME_INFINITY;
   this_p_item->id = id;
   this_p_item->alg = ALG_UNDEFINED;
   add_tail(this_p_list, &this_p_item->n);
}

static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

static inline void
init_bfd_opts(struct bfd_options **opts)
{
  cf_check_bfd(1);

  if (! *opts)
    *opts = bfd_new_options();
}

static inline void
open_bfd_opts(struct bfd_options **opts)
{
  init_bfd_opts(opts);
  this_bfd_opts = *opts;
}

static inline void
close_bfd_opts(void)
{
  this_bfd_opts = NULL;
}

static void
proto_postconfig(void)
{
  CALL(this_proto->protocol->postconfig, this_proto);
  this_channel = NULL;
  this_proto = NULL;
}


#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

#line 8 "proto/bfd/config.Y"
/* Headers from proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

#line 13 "proto/babel/config.Y"
/* Headers from proto/babel/config.Y */

#include "proto/babel/babel.h"
#include "nest/iface.h"

/* Defines from proto/babel/config.Y */

#define BABEL_CFG ((struct babel_config *) this_proto)
#define BABEL_IFACE ((struct babel_iface_config *) this_ipatt)

#line 9 "proto/bgp/config.Y"
/* Headers from proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)
#define BGP_CC ((struct bgp_channel_config *) this_channel)

#line 10 "proto/mrt/config.Y"
/* Headers from proto/mrt/config.Y */

#include "proto/mrt/mrt.h"

/* Defines from proto/mrt/config.Y */

#define MRT_CFG ((struct mrt_config *) this_proto)

#line 9 "proto/ospf/config.Y"
/* Headers from proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if (ospf_cfg_is_v2() && (ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;

      if (ospf_cfg_is_v3() && ip->autype && (pass->alg < ALG_HMAC))
	cf_error("Keyed hash algorithms are not allowed, use HMAC algorithms");
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;
  struct ospf_area_config *ac;
  struct ospf_iface_patt *ic;

  /* Define default channel */
  if (! proto_cf_main_channel(this_proto))
  {
    uint net_type = this_proto->net_type = ospf_cfg_is_v2() ? NET_IP4 : NET_IP6;
    channel_config_new(NULL, net_label[net_type], net_type, this_proto);
  }

  /* Propagate global instance ID to interfaces */
  if (cf->instance_id_set)
  {
    WALK_LIST(ac, cf->area_list)
      WALK_LIST(ic, ac->patt_list)
	if (!ic->instance_id_set)
	{ ic->instance_id = cf->instance_id; ic->instance_id_set = 1; }

    WALK_LIST(ic, cf->vlink_list)
      if (!ic->instance_id_set)
      { ic->instance_id = cf->instance_id; ic->instance_id_set = 1; }
  }

  if (ospf_cfg_is_v3())
  {
    uint ipv4 = (this_proto->net_type == NET_IP4);
    uint base = (ipv4 ? 64 : 0) + (cf->af_mc ? 32 : 0);

    /* RFC 5838 - OSPFv3-AF */
    if (cf->af_ext)
    {
      /* RFC 5838 2.1 - instance IDs based on AFs */
      WALK_LIST(ac, cf->area_list)
	WALK_LIST(ic, ac->patt_list)
	{
	  if (!ic->instance_id_set)
	    ic->instance_id = base;
	  else if (ic->instance_id >= 128)
	    log(L_WARN "Instance ID %d from unassigned/private range", ic->instance_id);
	  else if ((ic->instance_id < base) || (ic->instance_id >= (base + 32)))
	    cf_error("Instance ID %d invalid for given channel type", ic->instance_id);
	}

      /* RFC 5838 2.8 - vlinks limited to IPv6 unicast */
      if ((ipv4 || cf->af_mc) && !EMPTY_LIST(cf->vlink_list))
	cf_error("Vlinks not supported in AFs other than IPv6 unicast");
    }
    else
    {
      if (ipv4 || cf->af_mc)
	cf_error("Different channel type");
    }
  }

  if (EMPTY_LIST(cf->area_list))
    cf_error("No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (proto_cf_main_channel(this_proto)->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%u", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Plaintext authentication not supported in OSPFv3");
}


#line 9 "proto/perf/config.Y"
/* Headers from proto/perf/config.Y */

#include "filter/filter.h"
#include "proto/perf/perf.h"

/* Defines from proto/perf/config.Y */

#define PERF_CFG ((struct perf_config *) this_proto)

#line 9 "proto/pipe/config.Y"
/* Headers from proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

#line 10 "proto/radv/config.Y"
/* Headers from proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


#line 12 "proto/rip/config.Y"
/* Headers from proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


#line 9 "proto/rpki/config.Y"
/* Headers from proto/rpki/config.Y */

#include "proto/rpki/rpki.h"

/* Defines from proto/rpki/config.Y */

#define RPKI_CFG ((struct rpki_config *) this_proto)
#define RPKI_TR_SSH_CFG ((struct rpki_tr_ssh_config *) RPKI_CFG->tr_config.spec)

static void
rpki_check_unused_hostname(void)
{
  if (RPKI_CFG->hostname != NULL)
    cf_error("Only one cache server per protocol allowed");
}

static void
rpki_check_unused_transport(void)
{
  if (RPKI_CFG->tr_config.spec != NULL)
    cf_error("At the most one transport per protocol allowed");
}

#line 9 "proto/static/config.Y"
/* Headers from proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_snh;
static struct f_inst *this_srt_cmds, *this_srt_last_cmd;

static struct static_route *
static_nexthop_new(void)
{
  struct static_route *nh = this_srt;

  if (this_snh)
  {
    /* Additional next hop */
    nh = cfg_allocz(sizeof(struct static_route));
    nh->net = this_srt->net;
    this_snh->mp_next = nh;
  }

  nh->dest = RTD_UNICAST;
  nh->mp_head = this_srt;
  return nh;
};

static void
static_route_finish(void)
{
  if (net_type_match(this_srt->net, NB_DEST) == !this_srt->dest)
    cf_error("Unexpected or missing nexthop/type");

  this_srt->cmds = f_linearize(this_srt_cmds, 0);
}

#line 9 "sysdep/linux/netlink.Y"
/* Headers from sysdep/linux/netlink.Y */

#line 9 "sysdep/unix/config.Y"
/* Headers from sysdep/unix/config.Y */

#include "sysdep/unix/unix.h"
#include <stdio.h>

/* Defines from sysdep/unix/config.Y */

static struct log_config *this_log;

#line 9 "sysdep/unix/krt.Y"
/* Headers from sysdep/unix/krt.Y */

#include "sysdep/unix/krt.h"

/* Defines from sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)
#define KIF_IFACE ((struct kif_iface_config *) this_ipatt)

static void
kif_set_preferred(ip_addr ip)
{
  if (ipa_is_ip4(ip))
    KIF_IFACE->pref_v4 = ip;
  else if (!ipa_is_link_local(ip))
    KIF_IFACE->pref_v6 = ip;
  else
    KIF_IFACE->pref_ll = ip;
}

#line 50 "conf/gen_parser.m4"

#line 919 "obj/conf/cf-parse.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cf-parse.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_QUIT = 3,                       /* QUIT  */
  YYSYMBOL_EXIT = 4,                       /* EXIT  */
  YYSYMBOL_HELP = 5,                       /* HELP  */
  YYSYMBOL_END = 6,                        /* END  */
  YYSYMBOL_CLI_MARKER = 7,                 /* CLI_MARKER  */
  YYSYMBOL_INVALID_TOKEN = 8,              /* INVALID_TOKEN  */
  YYSYMBOL_ELSECOL = 9,                    /* ELSECOL  */
  YYSYMBOL_DDOT = 10,                      /* DDOT  */
  YYSYMBOL_GEQ = 11,                       /* GEQ  */
  YYSYMBOL_LEQ = 12,                       /* LEQ  */
  YYSYMBOL_NEQ = 13,                       /* NEQ  */
  YYSYMBOL_AND = 14,                       /* AND  */
  YYSYMBOL_OR = 15,                        /* OR  */
  YYSYMBOL_PO = 16,                        /* PO  */
  YYSYMBOL_PC = 17,                        /* PC  */
  YYSYMBOL_NUM = 18,                       /* NUM  */
  YYSYMBOL_ENUM = 19,                      /* ENUM  */
  YYSYMBOL_IP4 = 20,                       /* IP4  */
  YYSYMBOL_IP6 = 21,                       /* IP6  */
  YYSYMBOL_VPN_RD = 22,                    /* VPN_RD  */
  YYSYMBOL_CF_SYM_KNOWN = 23,              /* CF_SYM_KNOWN  */
  YYSYMBOL_CF_SYM_UNDEFINED = 24,          /* CF_SYM_UNDEFINED  */
  YYSYMBOL_TEXT = 25,                      /* TEXT  */
  YYSYMBOL_BYTESTRING = 26,                /* BYTESTRING  */
  YYSYMBOL_PREFIX_DUMMY = 27,              /* PREFIX_DUMMY  */
  YYSYMBOL_28_ = 28,                       /* '='  */
  YYSYMBOL_29_ = 29,                       /* '<'  */
  YYSYMBOL_30_ = 30,                       /* '>'  */
  YYSYMBOL_31_ = 31,                       /* '~'  */
  YYSYMBOL_NMA = 32,                       /* NMA  */
  YYSYMBOL_33_ = 33,                       /* '+'  */
  YYSYMBOL_34_ = 34,                       /* '-'  */
  YYSYMBOL_35_ = 35,                       /* '*'  */
  YYSYMBOL_36_ = 36,                       /* '/'  */
  YYSYMBOL_37_ = 37,                       /* '%'  */
  YYSYMBOL_38_ = 38,                       /* '!'  */
  YYSYMBOL_39_ = 39,                       /* '.'  */
  YYSYMBOL_DEFINE = 40,                    /* DEFINE  */
  YYSYMBOL_ON = 41,                        /* ON  */
  YYSYMBOL_OFF = 42,                       /* OFF  */
  YYSYMBOL_YES = 43,                       /* YES  */
  YYSYMBOL_NO = 44,                        /* NO  */
  YYSYMBOL_S = 45,                         /* S  */
  YYSYMBOL_MS = 46,                        /* MS  */
  YYSYMBOL_US = 47,                        /* US  */
  YYSYMBOL_PORT = 48,                      /* PORT  */
  YYSYMBOL_VPN = 49,                       /* VPN  */
  YYSYMBOL_MPLS = 50,                      /* MPLS  */
  YYSYMBOL_FROM = 51,                      /* FROM  */
  YYSYMBOL_52_ = 52,                       /* ';'  */
  YYSYMBOL_53_ = 53,                       /* '('  */
  YYSYMBOL_54_ = 54,                       /* ')'  */
  YYSYMBOL_FLOW4 = 55,                     /* FLOW4  */
  YYSYMBOL_FLOW6 = 56,                     /* FLOW6  */
  YYSYMBOL_DST = 57,                       /* DST  */
  YYSYMBOL_SRC = 58,                       /* SRC  */
  YYSYMBOL_PROTO = 59,                     /* PROTO  */
  YYSYMBOL_NEXT = 60,                      /* NEXT  */
  YYSYMBOL_HEADER = 61,                    /* HEADER  */
  YYSYMBOL_DPORT = 62,                     /* DPORT  */
  YYSYMBOL_SPORT = 63,                     /* SPORT  */
  YYSYMBOL_ICMP = 64,                      /* ICMP  */
  YYSYMBOL_TYPE = 65,                      /* TYPE  */
  YYSYMBOL_CODE = 66,                      /* CODE  */
  YYSYMBOL_TCP = 67,                       /* TCP  */
  YYSYMBOL_FLAGS = 68,                     /* FLAGS  */
  YYSYMBOL_LENGTH = 69,                    /* LENGTH  */
  YYSYMBOL_DSCP = 70,                      /* DSCP  */
  YYSYMBOL_DONT_FRAGMENT = 71,             /* DONT_FRAGMENT  */
  YYSYMBOL_IS_FRAGMENT = 72,               /* IS_FRAGMENT  */
  YYSYMBOL_FIRST_FRAGMENT = 73,            /* FIRST_FRAGMENT  */
  YYSYMBOL_LAST_FRAGMENT = 74,             /* LAST_FRAGMENT  */
  YYSYMBOL_FRAGMENT = 75,                  /* FRAGMENT  */
  YYSYMBOL_LABEL = 76,                     /* LABEL  */
  YYSYMBOL_OFFSET = 77,                    /* OFFSET  */
  YYSYMBOL_78_ = 78,                       /* ','  */
  YYSYMBOL_79_ = 79,                       /* '{'  */
  YYSYMBOL_80_ = 80,                       /* '}'  */
  YYSYMBOL_FUNCTION = 81,                  /* FUNCTION  */
  YYSYMBOL_PRINT = 82,                     /* PRINT  */
  YYSYMBOL_PRINTN = 83,                    /* PRINTN  */
  YYSYMBOL_UNSET = 84,                     /* UNSET  */
  YYSYMBOL_RETURN = 85,                    /* RETURN  */
  YYSYMBOL_ACCEPT = 86,                    /* ACCEPT  */
  YYSYMBOL_REJECT = 87,                    /* REJECT  */
  YYSYMBOL_ERROR = 88,                     /* ERROR  */
  YYSYMBOL_INT = 89,                       /* INT  */
  YYSYMBOL_BOOL = 90,                      /* BOOL  */
  YYSYMBOL_IP = 91,                        /* IP  */
  YYSYMBOL_PREFIX = 92,                    /* PREFIX  */
  YYSYMBOL_RD = 93,                        /* RD  */
  YYSYMBOL_PAIR = 94,                      /* PAIR  */
  YYSYMBOL_QUAD = 95,                      /* QUAD  */
  YYSYMBOL_EC = 96,                        /* EC  */
  YYSYMBOL_LC = 97,                        /* LC  */
  YYSYMBOL_SET = 98,                       /* SET  */
  YYSYMBOL_STRING = 99,                    /* STRING  */
  YYSYMBOL_BGPMASK = 100,                  /* BGPMASK  */
  YYSYMBOL_BGPPATH = 101,                  /* BGPPATH  */
  YYSYMBOL_CLIST = 102,                    /* CLIST  */
  YYSYMBOL_ECLIST = 103,                   /* ECLIST  */
  YYSYMBOL_LCLIST = 104,                   /* LCLIST  */
  YYSYMBOL_IF = 105,                       /* IF  */
  YYSYMBOL_THEN = 106,                     /* THEN  */
  YYSYMBOL_ELSE = 107,                     /* ELSE  */
  YYSYMBOL_CASE = 108,                     /* CASE  */
  YYSYMBOL_FOR = 109,                      /* FOR  */
  YYSYMBOL_IN = 110,                       /* IN  */
  YYSYMBOL_DO = 111,                       /* DO  */
  YYSYMBOL_TRUE = 112,                     /* TRUE  */
  YYSYMBOL_FALSE = 113,                    /* FALSE  */
  YYSYMBOL_RT = 114,                       /* RT  */
  YYSYMBOL_RO = 115,                       /* RO  */
  YYSYMBOL_UNKNOWN = 116,                  /* UNKNOWN  */
  YYSYMBOL_GENERIC = 117,                  /* GENERIC  */
  YYSYMBOL_GW = 118,                       /* GW  */
  YYSYMBOL_NET = 119,                      /* NET  */
  YYSYMBOL_MASK = 120,                     /* MASK  */
  YYSYMBOL_SOURCE = 121,                   /* SOURCE  */
  YYSYMBOL_SCOPE = 122,                    /* SCOPE  */
  YYSYMBOL_DEST = 123,                     /* DEST  */
  YYSYMBOL_IFNAME = 124,                   /* IFNAME  */
  YYSYMBOL_IFINDEX = 125,                  /* IFINDEX  */
  YYSYMBOL_WEIGHT = 126,                   /* WEIGHT  */
  YYSYMBOL_GW_MPLS = 127,                  /* GW_MPLS  */
  YYSYMBOL_PREFERENCE = 128,               /* PREFERENCE  */
  YYSYMBOL_ROA_CHECK = 129,                /* ROA_CHECK  */
  YYSYMBOL_ASN = 130,                      /* ASN  */
  YYSYMBOL_IS_V4 = 131,                    /* IS_V4  */
  YYSYMBOL_IS_V6 = 132,                    /* IS_V6  */
  YYSYMBOL_LEN = 133,                      /* LEN  */
  YYSYMBOL_MAXLEN = 134,                   /* MAXLEN  */
  YYSYMBOL_DATA = 135,                     /* DATA  */
  YYSYMBOL_DATA1 = 136,                    /* DATA1  */
  YYSYMBOL_DATA2 = 137,                    /* DATA2  */
  YYSYMBOL_DEFINED = 138,                  /* DEFINED  */
  YYSYMBOL_ADD = 139,                      /* ADD  */
  YYSYMBOL_DELETE = 140,                   /* DELETE  */
  YYSYMBOL_CONTAINS = 141,                 /* CONTAINS  */
  YYSYMBOL_RESET = 142,                    /* RESET  */
  YYSYMBOL_PREPEND = 143,                  /* PREPEND  */
  YYSYMBOL_FIRST = 144,                    /* FIRST  */
  YYSYMBOL_LAST = 145,                     /* LAST  */
  YYSYMBOL_LAST_NONAGGREGATED = 146,       /* LAST_NONAGGREGATED  */
  YYSYMBOL_MATCH = 147,                    /* MATCH  */
  YYSYMBOL_MIN = 148,                      /* MIN  */
  YYSYMBOL_MAX = 149,                      /* MAX  */
  YYSYMBOL_EMPTY = 150,                    /* EMPTY  */
  YYSYMBOL_FILTER = 151,                   /* FILTER  */
  YYSYMBOL_WHERE = 152,                    /* WHERE  */
  YYSYMBOL_EVAL = 153,                     /* EVAL  */
  YYSYMBOL_ATTRIBUTE = 154,                /* ATTRIBUTE  */
  YYSYMBOL_BT_ASSERT = 155,                /* BT_ASSERT  */
  YYSYMBOL_BT_TEST_SUITE = 156,            /* BT_TEST_SUITE  */
  YYSYMBOL_BT_CHECK_ASSIGN = 157,          /* BT_CHECK_ASSIGN  */
  YYSYMBOL_BT_TEST_SAME = 158,             /* BT_TEST_SAME  */
  YYSYMBOL_FORMAT = 159,                   /* FORMAT  */
  YYSYMBOL_160_ = 160,                     /* ':'  */
  YYSYMBOL_161_ = 161,                     /* '['  */
  YYSYMBOL_162_ = 162,                     /* ']'  */
  YYSYMBOL_163_ = 163,                     /* '?'  */
  YYSYMBOL_ROUTER = 164,                   /* ROUTER  */
  YYSYMBOL_ID = 165,                       /* ID  */
  YYSYMBOL_HOSTNAME = 166,                 /* HOSTNAME  */
  YYSYMBOL_PROTOCOL = 167,                 /* PROTOCOL  */
  YYSYMBOL_TEMPLATE = 168,                 /* TEMPLATE  */
  YYSYMBOL_DISABLED = 169,                 /* DISABLED  */
  YYSYMBOL_DEBUG = 170,                    /* DEBUG  */
  YYSYMBOL_ALL = 171,                      /* ALL  */
  YYSYMBOL_DIRECT = 172,                   /* DIRECT  */
  YYSYMBOL_INTERFACE = 173,                /* INTERFACE  */
  YYSYMBOL_IMPORT = 174,                   /* IMPORT  */
  YYSYMBOL_EXPORT = 175,                   /* EXPORT  */
  YYSYMBOL_NONE = 176,                     /* NONE  */
  YYSYMBOL_VRF = 177,                      /* VRF  */
  YYSYMBOL_DEFAULT = 178,                  /* DEFAULT  */
  YYSYMBOL_TABLE = 179,                    /* TABLE  */
  YYSYMBOL_STATES = 180,                   /* STATES  */
  YYSYMBOL_ROUTES = 181,                   /* ROUTES  */
  YYSYMBOL_FILTERS = 182,                  /* FILTERS  */
  YYSYMBOL_IPV4 = 183,                     /* IPV4  */
  YYSYMBOL_IPV6 = 184,                     /* IPV6  */
  YYSYMBOL_VPN4 = 185,                     /* VPN4  */
  YYSYMBOL_VPN6 = 186,                     /* VPN6  */
  YYSYMBOL_ROA4 = 187,                     /* ROA4  */
  YYSYMBOL_ROA6 = 188,                     /* ROA6  */
  YYSYMBOL_SADR = 189,                     /* SADR  */
  YYSYMBOL_RECEIVE = 190,                  /* RECEIVE  */
  YYSYMBOL_LIMIT = 191,                    /* LIMIT  */
  YYSYMBOL_ACTION = 192,                   /* ACTION  */
  YYSYMBOL_WARN = 193,                     /* WARN  */
  YYSYMBOL_BLOCK = 194,                    /* BLOCK  */
  YYSYMBOL_RESTART = 195,                  /* RESTART  */
  YYSYMBOL_DISABLE = 196,                  /* DISABLE  */
  YYSYMBOL_KEEP = 197,                     /* KEEP  */
  YYSYMBOL_FILTERED = 198,                 /* FILTERED  */
  YYSYMBOL_RPKI = 199,                     /* RPKI  */
  YYSYMBOL_PASSWORD = 200,                 /* PASSWORD  */
  YYSYMBOL_KEY = 201,                      /* KEY  */
  YYSYMBOL_PASSIVE = 202,                  /* PASSIVE  */
  YYSYMBOL_TO = 203,                       /* TO  */
  YYSYMBOL_EVENTS = 204,                   /* EVENTS  */
  YYSYMBOL_PACKETS = 205,                  /* PACKETS  */
  YYSYMBOL_PROTOCOLS = 206,                /* PROTOCOLS  */
  YYSYMBOL_CHANNELS = 207,                 /* CHANNELS  */
  YYSYMBOL_INTERFACES = 208,               /* INTERFACES  */
  YYSYMBOL_ALGORITHM = 209,                /* ALGORITHM  */
  YYSYMBOL_KEYED = 210,                    /* KEYED  */
  YYSYMBOL_HMAC = 211,                     /* HMAC  */
  YYSYMBOL_MD5 = 212,                      /* MD5  */
  YYSYMBOL_SHA1 = 213,                     /* SHA1  */
  YYSYMBOL_SHA256 = 214,                   /* SHA256  */
  YYSYMBOL_SHA384 = 215,                   /* SHA384  */
  YYSYMBOL_SHA512 = 216,                   /* SHA512  */
  YYSYMBOL_BLAKE2S128 = 217,               /* BLAKE2S128  */
  YYSYMBOL_BLAKE2S256 = 218,               /* BLAKE2S256  */
  YYSYMBOL_BLAKE2B256 = 219,               /* BLAKE2B256  */
  YYSYMBOL_BLAKE2B512 = 220,               /* BLAKE2B512  */
  YYSYMBOL_PRIMARY = 221,                  /* PRIMARY  */
  YYSYMBOL_STATS = 222,                    /* STATS  */
  YYSYMBOL_COUNT = 223,                    /* COUNT  */
  YYSYMBOL_BY = 224,                       /* BY  */
  YYSYMBOL_COMMANDS = 225,                 /* COMMANDS  */
  YYSYMBOL_PREEXPORT = 226,                /* PREEXPORT  */
  YYSYMBOL_NOEXPORT = 227,                 /* NOEXPORT  */
  YYSYMBOL_EXPORTED = 228,                 /* EXPORTED  */
  YYSYMBOL_GENERATE = 229,                 /* GENERATE  */
  YYSYMBOL_BGP = 230,                      /* BGP  */
  YYSYMBOL_PASSWORDS = 231,                /* PASSWORDS  */
  YYSYMBOL_DESCRIPTION = 232,              /* DESCRIPTION  */
  YYSYMBOL_RELOAD = 233,                   /* RELOAD  */
  YYSYMBOL_OUT = 234,                      /* OUT  */
  YYSYMBOL_MRTDUMP = 235,                  /* MRTDUMP  */
  YYSYMBOL_MESSAGES = 236,                 /* MESSAGES  */
  YYSYMBOL_RESTRICT = 237,                 /* RESTRICT  */
  YYSYMBOL_MEMORY = 238,                   /* MEMORY  */
  YYSYMBOL_IGP_METRIC = 239,               /* IGP_METRIC  */
  YYSYMBOL_CLASS = 240,                    /* CLASS  */
  YYSYMBOL_TIMEFORMAT = 241,               /* TIMEFORMAT  */
  YYSYMBOL_ISO = 242,                      /* ISO  */
  YYSYMBOL_SHORT = 243,                    /* SHORT  */
  YYSYMBOL_LONG = 244,                     /* LONG  */
  YYSYMBOL_ROUTE = 245,                    /* ROUTE  */
  YYSYMBOL_BASE = 246,                     /* BASE  */
  YYSYMBOL_LOG = 247,                      /* LOG  */
  YYSYMBOL_GRACEFUL = 248,                 /* GRACEFUL  */
  YYSYMBOL_WAIT = 249,                     /* WAIT  */
  YYSYMBOL_FLUSH = 250,                    /* FLUSH  */
  YYSYMBOL_AS = 251,                       /* AS  */
  YYSYMBOL_IDLE = 252,                     /* IDLE  */
  YYSYMBOL_RX = 253,                       /* RX  */
  YYSYMBOL_TX = 254,                       /* TX  */
  YYSYMBOL_INTERVAL = 255,                 /* INTERVAL  */
  YYSYMBOL_MULTIPLIER = 256,               /* MULTIPLIER  */
  YYSYMBOL_CHECK = 257,                    /* CHECK  */
  YYSYMBOL_LINK = 258,                     /* LINK  */
  YYSYMBOL_SORTED = 259,                   /* SORTED  */
  YYSYMBOL_TRIE = 260,                     /* TRIE  */
  YYSYMBOL_SETTLE = 261,                   /* SETTLE  */
  YYSYMBOL_TIME = 262,                     /* TIME  */
  YYSYMBOL_GC = 263,                       /* GC  */
  YYSYMBOL_THRESHOLD = 264,                /* THRESHOLD  */
  YYSYMBOL_PERIOD = 265,                   /* PERIOD  */
  YYSYMBOL_IPV4_MC = 266,                  /* IPV4_MC  */
  YYSYMBOL_IPV4_MPLS = 267,                /* IPV4_MPLS  */
  YYSYMBOL_IPV6_MC = 268,                  /* IPV6_MC  */
  YYSYMBOL_IPV6_MPLS = 269,                /* IPV6_MPLS  */
  YYSYMBOL_IPV6_SADR = 270,                /* IPV6_SADR  */
  YYSYMBOL_VPN4_MC = 271,                  /* VPN4_MC  */
  YYSYMBOL_VPN4_MPLS = 272,                /* VPN4_MPLS  */
  YYSYMBOL_VPN6_MC = 273,                  /* VPN6_MC  */
  YYSYMBOL_VPN6_MPLS = 274,                /* VPN6_MPLS  */
  YYSYMBOL_PRI = 275,                      /* PRI  */
  YYSYMBOL_SEC = 276,                      /* SEC  */
  YYSYMBOL_SHOW = 277,                     /* SHOW  */
  YYSYMBOL_STATUS = 278,                   /* STATUS  */
  YYSYMBOL_SUMMARY = 279,                  /* SUMMARY  */
  YYSYMBOL_SYMBOLS = 280,                  /* SYMBOLS  */
  YYSYMBOL_DUMP = 281,                     /* DUMP  */
  YYSYMBOL_RESOURCES = 282,                /* RESOURCES  */
  YYSYMBOL_SOCKETS = 283,                  /* SOCKETS  */
  YYSYMBOL_NEIGHBORS = 284,                /* NEIGHBORS  */
  YYSYMBOL_ATTRIBUTES = 285,               /* ATTRIBUTES  */
  YYSYMBOL_ECHO = 286,                     /* ECHO  */
  YYSYMBOL_ENABLE = 287,                   /* ENABLE  */
  YYSYMBOL_BABEL = 288,                    /* BABEL  */
  YYSYMBOL_METRIC = 289,                   /* METRIC  */
  YYSYMBOL_RXCOST = 290,                   /* RXCOST  */
  YYSYMBOL_HELLO = 291,                    /* HELLO  */
  YYSYMBOL_UPDATE = 292,                   /* UPDATE  */
  YYSYMBOL_WIRED = 293,                    /* WIRED  */
  YYSYMBOL_WIRELESS = 294,                 /* WIRELESS  */
  YYSYMBOL_BUFFER = 295,                   /* BUFFER  */
  YYSYMBOL_PRIORITY = 296,                 /* PRIORITY  */
  YYSYMBOL_HOP = 297,                      /* HOP  */
  YYSYMBOL_BABEL_METRIC = 298,             /* BABEL_METRIC  */
  YYSYMBOL_ENTRIES = 299,                  /* ENTRIES  */
  YYSYMBOL_RANDOMIZE = 300,                /* RANDOMIZE  */
  YYSYMBOL_MAC = 301,                      /* MAC  */
  YYSYMBOL_PERMISSIVE = 302,               /* PERMISSIVE  */
  YYSYMBOL_BFD = 303,                      /* BFD  */
  YYSYMBOL_MULTIHOP = 304,                 /* MULTIHOP  */
  YYSYMBOL_NEIGHBOR = 305,                 /* NEIGHBOR  */
  YYSYMBOL_DEV = 306,                      /* DEV  */
  YYSYMBOL_LOCAL = 307,                    /* LOCAL  */
  YYSYMBOL_AUTHENTICATION = 308,           /* AUTHENTICATION  */
  YYSYMBOL_SIMPLE = 309,                   /* SIMPLE  */
  YYSYMBOL_METICULOUS = 310,               /* METICULOUS  */
  YYSYMBOL_STRICT = 311,                   /* STRICT  */
  YYSYMBOL_BIND = 312,                     /* BIND  */
  YYSYMBOL_SESSIONS = 313,                 /* SESSIONS  */
  YYSYMBOL_HOLD = 314,                     /* HOLD  */
  YYSYMBOL_CONNECT = 315,                  /* CONNECT  */
  YYSYMBOL_RETRY = 316,                    /* RETRY  */
  YYSYMBOL_KEEPALIVE = 317,                /* KEEPALIVE  */
  YYSYMBOL_STARTUP = 318,                  /* STARTUP  */
  YYSYMBOL_VIA = 319,                      /* VIA  */
  YYSYMBOL_SELF = 320,                     /* SELF  */
  YYSYMBOL_PATH = 321,                     /* PATH  */
  YYSYMBOL_START = 322,                    /* START  */
  YYSYMBOL_DELAY = 323,                    /* DELAY  */
  YYSYMBOL_FORGET = 324,                   /* FORGET  */
  YYSYMBOL_AFTER = 325,                    /* AFTER  */
  YYSYMBOL_BGP_PATH = 326,                 /* BGP_PATH  */
  YYSYMBOL_BGP_LOCAL_PREF = 327,           /* BGP_LOCAL_PREF  */
  YYSYMBOL_BGP_MED = 328,                  /* BGP_MED  */
  YYSYMBOL_BGP_ORIGIN = 329,               /* BGP_ORIGIN  */
  YYSYMBOL_BGP_NEXT_HOP = 330,             /* BGP_NEXT_HOP  */
  YYSYMBOL_BGP_ATOMIC_AGGR = 331,          /* BGP_ATOMIC_AGGR  */
  YYSYMBOL_BGP_AGGREGATOR = 332,           /* BGP_AGGREGATOR  */
  YYSYMBOL_BGP_COMMUNITY = 333,            /* BGP_COMMUNITY  */
  YYSYMBOL_BGP_EXT_COMMUNITY = 334,        /* BGP_EXT_COMMUNITY  */
  YYSYMBOL_BGP_LARGE_COMMUNITY = 335,      /* BGP_LARGE_COMMUNITY  */
  YYSYMBOL_ADDRESS = 336,                  /* ADDRESS  */
  YYSYMBOL_RR = 337,                       /* RR  */
  YYSYMBOL_RS = 338,                       /* RS  */
  YYSYMBOL_CLIENT = 339,                   /* CLIENT  */
  YYSYMBOL_CLUSTER = 340,                  /* CLUSTER  */
  YYSYMBOL_AS4 = 341,                      /* AS4  */
  YYSYMBOL_ADVERTISE = 342,                /* ADVERTISE  */
  YYSYMBOL_CAPABILITIES = 343,             /* CAPABILITIES  */
  YYSYMBOL_PREFER = 344,                   /* PREFER  */
  YYSYMBOL_OLDER = 345,                    /* OLDER  */
  YYSYMBOL_MISSING = 346,                  /* MISSING  */
  YYSYMBOL_LLADDR = 347,                   /* LLADDR  */
  YYSYMBOL_DROP = 348,                     /* DROP  */
  YYSYMBOL_IGNORE = 349,                   /* IGNORE  */
  YYSYMBOL_REFRESH = 350,                  /* REFRESH  */
  YYSYMBOL_INTERPRET = 351,                /* INTERPRET  */
  YYSYMBOL_COMMUNITIES = 352,              /* COMMUNITIES  */
  YYSYMBOL_BGP_ORIGINATOR_ID = 353,        /* BGP_ORIGINATOR_ID  */
  YYSYMBOL_BGP_CLUSTER_LIST = 354,         /* BGP_CLUSTER_LIST  */
  YYSYMBOL_IGP = 355,                      /* IGP  */
  YYSYMBOL_GATEWAY = 356,                  /* GATEWAY  */
  YYSYMBOL_RECURSIVE = 357,                /* RECURSIVE  */
  YYSYMBOL_MED = 358,                      /* MED  */
  YYSYMBOL_TTL = 359,                      /* TTL  */
  YYSYMBOL_SECURITY = 360,                 /* SECURITY  */
  YYSYMBOL_DETERMINISTIC = 361,            /* DETERMINISTIC  */
  YYSYMBOL_SECONDARY = 362,                /* SECONDARY  */
  YYSYMBOL_ALLOW = 363,                    /* ALLOW  */
  YYSYMBOL_PATHS = 364,                    /* PATHS  */
  YYSYMBOL_AWARE = 365,                    /* AWARE  */
  YYSYMBOL_EXTENDED = 366,                 /* EXTENDED  */
  YYSYMBOL_SETKEY = 367,                   /* SETKEY  */
  YYSYMBOL_CONFEDERATION = 368,            /* CONFEDERATION  */
  YYSYMBOL_MEMBER = 369,                   /* MEMBER  */
  YYSYMBOL_MULTICAST = 370,                /* MULTICAST  */
  YYSYMBOL_LIVED = 371,                    /* LIVED  */
  YYSYMBOL_STALE = 372,                    /* STALE  */
  YYSYMBOL_IBGP = 373,                     /* IBGP  */
  YYSYMBOL_EBGP = 374,                     /* EBGP  */
  YYSYMBOL_MANDATORY = 375,                /* MANDATORY  */
  YYSYMBOL_INTERNAL = 376,                 /* INTERNAL  */
  YYSYMBOL_EXTERNAL = 377,                 /* EXTERNAL  */
  YYSYMBOL_SETS = 378,                     /* SETS  */
  YYSYMBOL_DYNAMIC = 379,                  /* DYNAMIC  */
  YYSYMBOL_RANGE = 380,                    /* RANGE  */
  YYSYMBOL_NAME = 381,                     /* NAME  */
  YYSYMBOL_DIGITS = 382,                   /* DIGITS  */
  YYSYMBOL_BGP_AIGP = 383,                 /* BGP_AIGP  */
  YYSYMBOL_AIGP = 384,                     /* AIGP  */
  YYSYMBOL_ORIGINATE = 385,                /* ORIGINATE  */
  YYSYMBOL_COST = 386,                     /* COST  */
  YYSYMBOL_ENFORCE = 387,                  /* ENFORCE  */
  YYSYMBOL_FREE = 388,                     /* FREE  */
  YYSYMBOL_VALIDATE = 389,                 /* VALIDATE  */
  YYSYMBOL_ROLE = 390,                     /* ROLE  */
  YYSYMBOL_ROLES = 391,                    /* ROLES  */
  YYSYMBOL_PEER = 392,                     /* PEER  */
  YYSYMBOL_PROVIDER = 393,                 /* PROVIDER  */
  YYSYMBOL_CUSTOMER = 394,                 /* CUSTOMER  */
  YYSYMBOL_RS_SERVER = 395,                /* RS_SERVER  */
  YYSYMBOL_RS_CLIENT = 396,                /* RS_CLIENT  */
  YYSYMBOL_REQUIRE = 397,                  /* REQUIRE  */
  YYSYMBOL_BGP_OTC = 398,                  /* BGP_OTC  */
  YYSYMBOL_GLOBAL = 399,                   /* GLOBAL  */
  YYSYMBOL_CEASE = 400,                    /* CEASE  */
  YYSYMBOL_HIT = 401,                      /* HIT  */
  YYSYMBOL_ADMINISTRATIVE = 402,           /* ADMINISTRATIVE  */
  YYSYMBOL_SHUTDOWN = 403,                 /* SHUTDOWN  */
  YYSYMBOL_CONFIGURATION = 404,            /* CONFIGURATION  */
  YYSYMBOL_CHANGE = 405,                   /* CHANGE  */
  YYSYMBOL_DECONFIGURED = 406,             /* DECONFIGURED  */
  YYSYMBOL_CONNECTION = 407,               /* CONNECTION  */
  YYSYMBOL_REJECTED = 408,                 /* REJECTED  */
  YYSYMBOL_COLLISION = 409,                /* COLLISION  */
  YYSYMBOL_OF = 410,                       /* OF  */
  YYSYMBOL_MRT = 411,                      /* MRT  */
  YYSYMBOL_FILENAME = 412,                 /* FILENAME  */
  YYSYMBOL_ALWAYS = 413,                   /* ALWAYS  */
  YYSYMBOL_OSPF = 414,                     /* OSPF  */
  YYSYMBOL_V2 = 415,                       /* V2  */
  YYSYMBOL_V3 = 416,                       /* V3  */
  YYSYMBOL_OSPF_METRIC1 = 417,             /* OSPF_METRIC1  */
  YYSYMBOL_OSPF_METRIC2 = 418,             /* OSPF_METRIC2  */
  YYSYMBOL_OSPF_TAG = 419,                 /* OSPF_TAG  */
  YYSYMBOL_OSPF_ROUTER_ID = 420,           /* OSPF_ROUTER_ID  */
  YYSYMBOL_AREA = 421,                     /* AREA  */
  YYSYMBOL_RFC1583COMPAT = 422,            /* RFC1583COMPAT  */
  YYSYMBOL_STUB = 423,                     /* STUB  */
  YYSYMBOL_TICK = 424,                     /* TICK  */
  YYSYMBOL_COST2 = 425,                    /* COST2  */
  YYSYMBOL_RETRANSMIT = 426,               /* RETRANSMIT  */
  YYSYMBOL_TRANSMIT = 427,                 /* TRANSMIT  */
  YYSYMBOL_DEAD = 428,                     /* DEAD  */
  YYSYMBOL_BROADCAST = 429,                /* BROADCAST  */
  YYSYMBOL_BCAST = 430,                    /* BCAST  */
  YYSYMBOL_NONBROADCAST = 431,             /* NONBROADCAST  */
  YYSYMBOL_NBMA = 432,                     /* NBMA  */
  YYSYMBOL_POINTOPOINT = 433,              /* POINTOPOINT  */
  YYSYMBOL_PTP = 434,                      /* PTP  */
  YYSYMBOL_POINTOMULTIPOINT = 435,         /* POINTOMULTIPOINT  */
  YYSYMBOL_PTMP = 436,                     /* PTMP  */
  YYSYMBOL_CRYPTOGRAPHIC = 437,            /* CRYPTOGRAPHIC  */
  YYSYMBOL_ELIGIBLE = 438,                 /* ELIGIBLE  */
  YYSYMBOL_POLL = 439,                     /* POLL  */
  YYSYMBOL_NETWORKS = 440,                 /* NETWORKS  */
  YYSYMBOL_HIDDEN = 441,                   /* HIDDEN  */
  YYSYMBOL_VIRTUAL = 442,                  /* VIRTUAL  */
  YYSYMBOL_ONLY = 443,                     /* ONLY  */
  YYSYMBOL_LARGE = 444,                    /* LARGE  */
  YYSYMBOL_NORMAL = 445,                   /* NORMAL  */
  YYSYMBOL_STUBNET = 446,                  /* STUBNET  */
  YYSYMBOL_TAG = 447,                      /* TAG  */
  YYSYMBOL_LSADB = 448,                    /* LSADB  */
  YYSYMBOL_ECMP = 449,                     /* ECMP  */
  YYSYMBOL_NSSA = 450,                     /* NSSA  */
  YYSYMBOL_TRANSLATOR = 451,               /* TRANSLATOR  */
  YYSYMBOL_STABILITY = 452,                /* STABILITY  */
  YYSYMBOL_LSID = 453,                     /* LSID  */
  YYSYMBOL_INSTANCE = 454,                 /* INSTANCE  */
  YYSYMBOL_REAL = 455,                     /* REAL  */
  YYSYMBOL_NETMASK = 456,                  /* NETMASK  */
  YYSYMBOL_MERGE = 457,                    /* MERGE  */
  YYSYMBOL_LSA = 458,                      /* LSA  */
  YYSYMBOL_SUPPRESSION = 459,              /* SUPPRESSION  */
  YYSYMBOL_RFC5838 = 460,                  /* RFC5838  */
  YYSYMBOL_PE = 461,                       /* PE  */
  YYSYMBOL_TOPOLOGY = 462,                 /* TOPOLOGY  */
  YYSYMBOL_STATE = 463,                    /* STATE  */
  YYSYMBOL_PERF = 464,                     /* PERF  */
  YYSYMBOL_EXP = 465,                      /* EXP  */
  YYSYMBOL_REPEAT = 466,                   /* REPEAT  */
  YYSYMBOL_MODE = 467,                     /* MODE  */
  YYSYMBOL_PIPE = 468,                     /* PIPE  */
  YYSYMBOL_RADV = 469,                     /* RADV  */
  YYSYMBOL_RA = 470,                       /* RA  */
  YYSYMBOL_SOLICITED = 471,                /* SOLICITED  */
  YYSYMBOL_UNICAST = 472,                  /* UNICAST  */
  YYSYMBOL_MANAGED = 473,                  /* MANAGED  */
  YYSYMBOL_OTHER = 474,                    /* OTHER  */
  YYSYMBOL_CONFIG = 475,                   /* CONFIG  */
  YYSYMBOL_LINGER = 476,                   /* LINGER  */
  YYSYMBOL_MTU = 477,                      /* MTU  */
  YYSYMBOL_REACHABLE = 478,                /* REACHABLE  */
  YYSYMBOL_RETRANS = 479,                  /* RETRANS  */
  YYSYMBOL_TIMER = 480,                    /* TIMER  */
  YYSYMBOL_CURRENT = 481,                  /* CURRENT  */
  YYSYMBOL_VALID = 482,                    /* VALID  */
  YYSYMBOL_PREFERRED = 483,                /* PREFERRED  */
  YYSYMBOL_MULT = 484,                     /* MULT  */
  YYSYMBOL_LIFETIME = 485,                 /* LIFETIME  */
  YYSYMBOL_SKIP = 486,                     /* SKIP  */
  YYSYMBOL_ONLINK = 487,                   /* ONLINK  */
  YYSYMBOL_AUTONOMOUS = 488,               /* AUTONOMOUS  */
  YYSYMBOL_RDNSS = 489,                    /* RDNSS  */
  YYSYMBOL_DNSSL = 490,                    /* DNSSL  */
  YYSYMBOL_NS = 491,                       /* NS  */
  YYSYMBOL_DOMAIN = 492,                   /* DOMAIN  */
  YYSYMBOL_TRIGGER = 493,                  /* TRIGGER  */
  YYSYMBOL_SENSITIVE = 494,                /* SENSITIVE  */
  YYSYMBOL_LOW = 495,                      /* LOW  */
  YYSYMBOL_MEDIUM = 496,                   /* MEDIUM  */
  YYSYMBOL_HIGH = 497,                     /* HIGH  */
  YYSYMBOL_PROPAGATE = 498,                /* PROPAGATE  */
  YYSYMBOL_RA_PREFERENCE = 499,            /* RA_PREFERENCE  */
  YYSYMBOL_RA_LIFETIME = 500,              /* RA_LIFETIME  */
  YYSYMBOL_RIP = 501,                      /* RIP  */
  YYSYMBOL_NG = 502,                       /* NG  */
  YYSYMBOL_INFINITY = 503,                 /* INFINITY  */
  YYSYMBOL_TIMEOUT = 504,                  /* TIMEOUT  */
  YYSYMBOL_GARBAGE = 505,                  /* GARBAGE  */
  YYSYMBOL_VERSION = 506,                  /* VERSION  */
  YYSYMBOL_SPLIT = 507,                    /* SPLIT  */
  YYSYMBOL_HORIZON = 508,                  /* HORIZON  */
  YYSYMBOL_POISON = 509,                   /* POISON  */
  YYSYMBOL_REVERSE = 510,                  /* REVERSE  */
  YYSYMBOL_ZERO = 511,                     /* ZERO  */
  YYSYMBOL_PLAINTEXT = 512,                /* PLAINTEXT  */
  YYSYMBOL_DEMAND = 513,                   /* DEMAND  */
  YYSYMBOL_CIRCUIT = 514,                  /* CIRCUIT  */
  YYSYMBOL_RIP_METRIC = 515,               /* RIP_METRIC  */
  YYSYMBOL_RIP_TAG = 516,                  /* RIP_TAG  */
  YYSYMBOL_REMOTE = 517,                   /* REMOTE  */
  YYSYMBOL_BIRD = 518,                     /* BIRD  */
  YYSYMBOL_PRIVATE = 519,                  /* PRIVATE  */
  YYSYMBOL_PUBLIC = 520,                   /* PUBLIC  */
  YYSYMBOL_SSH = 521,                      /* SSH  */
  YYSYMBOL_TRANSPORT = 522,                /* TRANSPORT  */
  YYSYMBOL_USER = 523,                     /* USER  */
  YYSYMBOL_EXPIRE = 524,                   /* EXPIRE  */
  YYSYMBOL_STATIC = 525,                   /* STATIC  */
  YYSYMBOL_PROHIBIT = 526,                 /* PROHIBIT  */
  YYSYMBOL_BLACKHOLE = 527,                /* BLACKHOLE  */
  YYSYMBOL_UNREACHABLE = 528,              /* UNREACHABLE  */
  YYSYMBOL_KERNEL = 529,                   /* KERNEL  */
  YYSYMBOL_NETLINK = 530,                  /* NETLINK  */
  YYSYMBOL_KRT_PREFSRC = 531,              /* KRT_PREFSRC  */
  YYSYMBOL_KRT_REALM = 532,                /* KRT_REALM  */
  YYSYMBOL_KRT_SCOPE = 533,                /* KRT_SCOPE  */
  YYSYMBOL_KRT_MTU = 534,                  /* KRT_MTU  */
  YYSYMBOL_KRT_WINDOW = 535,               /* KRT_WINDOW  */
  YYSYMBOL_KRT_RTT = 536,                  /* KRT_RTT  */
  YYSYMBOL_KRT_RTTVAR = 537,               /* KRT_RTTVAR  */
  YYSYMBOL_KRT_SSTRESH = 538,              /* KRT_SSTRESH  */
  YYSYMBOL_KRT_CWND = 539,                 /* KRT_CWND  */
  YYSYMBOL_KRT_ADVMSS = 540,               /* KRT_ADVMSS  */
  YYSYMBOL_KRT_REORDERING = 541,           /* KRT_REORDERING  */
  YYSYMBOL_KRT_HOPLIMIT = 542,             /* KRT_HOPLIMIT  */
  YYSYMBOL_KRT_INITCWND = 543,             /* KRT_INITCWND  */
  YYSYMBOL_KRT_RTO_MIN = 544,              /* KRT_RTO_MIN  */
  YYSYMBOL_KRT_INITRWND = 545,             /* KRT_INITRWND  */
  YYSYMBOL_KRT_QUICKACK = 546,             /* KRT_QUICKACK  */
  YYSYMBOL_KRT_LOCK_MTU = 547,             /* KRT_LOCK_MTU  */
  YYSYMBOL_KRT_LOCK_WINDOW = 548,          /* KRT_LOCK_WINDOW  */
  YYSYMBOL_KRT_LOCK_RTT = 549,             /* KRT_LOCK_RTT  */
  YYSYMBOL_KRT_LOCK_RTTVAR = 550,          /* KRT_LOCK_RTTVAR  */
  YYSYMBOL_KRT_LOCK_SSTRESH = 551,         /* KRT_LOCK_SSTRESH  */
  YYSYMBOL_KRT_LOCK_CWND = 552,            /* KRT_LOCK_CWND  */
  YYSYMBOL_KRT_LOCK_ADVMSS = 553,          /* KRT_LOCK_ADVMSS  */
  YYSYMBOL_KRT_LOCK_REORDERING = 554,      /* KRT_LOCK_REORDERING  */
  YYSYMBOL_KRT_LOCK_HOPLIMIT = 555,        /* KRT_LOCK_HOPLIMIT  */
  YYSYMBOL_KRT_LOCK_RTO_MIN = 556,         /* KRT_LOCK_RTO_MIN  */
  YYSYMBOL_KRT_FEATURE_ECN = 557,          /* KRT_FEATURE_ECN  */
  YYSYMBOL_KRT_FEATURE_ALLFRAG = 558,      /* KRT_FEATURE_ALLFRAG  */
  YYSYMBOL_SYSLOG = 559,                   /* SYSLOG  */
  YYSYMBOL_TRACE = 560,                    /* TRACE  */
  YYSYMBOL_INFO = 561,                     /* INFO  */
  YYSYMBOL_WARNING = 562,                  /* WARNING  */
  YYSYMBOL_AUTH = 563,                     /* AUTH  */
  YYSYMBOL_FATAL = 564,                    /* FATAL  */
  YYSYMBOL_BUG = 565,                      /* BUG  */
  YYSYMBOL_STDERR = 566,                   /* STDERR  */
  YYSYMBOL_SOFT = 567,                     /* SOFT  */
  YYSYMBOL_CONFIRM = 568,                  /* CONFIRM  */
  YYSYMBOL_UNDO = 569,                     /* UNDO  */
  YYSYMBOL_LATENCY = 570,                  /* LATENCY  */
  YYSYMBOL_WATCHDOG = 571,                 /* WATCHDOG  */
  YYSYMBOL_CONFIGURE = 572,                /* CONFIGURE  */
  YYSYMBOL_DOWN = 573,                     /* DOWN  */
  YYSYMBOL_PERSIST = 574,                  /* PERSIST  */
  YYSYMBOL_SCAN = 575,                     /* SCAN  */
  YYSYMBOL_LEARN = 576,                    /* LEARN  */
  YYSYMBOL_DEVICE = 577,                   /* DEVICE  */
  YYSYMBOL_KRT_SOURCE = 578,               /* KRT_SOURCE  */
  YYSYMBOL_KRT_METRIC = 579,               /* KRT_METRIC  */
  YYSYMBOL_YYACCEPT = 580,                 /* $accept  */
  YYSYMBOL_cli_cmd = 581,                  /* cli_cmd  */
  YYSYMBOL_cmd_QUIT = 582,                 /* cmd_QUIT  */
  YYSYMBOL_cmd_EXIT = 583,                 /* cmd_EXIT  */
  YYSYMBOL_cmd_HELP = 584,                 /* cmd_HELP  */
  YYSYMBOL_config = 585,                   /* config  */
  YYSYMBOL_conf_entries = 586,             /* conf_entries  */
  YYSYMBOL_conf = 587,                     /* conf  */
  YYSYMBOL_definition = 588,               /* definition  */
  YYSYMBOL_expr = 589,                     /* expr  */
  YYSYMBOL_expr_us = 590,                  /* expr_us  */
  YYSYMBOL_symbol = 591,                   /* symbol  */
  YYSYMBOL_bool = 592,                     /* bool  */
  YYSYMBOL_ipa = 593,                      /* ipa  */
  YYSYMBOL_ipa_scope = 594,                /* ipa_scope  */
  YYSYMBOL_pxlen4 = 595,                   /* pxlen4  */
  YYSYMBOL_net_ip4_ = 596,                 /* net_ip4_  */
  YYSYMBOL_net_ip6_ = 597,                 /* net_ip6_  */
  YYSYMBOL_net_ip6_sadr_ = 598,            /* net_ip6_sadr_  */
  YYSYMBOL_net_vpn4_ = 599,                /* net_vpn4_  */
  YYSYMBOL_net_vpn6_ = 600,                /* net_vpn6_  */
  YYSYMBOL_net_roa4_ = 601,                /* net_roa4_  */
  YYSYMBOL_net_roa6_ = 602,                /* net_roa6_  */
  YYSYMBOL_net_mpls_ = 603,                /* net_mpls_  */
  YYSYMBOL_net_ip_ = 604,                  /* net_ip_  */
  YYSYMBOL_net_vpn_ = 605,                 /* net_vpn_  */
  YYSYMBOL_net_roa_ = 606,                 /* net_roa_  */
  YYSYMBOL_net_ = 607,                     /* net_  */
  YYSYMBOL_net_ip4 = 608,                  /* net_ip4  */
  YYSYMBOL_net_ip6 = 609,                  /* net_ip6  */
  YYSYMBOL_net_ip = 610,                   /* net_ip  */
  YYSYMBOL_net_any = 611,                  /* net_any  */
  YYSYMBOL_net_or_ipa = 612,               /* net_or_ipa  */
  YYSYMBOL_label_stack_start = 613,        /* label_stack_start  */
  YYSYMBOL_label_stack = 614,              /* label_stack  */
  YYSYMBOL_time = 615,                     /* time  */
  YYSYMBOL_text = 616,                     /* text  */
  YYSYMBOL_opttext = 617,                  /* opttext  */
  YYSYMBOL_flow_num_op = 618,              /* flow_num_op  */
  YYSYMBOL_flow_logic_op = 619,            /* flow_logic_op  */
  YYSYMBOL_flow_num_type_ = 620,           /* flow_num_type_  */
  YYSYMBOL_flow_num_type = 621,            /* flow_num_type  */
  YYSYMBOL_flow_flag_type = 622,           /* flow_flag_type  */
  YYSYMBOL_flow_frag_type = 623,           /* flow_frag_type  */
  YYSYMBOL_flow_srcdst = 624,              /* flow_srcdst  */
  YYSYMBOL_flow_num_opts = 625,            /* flow_num_opts  */
  YYSYMBOL_flow_num_opt_ext_expr = 626,    /* flow_num_opt_ext_expr  */
  YYSYMBOL_flow_num_opt_ext = 627,         /* flow_num_opt_ext  */
  YYSYMBOL_flow_bmk_opts = 628,            /* flow_bmk_opts  */
  YYSYMBOL_flow_neg = 629,                 /* flow_neg  */
  YYSYMBOL_flow_frag_val = 630,            /* flow_frag_val  */
  YYSYMBOL_flow_frag_opts = 631,           /* flow_frag_opts  */
  YYSYMBOL_flow4_item = 632,               /* flow4_item  */
  YYSYMBOL_flow6_item = 633,               /* flow6_item  */
  YYSYMBOL_flow4_opts = 634,               /* flow4_opts  */
  YYSYMBOL_flow6_opts = 635,               /* flow6_opts  */
  YYSYMBOL_flow_builder_init = 636,        /* flow_builder_init  */
  YYSYMBOL_flow_builder_set_ipv4 = 637,    /* flow_builder_set_ipv4  */
  YYSYMBOL_flow_builder_set_ipv6 = 638,    /* flow_builder_set_ipv6  */
  YYSYMBOL_net_flow4_ = 639,               /* net_flow4_  */
  YYSYMBOL_net_flow6_ = 640,               /* net_flow6_  */
  YYSYMBOL_net_flow_ = 641,                /* net_flow_  */
  YYSYMBOL_filter_def = 642,               /* filter_def  */
  YYSYMBOL_643_1 = 643,                    /* $@1  */
  YYSYMBOL_filter_eval = 644,              /* filter_eval  */
  YYSYMBOL_custom_attr = 645,              /* custom_attr  */
  YYSYMBOL_bt_test_suite = 646,            /* bt_test_suite  */
  YYSYMBOL_bt_test_same = 647,             /* bt_test_same  */
  YYSYMBOL_type = 648,                     /* type  */
  YYSYMBOL_function_argsn = 649,           /* function_argsn  */
  YYSYMBOL_function_args = 650,            /* function_args  */
  YYSYMBOL_function_vars = 651,            /* function_vars  */
  YYSYMBOL_filter_body = 652,              /* filter_body  */
  YYSYMBOL_filter = 653,                   /* filter  */
  YYSYMBOL_654_2 = 654,                    /* $@2  */
  YYSYMBOL_where_filter = 655,             /* where_filter  */
  YYSYMBOL_function_body = 656,            /* function_body  */
  YYSYMBOL_function_def = 657,             /* function_def  */
  YYSYMBOL_658_3 = 658,                    /* $@3  */
  YYSYMBOL_659_4 = 659,                    /* $@4  */
  YYSYMBOL_cmds = 660,                     /* cmds  */
  YYSYMBOL_cmds_scoped = 661,              /* cmds_scoped  */
  YYSYMBOL_662_5 = 662,                    /* $@5  */
  YYSYMBOL_cmd_var = 663,                  /* cmd_var  */
  YYSYMBOL_cmd_prep = 664,                 /* cmd_prep  */
  YYSYMBOL_cmds_int = 665,                 /* cmds_int  */
  YYSYMBOL_fipa = 666,                     /* fipa  */
  YYSYMBOL_set_atom = 667,                 /* set_atom  */
  YYSYMBOL_switch_atom = 668,              /* switch_atom  */
  YYSYMBOL_cnum = 669,                     /* cnum  */
  YYSYMBOL_pair_item = 670,                /* pair_item  */
  YYSYMBOL_ec_kind = 671,                  /* ec_kind  */
  YYSYMBOL_ec_item = 672,                  /* ec_item  */
  YYSYMBOL_lc_item = 673,                  /* lc_item  */
  YYSYMBOL_set_item = 674,                 /* set_item  */
  YYSYMBOL_switch_item = 675,              /* switch_item  */
  YYSYMBOL_set_items = 676,                /* set_items  */
  YYSYMBOL_switch_items = 677,             /* switch_items  */
  YYSYMBOL_fprefix = 678,                  /* fprefix  */
  YYSYMBOL_fprefix_set = 679,              /* fprefix_set  */
  YYSYMBOL_switch_body = 680,              /* switch_body  */
  YYSYMBOL_bgp_path_expr = 681,            /* bgp_path_expr  */
  YYSYMBOL_bgp_path = 682,                 /* bgp_path  */
  YYSYMBOL_bgp_path_tail = 683,            /* bgp_path_tail  */
  YYSYMBOL_constant = 684,                 /* constant  */
  YYSYMBOL_constructor = 685,              /* constructor  */
  YYSYMBOL_var_list = 686,                 /* var_list  */
  YYSYMBOL_function_call = 687,            /* function_call  */
  YYSYMBOL_symbol_value = 688,             /* symbol_value  */
  YYSYMBOL_static_attr = 689,              /* static_attr  */
  YYSYMBOL_term = 690,                     /* term  */
  YYSYMBOL_break_command = 691,            /* break_command  */
  YYSYMBOL_print_list = 692,               /* print_list  */
  YYSYMBOL_var_init = 693,                 /* var_init  */
  YYSYMBOL_var = 694,                      /* var  */
  YYSYMBOL_for_var = 695,                  /* for_var  */
  YYSYMBOL_cmd = 696,                      /* cmd  */
  YYSYMBOL_697_6 = 697,                    /* $@6  */
  YYSYMBOL_698_7 = 698,                    /* $@7  */
  YYSYMBOL_699_8 = 699,                    /* $@8  */
  YYSYMBOL_get_cf_position = 700,          /* get_cf_position  */
  YYSYMBOL_lvalue = 701,                   /* lvalue  */
  YYSYMBOL_rtrid = 702,                    /* rtrid  */
  YYSYMBOL_idval = 703,                    /* idval  */
  YYSYMBOL_hostname_override = 704,        /* hostname_override  */
  YYSYMBOL_gr_opts = 705,                  /* gr_opts  */
  YYSYMBOL_net_type = 706,                 /* net_type  */
  YYSYMBOL_table = 707,                    /* table  */
  YYSYMBOL_table_start = 708,              /* table_start  */
  YYSYMBOL_table_sorted = 709,             /* table_sorted  */
  YYSYMBOL_table_opt = 710,                /* table_opt  */
  YYSYMBOL_table_opts = 711,               /* table_opts  */
  YYSYMBOL_table_opt_list = 712,           /* table_opt_list  */
  YYSYMBOL_proto_start = 713,              /* proto_start  */
  YYSYMBOL_proto_name = 714,               /* proto_name  */
  YYSYMBOL_proto_item = 715,               /* proto_item  */
  YYSYMBOL_channel_start = 716,            /* channel_start  */
  YYSYMBOL_channel_item_ = 717,            /* channel_item_  */
  YYSYMBOL_channel_item = 718,             /* channel_item  */
  YYSYMBOL_channel_opts = 719,             /* channel_opts  */
  YYSYMBOL_channel_opt_list = 720,         /* channel_opt_list  */
  YYSYMBOL_channel_end = 721,              /* channel_end  */
  YYSYMBOL_proto_channel = 722,            /* proto_channel  */
  YYSYMBOL_rtable = 723,                   /* rtable  */
  YYSYMBOL_imexport = 724,                 /* imexport  */
  YYSYMBOL_limit_action = 725,             /* limit_action  */
  YYSYMBOL_limit_spec = 726,               /* limit_spec  */
  YYSYMBOL_debug_default = 727,            /* debug_default  */
  YYSYMBOL_timeformat_which = 728,         /* timeformat_which  */
  YYSYMBOL_timeformat_spec = 729,          /* timeformat_spec  */
  YYSYMBOL_timeformat_base = 730,          /* timeformat_base  */
  YYSYMBOL_iface_patt_node_init = 731,     /* iface_patt_node_init  */
  YYSYMBOL_iface_patt_node_body = 732,     /* iface_patt_node_body  */
  YYSYMBOL_iface_negate = 733,             /* iface_negate  */
  YYSYMBOL_iface_patt_node = 734,          /* iface_patt_node  */
  YYSYMBOL_iface_patt_list = 735,          /* iface_patt_list  */
  YYSYMBOL_iface_patt_list_nopx = 736,     /* iface_patt_list_nopx  */
  YYSYMBOL_iface_patt_init = 737,          /* iface_patt_init  */
  YYSYMBOL_iface_patt = 738,               /* iface_patt  */
  YYSYMBOL_tos = 739,                      /* tos  */
  YYSYMBOL_proto = 740,                    /* proto  */
  YYSYMBOL_dev_proto_start = 741,          /* dev_proto_start  */
  YYSYMBOL_dev_proto = 742,                /* dev_proto  */
  YYSYMBOL_dev_iface_init = 743,           /* dev_iface_init  */
  YYSYMBOL_dev_iface_patt = 744,           /* dev_iface_patt  */
  YYSYMBOL_debug_mask = 745,               /* debug_mask  */
  YYSYMBOL_debug_list = 746,               /* debug_list  */
  YYSYMBOL_debug_flag = 747,               /* debug_flag  */
  YYSYMBOL_mrtdump_mask = 748,             /* mrtdump_mask  */
  YYSYMBOL_mrtdump_list = 749,             /* mrtdump_list  */
  YYSYMBOL_mrtdump_flag = 750,             /* mrtdump_flag  */
  YYSYMBOL_password_list = 751,            /* password_list  */
  YYSYMBOL_password_list_body = 752,       /* password_list_body  */
  YYSYMBOL_password_items = 753,           /* password_items  */
  YYSYMBOL_password_item = 754,            /* password_item  */
  YYSYMBOL_pass_key = 755,                 /* pass_key  */
  YYSYMBOL_password_item_begin = 756,      /* password_item_begin  */
  YYSYMBOL_password_item_params = 757,     /* password_item_params  */
  YYSYMBOL_password_algorithm = 758,       /* password_algorithm  */
  YYSYMBOL_password_item_end = 759,        /* password_item_end  */
  YYSYMBOL_bfd_item = 760,                 /* bfd_item  */
  YYSYMBOL_bfd_items = 761,                /* bfd_items  */
  YYSYMBOL_bfd_opts = 762,                 /* bfd_opts  */
  YYSYMBOL_cmd_SHOW_STATUS = 763,          /* cmd_SHOW_STATUS  */
  YYSYMBOL_cmd_SHOW_MEMORY = 764,          /* cmd_SHOW_MEMORY  */
  YYSYMBOL_cmd_SHOW_PROTOCOLS = 765,       /* cmd_SHOW_PROTOCOLS  */
  YYSYMBOL_cmd_SHOW_PROTOCOLS_ALL = 766,   /* cmd_SHOW_PROTOCOLS_ALL  */
  YYSYMBOL_optproto = 767,                 /* optproto  */
  YYSYMBOL_cmd_SHOW_INTERFACES = 768,      /* cmd_SHOW_INTERFACES  */
  YYSYMBOL_cmd_SHOW_INTERFACES_SUMMARY = 769, /* cmd_SHOW_INTERFACES_SUMMARY  */
  YYSYMBOL_cmd_SHOW_ROUTE = 770,           /* cmd_SHOW_ROUTE  */
  YYSYMBOL_r_args = 771,                   /* r_args  */
  YYSYMBOL_r_args_for = 772,               /* r_args_for  */
  YYSYMBOL_r_args_for_val = 773,           /* r_args_for_val  */
  YYSYMBOL_export_mode = 774,              /* export_mode  */
  YYSYMBOL_channel_sym = 775,              /* channel_sym  */
  YYSYMBOL_channel_arg = 776,              /* channel_arg  */
  YYSYMBOL_cmd_SHOW_SYMBOLS = 777,         /* cmd_SHOW_SYMBOLS  */
  YYSYMBOL_sym_args = 778,                 /* sym_args  */
  YYSYMBOL_cmd_DUMP_RESOURCES = 779,       /* cmd_DUMP_RESOURCES  */
  YYSYMBOL_cmd_DUMP_SOCKETS = 780,         /* cmd_DUMP_SOCKETS  */
  YYSYMBOL_cmd_DUMP_EVENTS = 781,          /* cmd_DUMP_EVENTS  */
  YYSYMBOL_cmd_DUMP_INTERFACES = 782,      /* cmd_DUMP_INTERFACES  */
  YYSYMBOL_cmd_DUMP_NEIGHBORS = 783,       /* cmd_DUMP_NEIGHBORS  */
  YYSYMBOL_cmd_DUMP_ATTRIBUTES = 784,      /* cmd_DUMP_ATTRIBUTES  */
  YYSYMBOL_cmd_DUMP_ROUTES = 785,          /* cmd_DUMP_ROUTES  */
  YYSYMBOL_cmd_DUMP_PROTOCOLS = 786,       /* cmd_DUMP_PROTOCOLS  */
  YYSYMBOL_cmd_DUMP_FILTER_ALL = 787,      /* cmd_DUMP_FILTER_ALL  */
  YYSYMBOL_cmd_EVAL = 788,                 /* cmd_EVAL  */
  YYSYMBOL_cmd_ECHO = 789,                 /* cmd_ECHO  */
  YYSYMBOL_echo_mask = 790,                /* echo_mask  */
  YYSYMBOL_echo_size = 791,                /* echo_size  */
  YYSYMBOL_cmd_DISABLE = 792,              /* cmd_DISABLE  */
  YYSYMBOL_cmd_ENABLE = 793,               /* cmd_ENABLE  */
  YYSYMBOL_cmd_RESTART = 794,              /* cmd_RESTART  */
  YYSYMBOL_cmd_RELOAD = 795,               /* cmd_RELOAD  */
  YYSYMBOL_cmd_RELOAD_IN = 796,            /* cmd_RELOAD_IN  */
  YYSYMBOL_cmd_RELOAD_OUT = 797,           /* cmd_RELOAD_OUT  */
  YYSYMBOL_cmd_DEBUG = 798,                /* cmd_DEBUG  */
  YYSYMBOL_debug_args = 799,               /* debug_args  */
  YYSYMBOL_cmd_MRTDUMP = 800,              /* cmd_MRTDUMP  */
  YYSYMBOL_cmd_RESTRICT = 801,             /* cmd_RESTRICT  */
  YYSYMBOL_proto_patt = 802,               /* proto_patt  */
  YYSYMBOL_proto_patt2 = 803,              /* proto_patt2  */
  YYSYMBOL_dynamic_attr = 804,             /* dynamic_attr  */
  YYSYMBOL_babel_proto_start = 805,        /* babel_proto_start  */
  YYSYMBOL_babel_proto_item = 806,         /* babel_proto_item  */
  YYSYMBOL_babel_proto_opts = 807,         /* babel_proto_opts  */
  YYSYMBOL_babel_proto = 808,              /* babel_proto  */
  YYSYMBOL_babel_iface_start = 809,        /* babel_iface_start  */
  YYSYMBOL_babel_iface_finish = 810,       /* babel_iface_finish  */
  YYSYMBOL_babel_iface_item = 811,         /* babel_iface_item  */
  YYSYMBOL_babel_iface_opts = 812,         /* babel_iface_opts  */
  YYSYMBOL_babel_iface_opt_list = 813,     /* babel_iface_opt_list  */
  YYSYMBOL_babel_iface = 814,              /* babel_iface  */
  YYSYMBOL_cmd_SHOW_BABEL_INTERFACES = 815, /* cmd_SHOW_BABEL_INTERFACES  */
  YYSYMBOL_cmd_SHOW_BABEL_NEIGHBORS = 816, /* cmd_SHOW_BABEL_NEIGHBORS  */
  YYSYMBOL_cmd_SHOW_BABEL_ENTRIES = 817,   /* cmd_SHOW_BABEL_ENTRIES  */
  YYSYMBOL_cmd_SHOW_BABEL_ROUTES = 818,    /* cmd_SHOW_BABEL_ROUTES  */
  YYSYMBOL_bfd_proto_start = 819,          /* bfd_proto_start  */
  YYSYMBOL_bfd_proto_item = 820,           /* bfd_proto_item  */
  YYSYMBOL_bfd_proto_opts = 821,           /* bfd_proto_opts  */
  YYSYMBOL_bfd_proto = 822,                /* bfd_proto  */
  YYSYMBOL_bfd_accept_item = 823,          /* bfd_accept_item  */
  YYSYMBOL_bfd_accept = 824,               /* bfd_accept  */
  YYSYMBOL_bfd_iface_start = 825,          /* bfd_iface_start  */
  YYSYMBOL_bfd_iface_finish = 826,         /* bfd_iface_finish  */
  YYSYMBOL_bfd_iface_item = 827,           /* bfd_iface_item  */
  YYSYMBOL_bfd_auth_type = 828,            /* bfd_auth_type  */
  YYSYMBOL_bfd_iface_opts = 829,           /* bfd_iface_opts  */
  YYSYMBOL_bfd_iface_opt_list = 830,       /* bfd_iface_opt_list  */
  YYSYMBOL_bfd_iface = 831,                /* bfd_iface  */
  YYSYMBOL_bfd_multihop = 832,             /* bfd_multihop  */
  YYSYMBOL_bfd_neigh_iface = 833,          /* bfd_neigh_iface  */
  YYSYMBOL_bfd_neigh_local = 834,          /* bfd_neigh_local  */
  YYSYMBOL_bfd_neigh_multihop = 835,       /* bfd_neigh_multihop  */
  YYSYMBOL_bfd_neighbor = 836,             /* bfd_neighbor  */
  YYSYMBOL_cmd_SHOW_BFD_SESSIONS = 837,    /* cmd_SHOW_BFD_SESSIONS  */
  YYSYMBOL_bgp_proto_start = 838,          /* bgp_proto_start  */
  YYSYMBOL_bgp_loc_opts = 839,             /* bgp_loc_opts  */
  YYSYMBOL_bgp_nbr_opts = 840,             /* bgp_nbr_opts  */
  YYSYMBOL_bgp_cease_mask = 841,           /* bgp_cease_mask  */
  YYSYMBOL_bgp_cease_list = 842,           /* bgp_cease_list  */
  YYSYMBOL_bgp_cease_flag = 843,           /* bgp_cease_flag  */
  YYSYMBOL_bgp_role_name = 844,            /* bgp_role_name  */
  YYSYMBOL_bgp_proto = 845,                /* bgp_proto  */
  YYSYMBOL_846_9 = 846,                    /* $@9  */
  YYSYMBOL_847_10 = 847,                   /* $@10  */
  YYSYMBOL_bgp_afi = 848,                  /* bgp_afi  */
  YYSYMBOL_bgp_channel_start = 849,        /* bgp_channel_start  */
  YYSYMBOL_bgp_nh = 850,                   /* bgp_nh  */
  YYSYMBOL_bgp_lladdr = 851,               /* bgp_lladdr  */
  YYSYMBOL_bgp_channel_item = 852,         /* bgp_channel_item  */
  YYSYMBOL_bgp_channel_opts = 853,         /* bgp_channel_opts  */
  YYSYMBOL_bgp_channel_opt_list = 854,     /* bgp_channel_opt_list  */
  YYSYMBOL_bgp_channel_end = 855,          /* bgp_channel_end  */
  YYSYMBOL_bgp_proto_channel = 856,        /* bgp_proto_channel  */
  YYSYMBOL_mrt_proto_start = 857,          /* mrt_proto_start  */
  YYSYMBOL_mrt_proto_item = 858,           /* mrt_proto_item  */
  YYSYMBOL_mrt_proto_opts = 859,           /* mrt_proto_opts  */
  YYSYMBOL_mrt_proto = 860,                /* mrt_proto  */
  YYSYMBOL_cmd_MRT_DUMP = 861,             /* cmd_MRT_DUMP  */
  YYSYMBOL_mrt_dump_args = 862,            /* mrt_dump_args  */
  YYSYMBOL_ospf_variant = 863,             /* ospf_variant  */
  YYSYMBOL_ospf_proto_start = 864,         /* ospf_proto_start  */
  YYSYMBOL_ospf_proto = 865,               /* ospf_proto  */
  YYSYMBOL_ospf_af_mc = 866,               /* ospf_af_mc  */
  YYSYMBOL_ospf_channel_start = 867,       /* ospf_channel_start  */
  YYSYMBOL_ospf_channel = 868,             /* ospf_channel  */
  YYSYMBOL_ospf_proto_item = 869,          /* ospf_proto_item  */
  YYSYMBOL_ospf_area_start = 870,          /* ospf_area_start  */
  YYSYMBOL_ospf_area = 871,                /* ospf_area  */
  YYSYMBOL_ospf_area_opts = 872,           /* ospf_area_opts  */
  YYSYMBOL_ospf_area_item = 873,           /* ospf_area_item  */
  YYSYMBOL_874_11 = 874,                   /* $@11  */
  YYSYMBOL_875_12 = 875,                   /* $@12  */
  YYSYMBOL_ospf_stubnet = 876,             /* ospf_stubnet  */
  YYSYMBOL_ospf_stubnet_start = 877,       /* ospf_stubnet_start  */
  YYSYMBOL_ospf_stubnet_opts = 878,        /* ospf_stubnet_opts  */
  YYSYMBOL_ospf_stubnet_item = 879,        /* ospf_stubnet_item  */
  YYSYMBOL_ospf_vlink = 880,               /* ospf_vlink  */
  YYSYMBOL_ospf_vlink_opts = 881,          /* ospf_vlink_opts  */
  YYSYMBOL_ospf_vlink_item = 882,          /* ospf_vlink_item  */
  YYSYMBOL_ospf_vlink_start = 883,         /* ospf_vlink_start  */
  YYSYMBOL_ospf_iface_item = 884,          /* ospf_iface_item  */
  YYSYMBOL_pref_list = 885,                /* pref_list  */
  YYSYMBOL_pref_item = 886,                /* pref_item  */
  YYSYMBOL_pref_base = 887,                /* pref_base  */
  YYSYMBOL_pref_opt = 888,                 /* pref_opt  */
  YYSYMBOL_nbma_list = 889,                /* nbma_list  */
  YYSYMBOL_nbma_eligible = 890,            /* nbma_eligible  */
  YYSYMBOL_nbma_item = 891,                /* nbma_item  */
  YYSYMBOL_ospf_iface_start = 892,         /* ospf_iface_start  */
  YYSYMBOL_ospf_instance_id = 893,         /* ospf_instance_id  */
  YYSYMBOL_ospf_iface_patt_list = 894,     /* ospf_iface_patt_list  */
  YYSYMBOL_895_13 = 895,                   /* $@13  */
  YYSYMBOL_ospf_iface_opts = 896,          /* ospf_iface_opts  */
  YYSYMBOL_ospf_iface_opt_list = 897,      /* ospf_iface_opt_list  */
  YYSYMBOL_ospf_iface = 898,               /* ospf_iface  */
  YYSYMBOL_cmd_SHOW_OSPF = 899,            /* cmd_SHOW_OSPF  */
  YYSYMBOL_cmd_SHOW_OSPF_NEIGHBORS = 900,  /* cmd_SHOW_OSPF_NEIGHBORS  */
  YYSYMBOL_cmd_SHOW_OSPF_INTERFACE = 901,  /* cmd_SHOW_OSPF_INTERFACE  */
  YYSYMBOL_cmd_SHOW_OSPF_TOPOLOGY = 902,   /* cmd_SHOW_OSPF_TOPOLOGY  */
  YYSYMBOL_cmd_SHOW_OSPF_TOPOLOGY_ALL = 903, /* cmd_SHOW_OSPF_TOPOLOGY_ALL  */
  YYSYMBOL_cmd_SHOW_OSPF_STATE = 904,      /* cmd_SHOW_OSPF_STATE  */
  YYSYMBOL_cmd_SHOW_OSPF_STATE_ALL = 905,  /* cmd_SHOW_OSPF_STATE_ALL  */
  YYSYMBOL_cmd_SHOW_OSPF_LSADB = 906,      /* cmd_SHOW_OSPF_LSADB  */
  YYSYMBOL_lsadb_args = 907,               /* lsadb_args  */
  YYSYMBOL_perf_proto_start = 908,         /* perf_proto_start  */
  YYSYMBOL_perf_proto = 909,               /* perf_proto  */
  YYSYMBOL_perf_proto_item = 910,          /* perf_proto_item  */
  YYSYMBOL_pipe_proto_start = 911,         /* pipe_proto_start  */
  YYSYMBOL_912_14 = 912,                   /* $@14  */
  YYSYMBOL_pipe_proto = 913,               /* pipe_proto  */
  YYSYMBOL_radv_proto_start = 914,         /* radv_proto_start  */
  YYSYMBOL_radv_proto_item = 915,          /* radv_proto_item  */
  YYSYMBOL_916_15 = 916,                   /* $@15  */
  YYSYMBOL_917_16 = 917,                   /* $@16  */
  YYSYMBOL_radv_proto_opts = 918,          /* radv_proto_opts  */
  YYSYMBOL_radv_proto = 919,               /* radv_proto  */
  YYSYMBOL_radv_iface_start = 920,         /* radv_iface_start  */
  YYSYMBOL_radv_iface_item = 921,          /* radv_iface_item  */
  YYSYMBOL_922_17 = 922,                   /* $@17  */
  YYSYMBOL_923_18 = 923,                   /* $@18  */
  YYSYMBOL_radv_preference = 924,          /* radv_preference  */
  YYSYMBOL_radv_iface_finish = 925,        /* radv_iface_finish  */
  YYSYMBOL_radv_iface_opts = 926,          /* radv_iface_opts  */
  YYSYMBOL_radv_iface_opt_list = 927,      /* radv_iface_opt_list  */
  YYSYMBOL_radv_iface = 928,               /* radv_iface  */
  YYSYMBOL_radv_prefix_start = 929,        /* radv_prefix_start  */
  YYSYMBOL_radv_prefix_item = 930,         /* radv_prefix_item  */
  YYSYMBOL_radv_prefix_finish = 931,       /* radv_prefix_finish  */
  YYSYMBOL_radv_prefix_opts = 932,         /* radv_prefix_opts  */
  YYSYMBOL_radv_prefix_opt_list = 933,     /* radv_prefix_opt_list  */
  YYSYMBOL_radv_prefix = 934,              /* radv_prefix  */
  YYSYMBOL_radv_rdnss_node = 935,          /* radv_rdnss_node  */
  YYSYMBOL_radv_rdnss_start = 936,         /* radv_rdnss_start  */
  YYSYMBOL_radv_rdnss_item = 937,          /* radv_rdnss_item  */
  YYSYMBOL_radv_rdnss_finish = 938,        /* radv_rdnss_finish  */
  YYSYMBOL_radv_rdnss_opts = 939,          /* radv_rdnss_opts  */
  YYSYMBOL_radv_rdnss = 940,               /* radv_rdnss  */
  YYSYMBOL_radv_dnssl_node = 941,          /* radv_dnssl_node  */
  YYSYMBOL_radv_dnssl_start = 942,         /* radv_dnssl_start  */
  YYSYMBOL_radv_dnssl_item = 943,          /* radv_dnssl_item  */
  YYSYMBOL_radv_dnssl_finish = 944,        /* radv_dnssl_finish  */
  YYSYMBOL_radv_dnssl_opts = 945,          /* radv_dnssl_opts  */
  YYSYMBOL_radv_dnssl = 946,               /* radv_dnssl  */
  YYSYMBOL_radv_mult = 947,                /* radv_mult  */
  YYSYMBOL_radv_sensitive = 948,           /* radv_sensitive  */
  YYSYMBOL_rip_variant = 949,              /* rip_variant  */
  YYSYMBOL_rip_proto_start = 950,          /* rip_proto_start  */
  YYSYMBOL_rip_proto_item = 951,           /* rip_proto_item  */
  YYSYMBOL_rip_proto_opts = 952,           /* rip_proto_opts  */
  YYSYMBOL_rip_proto = 953,                /* rip_proto  */
  YYSYMBOL_rip_iface_start = 954,          /* rip_iface_start  */
  YYSYMBOL_rip_iface_finish = 955,         /* rip_iface_finish  */
  YYSYMBOL_rip_iface_item = 956,           /* rip_iface_item  */
  YYSYMBOL_rip_auth = 957,                 /* rip_auth  */
  YYSYMBOL_rip_iface_opts = 958,           /* rip_iface_opts  */
  YYSYMBOL_rip_iface_opt_list = 959,       /* rip_iface_opt_list  */
  YYSYMBOL_rip_iface = 960,                /* rip_iface  */
  YYSYMBOL_cmd_SHOW_RIP_INTERFACES = 961,  /* cmd_SHOW_RIP_INTERFACES  */
  YYSYMBOL_cmd_SHOW_RIP_NEIGHBORS = 962,   /* cmd_SHOW_RIP_NEIGHBORS  */
  YYSYMBOL_rpki_proto_start = 963,         /* rpki_proto_start  */
  YYSYMBOL_rpki_proto = 964,               /* rpki_proto  */
  YYSYMBOL_rpki_proto_opts = 965,          /* rpki_proto_opts  */
  YYSYMBOL_rpki_proto_item = 966,          /* rpki_proto_item  */
  YYSYMBOL_rpki_keep_interval = 967,       /* rpki_keep_interval  */
  YYSYMBOL_rpki_proto_item_port = 968,     /* rpki_proto_item_port  */
  YYSYMBOL_rpki_cache_addr = 969,          /* rpki_cache_addr  */
  YYSYMBOL_rpki_transport = 970,           /* rpki_transport  */
  YYSYMBOL_rpki_transport_tcp_init = 971,  /* rpki_transport_tcp_init  */
  YYSYMBOL_rpki_transport_ssh_init = 972,  /* rpki_transport_ssh_init  */
  YYSYMBOL_rpki_transport_ssh_opts = 973,  /* rpki_transport_ssh_opts  */
  YYSYMBOL_rpki_transport_ssh_item = 974,  /* rpki_transport_ssh_item  */
  YYSYMBOL_rpki_transport_ssh_check = 975, /* rpki_transport_ssh_check  */
  YYSYMBOL_static_proto_start = 976,       /* static_proto_start  */
  YYSYMBOL_static_proto = 977,             /* static_proto  */
  YYSYMBOL_stat_nexthop = 978,             /* stat_nexthop  */
  YYSYMBOL_stat_nexthops = 979,            /* stat_nexthops  */
  YYSYMBOL_stat_route0 = 980,              /* stat_route0  */
  YYSYMBOL_stat_route = 981,               /* stat_route  */
  YYSYMBOL_stat_route_item = 982,          /* stat_route_item  */
  YYSYMBOL_stat_route_opts = 983,          /* stat_route_opts  */
  YYSYMBOL_stat_route_opt_list = 984,      /* stat_route_opt_list  */
  YYSYMBOL_cmd_SHOW_STATIC = 985,          /* cmd_SHOW_STATIC  */
  YYSYMBOL_kern_proto = 986,               /* kern_proto  */
  YYSYMBOL_kern_sys_item = 987,            /* kern_sys_item  */
  YYSYMBOL_log_begin = 988,                /* log_begin  */
  YYSYMBOL_log_config = 989,               /* log_config  */
  YYSYMBOL_syslog_name = 990,              /* syslog_name  */
  YYSYMBOL_log_limit = 991,                /* log_limit  */
  YYSYMBOL_log_file = 992,                 /* log_file  */
  YYSYMBOL_log_mask = 993,                 /* log_mask  */
  YYSYMBOL_log_mask_list = 994,            /* log_mask_list  */
  YYSYMBOL_log_cat = 995,                  /* log_cat  */
  YYSYMBOL_mrtdump_base = 996,             /* mrtdump_base  */
  YYSYMBOL_debug_unix = 997,               /* debug_unix  */
  YYSYMBOL_cmd_CONFIGURE = 998,            /* cmd_CONFIGURE  */
  YYSYMBOL_cmd_CONFIGURE_SOFT = 999,       /* cmd_CONFIGURE_SOFT  */
  YYSYMBOL_cmd_CONFIGURE_CONFIRM = 1000,   /* cmd_CONFIGURE_CONFIRM  */
  YYSYMBOL_cmd_CONFIGURE_UNDO = 1001,      /* cmd_CONFIGURE_UNDO  */
  YYSYMBOL_cmd_CONFIGURE_STATUS = 1002,    /* cmd_CONFIGURE_STATUS  */
  YYSYMBOL_cmd_CONFIGURE_CHECK = 1003,     /* cmd_CONFIGURE_CHECK  */
  YYSYMBOL_cmd_DOWN = 1004,                /* cmd_DOWN  */
  YYSYMBOL_cmd_GRACEFUL_RESTART = 1005,    /* cmd_GRACEFUL_RESTART  */
  YYSYMBOL_cfg_name = 1006,                /* cfg_name  */
  YYSYMBOL_cfg_timeout = 1007,             /* cfg_timeout  */
  YYSYMBOL_kern_proto_start = 1008,        /* kern_proto_start  */
  YYSYMBOL_kern_mp_limit = 1009,           /* kern_mp_limit  */
  YYSYMBOL_kern_item = 1010,               /* kern_item  */
  YYSYMBOL_kif_proto_start = 1011,         /* kif_proto_start  */
  YYSYMBOL_kif_proto = 1012,               /* kif_proto  */
  YYSYMBOL_kif_item = 1013,                /* kif_item  */
  YYSYMBOL_kif_iface_start = 1014,         /* kif_iface_start  */
  YYSYMBOL_kif_iface_item = 1015,          /* kif_iface_item  */
  YYSYMBOL_kif_iface_opts = 1016,          /* kif_iface_opts  */
  YYSYMBOL_kif_iface_opt_list = 1017,      /* kif_iface_opt_list  */
  YYSYMBOL_kif_iface = 1018                /* kif_iface  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
# define YYCOPY_NEEDED 1
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  79
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   6259

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  580
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  439
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1483
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  2724

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   813


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    38,     2,     2,     2,    37,     2,     2,
      53,    54,    35,    33,    78,    34,    39,    36,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   160,    52,
      29,    28,    30,   163,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   161,     2,   162,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    79,     2,    80,    31,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    32,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   519,   520,   521,   522,   523,   524,   525,
     526,   527,   528,   529,   530,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   137,   137,   138,   141,   143,   146,   151,   154,   162,
     163,   164,   170,   171,   172,   175,   175,   180,   181,   182,
     183,   184,   185,   192,   193,   194,   201,   202,   209,   215,
     225,   238,   257,   263,   269,   277,   285,   291,   291,   292,
     292,   293,   293,   296,   297,   298,   299,   300,   301,   308,
     309,   317,   318,   326,   327,   335,   336,   344,   345,   346,
     347,   348,   358,   366,   367,   376,   384,   385,   392,   393,
      37,    38,    39,    40,    41,    42,    43,    44,    48,    49,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      65,    66,    67,    70,    71,    75,    79,    83,    84,    88,
      92,   101,   102,   106,   110,   114,   121,   122,   126,   127,
     128,   129,   133,   136,   139,   145,   149,   150,   151,   155,
     159,   165,   166,   167,   170,   172,   175,   177,   181,   188,
     189,   191,   197,   203,   203,     9,     9,    10,    10,    11,
      11,   346,   348,   348,   358,   360,   363,   364,   368,   370,
     381,   383,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   435,   436,
     445,   446,   454,   455,   461,   464,   468,   468,   478,   485,
     491,   493,   497,   493,   521,   522,   525,   525,   527,   527,
     529,   537,   538,   555,   556,   569,   570,   571,   572,   573,
     577,   585,   586,   587,   588,   592,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   609,   610,   611,   612,
     616,   617,   618,   622,   623,   624,   625,   626,   627,   628,
     629,   634,   635,   636,   637,   638,   642,   643,   644,   645,
     646,   650,   651,   655,   656,   660,   661,   662,   663,   671,
     672,   675,   676,   684,   694,   695,   699,   703,   704,   705,
     706,   710,   711,   712,   713,   714,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   731,   732,   736,   737,   738,
     739,   744,   745,   746,   749,   768,   787,   788,   789,   790,
     791,   792,   793,   794,   795,   796,   797,   798,   802,   803,
     804,   805,   806,   807,   808,   809,   810,   811,   812,   813,
     814,   815,   816,   817,   818,   820,   821,   822,   824,   826,
     828,   829,   830,   831,   832,   833,   834,   835,   836,   837,
     838,   839,   840,   841,   842,   843,   844,   845,   855,   856,
     857,   858,   859,   860,   861,   862,   864,   865,   867,   871,
     875,   876,   877,   880,   881,   882,   891,   892,   896,   902,
     903,   907,   910,   913,   916,   922,   922,   916,   928,   940,
     944,   947,   952,   955,   966,   970,   973,   974,   978,   979,
     980,   981,   982,   983,   984,   988,   993,   994,   995,   159,
     162,   163,   167,   168,   169,   170,   180,   182,   184,   186,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     209,   211,   213,   218,   220,   224,   225,   230,   231,   232,
     233,   236,   238,   241,   243,   249,   252,   253,   257,   263,
     267,   277,   287,   289,   290,   291,   292,   293,   294,   295,
     299,   305,   310,   311,   312,   313,   314,   315,   316,   317,
     322,   323,   326,   328,   331,   333,   337,   344,   347,   350,
     351,   352,   353,   357,   358,   359,   360,   361,   365,   366,
     370,   373,   374,   375,   380,   383,   384,   385,   386,   390,
     391,   392,   393,   394,   395,   396,   397,   401,   408,   416,
     417,   421,   422,   426,   431,   432,   436,   438,   446,   450,
     451,   456,   458,   465,   466,   467,   468,   469,   473,   481,
     487,   488,   489,   493,   494,   498,   499,   500,   501,   502,
     503,   509,   510,   511,   515,   516,   520,   521,   527,   531,
     532,   535,   537,   541,   542,   545,   545,   548,   549,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   565,   566,
     567,   568,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   582,   590,   591,   592,   593,   594,   595,   596,
     599,   601,   605,   611,   611,   614,   614,   617,   617,   620,
     620,   624,   625,   628,   628,   631,   631,   635,   635,   639,
     645,   651,   657,   664,   670,   677,   682,   687,   692,   697,
     701,   705,   709,   719,   726,   735,   739,   746,   750,   751,
     752,   753,   757,   761,   765,   779,   780,   781,   782,   785,
     786,   787,   788,   793,   794,   795,   796,   797,   798,   799,
     800,   801,   802,   803,   804,   805,   806,   807,   808,   809,
     810,   811,   812,   816,   826,   826,   830,   833,   834,   835,
     836,   837,   838,   843,   843,   845,   845,   847,   847,   849,
     849,   851,   851,   853,   853,   855,   855,   857,   857,   859,
     859,   862,   862,   866,   866,   872,   873,   874,   878,   879,
     885,   885,   887,   887,   889,   889,   891,   891,   893,   893,
     895,   895,   899,   899,   903,   904,   908,   908,   911,   911,
     915,   916,   917,   921,   922,   923,   926,    35,    37,    47,
      48,    49,    50,    51,    52,    55,    57,    61,    65,    66,
      67,    68,    72,    76,    80,    94,   114,   115,   116,   117,
     118,   119,   120,   121,   125,   126,   127,   128,   129,   130,
     133,   135,   138,   140,   144,   147,   152,   153,   154,   158,
     159,   163,   164,   167,   186,   186,    32,    34,    42,    43,
      44,    45,    48,    50,    54,    58,    74,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   152,   154,   157,   159,
     164,   166,   170,   170,   173,   173,   176,   176,   179,   179,
      48,    50,    82,    84,    85,    88,    90,    91,    92,    93,
      98,    99,   103,   104,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   120,   121,   122,   123,   124,   128,   129,
     130,   131,   132,   136,   137,   143,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   210,   210,   211,   212,   213,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     231,   257,   258,   259,   261,   261,   261,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   302,   314,   316,   319,   321,   325,   332,   335,   337,
     339,   341,   343,   345,   347,   349,   351,   353,   355,   357,
     359,   361,    26,    28,    34,    35,    36,    37,    38,    39,
      40,    41,    44,    46,    50,    53,    53,    57,    58,    59,
      60,    61,    62,   211,   214,   215,   216,   219,   235,   236,
     240,   241,   245,   254,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   274,
     289,   292,   294,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   307,   308,   308,   309,   310,   311,   315,
     316,   320,   328,   330,   334,   335,   336,   340,   341,   344,
     346,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   362,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   415,   416,   417,
     418,   419,   422,   424,   427,   429,   437,   439,   440,   443,
     445,   449,   450,   453,   463,   485,   487,   491,   491,   494,
     496,   499,   501,   505,   508,   509,   510,   511,   514,   514,
     517,   517,   520,   520,   525,   525,   528,   528,   533,   533,
     536,   536,   540,   540,   549,   552,   553,   554,   555,   556,
     557,   558,   559,    24,    26,    40,    41,    42,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    23,    26,
      25,    40,    41,    42,    43,    44,    46,    58,    59,    60,
      61,    62,    62,    63,    63,    64,    65,    68,    70,    74,
      78,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   116,   120,   121,   122,   123,   124,   125,   125,
     126,   126,   127,   128,   132,   133,   134,   137,   175,   177,
     180,   182,   186,   189,   201,   202,   203,   204,   208,   215,
     223,   225,   228,   230,   234,   238,   248,   253,   254,   255,
     259,   271,   273,   277,   278,   282,   295,   300,   301,   302,
     306,   318,   320,   324,   325,   330,   331,   335,   336,   339,
     340,    46,    49,    50,    53,    67,    68,    69,    70,    71,
      72,    75,    77,    81,    85,   110,   140,   141,   142,   143,
     144,   145,   146,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   173,   174,   175,   176,   179,   181,   184,
     186,   190,   193,   194,   198,   198,   201,   201,    41,    43,
      50,    52,    54,    58,    59,    60,    61,    62,    63,    64,
      70,    76,    82,    86,    87,    90,    93,    97,   108,   109,
     113,   120,   130,   132,   136,   137,   138,   142,    54,    56,
      63,    64,    65,    66,    67,    75,    79,    84,    89,    92,
      95,    99,   105,   106,   109,   121,   122,   126,   131,   132,
     133,   134,   135,   136,   140,   149,   151,   154,   156,   160,
     160,    23,    26,    27,    28,    31,    32,    33,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    62,    63,    31,    33,    35,    42,    43,    46,    48,
      52,    62,    63,    67,    68,    72,    73,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    89,    92,    93,   104,
     107,   108,   109,   110,   118,   118,   121,   121,   128,   128,
     131,   131,   134,   134,   137,   137,   140,   140,   145,   145,
     150,   151,   155,   156,   157,    41,    43,    48,    49,    52,
      53,    57,    58,    59,    60,    64,    71,    72,    83,    85,
      88,    89,    92,    93,    94,   101,   108,   111,   113,   116,
     118,   122,   125,   126
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "QUIT", "EXIT", "HELP",
  "END", "CLI_MARKER", "INVALID_TOKEN", "ELSECOL", "DDOT", "GEQ", "LEQ",
  "NEQ", "AND", "OR", "PO", "PC", "NUM", "ENUM", "IP4", "IP6", "VPN_RD",
  "CF_SYM_KNOWN", "CF_SYM_UNDEFINED", "TEXT", "BYTESTRING", "PREFIX_DUMMY",
  "'='", "'<'", "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'",
  "'!'", "'.'", "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US",
  "PORT", "VPN", "MPLS", "FROM", "';'", "'('", "')'", "FLOW4", "FLOW6",
  "DST", "SRC", "PROTO", "NEXT", "HEADER", "DPORT", "SPORT", "ICMP",
  "TYPE", "CODE", "TCP", "FLAGS", "LENGTH", "DSCP", "DONT_FRAGMENT",
  "IS_FRAGMENT", "FIRST_FRAGMENT", "LAST_FRAGMENT", "FRAGMENT", "LABEL",
  "OFFSET", "','", "'{'", "'}'", "FUNCTION", "PRINT", "PRINTN", "UNSET",
  "RETURN", "ACCEPT", "REJECT", "ERROR", "INT", "BOOL", "IP", "PREFIX",
  "RD", "PAIR", "QUAD", "EC", "LC", "SET", "STRING", "BGPMASK", "BGPPATH",
  "CLIST", "ECLIST", "LCLIST", "IF", "THEN", "ELSE", "CASE", "FOR", "IN",
  "DO", "TRUE", "FALSE", "RT", "RO", "UNKNOWN", "GENERIC", "GW", "NET",
  "MASK", "SOURCE", "SCOPE", "DEST", "IFNAME", "IFINDEX", "WEIGHT",
  "GW_MPLS", "PREFERENCE", "ROA_CHECK", "ASN", "IS_V4", "IS_V6", "LEN",
  "MAXLEN", "DATA", "DATA1", "DATA2", "DEFINED", "ADD", "DELETE",
  "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED",
  "MATCH", "MIN", "MAX", "EMPTY", "FILTER", "WHERE", "EVAL", "ATTRIBUTE",
  "BT_ASSERT", "BT_TEST_SUITE", "BT_CHECK_ASSIGN", "BT_TEST_SAME",
  "FORMAT", "':'", "'['", "']'", "'?'", "ROUTER", "ID", "HOSTNAME",
  "PROTOCOL", "TEMPLATE", "DISABLED", "DEBUG", "ALL", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "NONE", "VRF", "DEFAULT", "TABLE",
  "STATES", "ROUTES", "FILTERS", "IPV4", "IPV6", "VPN4", "VPN6", "ROA4",
  "ROA6", "SADR", "RECEIVE", "LIMIT", "ACTION", "WARN", "BLOCK", "RESTART",
  "DISABLE", "KEEP", "FILTERED", "RPKI", "PASSWORD", "KEY", "PASSIVE",
  "TO", "EVENTS", "PACKETS", "PROTOCOLS", "CHANNELS", "INTERFACES",
  "ALGORITHM", "KEYED", "HMAC", "MD5", "SHA1", "SHA256", "SHA384",
  "SHA512", "BLAKE2S128", "BLAKE2S256", "BLAKE2B256", "BLAKE2B512",
  "PRIMARY", "STATS", "COUNT", "BY", "COMMANDS", "PREEXPORT", "NOEXPORT",
  "EXPORTED", "GENERATE", "BGP", "PASSWORDS", "DESCRIPTION", "RELOAD",
  "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC",
  "CLASS", "TIMEFORMAT", "ISO", "SHORT", "LONG", "ROUTE", "BASE", "LOG",
  "GRACEFUL", "WAIT", "FLUSH", "AS", "IDLE", "RX", "TX", "INTERVAL",
  "MULTIPLIER", "CHECK", "LINK", "SORTED", "TRIE", "SETTLE", "TIME", "GC",
  "THRESHOLD", "PERIOD", "IPV4_MC", "IPV4_MPLS", "IPV6_MC", "IPV6_MPLS",
  "IPV6_SADR", "VPN4_MC", "VPN4_MPLS", "VPN6_MC", "VPN6_MPLS", "PRI",
  "SEC", "SHOW", "STATUS", "SUMMARY", "SYMBOLS", "DUMP", "RESOURCES",
  "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "ECHO", "ENABLE", "BABEL",
  "METRIC", "RXCOST", "HELLO", "UPDATE", "WIRED", "WIRELESS", "BUFFER",
  "PRIORITY", "HOP", "BABEL_METRIC", "ENTRIES", "RANDOMIZE", "MAC",
  "PERMISSIVE", "BFD", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL",
  "AUTHENTICATION", "SIMPLE", "METICULOUS", "STRICT", "BIND", "SESSIONS",
  "HOLD", "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA", "SELF",
  "PATH", "START", "DELAY", "FORGET", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "BGP_LARGE_COMMUNITY", "ADDRESS", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "CAPABILITIES", "PREFER",
  "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH", "INTERPRET",
  "COMMUNITIES", "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST", "IGP", "GATEWAY",
  "RECURSIVE", "MED", "TTL", "SECURITY", "DETERMINISTIC", "SECONDARY",
  "ALLOW", "PATHS", "AWARE", "EXTENDED", "SETKEY", "CONFEDERATION",
  "MEMBER", "MULTICAST", "LIVED", "STALE", "IBGP", "EBGP", "MANDATORY",
  "INTERNAL", "EXTERNAL", "SETS", "DYNAMIC", "RANGE", "NAME", "DIGITS",
  "BGP_AIGP", "AIGP", "ORIGINATE", "COST", "ENFORCE", "FREE", "VALIDATE",
  "ROLE", "ROLES", "PEER", "PROVIDER", "CUSTOMER", "RS_SERVER",
  "RS_CLIENT", "REQUIRE", "BGP_OTC", "GLOBAL", "CEASE", "HIT",
  "ADMINISTRATIVE", "SHUTDOWN", "CONFIGURATION", "CHANGE", "DECONFIGURED",
  "CONNECTION", "REJECTED", "COLLISION", "OF", "MRT", "FILENAME", "ALWAYS",
  "OSPF", "V2", "V3", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG",
  "OSPF_ROUTER_ID", "AREA", "RFC1583COMPAT", "STUB", "TICK", "COST2",
  "RETRANSMIT", "TRANSMIT", "DEAD", "BROADCAST", "BCAST", "NONBROADCAST",
  "NBMA", "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "ONLY", "LARGE", "NORMAL", "STUBNET", "TAG", "LSADB", "ECMP", "NSSA",
  "TRANSLATOR", "STABILITY", "LSID", "INSTANCE", "REAL", "NETMASK",
  "MERGE", "LSA", "SUPPRESSION", "RFC5838", "PE", "TOPOLOGY", "STATE",
  "PERF", "EXP", "REPEAT", "MODE", "PIPE", "RADV", "RA", "SOLICITED",
  "UNICAST", "MANAGED", "OTHER", "CONFIG", "LINGER", "MTU", "REACHABLE",
  "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT", "LIFETIME",
  "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS", "DOMAIN",
  "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH", "PROPAGATE",
  "RA_PREFERENCE", "RA_LIFETIME", "RIP", "NG", "INFINITY", "TIMEOUT",
  "GARBAGE", "VERSION", "SPLIT", "HORIZON", "POISON", "REVERSE", "ZERO",
  "PLAINTEXT", "DEMAND", "CIRCUIT", "RIP_METRIC", "RIP_TAG", "REMOTE",
  "BIRD", "PRIVATE", "PUBLIC", "SSH", "TRANSPORT", "USER", "EXPIRE",
  "STATIC", "PROHIBIT", "BLACKHOLE", "UNREACHABLE", "KERNEL", "NETLINK",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "SYSLOG",
  "TRACE", "INFO", "WARNING", "AUTH", "FATAL", "BUG", "STDERR", "SOFT",
  "CONFIRM", "UNDO", "LATENCY", "WATCHDOG", "CONFIGURE", "DOWN", "PERSIST",
  "SCAN", "LEARN", "DEVICE", "KRT_SOURCE", "KRT_METRIC", "$accept",
  "cli_cmd", "cmd_QUIT", "cmd_EXIT", "cmd_HELP", "config", "conf_entries",
  "conf", "definition", "expr", "expr_us", "symbol", "bool", "ipa",
  "ipa_scope", "pxlen4", "net_ip4_", "net_ip6_", "net_ip6_sadr_",
  "net_vpn4_", "net_vpn6_", "net_roa4_", "net_roa6_", "net_mpls_",
  "net_ip_", "net_vpn_", "net_roa_", "net_", "net_ip4", "net_ip6",
  "net_ip", "net_any", "net_or_ipa", "label_stack_start", "label_stack",
  "time", "text", "opttext", "flow_num_op", "flow_logic_op",
  "flow_num_type_", "flow_num_type", "flow_flag_type", "flow_frag_type",
  "flow_srcdst", "flow_num_opts", "flow_num_opt_ext_expr",
  "flow_num_opt_ext", "flow_bmk_opts", "flow_neg", "flow_frag_val",
  "flow_frag_opts", "flow4_item", "flow6_item", "flow4_opts", "flow6_opts",
  "flow_builder_init", "flow_builder_set_ipv4", "flow_builder_set_ipv6",
  "net_flow4_", "net_flow6_", "net_flow_", "filter_def", "$@1",
  "filter_eval", "custom_attr", "bt_test_suite", "bt_test_same", "type",
  "function_argsn", "function_args", "function_vars", "filter_body",
  "filter", "$@2", "where_filter", "function_body", "function_def", "$@3",
  "$@4", "cmds", "cmds_scoped", "$@5", "cmd_var", "cmd_prep", "cmds_int",
  "fipa", "set_atom", "switch_atom", "cnum", "pair_item", "ec_kind",
  "ec_item", "lc_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix", "fprefix_set", "switch_body", "bgp_path_expr",
  "bgp_path", "bgp_path_tail", "constant", "constructor", "var_list",
  "function_call", "symbol_value", "static_attr", "term", "break_command",
  "print_list", "var_init", "var", "for_var", "cmd", "$@6", "$@7", "$@8",
  "get_cf_position", "lvalue", "rtrid", "idval", "hostname_override",
  "gr_opts", "net_type", "table", "table_start", "table_sorted",
  "table_opt", "table_opts", "table_opt_list", "proto_start", "proto_name",
  "proto_item", "channel_start", "channel_item_", "channel_item",
  "channel_opts", "channel_opt_list", "channel_end", "proto_channel",
  "rtable", "imexport", "limit_action", "limit_spec", "debug_default",
  "timeformat_which", "timeformat_spec", "timeformat_base",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "proto", "dev_proto_start",
  "dev_proto", "dev_iface_init", "dev_iface_patt", "debug_mask",
  "debug_list", "debug_flag", "mrtdump_mask", "mrtdump_list",
  "mrtdump_flag", "password_list", "password_list_body", "password_items",
  "password_item", "pass_key", "password_item_begin",
  "password_item_params", "password_algorithm", "password_item_end",
  "bfd_item", "bfd_items", "bfd_opts", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optproto", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "r_args_for", "r_args_for_val",
  "export_mode", "channel_sym", "channel_arg", "cmd_SHOW_SYMBOLS",
  "sym_args", "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_DUMP_FILTER_ALL",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "debug_args", "cmd_MRTDUMP",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "dynamic_attr",
  "babel_proto_start", "babel_proto_item", "babel_proto_opts",
  "babel_proto", "babel_iface_start", "babel_iface_finish",
  "babel_iface_item", "babel_iface_opts", "babel_iface_opt_list",
  "babel_iface", "cmd_SHOW_BABEL_INTERFACES", "cmd_SHOW_BABEL_NEIGHBORS",
  "cmd_SHOW_BABEL_ENTRIES", "cmd_SHOW_BABEL_ROUTES", "bfd_proto_start",
  "bfd_proto_item", "bfd_proto_opts", "bfd_proto", "bfd_accept_item",
  "bfd_accept", "bfd_iface_start", "bfd_iface_finish", "bfd_iface_item",
  "bfd_auth_type", "bfd_iface_opts", "bfd_iface_opt_list", "bfd_iface",
  "bfd_multihop", "bfd_neigh_iface", "bfd_neigh_local",
  "bfd_neigh_multihop", "bfd_neighbor", "cmd_SHOW_BFD_SESSIONS",
  "bgp_proto_start", "bgp_loc_opts", "bgp_nbr_opts", "bgp_cease_mask",
  "bgp_cease_list", "bgp_cease_flag", "bgp_role_name", "bgp_proto", "$@9",
  "$@10", "bgp_afi", "bgp_channel_start", "bgp_nh", "bgp_lladdr",
  "bgp_channel_item", "bgp_channel_opts", "bgp_channel_opt_list",
  "bgp_channel_end", "bgp_proto_channel", "mrt_proto_start",
  "mrt_proto_item", "mrt_proto_opts", "mrt_proto", "cmd_MRT_DUMP",
  "mrt_dump_args", "ospf_variant", "ospf_proto_start", "ospf_proto",
  "ospf_af_mc", "ospf_channel_start", "ospf_channel", "ospf_proto_item",
  "ospf_area_start", "ospf_area", "ospf_area_opts", "ospf_area_item",
  "$@11", "$@12", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@13", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "perf_proto_start", "perf_proto", "perf_proto_item",
  "pipe_proto_start", "$@14", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@15", "$@16", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@17", "$@18", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_variant", "rip_proto_start", "rip_proto_item", "rip_proto_opts",
  "rip_proto", "rip_iface_start", "rip_iface_finish", "rip_iface_item",
  "rip_auth", "rip_iface_opts", "rip_iface_opt_list", "rip_iface",
  "cmd_SHOW_RIP_INTERFACES", "cmd_SHOW_RIP_NEIGHBORS", "rpki_proto_start",
  "rpki_proto", "rpki_proto_opts", "rpki_proto_item", "rpki_keep_interval",
  "rpki_proto_item_port", "rpki_cache_addr", "rpki_transport",
  "rpki_transport_tcp_init", "rpki_transport_ssh_init",
  "rpki_transport_ssh_opts", "rpki_transport_ssh_item",
  "rpki_transport_ssh_check", "static_proto_start", "static_proto",
  "stat_nexthop", "stat_nexthops", "stat_route0", "stat_route",
  "stat_route_item", "stat_route_opts", "stat_route_opt_list",
  "cmd_SHOW_STATIC", "kern_proto", "kern_sys_item", "log_begin",
  "log_config", "syslog_name", "log_limit", "log_file", "log_mask",
  "log_mask_list", "log_cat", "mrtdump_base", "debug_unix",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_STATUS", "cmd_CONFIGURE_CHECK",
  "cmd_DOWN", "cmd_GRACEFUL_RESTART", "cfg_name", "cfg_timeout",
  "kern_proto_start", "kern_mp_limit", "kern_item", "kif_proto_start",
  "kif_proto", "kif_item", "kif_iface_start", "kif_iface_item",
  "kif_iface_opts", "kif_iface_opt_list", "kif_iface", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-2330)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-893)

#define yytable_value_is_error(Yyn) \
  ((Yyn) == YYTABLE_NINF)

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     249,   165,   274,    62,   219,   403,   412,  4338,   234,   261,
     261,   593,   261,   435,   116,   936,  1395,   221,   261,    92,
      11,   441, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330,   926, -2330, -2330, -2330, -2330,   926,   926,  4338,  3034,
     485,   571,   299,   872, -2330, -2330,   -66, -2330,   455, -2330,
   -2330, -2330, -2330,   140,   700, -2330,   463,   -89, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,   488,
   -2330,   416,   941, -2330, -2330, -2330,   832,  2466,   832, -2330,
     832, -2330,   832,  5862,   832, -2330,   832,  2082,   832,  1403,
     648,  1021,   832, -2330,   832, -2330,   832, -2330,   832,  2206,
    1122, -2330, -2330, -2330,   832,   832,   -31, -2330, -2330, -2330,
    1219, -2330, -2330,   742,   749,   969,   631, -2330,   604,   202,
    4338,   775, -2330,  2640,   735,   767, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,   800,
     808,   827,   852,   863,   883,   888,  1041, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330,   751,   814, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330,  2884, -2330,   933, -2330, -2330,   225,  1001,
     225, -2330,  1016,  1016,   261,   261,  1072,   544, -2330,  1075,
     325,    98,  1109, -2330,  1114, -2330,   498,   822,   159,   396,
    1116,   981,  1155,  1163,  1173,  1177,  1182,  1193,  1203,  1211,
   -2330,   -54, -2330,  1223,  1016, -2330, -2330,  1179,  1242,  1179,
    1254,  1281,   747, -2330, -2330, -2330,  1239, -2330, -2330,  4935,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330,   719,  1270,  1273,  1349, -2330,
   -2330,  1251,   225,   225,   669,  1084, -2330,   544,  1271, -2330,
   -2330, -2330, -2330,    94,  1284,    76,  1076,   669,   669,   926,
   -2330,  1265, -2330, -2330, -2330, -2330, -2330, -2330,   584, -2330,
   -2330, -2330,   838, -2330, -2330, -2330, -2330, -2330,  1333,  1311,
    1289, -2330,  1206,  1648,   225, -2330,   135,   872,   544,  1133,
   -2330,  1347,  1324,  1354,  1360,  1339,  1345,  1357, -2330, -2330,
   -2330,   432,  1097,   270,  1386,  1415,   706,    15,    65,    70,
      78,  1129,   872,  1648,  1086,  1277,  1202,   387,  1335,  1174,
     157,   167,  1156,  1215,   330,  1225,  1181,  1207,  1178,   718,
    1168,  1356,  1648,  1194,  1185,  1224,  1249,  1184,  1187,   413,
    1648,   113,  1169,  1398,  1237,  1164,  1500, -2330,  1479,  1507,
    1489,  1499,  1121, -2330,  1389,  1192,  1648,  1417,   669,  1648,
    1420,  1235,  1648,  1232, -2330,  1324, -2330,  1564,  1541, -2330,
    1547, -2330,  1648,   951,  1603,    79,  1612,   935,  1580, -2330,
    1581, -2330, -2330,   669,  1300,   768,  1624,  1462,  1421,  1476,
    1610,  1613,  1589,  1593,  1602,  1604, -2330,  1542,  1426,  1494,
    1633,  1635,    26,  1614, -2330,  1504,   669,  1330,  1516,  1447,
    1648,  1457,  1648, -2330, -2330,  1657,  1668,  1642,  1643, -2330,
   -2330,  1463, -2330,  1678,  1306, -2330,  1219,  1219,  4338,  1513,
    1219,  1219,  1726, -2330,  1731, -2330,  1746,   742,  1708, -2330,
   -2330,  4338,  1732,   251,  1736,  1727, -2330, -2330, -2330,  1759,
   -2330,  1707,  2320, -2330, -2330,  1624,  4338,  4338,  4338,  4338,
    4338,  4338, -2330, -2330,  1708, -2330, -2330,  2288, -2330, -2330,
   -2330,   771, -2330,  1778, -2330, -2330, -2330, -2330,    96, -2330,
     367,  1772,  1773, -2330,  4338,  4338,  4338,  4338,  4338,  4338,
    4338,  4338,  4338,  4338,  4338,  4338,  4338,  4338,  2791,  2307,
   -2330,   942, -2330, -2330, -2330, -2330, -2330,  1790,  1800,  1801,
    1804, -2330, -2330,   449, -2330,  1808, -2330, -2330, -2330,   887,
    1813, -2330,  1814, -2330,  4903, -2330,   834,  1116,  1116,  1116,
    1116,  1116, -2330,  1116,  1116, -2330,   134,   176,  1821,  1116,
    1116,  1823,  1824, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
     847, -2330, -2330,  1827,  1828,   608,  1830, -2330,   747, -2330,
   -2330,   669,  1831,  4338,  1756, -2330, -2330,  1786,  1761,  1764,
   -2330, -2330, -2330, -2330,  4338,  1791, -2330, -2330, -2330, -2330,
   -2330,  4338, -2330, -2330, -2330, -2330, -2330,   669, -2330, -2330,
    1792, -2330,   669,   950, -2330,  1466, -2330,   669,   172,   669,
     971, -2330, -2330, -2330, -2330, -2330, -2330, -2330,   832, -2330,
   -2330,  1826, -2330,  1192, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330,  1648, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
    1590,  1591,   673,  1596,  1605, -2330,  1799,   669,   669, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330,     3,  1805,  1812,
    -101,   273,  1648,  1515,  1648,  1630,  1819,  1820,  1794, -2330,
    1822, -2330, -2330, -2330,  1023,  1849,   334,  1247,  1849,   217,
    1648,   669,  1623,  1626,   669,  1627,  1648,  1629,  1648,  1733,
    1648,  1648,  1845,  1648,  1648,  1648,  1648,  1648,  1648,  1521,
    1649,  1648,  1851,  1648,  1852,    84,  1650,  1648,  1648, -2330,
   -2330, -2330, -2330, -2330, -2330,  1648,   726, -2330, -2330,  1648,
   -2330,  1716,   669,  1648, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330,   669,   669, -2330,  1890,  1892, -2330, -2330, -2330,
   -2330, -2330, -2330,  1888,  4338, -2330, -2330,   895,  1714, -2330,
   -2330,   895, -2330, -2330, -2330,   895,  1648,  1624, -2330, -2330,
   -2330, -2330, -2330, -2330,   749,   969, -2330, -2330, -2330,  1648,
    1624, -2330, -2330, -2330,  1145, -2330,   673, -2330, -2330, -2330,
      28,  1600, -2330,  1862,  1648, -2330,  1648,   669,  1625, -2330,
     669, -2330, -2330, -2330, -2330, -2330, -2330, -2330,   669, -2330,
    1903, -2330, -2330, -2330,  3550, -2330, -2330,  1219,   468, -2330,
   -2330, -2330, -2330,  1871,  1905,   210,  4935, -2330,  1775,  1894,
   -2330, -2330,  4338, -2330,  4338, -2330, -2330,   472,  3635,  2985,
    2997,  3080,  3272,  3664,  1853,   214,  1855,  3837, -2330, -2330,
    1908,  1740,  1803, -2330,   969, -2330,  1679,  1683,  1988,  1988,
    1988,  2017,  2017,  1988,  1988,  1988,  1988,  1988,  1226,  1226,
    1727,  1727, -2330, -2330, -2330, -2330, -2330,  1876, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330,   897, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330,   904, -2330, -2330,  1929, -2330,
   -2330, -2330,  1261,  1542,  1888,  1913, -2330,  1762,  1763,   191,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,  1915,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330,  1016,  1016,  1016,
    1016,  1934,  1016,  1016,   156,  1116,  1016,  1116,  1016, -2330,
    1016,  1016, -2330, -2330,   -54, -2330, -2330, -2330, -2330,  1888,
    1003,   872, -2330, -2330,  1937, -2330, -2330,  4402,  1893, -2330,
    4419, -2330, -2330, -2330,   872,  1925, -2330,  1897,  3922, -2330,
    3951, -2330, -2330,  1927,  1230,  1243,   872, -2330,   872, -2330,
     -54, -2330,  1898,  1902, -2330, -2330, -2330,   105, -2330, -2330,
   -2330,  1922, -2330,  1881,  1909,  1315, -2330,  1554,   990,   669,
     669,  1912,   669,   669, -2330,  1914,  1917,  1648,  1552, -2330,
   -2330,  1765,  1703,   669,  1918,  1919,  1920,  1648,  1921,  1648,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,   926, -2330,
     669, -2330,   669, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
    1926, -2330,   669, -2330,   669,  1933,  1936,   669,   669,  1938,
     669,  1939,   669,  1941,  1192,  1942,  1943, -2330,  1944,  1945,
    1946,  1952,  1953,  1955,  1648,  1183,  1956, -2330,  1958, -2330,
     669,  1960,  1648,  1961,  1962,  1864, -2330,   643, -2330,   669,
   -2330, -2330, -2330,   669, -2330, -2330, -2330,   585, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330,  4935, -2330,  1782, -2330,  1648,
   -2330, -2330, -2330,  1973,  1342,   810,   301,  1980,  1981, -2330,
    1849,  1931,  1949,   669,  1648,  1648,    28,  4981, -2330, -2330,
    1795, -2330,   669, -2330,  1881,  1910, -2330,  1219, -2330, -2330,
    1219,  2014, -2330, -2330,  4338,  2002,  2003,  3284,  3068, -2330,
   -2330, -2330,  4338, -2330,  4338,  4338,  4338,  4338, -2330,  2927,
    4338,  3214,  4338, -2330,  1899,  4338, -2330, -2330, -2330,  2023,
    2024,  4338,   942, -2330,   449, -2330, -2330,   742,   605,  1297,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330,  2021,  2021, -2330, -2330,   933, -2330,  2049,  2051,  2052,
    2054, -2330,  2055,  2056, -2330, -2330,  2046,  1192, -2330, -2330,
   -2330,  1192,  1192,  1016,  2059,  1016,  2060,  2061,  2067, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330,  3034, -2330,  4445,
     719,  2020,  1997,  1881, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330,   974, -2330, -2330, -2330,  1817,  1818,
    1648,  1648,  1056,  2028, -2330,  2058, -2330, -2330, -2330,   225,
   -2330,  2032, -2330, -2330,  1923, -2330, -2330,  2034, -2330, -2330,
   -2330, -2330,   673,  1776, -2330,  2037,  2012,  2040, -2330,  2041,
    2042, -2330, -2330,  2043,   569, -2330,  2047,   237,   669,  2050,
   -2330, -2330, -2330,  2057, -2330,  2062,   636,  2063,   591, -2330,
     634, -2330, -2330, -2330,   218, -2330, -2330, -2330, -2330,  2066,
    2068, -2330,  2074, -2330,  2075, -2330,  2076, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330,  2078, -2330,  2081, -2330, -2330,
    2084, -2330,  2087, -2330, -2330,  1806, -2330,  1737,  1485,  1256,
    1742,  1932,  1924,  1757,  1963,   -35,  1648,  2083,  1648,   166,
     669,  1648, -2330,  2089, -2330,  1888,  1070,   669,   872,  2006,
   -2330, -2330,  2094, -2330, -2330, -2330, -2330,   241,  1648, -2330,
     153, -2330,  1891,  1023, -2330,    82,  2098, -2330,  1700, -2330,
    1464, -2330, -2330, -2330, -2330,  1161, -2330, -2330, -2330,  1161,
    1974, -2330, -2330,  2104, -2330, -2330,  1648,   669, -2330, -2330,
    2105,   669, -2330,  1966,  2009,  1966,  1594,   -42,  1966, -2330,
   -2330,  2107, -2330, -2330, -2330, -2330,  1949, -2330, -2330,  2124,
   -2330, -2330, -2330,   259, -2330, -2330,  4338,  4338,  2111,  4338,
   -2330, -2330, -2330,  4338,  4338, -2330,  2112,  2113,  2115,  2140,
    4338, -2330,   686, -2330,   669, -2330, -2330, -2330, -2330, -2330,
   -2330,  2134,  4935,  2137, -2330,  4338, -2330,  4338,  2450,  2652,
    3355,  4124,  4209,  4238,  4646,   708,   664,  4935,  2099,   746,
     635,  2100,  2158,  3837, -2330, -2330,  4675, -2330, -2330,  2169,
     742,  1708,   933, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330,  2185, -2330,  2188, -2330, -2330,
   -2330,   719, -2330,   719,  2117, -2330, -2330,  4445, -2330, -2330,
    2146, -2330,  2181, -2330,  1940,  1947, -2330, -2330,   669,   669,
   -2330,  1045,  1291, -2330, -2330, -2330, -2330, -2330, -2330,  2035,
   -2330,   453, -2330, -2330,  2122, -2330,    49, -2330,  1648, -2330,
     669, -2330, -2330, -2330, -2330,  2015,  1798,  1807, -2330,     9,
    1809,   934,  1150, -2330, -2330,  2153,  2159,  2160, -2330, -2330,
   -2330, -2330,  1095,  1648, -2330,  1967,   669,   669,  2163, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330,   508,   996,  1648,  1648,   -45,  1624,  1648,   514,
    1624, -2330, -2330, -2330,  1928, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330,  1901, -2330, -2330, -2330,
     669,   669,  1648, -2330,  2144,   669, -2330,  2145,  1192, -2330,
   -2330,  2148,   669, -2330, -2330,   669,  2150, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330,  2152, -2330, -2330, -2330,   886,   411,
   -2330,  1648, -2330, -2330, -2330,  2044, -2330, -2330, -2330, -2330,
     669,  2165,   669, -2330, -2330, -2330,  2184, -2330, -2330, -2330,
     669, -2330,  2124,  2218,  4338,  2157,  4445,  3367,  2186,  2189,
    5424,  5415,  1769,  1848,  2500, -2330, -2330, -2330,  4338,  2190,
    4338,  1359, -2330,   -29,  2222,  2209,  4753,  4782, -2330, -2330,
   -2330, -2330,  2183, -2330, -2330,  1295,  2177, -2330, -2330, -2330,
   -2330, -2330, -2330,  1595,  2211,  2211,   812,  2195, -2330,  1595,
    2211,  2211,  1161,  2202,  4338, -2330, -2330, -2330, -2330, -2330,
    2220,  4338, -2330,  3501, -2330,  2223,  4338,  2247,  3788,  4075,
    2180, -2330, -2330, -2330, -2330,  1186,  2235, -2330, -2330, -2330,
    2210,   669,   669, -2330, -2330,   742,  1708, -2330, -2330, -2330,
   -2330,  2192,  1648, -2330, -2330, -2330, -2330, -2330,  2122, -2330,
   -2330,   926,   872,  1965, -2330,  2224,  1873,  1998, -2330, -2330,
   -2330, -2330, -2330, -2330,   569, -2330, -2330, -2330, -2330,  2026,
    2027, -2330,  2029, -2330, -2330, -2330,   199,   199,   673,  1880,
   -2330, -2330, -2330, -2330, -2330,  2088,  2025, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330,  1648,  1648,  1881,  2212, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330,  2214, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330,  2215,   669, -2330,  1648, -2330, -2330, -2330,  2216, -2330,
   -2330,  5679, -2330, -2330,  4338, -2330, -2330,  2234, -2330,  5088,
   -2330, -2330,   719,  2179,  4338,  5351,  5797, -2330,  5984,  2237,
    2243,  2244,  2246,  2248, -2330,   673,  2250, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330,  2289,   669,  1369, -2330,  2225, -2330,   801,
     669,  1680,   815, -2330, -2330, -2330, -2330,  1369,   801,   815,
    2228, -2330,  4900,  2258,  2261,   791,   736,  2262,   793,  2265,
    2266,   816,  2270,   833, -2330, -2330, -2330,  4338,  2267, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330,  1248, -2330, -2330, -2330,
     673,  1996, -2330, -2330, -2330, -2330,   669,   669,   669, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330,  1648,   669, -2330, -2330,
    1700, -2330, -2330,  1009,  1166,   -52,   382,    31, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
    2273,  2221,  1313, -2330, -2330,  4935, -2330, -2330, -2330, -2330,
   -2330, -2330,  4338,  4338,  4338, -2330,  4338, -2330, -2330,   669,
   -2330, -2330,   669,  1616,   669, -2330,  2211,  2211,  2291, -2330,
   -2330, -2330, -2330, -2330,  2211,  2211,  2311, -2330, -2330, -2330,
   -2330,  2301,  4338, -2330, -2330, -2330,  2302,  4338, -2330,  4338,
    2330, -2330,  4338, -2330,  4935, -2330,  1073, -2330, -2330, -2330,
    1120, -2330, -2330,  1648,  2263,  2092,   669,   669,    29, -2330,
   -2330, -2330,   932,  2279,  2308, -2330,  1648, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330,  5488, -2330, -2330, -2330,  -203, -2330,
   -2330,  1648,   669,  1648,  2309, -2330,   669,   669,    24,   669,
    2045,   254, -2330,  2312, -2330,  1882,  1884,  1648,  1648,  1648,
    2313,   181, -2330,   -10,   -18,   447, -2330,   -25, -2330,  5088,
   -2330, -2330, -2330,  2288, -2330, -2330,  2356, -2330, -2330, -2330,
   -2330,   289,  4338,  2317,  2294,  5129,  5218,  5252,  5289, -2330,
    2225,   669, -2330,   669,   669,   669,  1680,  1680, -2330,  2319,
    2323,  2324,  2303,  2325,  2329,  2331,   669,  2090,  1093, -2330,
     669,  2091,   123,  2126,   669,  2133,  2141,    36, -2330,  2343,
    2142,  2164, -2330,  1220,  2166, -2330, -2330, -2330,  1233, -2330,
    2198, -2330, -2330, -2330,   454, -2330, -2330, -2330,  1751, -2330,
     669,  2123,   164,  2162,  1964,  2344,   669,   669,  1648,    35,
    1968,  2064,   669,  1648,   669,  2102,   305,  -155,   669,  2304,
    2000, -2330,  2381, -2330,   669,  2382, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330,   669,   669, -2330, -2330,
     669,   669, -2330, -2330, -2330, -2330, -2330,    27,  -100,  1970,
     -47,   -56,  1959,  1972,  1648,  1969,  2173,  1957,  2149,  2136,
    2143,  2396, -2330,    41,   673,  2400, -2330,    41,  2428,  2402,
     669, -2330,  1648,  2161,   272,  -136,   669,  2193,  1648,   -68,
     673,  2097,  2196,  2333,   306,  2199,  2203,   138,  1971,  1954,
    1975, -2330,  2414, -2330,  1948,  1950,   872,  2415, -2330, -2330,
    5318,  1053,  1693, -2330,  4935,  2418,  4338,  2419,  2420,  2421,
    2422, -2330,  2439,  2444, -2330, -2330, -2330, -2330, -2330, -2330,
    4338, -2330,  4338, -2330, -2330,  1309, -2330, -2330, -2330,   669,
     669,   669,   669,   669, -2330,  1648, -2330,   669,   669, -2330,
    2182, -2330,   669,   669,  2401,  2430,   669, -2330, -2330,  1262,
    2458,   122,   669,  2458,  1245,   151,  2405, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330,   130,   669,   669, -2330,
    1648,  2038, -2330, -2330, -2330, -2330, -2330, -2330, -2330,  1648,
     880, -2330, -2330, -2330,   669,   669, -2330,  1648,  1648, -2330,
     669,  1648, -2330, -2330, -2330, -2330, -2330,  1992,  1992,  2226,
   -2330,   669,  2232,  2241,   660,   669,   660,  2238,   669,   669,
    2030, -2330,  1648,   669,   669,  2310,  1648,   886,  1648,   411,
   -2330, -2330,   669, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330,   669,   669,   669, -2330,  1648,  1648, -2330,
     669, -2330, -2330, -2330, -2330, -2330, -2330, -2330,  1190,   669,
     669, -2330, -2330,   669,   669,  1648, -2330,  1648,  1648,  1648,
   -2330, -2330,  2298,  2314, -2330, -2330, -2330,  4338, -2330, -2330,
   -2330,  2407, -2330,  5543, -2330, -2330, -2330, -2330,   669,   669,
    2457,  2446,   673,   673, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330,  1220, -2330, -2330, -2330,
   -2330,  2476,  2458,  2458,  2477,  2480,  1490,  1520, -2330, -2330,
   -2330, -2330,  2481,  2458,  2458, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330,  1648,  1198, -2330,  2095, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330,  1648, -2330, -2330,   669, -2330,   669,   669,
   -2330, -2330, -2330, -2330,  1992, -2330,   669,  1992, -2330,  1648,
   -2330, -2330, -2330,   669, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330,  2101, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330,   872,   872,  5318,  5088,  2482,
   -2330, -2330, -2330,  4338, -2330, -2330, -2330,   454,  2483,  2485,
     454,   454, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330,   454,  2488,  2491, -2330, -2330, -2330,  2109, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330,  2467, -2330,   454,   454, -2330,
   -2330, -2330,   454,   454, -2330,  2496,  4338, -2330, -2330, -2330,
   -2330, -2330,  2495, -2330
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       4,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1450,     0,     3,   135,   137,   139,   573,   575,   577,   579,
     583,   585,   587,   644,   653,   655,   657,   659,   661,   663,
     665,   667,   669,   671,   673,   680,   682,   684,   686,   688,
     690,   692,   696,   698,   792,   794,   796,   798,   754,   975,
    1118,  1120,  1122,  1124,  1126,  1128,  1130,  1132,  1304,  1306,
    1369,  1434,  1436,  1438,  1440,  1442,  1444,  1446,  1448,     1,
       2,     0,   409,     6,   407,   408,     0,     0,     0,     0,
       0,     0,     0,     0,   426,   427,     0,   400,   401,   403,
     404,   405,   406,     0,     0,  1404,     0,     0,     5,     7,
     141,   144,   146,   148,   150,   180,   389,   396,   398,     0,
     410,   413,     0,   470,   474,   425,   428,   432,   428,   756,
     428,   707,   428,   432,   428,   962,   428,   432,   428,   432,
       0,   432,   428,  1165,   428,  1251,   428,  1308,   428,   432,
     432,  1403,  1426,  1429,   428,   428,   432,   136,   138,   140,
     265,   266,   276,   193,   194,   271,   285,   269,     0,     0,
       0,     0,   286,     0,     0,     0,   289,   267,   268,   287,
     288,   290,   291,   292,   293,   294,   295,   297,   296,     0,
       0,     0,     0,     0,     0,     0,     0,   706,   791,   949,
     952,   951,   948,   950,   953,   954,   955,   958,   960,   956,
     957,   959,   961,  1114,  1115,  1116,  1117,  1249,  1250,  1302,
    1303,  1375,  1376,  1377,  1378,  1379,  1380,  1381,  1382,  1383,
    1384,  1385,  1386,  1387,  1388,  1389,  1390,  1391,  1392,  1393,
    1394,  1395,  1396,  1397,  1398,  1399,  1400,  1401,  1402,  1482,
    1483,    37,    38,    47,    39,    40,    41,    42,    48,    43,
      44,    45,   272,   133,   134,    46,   270,   280,   316,   317,
     349,   315,   318,     0,   319,   700,   702,   701,     0,     0,
       0,   700,    69,    69,     0,     0,     0,     0,   699,     0,
     704,     0,     0,   589,     0,   646,     0,     0,   582,     0,
     582,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     676,     0,   675,   678,    69,   977,  1451,  1450,     0,  1450,
       0,     0,  1452,  1447,    16,    15,     0,   181,   142,   145,
     152,   153,   154,   156,   155,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,     0,     0,     0,     0,    67,
      66,     0,     0,     0,     0,    22,   402,     0,     0,   476,
     475,   477,   478,     0,     0,     0,     0,     0,     0,     0,
     414,   423,   502,  1309,   801,   757,   708,   963,   984,  1144,
    1159,  1166,  1252,  1339,  1456,  1469,   987,  1254,     0,   429,
       0,   501,     0,    22,     0,   508,     0,     0,     0,     0,
     440,     0,   454,     0,     0,     0,     0,     0,   908,   909,
     800,     0,     0,     0,     0,     0,     0,   898,   899,     0,
       0,     0,     0,    22,     0,     0,     0,     0,    22,     0,
     805,   802,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    22,     0,     0,     0,     0,     0,     0,     0,
      22,     0,     0,     0,     0,     0,     0,   910,   944,     0,
       0,     0,     0,   983,     0,     0,    22,     0,     0,    22,
       0,     0,    22,   990,   994,   454,   995,     0,     0,  1008,
       0,  1143,    22,     0,     0,     0,     0,     0,     0,  1148,
       0,  1161,  1158,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1338,     0,     0,     0,
       0,     0,  1358,  1367,  1455,     0,     0,     0,     0,     0,
      22,     0,    22,  1461,  1462,     0,     0,     0,     0,  1468,
    1475,     0,  1472,     0,   265,   285,   265,   265,     0,     0,
     265,   265,     0,   254,     0,    29,     0,     0,     0,    32,
      33,   281,     0,     0,     0,   313,    36,   216,   217,     0,
     219,     0,     0,   128,   128,     0,     0,     0,     0,     0,
       0,     0,   195,   198,   194,   197,   200,     0,   273,    37,
      38,   245,   196,   234,   231,   232,   233,   241,     0,   249,
       0,     0,     0,   672,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     511,     0,   510,   695,   693,   694,    68,     0,     0,     0,
       0,   687,   522,     0,   521,     0,  1449,   703,   705,   704,
       0,   584,     0,   576,     0,   574,     0,   582,   582,   582,
     582,   582,   581,   582,   582,  1134,   582,   582,     0,   582,
     582,     0,     0,   666,   658,   668,   660,   654,   656,   662,
     664,  1422,  1417,  1420,  1418,  1419,  1421,  1423,  1424,  1425,
       0,  1415,   679,     0,     0,     0,     0,  1443,  1452,  1439,
    1441,  1453,     0,     0,     0,   172,   167,     0,     0,     0,
     392,   394,   395,   497,     0,     0,   397,   471,   472,     9,
      11,     0,   473,    18,    20,    19,    21,     0,    17,  1430,
       0,  1428,   479,     0,   487,  1407,  1412,  1408,     0,     0,
       0,  1433,  1432,   412,   421,   411,   985,   986,   428,  1253,
     430,     0,   503,     0,   433,   434,   488,   439,   438,   437,
     435,    22,   504,   452,   456,   505,   506,   762,   715,   828,
       0,     0,     0,     0,     0,   845,     0,     0,     0,   902,
     900,   903,   901,   904,   906,   905,   907,     0,     0,     0,
       0,    22,    22,     0,    22,     0,     0,     0,     0,   846,
       0,    23,    24,    25,     0,    26,     0,     0,    26,     0,
      22,     0,     0,     0,     0,     0,    22,     0,    22,     0,
      22,    22,     0,    22,    22,    22,    22,    22,    22,     0,
       0,    22,     0,    22,     0,     0,     0,    22,    22,   829,
     942,   946,   830,   972,   988,    22,    22,  1009,   996,    22,
    1006,  1003,     0,    22,   997,   991,   992,   456,   989,  1011,
    1145,  1155,     0,     0,  1154,     0,     0,  1151,  1156,  1157,
    1147,  1146,   447,   176,     0,   461,   462,     0,     0,   460,
     442,     0,   443,   458,   441,     0,    22,     0,  1162,  1163,
    1177,  1261,  1311,  1340,     0,     0,    56,    55,  1354,    22,
       0,  1341,  1342,  1360,     0,  1359,     0,  1363,  1361,  1362,
    1352,  1355,  1365,     0,    22,  1373,    22,     0,     0,  1463,
       0,  1465,  1371,  1458,  1457,  1470,   488,  1473,     0,  1471,
       0,   257,   263,   261,     0,   193,   194,   265,     0,   262,
     264,   256,    28,    30,     0,     0,   282,   338,     0,     0,
     339,   218,     0,   298,     0,   129,   130,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   205,   246,   247,
       0,     0,     0,   274,     0,   275,     0,     0,   310,   308,
     306,   303,   304,   305,   307,   309,   311,   312,   299,   300,
     301,   302,   328,   327,   321,   322,   323,     0,   326,   320,
     324,   325,   333,   334,   335,   330,   331,   332,   336,   337,
     640,   638,   639,   623,   626,   630,   633,   636,   637,   624,
     625,   627,   628,   629,   631,   632,   634,   635,   641,   642,
     643,   515,   516,   517,   519,   520,   518,     0,   513,   685,
     681,   689,   691,   526,   527,     0,   524,   697,     0,   578,
     586,   588,     0,     0,   176,     0,   599,     0,   620,     0,
     601,   600,   605,   606,   619,   621,   622,   590,   598,     0,
     645,   648,   649,   650,   651,   647,   652,    69,    69,    69,
      69,     0,    69,    69,     0,   582,    69,   582,    69,  1119,
      69,    69,  1370,   670,     0,   677,   674,   683,   976,   176,
       0,     0,   981,  1445,     0,  1454,  1435,     0,   168,   182,
       0,   143,   174,   147,     0,     0,   488,     0,     0,   390,
       0,  1431,  1427,     0,   481,   484,     0,  1411,     0,  1410,
       0,  1413,     0,     0,    12,    13,    14,     0,  1160,   431,
     436,   491,   494,   509,     0,     0,   457,   432,   432,     0,
       0,     0,     0,     0,   836,     0,     0,    22,    22,   874,
     876,     0,     0,     0,     0,     0,     0,    22,     0,    22,
     891,   890,   570,   893,   847,    54,    53,   805,     0,   805,
       0,   833,     0,   808,   809,   823,   824,   825,   826,   827,
       0,   802,     0,   831,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   873,     0,     0,
       0,     0,     0,     0,    22,     0,     0,   875,     0,   840,
       0,     0,    22,     0,     0,     0,   947,   432,   998,     0,
    1001,  1000,   999,     0,  1007,  1005,   993,     0,  1152,  1153,
    1149,  1150,   175,   459,   172,   178,   469,   463,   445,    22,
     446,   444,   449,     0,   432,   432,   432,     0,     0,  1347,
      26,  1356,     0,     0,    22,    22,  1353,     0,  1345,  1466,
    1459,  1372,     0,  1464,   496,  1479,  1474,   265,   255,   259,
     265,     0,    30,   284,     0,     0,     0,     0,     0,   124,
     126,   346,     0,   314,     0,     0,     0,     0,   348,     0,
       0,     0,     0,   199,     0,     0,   235,   242,   250,     0,
       0,     0,     0,   512,     0,   523,   580,   617,   618,     0,
     614,   615,   616,   610,   608,   609,   591,   607,   592,   597,
     604,     0,     0,   593,   594,   602,   603,     0,     0,     0,
       0,   755,     0,     0,  1133,  1142,     0,     0,  1137,  1140,
    1135,     0,     0,    69,     0,    69,     0,     0,     0,  1416,
     980,   979,   978,   982,  1437,     8,   170,     0,   172,   184,
       0,     0,     0,   498,   391,   393,    10,   480,   482,   483,
     485,   486,  1406,  1409,     0,  1405,   399,   424,     0,     0,
      22,    22,     0,     0,   492,    69,   488,   507,   455,     0,
     450,     0,   764,   765,     0,   758,   759,     0,   717,   722,
     724,   724,     0,     0,   709,     0,     0,     0,   859,     0,
       0,   858,   857,     0,     0,   810,     0,    22,     0,     0,
     883,   882,   889,     0,   870,     0,     0,     0,     0,    27,
       0,   806,   807,   896,     0,   803,   804,   850,   842,     0,
       0,   863,     0,   852,     0,   838,     0,   839,   872,   855,
     877,   854,   853,   888,   856,     0,   878,     0,   880,   841,
       0,   848,     0,   851,   897,     0,   945,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    22,     0,    22,    22,
       0,    22,   917,     0,   974,   176,     0,     0,     0,     0,
     968,   964,     0,  1002,  1004,  1010,  1104,     0,    22,  1024,
      22,  1022,     0,     0,  1014,    22,     0,  1028,  1105,   177,
       0,   468,   448,  1164,  1179,     0,  1180,  1171,  1173,     0,
       0,  1167,  1168,     0,  1263,  1264,    22,     0,  1255,  1256,
       0,     0,  1310,  1323,     0,  1323,     0,     0,  1323,  1313,
    1314,     0,  1317,  1343,  1344,  1346,     0,    62,    63,  1348,
    1350,  1351,  1349,     0,   186,  1368,   353,   353,     0,     0,
     350,   351,   352,     0,     0,   364,     0,     0,     0,     0,
     353,  1364,     0,  1366,     0,  1467,  1374,  1477,  1481,   258,
     260,     0,   283,     0,   340,     0,   277,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   205,     0,     0,
       0,     0,     0,     0,    34,    35,     0,   514,   525,     0,
     611,   612,     0,   595,   596,   799,   793,   795,   797,  1123,
    1121,  1138,  1141,  1136,  1139,     0,  1125,     0,  1129,  1305,
    1307,     0,   183,     0,     0,   190,   191,   185,   188,   189,
       0,   149,     0,  1414,     0,     0,   415,   416,     0,     0,
     422,   489,     0,   493,   495,   451,   453,   488,   760,     0,
     763,   710,   488,   711,   742,   712,   746,   713,    22,   716,
       0,   865,   843,   864,   867,     0,     0,     0,   814,     0,
       0,     0,     0,   812,   868,     0,     0,     0,   884,   869,
     871,   572,     0,    22,   569,     0,     0,     0,     0,   894,
     835,   834,   832,   862,   861,   844,   860,   837,   881,   879,
     849,   895,     0,    22,    22,    22,     0,     0,    22,     0,
       0,   924,   925,   926,     0,   922,   938,   937,   939,   927,
     943,   967,   966,   965,   970,   969,     0,   973,   488,  1027,
       0,     0,    22,  1015,     0,     0,  1013,     0,     0,  1031,
    1026,  1030,     0,  1020,  1012,     0,  1038,   464,   465,   466,
     467,    52,    51,  1213,  1222,  1170,   488,  1169,     0,     0,
    1175,    22,  1178,   488,  1260,  1257,  1259,  1262,  1325,  1324,
       0,     0,     0,    25,  1327,  1326,  1315,  1330,  1331,  1318,
       0,  1312,  1357,     0,     0,     0,   184,   354,     0,     0,
       0,     0,     0,     0,     0,   385,   385,   376,     0,     0,
       0,     0,  1460,     0,     0,     0,     0,     0,    82,    93,
      94,    80,     0,    83,    84,     0,     0,    87,    88,    92,
      89,   131,    90,     0,   106,   106,     0,     0,   132,     0,
     106,   106,     0,     0,     0,   343,   344,   342,   345,   214,
       0,     0,   212,     0,   208,     0,     0,   206,     0,     0,
       0,   329,   613,  1127,  1131,     0,   356,   179,   192,   173,
       0,     0,     0,   419,   420,    59,    60,    61,    57,    58,
     490,   788,    22,   720,   718,   719,   721,   723,   742,   740,
     725,     0,     0,   749,   714,     0,     0,     0,   817,   818,
     816,   820,   819,   821,     0,   811,   886,   885,   887,     0,
       0,   568,     0,   563,   567,   571,    22,    22,     0,     0,
     932,   933,   934,   935,   936,     0,     0,   941,   928,   914,
     915,   916,   923,   940,    22,    22,  1107,  1111,  1017,  1018,
    1016,  1092,  1019,  1092,  1052,  1032,  1021,  1106,  1039,  1220,
    1219,  1210,  1226,  1225,  1233,  1172,  1235,  1236,  1243,  1174,
    1176,  1299,     0,  1320,    22,  1319,  1316,  1328,     0,  1321,
      64,     0,   361,   187,   353,   374,   375,     0,   369,     0,
     251,   360,     0,     0,     0,     0,     0,   373,     0,     0,
       0,     0,     0,     0,  1480,     0,     0,    31,   341,   278,
     279,    81,    85,    86,    91,    76,    74,    72,    71,    73,
      75,    70,    77,    99,     0,   116,   101,    97,   107,   117,
       0,     0,   118,    50,    49,   115,   125,   121,   122,   123,
     119,   127,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   248,   169,   171,     0,     0,   151,
     417,   418,   786,   766,   761,   725,     0,   745,   747,   748,
       0,   751,   866,   815,   822,   813,     0,     0,     0,   912,
     913,   911,   920,   919,   918,   921,    22,     0,   931,   971,
    1105,  1109,  1113,     0,     0,     0,  1041,     0,  1224,  1208,
    1207,  1231,  1241,  1297,  1265,  1258,  1322,  1332,   368,   355,
       0,   362,     0,   359,   365,   385,   386,   387,   385,   388,
     371,   370,     0,     0,     0,   378,     0,  1476,  1478,     0,
      95,    79,    78,     0,     0,    78,   106,   106,     0,   108,
     109,   110,   111,   112,   106,   106,     0,   347,   229,   213,
     211,     0,     0,   209,   227,   207,     0,     0,   225,     0,
     223,   222,     0,   220,   357,   358,   767,   790,   744,   743,
       0,   535,   536,    22,     0,     0,     0,     0,     0,   733,
     528,   530,     0,   562,     0,   750,    22,   753,   564,   565,
     566,   929,   930,  1108,     0,  1025,  1095,  1093,  1096,  1023,
    1029,    22,     0,    22,     0,  1037,     0,     0,     0,     0,
       0,     0,  1051,     0,  1223,     0,     0,    22,    22,    22,
       0,     0,  1212,  1227,  1237,     0,  1301,     0,   372,     0,
     186,   201,   204,     0,   377,   203,   239,   236,   237,   238,
     243,     0,     0,     0,     0,     0,     0,     0,     0,   100,
      98,     0,   102,     0,     0,     0,     0,     0,   120,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   789,
       0,     0,     0,     0,     0,     0,     0,     0,   785,     0,
       0,     0,   731,   531,     0,   726,   730,   734,     0,   735,
       0,   732,   538,   537,   539,   534,   741,   752,     0,  1112,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,     0,     0,    22,     0,     0,     0,     0,     0,     0,
       0,  1091,     0,  1097,     0,     0,  1035,  1036,  1034,  1033,
    1045,  1042,  1048,  1049,  1050,  1043,     0,     0,  1046,  1040,
       0,     0,  1214,  1215,  1216,  1221,  1211,     0,     0,     0,
       0,     0,     0,     0,    22,     0,     0,     0,     0,  1198,
    1200,     0,  1230,     0,     0,     0,  1240,     0,     0,     0,
       0,  1300,    22,     0,     0,     0,     0,     0,    22,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1292,     0,  1337,     0,     0,     0,     0,   363,   253,
     205,     0,     0,   186,   366,     0,     0,     0,     0,     0,
       0,    96,     0,     0,   103,   114,   113,   228,   210,   226,
       0,   224,     0,   221,   768,     0,   771,   772,   770,     0,
       0,     0,     0,     0,   777,    22,   769,     0,     0,   782,
     783,   787,     0,     0,     0,     0,     0,   736,   737,     0,
       0,     0,     0,     0,     0,     0,     0,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1057,     0,     0,     0,  1085,
      22,     0,  1099,  1054,  1072,  1090,  1079,  1080,  1081,    22,
      22,  1053,  1074,  1056,     0,     0,  1058,    22,    22,  1055,
       0,    22,  1110,  1098,  1094,  1044,  1047,  1247,  1247,     0,
    1197,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1185,    22,     0,     0,     0,    22,     0,    22,     0,
    1209,  1234,     0,  1245,  1229,  1228,  1232,  1244,  1239,  1238,
    1242,  1271,  1269,     0,     0,     0,  1285,    22,    22,  1266,
       0,  1290,  1293,  1296,  1295,  1294,  1291,  1270,    22,     0,
       0,  1267,  1268,     0,     0,    22,  1272,    22,    22,    22,
    1298,  1329,     0,     0,  1336,  1333,   202,     0,   240,   244,
     252,     0,   383,     0,   380,   381,   379,   382,     0,     0,
       0,     0,     0,     0,   775,   776,   500,   499,   778,   779,
     773,   774,   784,   727,   728,   529,   531,   729,   738,   739,
      65,     0,     0,     0,     0,     0,     0,     0,   558,   559,
     560,   561,     0,     0,     0,   562,  1083,  1082,  1084,  1087,
    1086,  1075,    22,     0,  1073,     0,  1088,  1071,  1059,  1070,
    1069,  1076,  1068,    22,  1217,  1218,     0,  1183,     0,     0,
    1204,  1205,  1206,  1193,  1247,  1194,     0,  1247,  1187,    22,
    1186,  1188,  1189,     0,  1202,  1199,  1203,  1201,  1246,  1283,
    1284,  1286,  1289,  1276,  1278,     0,  1287,  1281,  1282,  1279,
    1280,  1273,  1274,  1275,  1277,     0,     0,     0,     0,     0,
     105,   104,   215,     0,   780,   781,   532,   539,     0,     0,
     539,   539,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   539,     0,     0,   533,  1077,  1078,  1101,  1100,
    1089,  1248,  1195,  1181,  1182,  1191,  1196,  1192,  1184,  1190,
    1288,  1335,  1334,   367,   384,     0,   544,   539,   539,   546,
     545,   547,   539,   539,  1102,     0,     0,   542,   543,   540,
     541,  1103,     0,   230
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,  -341,
    -301,   -70,   279,  -428,  -741, -2330,  -156,  -158,  1518,  1519,
    1522, -2330, -2330, -2330,  -178, -2330, -2330,  -484, -2330, -1435,
    -760,  -576, -2330, -2330,  1019, -1885,  -103,  -128,   443,  -997,
   -2330,   978,   979,   980,   983,   731,   450,   451,   738, -1594,
    -720,   734, -2330, -2330, -2330, -2330,  2005, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,   -84, -2330,
   -2330, -2330,  1346,  -981, -2330,  -595,  1218, -2330, -2330, -2330,
     785, -2081, -2330, -2330,   957, -2330,  -186,  1634,   206, -1238,
   -2002,  2425, -1995, -1989,  1636,   223,  2069, -2330,  1652, -2330,
   -2330, -2330, -2330,  -480, -2330, -2330, -2330, -1217,  -146, -1228,
      -6, -2330, -1484, -2330, -2330, -2330, -1239, -2330, -2330, -2330,
   -1598, -2330, -2330,  -450, -2330, -2330,   169, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330,   -59,  -104, -2330,  2468,  1402, -2330,
    2135,  1774,  -118,  -559,  -473, -2330,  -406, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330,  1236,  -724, -1032, -2330, -2330, -1871,
   -2330, -2330, -2330, -2330, -2330,  -260, -2330,  1332,  -122, -2330,
    1331, -1506, -2330,    50, -2197, -2330, -2330,  -895, -2330,    32,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330,  -216, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330,  -904, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330,   763,  1999, -1243, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330,  1238,   587, -2330, -2330, -2330,
     755, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,  1467,
     143, -2330, -2330,   740, -2330, -2330, -2330, -2330, -2330, -2330,
     733, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330,   711, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330,   575, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330,   160, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330,   320,   304, -2330, -2330, -2330, -2330,
     158,   309, -2330, -2330, -2330, -2330,   168,   317, -2329, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330,  -639,   890, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,  1777, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330,  1559,  1598, -2330, -2330, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330,   938,  2001, -2330, -2330,
   -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330, -2330
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,    22,    23,    24,    25,     2,     3,   108,   109,   708,
     721,   389,  2061,  1943,  1159,   545,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,  2015,  1753,
    2176,   878,  1870,  1538,  1539,  2581,   351,   617,  2004,  2113,
    1822,  1823,  1824,  1825,  1826,  2005,  2006,  2007,  2009,  2010,
    2123,  2012,  1827,  1833,  1578,  1579,   935,  1269,  1270,   263,
     264,   265,   110,   685,   111,   112,   113,   114,  1623,  1347,
    1089,  1090,  1091,  1223,  1224,   859,  1092,   115,   684,  1348,
    1624,  1785,  1786,  1625,  1626,  1627,   266,   583,  2216,   945,
     584,   946,   585,   586,   587,  2220,   588,  2221,   589,   590,
    2092,   541,   267,   542,   268,   269,   925,   270,   271,   272,
    1587,  1560,  1788,  2038,  1628,  1973,  1629,  1794,  2222,  2551,
    1974,  2098,   116,   695,   117,   118,   400,   120,   121,   371,
    1373,  1117,   725,   122,   390,   401,   402,  1380,  1381,  1125,
     744,  1126,   403,   864,   860,  1501,  1228,   123,   363,   364,
     124,  1121,  1643,  1375,  1122,  1254,  1255,  1096,  1097,  2414,
     125,   126,   127,   736,   404,   613,  1017,  1018,   625,  1025,
    1026,  2159,  2160,  2424,  2161,  2162,  2163,  2436,  2592,  2275,
    1688,  1416,  1153,    26,    27,    28,    29,   648,    30,    31,
      32,   634,  1306,  1307,  1049,  1010,   278,    33,   636,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
     313,   673,    45,    46,    47,    48,    49,    50,    51,   279,
      52,    53,   280,   630,   274,   128,  1387,  1127,   129,  1647,
    2147,  2259,  2146,  2043,  1648,    54,    55,    56,    57,   130,
    1395,  1128,   131,  1877,  1651,  1652,  2047,  2164,  2271,  2046,
    1880,  1653,  1655,  1883,  2051,  2167,  1657,    58,   132,   789,
     786,  1406,  1672,  1673,  1170,   133,   778,  1417,   457,   458,
    2062,  1922,  1473,  1205,   821,  1206,   459,   134,  1482,  1207,
     135,    59,   675,   386,   136,   137,   836,   475,   476,   477,
     478,   479,  1217,  1496,  1737,  1734,  1740,  1741,  2075,  2184,
    1497,  2076,  2193,  1498,  2302,  2073,  2177,  2178,  2305,  2603,
    2715,  2689,  1728,  1746,  1927,  2070,  2174,  2072,  1729,    60,
      61,    62,    63,    64,    65,    66,    67,  1064,   138,   139,
     490,   140,   728,   141,   142,  1513,  1758,  1759,  1234,   143,
    1756,  2341,  2497,  2499,  2623,  2202,  2201,  2080,  1757,  1754,
    2200,  2078,  2077,  1940,  1755,  1944,  2081,  2345,  2501,  2203,
    1945,  1948,  2082,  2349,  2507,  2204,  1949,  2504,  2614,   387,
     144,  1520,  1235,   145,  1763,  2206,  2372,  2526,  2205,  2084,
    1764,    68,    69,   146,   147,  1236,  1531,  1770,  1532,  1776,
    1779,  1957,  1958,  2207,  2377,  2541,   148,   149,   890,   891,
     512,   513,  1563,  1247,   893,    70,   150,   525,   365,   151,
    1107,  1109,   718,  1112,   670,   671,   152,   153,    71,    72,
      73,    74,    75,    76,    77,    78,   322,   682,   154,  1565,
     526,   155,   156,   533,   906,  1986,  1803,  1568,   907
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     358,   273,   785,   788,  1562,   345,   937,   550,  1561,   549,
     582,   326,  1123,   702,   543,   827,   327,   328,   581,  1559,
     615,   489,   862,   877,  1157,  1777,   720,   720,  2180,   456,
    1558,   511,   524,   474,   661,   488,   316,   500,   580,  1048,
     579,  1586,  1588,  1590,  1591,   510,   523,  1171,   548,   529,
    1751,  1984,   532,  1309,   911,  2373,   912,   913,  1047,   699,
     919,   920,  2346,  1789,   700,   759,  2425,   722,    80,   405,
    2342,   406,  2486,   407,  1760,   460,  1799,   461,  1242,   480,
    1082,  2484,   329,   502,   651,   503,  1881,   504,   780,   505,
    2217,  1137,   697,   698,   701,   527,   528,  2218,  1340,   349,
     699,   350,    81,  2219,   631,   700,  1562,   349,  2522,   350,
     814,  2194,    82,   883,    83,   761,   662,    84,    85,   712,
     763,  1559,  2517,   703,   704,   705,   706,   830,   765,  2379,
     845,   699,  1558,   392,   735,   701,   700,  1711,   393,   394,
     352,   353,   530,    86,  2523,  1316,   396,  1141,   699,  2615,
     877,  1889,   852,   700,  1243,   618,   699,   642,   349,   354,
     350,   700,  1324,   349,   555,   350,   701,   562,     4,     5,
       6,   699,   119,  2582,   952,   895,   700,   781,   782,  1325,
     783,  2467,   642,   701,   699,  1367,   674,   781,   782,   700,
     783,   701,  2410,  2411,   703,   704,   705,   706,  1975,   642,
    2312,   397,  2593,  1915,   398,  2267,   701,   703,   704,   705,
     706,  2456,  2419,    87,  1313,    88,    89,   699,    90,   701,
      91,  1326,   700,  2481,  1280,   157,    92,  2181,    93,    94,
      95,  2011,    96,  2447,  2411,   710,   553,  2011,  2303,  2268,
     703,   704,   705,   706,  2304,    97,    98,    99,   100,   101,
     102,  1110,   701,  1368,  1369,   699,     1,   275,   953,   276,
     700,  2326,   717,   310,  1263,  1172,  1172,   610,   317,  1173,
    1692,  1142,   699,  2327,    79,   687,   740,   700,   703,   704,
     705,   706,   846,  1120,   281,   928,   276,  1784,  1264,   318,
     701,   699,  1281,   738,   739,  2695,   700,   103,  2697,   723,
     311,  2468,  2550,   104,   611,  1065,   473,   701,  1233,   105,
     106,   289,   551,   737,   703,   704,   705,   706,     7,   768,
    1327,  1238,  1712,   699,  1131,  2583,   701,  1916,   700,  2328,
    2329,  1244,   643,  2313,  2182,     8,   713,  2420,  2269,  2270,
    1085,  2514,  2411,  1111,  2457,   884,   357,  1067,   627,  1521,
     628,    82,   554,   582,  2594,  1882,    84,    85,   701,  2330,
       9,    10,  1314,  2412,  1370,  1371,   720,  2382,  1372,  2524,
    2482,  1103,  1353,   315,   885,  2518,  1108,   632,  1113,  2425,
    2217,  1522,  1160,   886,  1562,   760,  1161,  2218,   543,  2183,
     543,   543,   312,  2219,   543,   543,   612,  2020,    11,  1559,
      12,   929,    13,  1138,  2412,   277,  1101,  1603,  1604,   158,
    1558,  2449,  1890,    14,  1328,   367,  1135,  1136,   159,  2413,
    2487,  1057,  1058,  1059,  1060,  1061,  2331,  1062,  1063,  2488,
    1066,  1068,   277,  1070,  1071,   762,  1946,  1259,  2485,  2332,
     764,   288,    15,   644,  2525,   954,    16,   323,   766,  2383,
    1176,    17,    18,  1179,  1985,  1230,  1240,  1308,  1241,  1231,
    2448,  2314,  2185,   663,   348,   392,  1200,  2347,  1174,  1174,
     393,   394,  2458,   368,  2348,  2343,  1329,  2317,   396,  1778,
    2089,  2344,   813,  2516,    97,    98,    99,   100,   101,   102,
    1947,  1214,  2374,  2375,  1721,  2350,   629,  2223,  2376,  1535,
    2224,   720,   720,  2479,   355,  2430,   664,   665,   666,   667,
     668,   669,  2412,  2195,  2196,  1245,  1227,  2197,  2198,  2199,
    1227,  1342,  2233,  2234,  1227,  2502,  1271,  2351,  2465,   955,
    2236,  2237,   914,   397,  1742,  1143,   398,   784,   346,  1735,
    2431,  1218,  1219,  1562,   531,   926,   952,  1967,  2585,   877,
    1272,  1716,   887,   888,   889,  1330,  1251,   787,  1559,  1253,
     938,   939,   940,   941,   942,   943,  1056,  1256,  2515,  1558,
    2192,   947,  2059,  2060,  2596,  2597,    19,  1331,   319,   320,
     321,  2535,  2151,  2152,   753,  1162,   622,   754,   958,   959,
     960,   961,   962,   963,   964,   965,   966,   967,   968,   969,
     970,   971,  1675,  2024,   649,  2026,  1156,   645,  2028,  1332,
    2031,  2033,  1480,  2154,  1078,  1871,   281,  1523,   276,  2432,
    1878,   646,   647,   623,   347,  1873,   580,  1730,   579,  1023,
    1260,  2186,   773,   107,   709,   715,  1874,  1875,  1144,  1160,
    2258,   546,   716,  1690,   356,  1846,   792,  2151,  2152,  2352,
    1524,  1525,  2333,   793,  2334,  2335,  1599,  2433,   366,  2336,
    2337,  1665,  2338,  2434,   809,  1485,  1731,   369,  2301,  1118,
    2339,  2340,   734,  2187,  1841,   370,  2531,  1087,  2154,   637,
     650,   750,  1160,  2435,   551,  1024,  1691,   699,  1098,  1847,
    2188,  1732,   700,   781,   782,  1100,   783,  2668,  2669,  2371,
    2353,  2354,   769,   284,  2355,  1906,   638,   777,  2683,  2684,
    1163,  1164,  1201,  1848,  1800,   624,  1681,   550,  1842,   549,
     810,   802,   701,  1474,  1941,  1801,  1562,   491,   774,   812,
    2091,  1951,  2099,  1739,  1436,  2532,  2356,    20,    21,  2357,
     811,  1559,   324,   325,   699,   828,  2132,  2097,   831,   700,
    2358,   834,  1558,   775,   552,  2359,   751,  1876,  1486,  1079,
     854,   841,  1839,  1487,   277,   582,   582,   703,   704,   705,
     706,   543,   282,   283,   286,   287,   581,  1569,   544,   701,
    1570,   314,   639,  2360,  1682,   546,  1840,  1080,  1396,  1397,
    2133,  1399,  1400,   556,  1475,   854,   580,   640,   579,   899,
    1844,   901,  1409,  1666,   948,   949,  2361,   392,  2189,  2190,
    2191,  1081,   393,   394,   563,  2111,  2115,   686,  1526,  1421,
     396,  1422,  1476,  1527,  1845,  1528,  2139,   285,  1907,  2111,
    2115,  1425,   547,  1426,  1919,  2013,  1429,  1430,  1683,  1432,
    1050,  1434,  1162,  2142,  1908,  2130,   564,  2135,  1225,  1333,
     950,  1335,  1909,   565,  1447,   324,   325,   324,   325,  1450,
      82,   566,  1920,  1921,  1488,    84,    85,   359,  1483,  2131,
    2140,  2136,  1484,  2362,  1302,   397,  1301,  1612,   398,  2116,
     567,  1613,  1614,   388,  1684,  1162,  1772,  2143,  1685,  1780,
    1514,  1686,  1687,  2124,  2240,   349,  2363,   350,   699,  2242,
     591,  2243,  1540,   700,  2245,   568,   781,   782,  1477,   783,
     627,  1566,   628,   699,  2364,  1051,   569,  1723,   700,   853,
     854,   703,   704,   705,   706,  1074,  1267,  1075,  1268,  1317,
    1318,  1319,  1320,   701,  1322,  1323,   570,  1226,  1334,   855,
    1336,   571,  1337,  1338,   856,   360,   361,   362,   701,   324,
     325,  2365,  2366,  2367,  2368,   349,  2369,   350,  2272,   861,
    2370,  1667,  1489,   592,  1656,  1942,  1562,  1163,  1164,  1668,
    2378,  1669,   609,  1670,   392,  1292,  1671,  1293,  1343,   393,
     394,  1559,  1294,  1515,  1295,  1052,   862,   396,  1209,   547,
     548,  1351,  1558,    97,    98,    99,   100,   101,   102,   726,
     727,  1053,  1054,  1362,  1926,  1363,  1350,   614,  1490,  1386,
    1163,  1164,  2117,  1055,   699,  2125,  1114,  1115,  1116,   700,
    1124,  2117,  2125,  1385,  1394,  1491,   863,  1492,  1341,   547,
     548,  1493,  1155,   757,   758,  1494,  1495,   703,   704,   705,
     706,   616,   397,   547,   548,   398,  1155,   619,   620,   701,
    1145,  1146,  1074,  1148,  1633,  1478,  1479,   798,   799,   572,
     573,   163,   574,   575,   576,   -68,   -68,  1677,   -68,  1175,
    1388,  2211,  2212,   915,   916,  1181,  1389,  1183,   621,  1185,
    1186,   626,  1188,  1189,  1190,  1191,  1192,  1193,  1419,  2175,
    1196,  1210,  1198,   863,   577,  1722,  1203,  1204,  1774,   842,
     843,   492,   699,  1481,  1208,  1211,  2547,   700,  1212,   848,
     849,   543,  1215,   372,   543,   633,  1512,  1519,  1530,  1645,
     635,  2246,  1011,  1012,  1013,   703,   704,   705,   706,  1718,
    1511,  1518,  1529,  2247,  2605,   641,  1724,   701,  2248,   642,
     373,   550,   290,   549,   291,  1232,  1014,  1015,  1917,   493,
    1016,  1923,   652,  2249,   392,  2620,  2621,  2622,  1237,   393,
     394,   653,  2560,  1390,  2561,   781,   782,   396,   783,   654,
    1239,   374,    82,  1249,   292,  1250,  1766,    84,    85,   655,
    1768,   293,   548,   656,  1751,   392,   547,   548,   657,  1155,
     393,   394,   699,  1104,  1105,   494,   495,   700,   396,   658,
     496,   699,   514,   578,   316,  1615,   700,  1617,   699,   659,
     690,   497,   691,   700,   294,   692,   295,   660,   781,   782,
     498,   783,   397,  1802,   296,   398,   779,   701,  1894,   375,
    1895,   703,   704,   705,   706,  1446,   701,   534,  2035,   297,
    2036,   672,   535,   701,   376,   694,  2179,  1642,   677,  1910,
    1911,   681,   536,   397,   537,   676,   398,   678,  1572,  1516,
     679,   606,   607,  1621,  2250,   608,  1580,   683,  1581,  1582,
    1583,  1584,   538,  2151,  2152,   707,  1358,  1359,  2687,  1593,
    1630,  1297,  1298,  1299,  1300,  1596,   392,   680,  1934,  1360,
    1361,   393,   394,   688,  1391,  1392,   689,  1863,   720,   396,
    1418,  1393,  1420,   696,  2154,    97,    98,    99,   100,   101,
     102,  1865,  1866,  1517,  1867,  1156,   910,  1600,  1601,  1885,
    1638,  1639,  2210,   711,   534,   719,  2251,  2252,  2149,   535,
    2253,  2211,  2212,   915,   916,   580,   714,   579,  1864,   536,
     729,   537,  1892,  1893,   724,   720,  1904,  1752,  1899,  1900,
     298,  1752,   377,   699,   397,   378,   730,   398,   700,   538,
    1992,  1993,   731,  2254,  2255,  2256,  2213,   690,   732,   691,
     515,   733,   692,  2260,  2261,  1725,   703,   704,   705,   706,
     539,  2257,   540,  2111,  2112,  1903,  2406,  2407,   701,  1928,
    1929,   741,    82,  2214,  1932,  1378,  2150,    84,    85,   742,
     693,  1936,   694,   743,  1937,   379,   745,   853,   854,   380,
     381,   516,   746,   499,  -892,  1562,  1403,  1405,   747,  2703,
    2151,  2152,  1504,  1775,   748,  2705,  1413,   855,  1415,  1953,
    1559,  1955,   856,   752,  1505,  1705,   749,   299,   755,  1959,
     756,  1558,   382,   493,  2645,  2427,  2428,   861,  2151,  2152,
    2153,   853,   854,    82,   767,  2586,  2587,   770,    84,    85,
     772,   300,  2588,  2589,  2590,  2591,   383,   539,   790,   540,
     384,   855,   771,  1445,  2578,  2579,   856,   791,  2722,  2154,
    2064,  1452,  2003,   481,  1869,  1379,  1868,   794,  2003,   494,
     495,   857,  2562,  2563,   496,   795,   796,   858,  1979,  1980,
    2155,   797,  1981,  2156,  2157,   497,   392,   800,  1502,  1982,
    1983,   393,   394,   805,   498,  1506,  2395,  2396,   385,   396,
     720,   720,   801,  1541,  1542,    97,    98,    99,   100,   101,
     102,   572,   573,   915,   916,   575,   576,   804,   806,   803,
    1787,  1787,   816,  1791,   807,   808,   301,  1792,  1793,   817,
     815,  1855,   819,  1856,  1787,   818,  2158,  2107,   820,   822,
    2040,  2041,   547,   874,   875,   876,   577,   392,   823,  1806,
     699,  1807,   393,   394,   397,   700,   302,   398,   824,   517,
     396,   829,   825,   776,   826,   832,    97,    98,    99,   100,
     101,   102,   171,   703,   704,   705,   706,   174,   175,   303,
     482,   304,   835,   305,    82,   701,  1995,  1996,  1997,    84,
      85,  2085,   833,   699,   781,   782,   838,  1773,   700,   350,
     839,   844,  2165,  1998,  1999,  2000,   840,  1995,  1996,  1997,
     847,  1404,   850,   851,  1382,   397,   853,   854,   398,  1165,
    1166,  1167,  1168,  1169,  1998,  1999,  2000,   863,   701,  1636,
    1637,   518,   519,   865,   866,   867,   855,  1747,  1748,  1749,
    1750,   856,   868,  2110,  1704,   869,   699,   483,   870,  2118,
    2014,   700,   871,   880,  1752,   917,   857,   306,   307,   308,
     309,   872,   858,   873,   879,   881,  1676,   882,   484,   703,
     704,   705,   706,   892,   896,   897,   520,   521,   522,   894,
     898,   701,  2672,  2673,  2674,  2675,  2676,  2001,  2002,   902,
    1972,  2211,  2212,   915,   916,   720,   720,   720,   392,   900,
     903,   904,   905,   393,   394,   908,  2172,  1383,  2001,  2002,
     909,   396,  2677,  2678,  2679,  2680,  2681,    97,    98,    99,
     100,   101,   102,   921,   924,  1713,  2213,  1715,  1717,   922,
    1719,  2119,  2120,  2121,  2122,  2168,  2169,  2170,   572,   573,
     915,   916,   575,   576,   923,   927,   608,  1733,  2229,  1736,
     930,  2003,  2706,  2003,  1743,  2709,  2710,   931,  1961,  2049,
     594,   595,   596,   597,   598,   932,   397,  2711,   951,   398,
     956,   957,  1976,  1285,  1978,  1765,  1019,   599,   600,   601,
     602,   603,   604,   605,   606,   607,  1020,  1021,   608,  1088,
    1022,  2048,  2717,  2718,  1027,   720,  2266,  2719,  2720,  1029,
    1030,   572,   573,   915,   916,   575,   576,  1069,  2022,  1072,
    1073,  1507,  1508,  1076,  1077,  1509,  1083,  1086,  1093,  1094,
    1510,  2307,  1095,  1099,  1102,  2310,  2311,  1106,  2315,  1119,
    2318,  1134,  1129,  1130,  1384,  2265,   577,  1139,  1132,   594,
     595,   596,   597,   598,  1140,  1147,  1149,  1133,   485,   486,
     487,  1150,  1151,  1152,  1154,  1969,   599,   600,   601,   602,
     603,   604,   605,   606,   607,  1177,  1158,   608,  1178,  1180,
    2391,  1182,  2392,  2393,  2394,  1156,  1156,  1187,  1184,  1194,
    1195,  1202,  2093,  1197,  1199,  2404,  2215,  1213,  1220,  2408,
    1221,  1222,  1229,  2416,  1248,   580,   580,   579,   579,   884,
    1252,  1257,  1261,  1262,  1455,  1265,  1284,  1970,  1266,  1291,
    1289,  1279,  2527,  1282,  1290,  1296,  1310,  1884,  1315,  2445,
    1321,  1311,  1312,  1344,  1456,  2453,  2454,  1346,  1352,  1354,
    1365,  2461,  1357,  2463,  1366,  2466,  1374,  2469,  1787,  1376,
    1407,  1377,  1901,  2473,  1398,  1408,  1401,  1537,  2095,  1402,
    1410,  1411,  1412,  1414,  1500,  2475,  2476,  1592,  1423,  2477,
    2478,  1536,  1912,  1913,  1914,  1427,  1564,  1918,  1428,  1567,
    1431,  1433,   493,  1435,  1437,  1438,  1439,  1440,  1441,  -893,
    -893,  -893,  2503,  1457,  1442,  1443,  2503,  1444,  1448,  2511,
    1449,  1930,  1451,  1453,  1454,  2519,  -893,  -893,  -893,  -893,
    -893,   604,   605,   606,   607,  1503,  2536,   608,   594,   595,
     596,  2144,  1533,  1534,  1379,  1571,  1573,  1574,  1458,  1459,
    1950,  1594,  1595,   496,  1602,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   497,  1605,   608,  1606,  1607,  2273,
    1608,  1609,  1610,   498,  1611,  1616,  1618,  1619,  2564,  2565,
    2566,  2567,  2568,  1620,  1631,  1632,   720,   720,  1634,  1635,
    1640,   720,   720,  1641,  1646,   720,  1650,  1649,  1658,  1659,
    1660,  2584,  1661,  1662,  1663,  1664,  2225,  2226,  2227,  1674,
    2228,  1703,  1678,  1702,  1709,  2598,  2599,  2600,  1460,  1679,
    1461,  1707,  1462,  1706,  1680,  1689,  2570,  2571,  1693,  1708,
    1694,  2573,  2574,  2607,  2608,  2577,  1695,  1696,  1697,  2611,
    1698,   462,    82,  1699,  2664,  2665,  1700,    84,    85,  1701,
    2617,  1720,  1710,  1714,  2624,  1726,  1727,  2627,  2628,  1738,
    1744,  2044,  2631,  2632,  1745,  1761,  1762,  1767,  1771,  1781,
    1783,  2638,   463,  1769,  1790,  1795,  1796,  1797,  1798,  1752,
    1804,  1805,  2639,  2640,  2641,  2688,  1850,  1843,  1849,  2644,
    2437,  2438,  2439,  2440,  2441,  2442,  2443,  2444,   720,  2648,
    1852,  1853,  2649,  2650,  1854,  2215,  2215,  1857,  1859,  1860,
    1872,  1879,  1861,  2068,  2069,  1896,  1886,  2380,  1887,  1862,
    1463,  1897,  1898,  1888,  1891,  1905,  2384,  2660,  2661,  1464,
    1465,  1902,  1925,  1931,  1933,  1924,  1466,  1935,  2647,  1938,
    1467,  1939,  1521,  2086,  1954,  1952,  1960,  1962,  1965,  1468,
    1987,  1966,  1977,  1988,  1991,  1994,   392,  2016,  1469,  2008,
    1470,   393,   394,  1471,  2021,  2023,    82,  2029,  2027,   396,
    2034,    84,    85,  2037,  2039,    97,    98,    99,   100,   101,
     102,  2042,  2050,  2544,  2053,  2692,  2052,  2693,  2694,  2065,
    2054,  2056,  2057,  2066,  2058,  2696,   506,  2067,  2090,  2094,
    2102,  2071,  2699,  2079,  2083,  2087,  2103,  2104,  2105,  2109,
    2166,  2106,  2108,  2114,   160,  2126,   161,   162,   163,   164,
     165,   166,  2128,   167,   397,  2129,  2134,   398,  2137,  2145,
    2138,   168,   169,   944,  2141,  2208,   170,  2235,  2209,  2238,
     464,   594,   595,   596,   597,   598,  2239,  2241,   171,   172,
    2244,   173,  2263,   174,   175,  2171,  2264,   176,   599,   600,
     601,   602,   603,   604,   605,   606,   607,   990,  2274,   608,
    2276,  2309,   991,   992,  2319,  2325,  2381,  2320,  2316,  2321,
     392,  2385,  2386,  2397,   933,   393,   394,  2398,  2399,  2401,
    2553,  2400,  2402,   396,  2415,  2403,  2409,  2405,  2417,    97,
      98,    99,   100,   101,   102,  2421,  2418,  2422,   934,  2459,
     177,   178,   557,   558,   559,   560,   179,   180,  2429,   181,
     182,   183,   184,   185,   186,   187,   188,   189,  2446,  2423,
    2450,  2426,  2451,  2452,  2460,  2464,   190,   191,   192,  2471,
    2470,   193,  2262,  2472,  2474,  2493,  2489,  2494,   397,   194,
    2483,   398,  2490,  2496,  2492,  2277,  2495,   195,  2500,   196,
    2498,   507,  2506,  1946,  2510,  2520,  2513,  2528,  2529,  2530,
    2306,  2533,  2308,   508,  2538,  2534,  2540,  2545,  2542,  2543,
    2552,  2554,  2555,  2556,  2557,  2558,  2322,  2323,  2324,  2537,
    2559,  2575,  2576,  2580,  2572,  2595,  2613,  2618,  2616,  2539,
     993,   994,   995,   996,   997,   998,  2619,  2602,  1808,  2655,
    2626,  2633,  2629,   465,   466,   467,   468,  1809,  1810,  1811,
    1812,  2662,  1813,  1814,  1815,  2656,    82,  1816,  2658,  1817,
    1818,    84,    85,  1971,  2663,  1819,  1820,   197,  2667,  2670,
    1821,   469,  2671,  2682,  2704,  2707,   470,  2708,  2690,   471,
    2712,  2657,   472,  2713,  2700,  2716,   391,  2714,  2721,  2723,
    1303,  1304,  2701,  2702,  1305,  1782,  2231,  1829,  1830,  1831,
    2017,   509,  1832,  2230,  2232,  2019,  1622,  2455,  2018,   936,
    1499,  1963,  2462,   999,  1000,  1001,  1002,  1003,  1004,  1005,
    1006,  1007,  1008,  1009,  1858,  1286,   198,  2548,  1287,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   561,   339,
     340,   341,   342,   343,   344,  2549,  1288,  1472,   918,   501,
     837,  1216,  1644,  2491,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,  1597,  1598,  2666,  2685,  1028,  1654,
     392,  2512,  2148,  2045,  2055,   393,   394,  2521,  1424,   395,
    2063,   209,   210,   396,  2074,  2173,  2625,  2480,  2505,    97,
      98,    99,   100,   101,   102,  2635,   160,  2509,   161,   162,
     163,   164,   165,   166,  2508,   167,  1956,  2637,  1246,  1364,
       0,   211,  1339,   168,   169,     0,     0,     0,   170,  1084,
       0,     0,     0,     0,     0,     0,   212,     0,     0,     0,
     171,   172,     0,   173,  2569,   174,   175,     0,   397,   176,
    1808,   398,     0,     0,     0,   213,   214,   215,   216,  1809,
    1810,  1811,  1812,     0,  1813,  1814,  1815,     0,     0,  1816,
       0,  1817,  1818,   399,     0,     0,     0,  1819,  1820,  2601,
       0,     0,  1828,     0,     0,     0,     0,     0,  2604,  2606,
       0,     0,     0,     0,     0,     0,  2609,  2610,     0,     0,
    2612,     0,   177,   178,   557,   558,   559,   560,   179,   180,
       0,   181,   182,   183,   184,   185,   186,   187,   188,   189,
       0,  2630,     0,     0,     0,  2634,     0,  2636,   190,   191,
     192,     0,     0,   193,     0,     0,     0,   217,   218,     0,
       0,   194,     0,     0,     0,     0,  2642,  2643,     0,   195,
       0,   196,     0,   219,   220,     0,     0,  2646,     0,     0,
       0,     0,     0,     0,  2651,     0,  2652,  2653,  2654,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,     0,   972,   973,
       0,     0,     0,     0,     0,     0,   974,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   249,   250,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   197,
       0,  2686,   975,     0,   976,     0,     0,     0,     0,     0,
     593,     0,  2691,     0,     0,   594,   595,   596,   597,   598,
       0,     0,     0,     0,     0,     0,     0,     0,  2698,     0,
       0,   977,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   978,   979,   608,   980,   981,   982,   983,   984,     0,
       0,     0,     0,     0,     0,   985,   986,   987,   198,   988,
     989,     0,     0,   160,     0,   161,   162,   163,   164,   165,
     166,     0,   167,     0,     0,     0,     0,     0,     0,     0,
     168,   169,  1585,     0,     0,   170,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,     0,   171,   172,     0,
     173,     0,   174,   175,     0,     0,   176,     0,     0,     0,
       0,     0,     0,   209,   210,     0,   594,   595,   596,   597,
     598,     0,     0,     0,     0,     0,     0,     0,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,     0,   211,   608,   599,   600,   601,   602,   603,
     604,   605,   606,   607,     0,     0,   608,     0,   212,   177,
     178,     0,     0,     0,     0,   179,   180,     0,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   213,   214,   215,
     216,     0,     0,  1274,     0,   190,   191,   192,     0,     0,
     193,     0,     0,     0,     0,  1275,     0,     0,   194,   594,
     595,   596,   597,   598,     0,     0,   195,     0,   196,     0,
       0,   594,   595,   596,   597,   598,   599,   600,   601,   602,
     603,   604,   605,   606,   607,     0,     0,   608,   599,   600,
     601,   602,   603,   604,   605,   606,   607,     0,     0,   608,
       0,     0,  1576,   330,   331,   332,   333,   334,   335,   336,
     337,   338,     0,   339,   340,   341,   342,   343,   344,   217,
     218,     0,     0,     0,     0,     0,  1577,     0,     0,     0,
       0,     0,     0,     0,     0,   219,   220,     0,  1276,     0,
       0,     0,     0,     0,     0,     0,   197,     0,     0,     0,
       0,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   249,   250,
       0,     0,     0,     0,     0,   198,     0,     0,     0,     0,
     160,     0,   161,   162,   163,   164,   165,   166,     0,   167,
       0,     0,     0,     0,     0,     0,     0,   168,   169,  1589,
       0,     0,   170,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,     0,   171,   172,     0,   173,     0,   174,
     175,     0,     0,   176,     0,     0,     0,     0,     0,     0,
     209,   210,     0,   594,   595,   596,   597,   598,     0,     0,
       0,     0,     0,     0,     0,   594,   595,   596,   597,   598,
     599,   600,   601,   602,   603,   604,   605,   606,   607,     0,
     211,   608,   599,   600,   601,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,   212,   177,   178,     0,     0,
       0,     0,   179,   180,     0,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   213,   214,   215,   216,     0,     0,
    1277,     0,   190,   191,   192,     0,     0,   193,     0,     0,
       0,     0,  1575,     0,     0,   194,   594,   595,   596,   597,
     598,     0,     0,   195,     0,   196,     0,     0,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,     0,     0,   608,   599,   600,   601,   602,   603,
     604,   605,   606,   607,     0,     0,   608,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   217,   218,     0,     0,
       0,     0,     0,  1834,     0,     0,     0,     0,     0,     0,
       0,     0,   219,   220,     0,  1964,     0,     0,     0,     0,
       0,     0,     0,   197,     0,     0,     0,     0,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   249,   250,     0,     0,     0,
       0,     0,   198,     0,     0,     0,     0,   160,     0,   161,
     162,   163,   164,   165,   166,     0,   167,     0,     0,     0,
       0,     0,     0,     0,   168,   169,  2025,     0,     0,   170,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
       0,   171,   172,     0,   173,     0,   174,   175,     0,     0,
     176,   594,   595,   596,   597,   598,     0,   209,   210,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   599,   600,
     601,   602,   603,   604,   605,   606,   607,     0,     0,   608,
       0,     0,     0,     0,     0,     0,     0,   211,     0,     0,
       0,     0,     0,     0,  1258,     0,     0,     0,     0,     0,
       0,     0,   212,   177,   178,     0,     0,     0,     0,   179,
     180,     0,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   213,   214,   215,   216,     0,     0,     0,     0,   190,
     191,   192,     0,     0,   193,     0,   594,   595,   596,   597,
     598,     0,   194,     0,     0,     0,     0,     0,     0,     0,
     195,     0,   196,   599,   600,   601,   602,   603,   604,   605,
     606,   607,     0,     0,   608,   594,   595,   596,   597,   598,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1273,
       0,     0,   599,   600,   601,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   217,   218,     0,     0,     0,  1278,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   219,
     220,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     197,     0,     0,     0,     0,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   249,   250,     0,     0,     0,     0,     0,   198,
       0,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,     0,   167,     0,     0,     0,     0,     0,     0,
       0,   168,   169,  2030,     0,     0,   170,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,     0,   171,   172,
       0,   173,     0,   174,   175,     0,     0,   176,   594,   595,
     596,   597,   598,     0,   209,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,     0,     0,   608,     0,     0,     0,
       0,     0,     0,     0,   211,     0,     0,     0,     0,     0,
       0,  1283,     0,     0,     0,     0,     0,     0,     0,   212,
     177,   178,     0,     0,     0,     0,   179,   180,     0,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   213,   214,
     215,   216,     0,     0,     0,     0,   190,   191,   192,     0,
       0,   193,     0,   594,   595,   596,   597,   598,     0,   194,
       0,     0,     0,     0,     0,     0,     0,   195,     0,   196,
     599,   600,   601,   602,   603,   604,   605,   606,   607,     0,
       0,   608,   594,   595,   596,   597,   598,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1355,     0,     0,   599,
     600,   601,   602,   603,   604,   605,   606,   607,     0,     0,
     608,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     217,   218,     0,     0,     0,  1356,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   219,   220,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   197,     0,     0,
       0,     0,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   249,
     250,     0,     0,     0,     0,     0,   198,     0,     0,     0,
       0,   160,     0,   161,   162,   163,   164,   165,   166,     0,
     167,     0,     0,     0,     0,     0,     0,     0,   168,   169,
    2032,     0,     0,   170,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,     0,   171,   172,     0,   173,     0,
     174,   175,     0,     0,   176,   594,   595,   596,   597,   598,
       0,   209,   210,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   599,   600,   601,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,     0,     0,     0,     0,     0,
       0,   211,     0,     0,     0,     0,     0,     0,  1835,     0,
       0,     0,     0,     0,     0,     0,   212,   177,   178,     0,
       0,     0,     0,   179,   180,     0,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   213,   214,   215,   216,     0,
       0,     0,     0,   190,   191,   192,     0,     0,   193,     0,
     594,   595,   596,   597,   598,     0,   194,     0,     0,     0,
       0,     0,     0,     0,   195,     0,   196,   599,   600,   601,
     602,   603,   604,   605,   606,   607,     0,     0,   608,   594,
     595,   596,   597,   598,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1836,     0,     0,   599,   600,   601,   602,
     603,   604,   605,   606,   607,     0,     0,   608,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   217,   218,     0,
       0,     0,  1837,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   219,   220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   197,     0,     0,     0,     0,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,     0,     0,     0,
       0,     0,     0,     0,   160,     0,   161,   162,   163,   164,
     165,   166,     0,   167,     0,     0,   249,   250,     0,     0,
       0,   168,   169,   198,     0,     0,   170,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   171,   172,
       0,   173,     0,   174,   175,     0,     0,   176,     0,     0,
       0,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,     0,     0,   594,   595,   596,   597,   598,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   209,   210,
     599,   600,   601,   602,   603,   604,   605,   606,   607,     0,
       0,   608,     0,     0,     0,     0,     0,     0,     0,     0,
     177,   178,     0,     0,  1345,     0,   179,   180,   211,   181,
     182,   183,   184,   185,   186,   187,   188,   189,  1543,     0,
       0,     0,     0,   212,     0,     0,   190,   191,   192,     0,
       0,   193,     0,     0,     0,     0,     0,     0,     0,   194,
       0,     0,   213,   214,   215,   216,   172,   195,  1349,   196,
       0,     0,     0,     0,   176,     0,     0,     0,   330,   331,
     332,   333,   334,   335,   336,   337,   338,     0,   339,   340,
     341,   342,   343,   344,  1544,     0,     0,  1546,  1547,  1548,
    1549,  1550,  1551,  1552,   330,   331,   332,   333,   334,   335,
     336,   337,   338,     0,   339,   340,   341,   342,   343,   344,
    1553,     0,     0,  1554,  1555,     0,     0,     0,     0,     0,
       0,     0,     0,   179,   180,     0,   181,   182,   183,   184,
     185,   186,   187,   188,   217,   218,     0,   197,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     219,   220,     0,     0,     0,     0,     0,     0,     0,     0,
    1556,     0,  1557,     0,     0,     0,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,     0,     0,   198,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   249,   250,     0,     0,   594,   595,   596,
     597,   598,     0,     0,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   599,   600,   601,   602,   603,   604,
     605,   606,   607,     0,   197,   608,   594,   595,   596,   597,
     598,   209,   210,     0,     0,     0,     0,     0,     0,     0,
    1838,     0,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,     0,     0,   608,     0,     0,     0,     0,     0,
       0,   211,     0,     0,     0,     0,     0,     0,     0,  1851,
       0,     0,     0,     0,     0,     0,   212,     0,     0,     0,
       0,     0,     0,   198,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   213,   214,   215,   216,     0,
       0,     0,     0,     0,   594,   595,   596,   597,   598,     0,
       0,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   599,   600,   601,   602,   603,   604,   605,   606,   607,
       0,     0,   608,   594,   595,   596,   597,   598,   209,   210,
       0,     0,     0,     0,     0,     0,     0,  1989,     0,     0,
     599,   600,   601,   602,   603,   604,   605,   606,   607,     0,
       0,   608,     0,     0,     0,     0,     0,     0,   211,     0,
       0,     0,     0,     0,     0,     0,  1990,   217,   218,     0,
       0,     0,     0,   212,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   219,   220,     0,     0,     0,     0,     0,
       0,     0,   213,   214,   215,   216,     0,     0,     0,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1031,
       0,   594,   595,   596,   597,   598,   249,   250,     0,     0,
       0,     0,     0,   547,   874,   875,   876,     0,   599,   600,
     601,   602,   603,   604,   605,   606,   607,     0,     0,   608,
       0,     0,     0,     0,   217,   218,   594,   595,   596,   597,
     598,     0,     0,   171,  2127,     0,     0,     0,   174,   175,
     219,   220,     0,   599,   600,   601,   602,   603,   604,   605,
     606,   607,     0,     0,   608,     0,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,  1543,     0,     0,     0,     0,     0,
       0,     0,  1032,  1033,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   249,   250,     0,     0,     0,     0,     0,
       0,     0,   172,     0,     0,     0,     0,     0,     0,     0,
     176,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1034,   854,     0,     0,     0,     0,
    1544,  1545,     0,  1546,  1547,  1548,  1549,  1550,  1551,  1552,
    1035,     0,     0,     0,  1036,     0,     0,  1037,  1038,     0,
       0,     0,  1039,     0,     0,     0,  1553,     0,     0,  1554,
    1555,     0,     0,     0,     0,     0,     0,     0,     0,   179,
     180,  1040,   181,   182,   183,   184,   185,   186,   187,   188,
       0,  1543,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1041,  1042,  1043,     0,     0,  1044,
    1045,  1046,     0,     0,     0,     0,  1556,     0,  1557,   172,
     594,   595,   596,   597,   598,     0,     0,   176,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,     0,  1544,   608,     0,
    1546,  1547,  1548,  1549,  1550,  1551,  1552,     0,     0,     0,
       0,     0,     0,  2387,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1553,     0,     0,  1554,  1555,     0,     0,
       0,     0,     0,     0,     0,     0,   179,   180,     0,   181,
     182,   183,   184,   185,   186,   187,   188,     0,     0,     0,
     197,     0,     0,     0,     0,     0,     0,     0,     0,   594,
     595,   596,   597,   598,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1556,     0,  1557,   599,   600,   601,   602,
     603,   604,   605,   606,   607,     0,     0,   608,     0,     0,
       0,     0,     0,   594,   595,   596,   597,   598,     0,     0,
       0,     0,  2388,     0,     0,     0,     0,     0,     0,   198,
     599,   600,   601,   602,   603,   604,   605,   606,   607,     0,
       0,   608,     0,     0,     0,     0,     0,     0,     0,     0,
     594,   595,   596,   597,   598,     0,  2389,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   599,   600,   601,
     602,   603,   604,   605,   606,   607,     0,   197,   608,   594,
     595,   596,   597,   598,   209,   210,     0,     0,     0,     0,
       0,     0,     0,  2390,     0,     0,   599,   600,   601,   602,
     603,   604,   605,   606,   607,     0,     0,   608,     0,     0,
       0,     0,     0,     0,   211,     0,     0,     0,     0,     0,
       0,     0,  2546,     0,  2096,     0,     0,     0,     0,   212,
       0,     0,     0,     0,     0,     0,   198,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   213,   214,
     215,   216,   172,     0,     0,     0,     0,     0,     0,     0,
     176,     0,     0,     0,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,     0,     0,   594,   595,   596,   597,
     598,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   209,   210,   599,   600,   601,   602,   603,   604,   605,
     606,   607,     0,     0,   608,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1968,     0,   179,
     180,   211,   181,   182,   183,   184,   185,   186,   187,   188,
     217,   218,     0,     0,     0,     0,   212,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   219,   220,     0,     0,
       0,     0,     0,     0,     0,   213,   214,   215,   216,     0,
       0,     0,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2278,   594,   595,   596,   597,   598,   249,
     250,     0,     0,     0,     0,     0,     0,     0,  2279,     0,
       0,   599,   600,   601,   602,   603,   604,   605,   606,   607,
       0,     0,   608,     0,     0,     0,     0,   217,   218,     0,
     197,     0,     0,     0,     0,     0,     0,  2659,     0,     0,
       0,     0,     0,   219,   220,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,     0,     0,   198,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   197,     0,     0,   249,   250,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,     0,  2151,  2152,
     594,   595,   596,   597,   598,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   209,   210,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,     0,     0,   608,  2154,
       0,     0,   198,     0,     0,     0,     0,     0,     0,     0,
       0,  2088,     0,     0,   211,     0,     0,  2280,     0,     0,
       0,  2281,  2282,     0,     0,  2283,  2284,     0,     0,   212,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
       0,     0,     0,     0,     0,     0,     0,     0,   213,   214,
     215,   216,  2285,     0,     0,     0,     0,   209,   210,  2286,
       0,     0,     0,     0,  2287,     0,     0,     0,     0,     0,
       0,  2288,     0,     0,     0,     0,  2289,     0,     0,  2290,
       0,     0,     0,     0,     0,     0,     0,   211,   594,   595,
     596,   597,   598,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   212,     0,     0,   599,   600,   601,   602,   603,
     604,   605,   606,   607,     0,     0,   608,     0,     0,     0,
       0,   213,   214,   215,   216,     0,     0,  2291,     0,  2100,
     217,   218,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   219,   220,     0,     0,
       0,     0,     0,     0,  2292,     0,     0,     0,     0,     0,
       0,     0,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
       0,  2293,     0,     0,  2294,  2295,  2296,   408,   409,     0,
       0,     0,  2297,   217,   218,     0,     0,  2298,     0,   249,
     250,     0,     0,     0,     0,     0,     0,  2299,     0,   219,
     220,     0,   410,  2300,     0,     0,     0,     0,     0,     0,
     411,     0,     0,     0,     0,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   412,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   594,   595,   596,   597,   598,
       0,     0,   249,   250,     0,     0,     0,     0,     0,     0,
     413,     0,   599,   600,   601,   602,   603,   604,   605,   606,
     607,     0,     0,   608,     0,     0,   392,     0,     0,     0,
       0,   393,   394,     0,   414,   415,  2101,     0,     0,   396,
     416,     0,     0,     0,     0,   417,   418,   419,   420,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   421,     0,
       0,     0,   422,     0,   423,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   397,     0,     0,   398,     0,     0,
       0,     0,     0,     0,     0,     0,   424,     0,     0,     0,
     425,     0,     0,     0,     0,     0,     0,     0,     0,   426,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   427,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   428,   429,   430,     0,   431,
       0,     0,     0,   432,     0,     0,   433,   434,     0,   435,
     436,     0,     0,   437,   438,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   439,
     440,     0,     0,     0,   441,   442,   443,     0,     0,     0,
       0,     0,     0,   444,     0,     0,     0,   445,     0,     0,
     446,   447,     0,   448,     0,   449,     0,     0,     0,   450,
     451,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   452,     0,     0,     0,     0,     0,     0,     0,   453,
     454,     0,     0,     0,     0,     0,     0,     0,     0,   455
};

static const yytype_int16 yycheck[] =
{
     103,     7,   430,   431,  1247,    89,   565,   165,  1247,   165,
     196,    81,   736,   354,   160,   465,    86,    87,   196,  1247,
     280,   139,   495,   507,   784,    67,   367,   368,    80,   133,
    1247,   149,   150,   137,    88,   139,    25,   141,   196,   634,
     196,  1279,  1280,  1281,  1282,   149,   150,   788,    21,    80,
      23,    80,   156,  1034,   534,    80,   536,   537,   634,    18,
     540,   541,    80,  1547,    23,    50,  2263,   368,     6,   128,
      80,   130,   128,   132,  1509,   134,  1560,   136,    50,   138,
     675,   128,    88,   142,   300,   144,    37,   146,   429,   148,
    2092,    88,   352,   353,    53,   154,   155,  2092,  1079,    23,
      18,    25,    40,  2092,     6,    23,  1349,    23,   176,    25,
     451,    80,    50,    87,    52,    50,   170,    55,    56,    25,
      50,  1349,   258,    41,    42,    43,    44,   468,    50,  2210,
      51,    18,  1349,   164,   394,    53,    23,   172,   169,   170,
     206,   207,   173,    81,   212,  1049,   177,   248,    18,  2478,
     634,   142,   493,    23,   126,   283,    18,    23,    23,   225,
      25,    23,     6,    23,   170,    25,    53,   173,     3,     4,
       5,    18,     3,    51,    78,   516,    23,    20,    21,    23,
      23,   336,    23,    53,    18,    80,   314,    20,    21,    23,
      23,    53,    69,    70,    41,    42,    43,    44,  1796,    23,
     176,   232,    51,   248,   235,   176,    53,    41,    42,    43,
      44,   176,   176,   151,    23,   153,   154,    18,   156,    53,
     158,    65,    23,   323,    10,     6,   164,   279,   166,   167,
     168,  1825,   170,    69,    70,   357,    34,  1831,   441,   210,
      41,    42,    43,    44,   447,   183,   184,   185,   186,   187,
     188,    79,    53,   148,   149,    18,     7,    23,   162,    25,
      23,    80,   365,    42,    54,    48,    48,    42,   257,    52,
      52,   372,    18,    92,     0,   345,   398,    23,    41,    42,
      43,    44,   203,   733,    23,    34,    25,    28,    78,   278,
      53,    18,    78,   396,   397,  2624,    23,   235,  2627,   369,
      79,   456,  2383,   241,    79,   171,   137,    53,   867,   247,
     248,   195,    53,   178,    41,    42,    43,    44,   153,   422,
     164,   880,   357,    18,   752,   203,    53,   372,    23,   148,
     149,   303,   173,   309,   386,   170,   242,   301,   309,   310,
     681,    69,    70,   171,   309,   319,   206,   171,    23,    48,
      25,    50,   150,   539,   203,   306,    55,    56,    53,   178,
     195,   196,   171,   240,   259,   260,   707,    78,   263,   437,
     470,   712,  1096,   281,   348,   511,   717,   279,   719,  2576,
    2382,    80,    48,   357,  1627,   370,    52,  2382,   534,   441,
     536,   537,   171,  2382,   540,   541,   171,  1832,   233,  1627,
     235,   150,   237,   400,   240,   171,   707,  1311,  1312,     6,
    1627,  2282,   403,   248,   258,   504,   757,   758,     6,   296,
     476,   637,   638,   639,   640,   641,   245,   643,   644,   485,
     646,   647,   171,   649,   650,   370,    25,   917,   485,   258,
     370,     6,   277,   284,   512,    78,   281,     6,   370,   160,
     791,   286,   287,   794,   483,   861,   884,  1033,   886,   865,
     296,   437,    80,   517,   165,   164,   382,   485,   251,   251,
     169,   170,   437,   562,   492,   485,   320,   223,   177,   521,
    1964,   491,   369,  2354,   183,   184,   185,   186,   187,   188,
      79,   832,   517,   518,  1475,    48,   171,  2095,   523,  1240,
    2098,   842,   843,   476,   570,    51,   560,   561,   562,   563,
     564,   565,   240,   482,   483,   487,   857,   486,   487,   488,
     861,  1080,  2116,  2117,   865,   484,    54,    80,   223,   162,
    2124,  2125,   538,   232,   452,   262,   235,   380,    53,   386,
      86,   842,   843,  1786,   575,   551,    78,  1790,  2433,  1033,
      78,   385,   526,   527,   528,   399,   897,   390,  1786,   900,
     566,   567,   568,   569,   570,   571,   636,   908,   296,  1786,
    2076,   577,   373,   374,   444,   445,   411,   421,   567,   568,
     569,   443,   200,   201,   314,   251,    42,   317,   594,   595,
     596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   365,  1841,   208,  1843,   784,   448,  1846,   453,
    1848,  1849,  1207,   231,     6,  1647,    23,   316,    25,   165,
    1652,   462,   463,    79,    53,   172,   784,   386,   784,   180,
     162,   249,   245,   571,   355,   559,   183,   184,   365,    48,
    2146,    36,   566,    52,   189,    10,   316,   200,   201,   202,
     349,   350,   471,   323,   473,   474,    51,   203,   195,   478,
     479,    92,   481,   209,   251,    80,   425,   179,  2174,   728,
     489,   490,   393,   291,    10,   259,   370,   683,   231,   181,
     284,   249,    48,   229,    53,   236,    52,    18,   694,    54,
     308,   450,    23,    20,    21,   701,    23,  2582,  2583,  2205,
     253,   254,   423,   110,   257,   197,   208,   428,  2593,  2594,
     376,   377,   815,    78,    28,   171,    80,   875,    54,   875,
     307,   442,    53,    80,  1756,    39,  1969,    79,   341,   450,
    1969,  1763,  1975,  1493,  1184,   429,   289,   572,   573,   292,
     327,  1969,    23,    24,    18,   466,    10,  1975,   469,    23,
     303,   472,  1969,   366,   150,   308,   324,   304,   173,   151,
     152,   482,    54,   178,   171,   951,   952,    41,    42,    43,
      44,   917,     9,    10,    11,    12,   954,  1257,    36,    53,
    1260,    18,   284,   336,   148,    36,    78,   179,  1129,  1130,
      54,  1132,  1133,    18,   151,   152,   954,   299,   954,   520,
      54,   522,  1143,   234,    33,    34,   359,   164,   426,   427,
     428,   203,   169,   170,    79,    14,    15,    98,   517,  1160,
     177,  1162,   179,   522,    78,   524,    10,   234,   320,    14,
      15,  1172,    20,  1174,   320,    23,  1177,  1178,   202,  1180,
       6,  1182,   251,    10,   336,    54,    79,    54,   854,  1065,
      79,  1067,   344,    53,  1195,    23,    24,    23,    24,  1200,
      50,    53,   348,   349,   279,    55,    56,   167,  1209,    78,
      54,    78,  1213,   426,  1032,   232,  1032,  1327,   235,    78,
      53,  1331,  1332,    51,   248,   251,  1525,    54,   252,  1528,
      80,   255,   256,    78,  2132,    23,   449,    25,    18,  2137,
     149,  2139,  1243,    23,  2142,    53,    20,    21,   265,    23,
      23,  1252,    25,    18,   467,    81,    53,  1476,    23,   151,
     152,    41,    42,    43,    44,    78,   932,    80,   934,  1057,
    1058,  1059,  1060,    53,  1062,  1063,    53,    42,  1066,   171,
    1068,    53,  1070,  1071,   176,   245,   246,   247,    53,    23,
      24,   504,   505,   506,   507,    23,   509,    25,    26,   191,
     513,   392,   377,   149,  1392,    79,  2209,   376,   377,   400,
    2209,   402,    39,   404,   164,    78,   407,    80,  1081,   169,
     170,  2209,    78,   173,    80,   151,  1459,   177,   262,    20,
      21,  1094,  2209,   183,   184,   185,   186,   187,   188,   415,
     416,   167,   168,  1106,  1728,  1108,  1090,     6,   423,  1127,
     376,   377,  2009,   179,    18,  2012,    45,    46,    47,    23,
     741,  2018,  2019,  1127,  1128,   440,    23,   442,    25,    20,
      21,   446,    23,   327,   328,   450,   451,    41,    42,    43,
      44,    25,   232,    20,    21,   235,    23,   284,   285,    53,
     771,   772,    78,   774,    80,   412,   413,   339,   340,    18,
      19,    20,    21,    22,    23,    20,    21,  1408,    23,   790,
      80,    18,    19,    20,    21,   796,    86,   798,     6,   800,
     801,     6,   803,   804,   805,   806,   807,   808,  1158,    80,
     811,   365,   813,    23,    53,    25,   817,   818,  1526,   148,
     149,    80,    18,  1207,   825,   826,    53,    23,   829,   174,
     175,  1257,   833,   172,  1260,     6,  1234,  1235,  1236,  1379,
       6,    48,   180,   181,   182,    41,    42,    43,    44,  1470,
    1234,  1235,  1236,    60,   254,   313,  1477,    53,    65,    23,
     199,  1299,   206,  1299,   208,   866,   204,   205,  1707,   128,
     208,  1710,   171,    80,   164,   495,   496,   497,   879,   169,
     170,     6,  2400,   173,  2402,    20,    21,   177,    23,     6,
      25,   230,    50,   894,   238,   896,  1517,    55,    56,     6,
    1521,   245,    21,     6,    23,   164,    20,    21,     6,    23,
     169,   170,    18,   243,   244,   174,   175,    23,   177,     6,
     179,    18,    80,   162,    25,  1333,    23,  1335,    18,     6,
      18,   190,    20,    23,   278,    23,   280,     6,    20,    21,
     199,    23,   232,  1564,   288,   235,    52,    53,    78,   288,
      80,    41,    42,    43,    44,    52,    53,    18,    52,   303,
      54,    18,    23,    53,   303,    53,    80,  1375,     6,   253,
     254,   504,    33,   232,    35,   317,   235,   319,  1264,   449,
       6,    35,    36,  1347,   191,    39,  1272,    28,  1274,  1275,
    1276,  1277,    53,   200,   201,   191,    46,    47,    80,  1285,
    1350,    20,    21,    22,    23,  1291,   164,     6,  1738,    46,
      47,   169,   170,    23,   304,   305,    23,  1638,  1639,   177,
    1157,   311,  1159,    52,   231,   183,   184,   185,   186,   187,
     188,    20,    21,   503,    23,  1493,    10,    20,    21,  1660,
     264,   265,     9,    52,    18,   249,   253,   254,    80,    23,
     257,    18,    19,    20,    21,  1493,    52,  1493,  1639,    33,
     502,    35,   408,   409,    79,  1686,  1687,  1505,   253,   254,
     414,  1509,   411,    18,   232,   414,    23,   235,    23,    53,
      65,    66,    51,   290,   291,   292,    53,    18,    79,    20,
     248,   165,    23,   253,   254,  1478,    41,    42,    43,    44,
     161,   308,   163,    14,    15,  1686,   293,   294,    53,  1730,
    1731,   258,    50,    80,  1735,    80,   148,    55,    56,    52,
      51,  1742,    53,    79,  1745,   464,    52,   151,   152,   468,
     469,   289,    52,   392,    79,  2658,  1137,  1138,    79,  2658,
     200,   201,    80,  1526,    79,  2663,  1147,   171,  1149,  1770,
    2658,  1772,   176,   336,    92,   179,    79,   501,    52,  1780,
      25,  2658,   501,   128,   254,   212,   213,   191,   200,   201,
     202,   151,   152,    50,   325,   210,   211,   371,    55,    56,
     258,   525,   217,   218,   219,   220,   525,   161,   312,   163,
     529,   171,   195,  1194,   212,   213,   176,   262,  2716,   231,
    1908,  1202,  1823,    80,  1642,   170,  1642,   262,  1829,   174,
     175,   191,   183,   184,   179,   314,   289,   197,   139,   140,
     252,   323,   143,   255,   256,   190,   164,   339,  1229,   150,
     151,   169,   170,   289,   199,   173,  2236,  2237,   577,   177,
    1861,  1862,   166,  1244,  1245,   183,   184,   185,   186,   187,
     188,    18,    19,    20,    21,    22,    23,   352,   289,   345,
    1546,  1547,   144,  1549,   360,   358,   151,  1553,  1554,   312,
     381,  1621,    52,  1623,  1560,   391,   308,  1985,    79,    52,
    1861,  1862,    20,    21,    22,    23,    53,   164,    79,  1575,
      18,  1577,   169,   170,   232,    23,   181,   235,    79,   457,
     177,   164,   461,   248,   195,   165,   183,   184,   185,   186,
     187,   188,    50,    41,    42,    43,    44,    55,    56,   204,
     197,   206,   370,   208,    50,    53,    11,    12,    13,    55,
      56,  1952,   377,    18,    20,    21,    52,    23,    23,    25,
      79,    18,  2050,    28,    29,    30,    79,    11,    12,    13,
      18,    79,    52,    52,    80,   232,   151,   152,   235,   392,
     393,   394,   395,   396,    28,    29,    30,    23,    53,  1370,
    1371,   529,   530,   191,   233,   179,   171,   193,   194,   195,
     196,   176,    52,  2004,   179,    52,    18,   264,    79,  2010,
    1826,    23,    79,   179,  1832,   162,   191,   282,   283,   284,
     285,    79,   197,    79,   258,    52,  1407,    52,   285,    41,
      42,    43,    44,    79,   364,   179,   574,   575,   576,   195,
     253,    53,   212,   213,   214,   215,   216,   112,   113,    52,
    1794,    18,    19,    20,    21,  2056,  2057,  2058,   164,   262,
      52,    79,    79,   169,   170,   262,  2067,   173,   112,   113,
      52,   177,   212,   213,   214,   215,   216,   183,   184,   185,
     186,   187,   188,    17,    36,  1466,    53,  1468,  1469,    18,
    1471,    71,    72,    73,    74,  2056,  2057,  2058,    18,    19,
      20,    21,    22,    23,    18,    33,    39,  1488,  2109,  1490,
      34,  2112,  2667,  2114,  1495,  2670,  2671,    18,  1784,  1882,
      11,    12,    13,    14,    15,    78,   232,  2682,    10,   235,
      18,    18,  1798,    53,  1800,  1516,     6,    28,    29,    30,
      31,    32,    33,    34,    35,    36,     6,     6,    39,    53,
       6,  1881,  2707,  2708,     6,  2156,  2157,  2712,  2713,     6,
       6,    18,    19,    20,    21,    22,    23,     6,  1834,     6,
       6,   489,   490,     6,     6,   493,     6,     6,    52,    78,
     498,  2182,    78,    52,    52,  2186,  2187,   381,  2189,    23,
    2191,    52,   262,   262,   300,  2156,    53,    52,   262,    11,
      12,    13,    14,    15,    52,   350,   236,   262,   465,   466,
     467,    52,    52,    79,    52,   106,    28,    29,    30,    31,
      32,    33,    34,    35,    36,   262,    37,    39,   262,   262,
    2231,   262,  2233,  2234,  2235,  2073,  2074,    52,   165,   378,
     251,   251,  1972,    52,    52,  2246,  2092,   191,    18,  2250,
      18,    23,   198,  2254,    52,  2073,  2074,  2073,  2074,   319,
     295,    18,    51,    18,    60,   150,    18,    79,    34,    53,
     251,    78,  2360,    78,   251,     6,    23,  1658,    23,  2280,
       6,   179,   179,     6,    80,  2286,  2287,    54,    23,    52,
      52,  2292,    25,  2294,    52,  2296,    34,  2298,  1964,    78,
     195,    52,  1683,  2304,    52,   262,    52,    18,  1974,    52,
      52,    52,    52,    52,   192,  2316,  2317,    78,    52,  2320,
    2321,    50,  1703,  1704,  1705,    52,   191,  1708,    52,    79,
      52,    52,   128,    52,    52,    52,    52,    52,    52,    11,
      12,    13,  2343,   139,    52,    52,  2347,    52,    52,  2350,
      52,  1732,    52,    52,    52,  2356,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    52,  2367,    39,    11,    12,
      13,  2037,    52,    52,   170,    21,    34,    34,   174,   175,
    1761,    18,    18,   179,    23,    28,    29,    30,    31,    32,
      33,    34,    35,    36,   190,     6,    39,     6,     6,  2162,
       6,     6,     6,   199,    18,     6,     6,     6,  2409,  2410,
    2411,  2412,  2413,     6,    54,    78,  2417,  2418,   261,   261,
      52,  2422,  2423,    25,    52,  2426,    52,   164,   312,    52,
      78,  2432,    52,    52,    52,    52,  2102,  2103,  2104,    52,
    2106,   364,    52,   297,   347,  2446,  2447,  2448,   244,    52,
     246,   179,   248,   371,    52,    52,  2417,  2418,    52,   195,
      52,  2422,  2423,  2464,  2465,  2426,    52,    52,    52,  2470,
      52,    49,    50,    52,  2562,  2563,    52,    55,    56,    52,
    2481,    52,   179,    60,  2485,   139,    52,  2488,  2489,   258,
      52,  1872,  2493,  2494,   454,   181,    52,    52,   149,    52,
      36,  2502,    80,   197,    53,    53,    53,    52,    28,  2327,
      36,    34,  2513,  2514,  2515,  2603,    18,    78,    78,  2520,
     429,   430,   431,   432,   433,   434,   435,   436,  2529,  2530,
      21,     6,  2533,  2534,     6,  2381,  2382,    80,    52,    18,
     165,    79,   262,  1924,  1925,    52,   191,  2213,   410,   262,
     346,    52,    52,   406,   405,    52,  2222,  2558,  2559,   355,
     356,   254,   321,    79,    79,   297,   362,    79,  2529,    79,
     366,    79,    48,  1954,    69,   191,    18,    80,    52,   375,
      18,    52,    52,    34,    61,    68,   164,    52,   384,    38,
     386,   169,   170,   389,    52,    35,    50,    10,    35,   177,
      80,    55,    56,    28,    54,   183,   184,   185,   186,   187,
     188,    79,   307,  2376,   401,  2616,    52,  2618,  2619,   399,
     282,   255,   255,   195,   255,  2626,    80,   262,    54,   110,
      53,    79,  2633,    79,    79,    79,    53,    53,    52,    10,
     304,    53,    52,    78,    16,    77,    18,    19,    20,    21,
      22,    23,    54,    25,   232,    54,    54,   235,    53,    52,
      54,    33,    34,    35,    54,    52,    38,    36,   107,    18,
     248,    11,    12,    13,    14,    15,    35,    35,    50,    51,
      10,    53,    79,    55,    56,  2066,   254,    59,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    50,    79,    39,
      52,    52,    55,    56,    52,    52,    10,   485,   323,   485,
     164,    54,    78,    54,    54,   169,   170,    54,    54,    54,
    2386,    78,    53,   177,   258,    54,   295,   297,   255,   183,
     184,   185,   186,   187,   188,    52,   255,   255,    78,   431,
     112,   113,   114,   115,   116,   117,   118,   119,   210,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   295,   255,
     258,   255,   458,    79,   360,   323,   138,   139,   140,   429,
     126,   143,  2153,    52,    52,   262,   477,   480,   232,   151,
     470,   235,   470,   307,   475,  2166,   297,   159,    52,   161,
     307,   245,    52,    25,    52,   262,   295,   360,   262,   126,
    2181,   262,  2183,   257,   510,   262,    52,    52,   520,   519,
      52,    52,    52,    52,    52,    36,  2197,  2198,  2199,   508,
      36,    80,    52,    25,   302,    80,   494,   255,   262,   514,
     183,   184,   185,   186,   187,   188,   255,   459,    48,   201,
     262,   191,   472,   421,   422,   423,   424,    57,    58,    59,
      60,    54,    62,    63,    64,   201,    50,    67,   111,    69,
      70,    55,    56,    23,    78,    75,    76,   239,    52,    52,
      80,   449,    52,    52,    52,    52,   454,    52,   443,   457,
      52,  2547,   460,    52,   443,    78,    80,   438,    52,    54,
    1032,  1032,  2655,  2656,  1032,  1536,  2113,  1579,  1579,  1579,
    1829,   355,  1579,  2112,  2114,  1831,  1348,  2288,  1830,   564,
    1224,  1786,  2293,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,  1627,   951,   298,  2381,   952,    89,
      90,    91,    92,    93,    94,    95,    96,    97,   173,    99,
     100,   101,   102,   103,   104,  2382,   954,  1205,   539,   141,
     475,   837,  1376,  2334,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,  1292,  1294,  2576,  2595,   629,  1391,
     164,  2352,  2045,  1878,  1894,   169,   170,  2358,  1171,   173,
    1907,   353,   354,   177,  1933,  2070,  2486,  2327,  2344,   183,
     184,   185,   186,   187,   188,  2497,    16,  2348,    18,    19,
      20,    21,    22,    23,  2347,    25,  1776,  2499,   891,  1110,
      -1,   383,  1074,    33,    34,    -1,    -1,    -1,    38,   678,
      -1,    -1,    -1,    -1,    -1,    -1,   398,    -1,    -1,    -1,
      50,    51,    -1,    53,  2415,    55,    56,    -1,   232,    59,
      48,   235,    -1,    -1,    -1,   417,   418,   419,   420,    57,
      58,    59,    60,    -1,    62,    63,    64,    -1,    -1,    67,
      -1,    69,    70,   257,    -1,    -1,    -1,    75,    76,  2450,
      -1,    -1,    80,    -1,    -1,    -1,    -1,    -1,  2459,  2460,
      -1,    -1,    -1,    -1,    -1,    -1,  2467,  2468,    -1,    -1,
    2471,    -1,   112,   113,   114,   115,   116,   117,   118,   119,
      -1,   121,   122,   123,   124,   125,   126,   127,   128,   129,
      -1,  2492,    -1,    -1,    -1,  2496,    -1,  2498,   138,   139,
     140,    -1,    -1,   143,    -1,    -1,    -1,   499,   500,    -1,
      -1,   151,    -1,    -1,    -1,    -1,  2517,  2518,    -1,   159,
      -1,   161,    -1,   515,   516,    -1,    -1,  2528,    -1,    -1,
      -1,    -1,    -1,    -1,  2535,    -1,  2537,  2538,  2539,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,    -1,    57,    58,
      -1,    -1,    -1,    -1,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   578,   579,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,
      -1,  2602,    91,    -1,    93,    -1,    -1,    -1,    -1,    -1,
       6,    -1,  2613,    -1,    -1,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2629,    -1,
      -1,   120,    28,    29,    30,    31,    32,    33,    34,    35,
      36,   130,   131,    39,   133,   134,   135,   136,   137,    -1,
      -1,    -1,    -1,    -1,    -1,   144,   145,   146,   298,   148,
     149,    -1,    -1,    16,    -1,    18,    19,    20,    21,    22,
      23,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    35,    -1,    -1,    38,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,    -1,    50,    51,    -1,
      53,    -1,    55,    56,    -1,    -1,    59,    -1,    -1,    -1,
      -1,    -1,    -1,   353,   354,    -1,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,    12,
      13,    14,    15,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,   383,    39,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    39,    -1,   398,   112,
     113,    -1,    -1,    -1,    -1,   118,   119,    -1,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   417,   418,   419,
     420,    -1,    -1,    78,    -1,   138,   139,   140,    -1,    -1,
     143,    -1,    -1,    -1,    -1,    78,    -1,    -1,   151,    11,
      12,    13,    14,    15,    -1,    -1,   159,    -1,   161,    -1,
      -1,    11,    12,    13,    14,    15,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    39,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    -1,    -1,    39,
      -1,    -1,    54,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    -1,    99,   100,   101,   102,   103,   104,   499,
     500,    -1,    -1,    -1,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   515,   516,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   239,    -1,    -1,    -1,
      -1,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   578,   579,
      -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,
      16,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    35,
      -1,    -1,    38,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,    -1,    50,    51,    -1,    53,    -1,    55,
      56,    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,
     353,   354,    -1,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    11,    12,    13,    14,    15,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    -1,
     383,    39,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    39,    -1,   398,   112,   113,    -1,    -1,
      -1,    -1,   118,   119,    -1,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   417,   418,   419,   420,    -1,    -1,
      78,    -1,   138,   139,   140,    -1,    -1,   143,    -1,    -1,
      -1,    -1,    78,    -1,    -1,   151,    11,    12,    13,    14,
      15,    -1,    -1,   159,    -1,   161,    -1,    -1,    11,    12,
      13,    14,    15,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   499,   500,    -1,    -1,
      -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   515,   516,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,    -1,    -1,    -1,    -1,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   578,   579,    -1,    -1,    -1,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    16,    -1,    18,
      19,    20,    21,    22,    23,    -1,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    35,    -1,    -1,    38,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,    50,    51,    -1,    53,    -1,    55,    56,    -1,    -1,
      59,    11,    12,    13,    14,    15,    -1,   353,   354,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    -1,    -1,    39,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   383,    -1,    -1,
      -1,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   398,   112,   113,    -1,    -1,    -1,    -1,   118,
     119,    -1,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   417,   418,   419,   420,    -1,    -1,    -1,    -1,   138,
     139,   140,    -1,    -1,   143,    -1,    11,    12,    13,    14,
      15,    -1,   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     159,    -1,   161,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    11,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
      -1,    -1,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   499,   500,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   515,
     516,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     239,    -1,    -1,    -1,    -1,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   578,   579,    -1,    -1,    -1,    -1,    -1,   298,
      -1,    -1,    -1,    -1,    16,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    35,    -1,    -1,    38,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,    50,    51,
      -1,    53,    -1,    55,    56,    -1,    -1,    59,    11,    12,
      13,    14,    15,    -1,   353,   354,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   383,    -1,    -1,    -1,    -1,    -1,
      -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   398,
     112,   113,    -1,    -1,    -1,    -1,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   417,   418,
     419,   420,    -1,    -1,    -1,    -1,   138,   139,   140,    -1,
      -1,   143,    -1,    11,    12,    13,    14,    15,    -1,   151,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   159,    -1,   161,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    -1,
      -1,    39,    11,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    54,    -1,    -1,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    -1,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     499,   500,    -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   515,   516,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   239,    -1,    -1,
      -1,    -1,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   578,
     579,    -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,
      -1,    16,    -1,    18,    19,    20,    21,    22,    23,    -1,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      35,    -1,    -1,    38,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,    50,    51,    -1,    53,    -1,
      55,    56,    -1,    -1,    59,    11,    12,    13,    14,    15,
      -1,   353,   354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   383,    -1,    -1,    -1,    -1,    -1,    -1,    54,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   398,   112,   113,    -1,
      -1,    -1,    -1,   118,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   417,   418,   419,   420,    -1,
      -1,    -1,    -1,   138,   139,   140,    -1,    -1,   143,    -1,
      11,    12,    13,    14,    15,    -1,   151,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   159,    -1,   161,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    39,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    -1,    -1,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   499,   500,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   515,   516,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   239,    -1,    -1,    -1,    -1,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    16,    -1,    18,    19,    20,    21,
      22,    23,    -1,    25,    -1,    -1,   578,   579,    -1,    -1,
      -1,    33,    34,   298,    -1,    -1,    38,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    51,
      -1,    53,    -1,    55,    56,    -1,    -1,    59,    -1,    -1,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    -1,    -1,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   353,   354,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    -1,
      -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     112,   113,    -1,    -1,    52,    -1,   118,   119,   383,   121,
     122,   123,   124,   125,   126,   127,   128,   129,    23,    -1,
      -1,    -1,    -1,   398,    -1,    -1,   138,   139,   140,    -1,
      -1,   143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   151,
      -1,    -1,   417,   418,   419,   420,    51,   159,    79,   161,
      -1,    -1,    -1,    -1,    59,    -1,    -1,    -1,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    -1,    99,   100,
     101,   102,   103,   104,    79,    -1,    -1,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    -1,    99,   100,   101,   102,   103,   104,
     105,    -1,    -1,   108,   109,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   118,   119,    -1,   121,   122,   123,   124,
     125,   126,   127,   128,   499,   500,    -1,   239,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     515,   516,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     155,    -1,   157,    -1,    -1,    -1,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,    -1,    -1,   298,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   578,   579,    -1,    -1,    11,    12,    13,
      14,    15,    -1,    -1,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    -1,   239,    39,    11,    12,    13,    14,
      15,   353,   354,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      54,    -1,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      -1,   383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,
      -1,    -1,    -1,    -1,    -1,    -1,   398,    -1,    -1,    -1,
      -1,    -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   417,   418,   419,   420,    -1,
      -1,    -1,    -1,    -1,    11,    12,    13,    14,    15,    -1,
      -1,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    39,    11,    12,    13,    14,    15,   353,   354,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    -1,
      -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,   383,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    54,   499,   500,    -1,
      -1,    -1,    -1,   398,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   515,   516,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   417,   418,   419,   420,    -1,    -1,    -1,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     6,
      -1,    11,    12,    13,    14,    15,   578,   579,    -1,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    -1,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    -1,    -1,    39,
      -1,    -1,    -1,    -1,   499,   500,    11,    12,    13,    14,
      15,    -1,    -1,    50,    54,    -1,    -1,    -1,    55,    56,
     515,   516,    -1,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,    23,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   578,   579,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   151,   152,    -1,    -1,    -1,    -1,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    88,
     167,    -1,    -1,    -1,   171,    -1,    -1,   174,   175,    -1,
      -1,    -1,   179,    -1,    -1,    -1,   105,    -1,    -1,   108,
     109,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   118,
     119,   198,   121,   122,   123,   124,   125,   126,   127,   128,
      -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   221,   222,   223,    -1,    -1,   226,
     227,   228,    -1,    -1,    -1,    -1,   155,    -1,   157,    51,
      11,    12,    13,    14,    15,    -1,    -1,    59,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    -1,    79,    39,    -1,
      82,    83,    84,    85,    86,    87,    88,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   105,    -1,    -1,   108,   109,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   118,   119,    -1,   121,
     122,   123,   124,   125,   126,   127,   128,    -1,    -1,    -1,
     239,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    11,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   155,    -1,   157,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    11,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,   298,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    -1,
      -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      11,    12,    13,    14,    15,    -1,    54,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    -1,   239,    39,    11,
      12,    13,    14,    15,   353,   354,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    54,    -1,    -1,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    -1,   383,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    54,    -1,    23,    -1,    -1,    -1,    -1,   398,
      -1,    -1,    -1,    -1,    -1,    -1,   298,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
     419,   420,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      59,    -1,    -1,    -1,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,    -1,    -1,    11,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   353,   354,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    52,    -1,   118,
     119,   383,   121,   122,   123,   124,   125,   126,   127,   128,
     499,   500,    -1,    -1,    -1,    -1,   398,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   515,   516,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   417,   418,   419,   420,    -1,
      -1,    -1,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    11,    12,    13,    14,    15,   578,
     579,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,
      -1,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      -1,    -1,    39,    -1,    -1,    -1,    -1,   499,   500,    -1,
     239,    -1,    -1,    -1,    -1,    -1,    -1,    54,    -1,    -1,
      -1,    -1,    -1,   515,   516,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,
     532,   533,   534,   535,   536,   537,   538,   539,   540,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,    -1,    -1,   298,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   239,    -1,    -1,   578,   579,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,    -1,   200,   201,
      11,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   353,   354,    -1,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    -1,    -1,    39,   231,
      -1,    -1,   298,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    52,    -1,    -1,   383,    -1,    -1,   249,    -1,    -1,
      -1,   253,   254,    -1,    -1,   257,   258,    -1,    -1,   398,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,   418,
     419,   420,   284,    -1,    -1,    -1,    -1,   353,   354,   291,
      -1,    -1,    -1,    -1,   296,    -1,    -1,    -1,    -1,    -1,
      -1,   303,    -1,    -1,    -1,    -1,   308,    -1,    -1,   311,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   383,    11,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   398,    -1,    -1,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    -1,    -1,    39,    -1,    -1,    -1,
      -1,   417,   418,   419,   420,    -1,    -1,   359,    -1,    52,
     499,   500,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   515,   516,    -1,    -1,
      -1,    -1,    -1,    -1,   386,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
      -1,   423,    -1,    -1,   426,   427,   428,    55,    56,    -1,
      -1,    -1,   434,   499,   500,    -1,    -1,   439,    -1,   578,
     579,    -1,    -1,    -1,    -1,    -1,    -1,   449,    -1,   515,
     516,    -1,    80,   455,    -1,    -1,    -1,    -1,    -1,    -1,
      88,    -1,    -1,    -1,    -1,   531,   532,   533,   534,   535,
     536,   537,   538,   539,   540,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    11,    12,    13,    14,    15,
      -1,    -1,   578,   579,    -1,    -1,    -1,    -1,    -1,    -1,
     148,    -1,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    -1,    -1,    39,    -1,    -1,   164,    -1,    -1,    -1,
      -1,   169,   170,    -1,   172,   173,    52,    -1,    -1,   177,
     178,    -1,    -1,    -1,    -1,   183,   184,   185,   186,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   196,    -1,
      -1,    -1,   200,    -1,   202,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   232,    -1,    -1,   235,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   244,    -1,    -1,    -1,
     248,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   257,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   287,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   303,   304,   305,    -1,   307,
      -1,    -1,    -1,   311,    -1,    -1,   314,   315,    -1,   317,
     318,    -1,    -1,   321,   322,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   337,
     338,    -1,    -1,    -1,   342,   343,   344,    -1,    -1,    -1,
      -1,    -1,    -1,   351,    -1,    -1,    -1,   355,    -1,    -1,
     358,   359,    -1,   361,    -1,   363,    -1,    -1,    -1,   367,
     368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   387,
     388,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   397
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     7,   585,   586,     3,     4,     5,   153,   170,   195,
     196,   233,   235,   237,   248,   277,   281,   286,   287,   411,
     572,   573,   581,   582,   583,   584,   763,   764,   765,   766,
     768,   769,   770,   777,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   792,   793,   794,   795,   796,
     797,   798,   800,   801,   815,   816,   817,   818,   837,   861,
     899,   900,   901,   902,   903,   904,   905,   906,   961,   962,
     985,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,     0,
       6,    40,    50,    52,    55,    56,    81,   151,   153,   154,
     156,   158,   164,   166,   167,   168,   170,   183,   184,   185,
     186,   187,   188,   235,   241,   247,   248,   571,   587,   588,
     642,   644,   645,   646,   647,   657,   702,   704,   705,   706,
     707,   708,   713,   727,   730,   740,   741,   742,   805,   808,
     819,   822,   838,   845,   857,   860,   864,   865,   908,   909,
     911,   913,   914,   919,   950,   953,   963,   964,   976,   977,
     986,   989,   996,   997,  1008,  1011,  1012,     6,     6,     6,
      16,    18,    19,    20,    21,    22,    23,    25,    33,    34,
      38,    50,    51,    53,    55,    56,    59,   112,   113,   118,
     119,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     138,   139,   140,   143,   151,   159,   161,   239,   298,   326,
     327,   328,   329,   330,   331,   332,   333,   334,   335,   353,
     354,   383,   398,   417,   418,   419,   420,   499,   500,   515,
     516,   531,   532,   533,   534,   535,   536,   537,   538,   539,
     540,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     550,   551,   552,   553,   554,   555,   556,   557,   558,   578,
     579,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   639,   640,   641,   666,   682,   684,   685,
     687,   688,   689,   690,   804,    23,    25,   171,   776,   799,
     802,    23,   802,   802,   110,   234,   802,   802,     6,   195,
     206,   208,   238,   245,   278,   280,   288,   303,   414,   501,
     525,   151,   181,   204,   206,   208,   282,   283,   284,   285,
      42,    79,   171,   790,   802,   281,    25,   257,   278,   567,
     568,   569,  1006,     6,    23,    24,   591,   591,   591,   690,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    99,
     100,   101,   102,   103,   104,   648,    53,    53,   165,    23,
      25,   616,   206,   207,   225,   570,   189,   206,   616,   167,
     245,   246,   247,   728,   729,   988,   195,   504,   562,   179,
     259,   709,   172,   199,   230,   288,   303,   411,   414,   464,
     468,   469,   501,   525,   529,   577,   863,   949,    51,   591,
     714,    80,   164,   169,   170,   173,   177,   232,   235,   257,
     706,   715,   716,   722,   744,   714,   714,   714,    55,    56,
      80,    88,   121,   148,   172,   173,   178,   183,   184,   185,
     186,   196,   200,   202,   244,   248,   257,   287,   303,   304,
     305,   307,   311,   314,   315,   317,   318,   321,   322,   337,
     338,   342,   343,   344,   351,   355,   358,   359,   361,   363,
     367,   368,   379,   387,   388,   397,   715,   848,   849,   856,
     714,   714,    49,    80,   248,   421,   422,   423,   424,   449,
     454,   457,   460,   706,   715,   867,   868,   869,   870,   871,
     714,    80,   197,   264,   285,   465,   466,   467,   715,   722,
     910,    79,    80,   128,   174,   175,   179,   190,   199,   392,
     715,   717,   714,   714,   714,   714,    80,   245,   257,   355,
     715,   722,   980,   981,    80,   248,   289,   457,   529,   530,
     574,   575,   576,   715,   722,   987,  1010,   714,   714,    80,
     173,   575,   715,  1013,    18,    23,    33,    35,    53,   161,
     163,   681,   683,   688,    36,   595,    36,    20,    21,   596,
     597,    53,   150,    34,   150,   690,    18,   114,   115,   116,
     117,   671,   690,    79,    79,    53,    53,    53,    53,    53,
      53,    53,    18,    19,    21,    22,    23,    53,   162,   596,
     597,   604,   666,   667,   670,   672,   673,   674,   676,   678,
     679,   149,   149,     6,    11,    12,    13,    14,    15,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    39,    39,
      42,    79,   171,   745,     6,   745,    25,   617,   617,   802,
     802,     6,    42,    79,   171,   748,     6,    23,    25,   171,
     803,     6,   279,     6,   771,     6,   778,   181,   208,   284,
     299,   313,    23,   173,   284,   448,   462,   463,   767,   208,
     284,   767,   171,     6,     6,     6,     6,     6,     6,     6,
       6,    88,   170,   517,   560,   561,   562,   563,   564,   565,
     994,   995,    18,   791,   617,   862,  1006,     6,  1006,     6,
       6,   504,  1007,    28,   658,   643,    98,   591,    23,    23,
      18,    20,    23,    51,    53,   703,    52,   745,   745,    18,
      23,    53,   589,    41,    42,    43,    44,   191,   589,   592,
     748,    52,    25,   242,    52,   559,   566,   616,   992,   249,
     589,   590,   590,   591,    79,   712,   415,   416,   912,   502,
      23,    51,    79,   165,   592,   745,   743,   178,   616,   616,
     748,   258,    52,    79,   720,    52,    52,    79,    79,    79,
     249,   324,   336,   314,   317,    52,    25,   327,   328,    50,
     370,    50,   370,    50,   370,    50,   370,   325,   616,   592,
     371,   195,   258,   245,   341,   366,   248,   592,   846,    52,
     589,    20,    21,    23,   380,   593,   840,   390,   593,   839,
     312,   262,   316,   323,   262,   314,   289,   323,   339,   340,
     339,   166,   592,   345,   352,   289,   289,   360,   358,   251,
     307,   327,   592,   369,   589,   381,   144,   312,   391,    52,
      79,   854,    52,    79,    79,   461,   195,   703,   592,   164,
     589,   592,   165,   377,   592,   370,   866,   720,    52,    79,
      79,   592,   148,   149,    18,    51,   203,    18,   174,   175,
      52,    52,   589,   151,   152,   171,   176,   191,   197,   655,
     724,   191,   724,    23,   723,   191,   233,   179,    52,    52,
      79,    79,    79,    79,    21,    22,    23,   607,   611,   258,
     179,    52,    52,    87,   319,   348,   357,   526,   527,   528,
     978,   979,    79,   984,   195,   589,   364,   179,   253,   592,
     262,   592,    52,    52,    79,    79,  1014,  1018,   262,    52,
      10,   683,   683,   683,   690,    20,    21,   162,   676,   683,
     683,    17,    18,    18,    36,   686,   690,    33,    34,   150,
      34,    18,    78,    54,    78,   636,   636,   723,   690,   690,
     690,   690,   690,   690,    35,   669,   671,   690,    33,    34,
      79,    10,    78,   162,    78,   162,    18,    18,   690,   690,
     690,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     690,   690,    57,    58,    65,    91,    93,   120,   130,   131,
     133,   134,   135,   136,   137,   144,   145,   146,   148,   149,
      50,    55,    56,   183,   184,   185,   186,   187,   188,   266,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     775,   180,   181,   182,   204,   205,   208,   746,   747,     6,
       6,     6,     6,   180,   236,   749,   750,     6,   803,     6,
       6,     6,   109,   110,   151,   167,   171,   174,   175,   179,
     198,   221,   222,   223,   226,   227,   228,   611,   655,   774,
       6,    81,   151,   167,   168,   179,   591,   767,   767,   767,
     767,   767,   767,   767,   907,   171,   767,   171,   767,     6,
     767,   767,     6,     6,    78,    80,     6,     6,     6,   151,
     179,   203,   655,     6,  1007,   589,     6,   690,    53,   650,
     651,   652,   656,    52,    78,    78,   737,   738,   690,    52,
     690,   590,    52,   589,   243,   244,   381,   990,   589,   991,
      79,   171,   993,   589,    45,    46,    47,   711,   714,    23,
     703,   731,   734,   735,   592,   719,   721,   807,   821,   262,
     262,   593,   262,   262,    52,   589,   589,    88,   400,    52,
      52,   248,   372,   262,   365,   592,   592,   350,   592,   236,
      52,    52,    79,   762,    52,    23,   604,   610,    37,   594,
      48,    52,   251,   376,   377,   392,   393,   394,   395,   396,
     844,   594,    48,    52,   251,   592,   589,   262,   262,   589,
     262,   592,   262,   592,   165,   592,   592,    52,   592,   592,
     592,   592,   592,   592,   378,   251,   592,    52,   592,    52,
     382,   616,   251,   592,   592,   853,   855,   859,   592,   262,
     365,   592,   592,   191,   589,   592,   721,   872,   590,   590,
      18,    18,    23,   653,   654,   690,    42,   589,   726,   198,
     726,   726,   592,   723,   918,   952,   965,   592,   723,    25,
     593,   593,    50,   126,   303,   487,   978,   983,    52,   592,
     592,   589,   295,   589,   735,   736,   589,    18,    54,   683,
     162,    51,    18,    54,    78,   150,    34,   690,   690,   637,
     638,    54,    78,    54,    78,    78,    78,    78,    54,    78,
      10,    78,    78,    54,    18,    53,   667,   674,   678,   251,
     251,    53,    78,    80,    78,    80,     6,    20,    21,    22,
      23,   596,   597,   598,   599,   600,   772,   773,   611,   653,
      23,   179,   179,    23,   171,    23,   776,   617,   617,   617,
     617,     6,   617,   617,     6,    23,    65,   164,   258,   320,
     399,   421,   453,   767,   617,   767,   617,   617,   617,   995,
     653,    25,   723,   616,     6,    52,    54,   649,   659,    79,
     648,   616,    23,   735,    52,    54,    54,    25,    46,    47,
      46,    47,   616,   616,   994,    52,    52,    80,   148,   149,
     259,   260,   263,   710,    34,   733,    78,    52,    80,   170,
     717,   718,    80,   173,   300,   715,   722,   806,    80,    86,
     173,   304,   305,   311,   715,   820,   589,   589,    52,   589,
     589,    52,    52,   592,    79,   592,   841,   195,   262,   589,
      52,    52,    52,   592,    52,   592,   761,   847,   840,   591,
     840,   589,   589,    52,   839,   589,   589,    52,    52,   589,
     589,    52,   589,    52,   589,    52,   703,    52,    52,    52,
      52,    52,    52,    52,    52,   592,    52,   589,    52,    52,
     589,    52,   592,    52,    52,    60,    80,   139,   174,   175,
     244,   246,   248,   346,   355,   356,   362,   366,   375,   384,
     386,   389,   718,   852,    80,   151,   179,   265,   412,   413,
     655,   715,   858,   589,   589,    80,   173,   178,   279,   377,
     423,   440,   442,   446,   450,   451,   873,   880,   883,   652,
     192,   725,   592,    52,    80,    92,   173,   489,   490,   493,
     498,   715,   722,   915,    80,   173,   449,   503,   715,   722,
     951,    48,    80,   316,   349,   350,   517,   522,   524,   715,
     722,   966,   968,    52,    52,   594,    50,    18,   613,   614,
     589,   592,   592,    23,    79,    80,    82,    83,    84,    85,
      86,    87,    88,   105,   108,   109,   155,   157,   687,   689,
     691,   696,   804,   982,   191,  1009,   589,    79,  1017,   683,
     683,    21,   690,    34,    34,    78,    54,    78,   634,   635,
     690,   690,   690,   690,   690,    35,   669,   690,   669,    35,
     669,   669,    78,   690,    18,    18,   690,   747,   750,    51,
      20,    21,    23,   776,   776,     6,     6,     6,     6,     6,
       6,    18,   703,   703,   703,   617,     6,   617,     6,     6,
       6,   648,   656,   648,   660,   663,   664,   665,   694,   696,
     591,    54,    78,    80,   261,   261,   592,   592,   264,   265,
      52,    25,   617,   732,   734,   745,    52,   809,   814,   164,
      52,   824,   825,   831,   825,   832,   593,   836,   312,    52,
      78,    52,    52,    52,    52,    92,   234,   392,   400,   402,
     404,   407,   842,   843,    52,   365,   592,   589,    52,    52,
      52,    80,   148,   202,   248,   252,   255,   256,   760,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,   297,   364,   179,   179,   371,   179,   195,   347,
     179,   172,   357,   592,    60,   592,   385,   592,   589,   592,
      52,   653,    25,   723,   589,   616,   139,    52,   892,   898,
     386,   425,   450,   592,   875,   386,   592,   874,   258,   610,
     876,   877,   452,   592,    52,   454,   893,   193,   194,   195,
     196,    23,   597,   609,   929,   934,   920,   928,   916,   917,
     609,   181,    52,   954,   960,   592,   589,    52,   589,   197,
     967,   149,   967,    23,   593,   616,   969,    67,   521,   970,
     967,    52,   614,    36,    28,   661,   662,   690,   692,   692,
      53,   690,   690,   690,   697,    53,    53,    52,    28,   692,
      28,    39,   589,  1016,    36,    34,   690,   690,    48,    57,
      58,    59,    60,    62,    63,    64,    67,    69,    70,    75,
      76,    80,   620,   621,   622,   623,   624,   632,    80,   621,
     622,   623,   624,   633,    78,    54,    54,    54,    54,    54,
      78,    10,    54,    78,    54,    78,    10,    54,    78,    78,
      18,    54,    21,     6,     6,   591,   591,    80,   664,    52,
      18,   262,   262,   589,   590,    20,    21,    23,   596,   597,
     612,   736,   165,   172,   183,   184,   304,   823,   736,    79,
     830,    37,   306,   833,   592,   589,   191,   410,   406,   142,
     403,   405,   408,   409,    78,    80,    52,    52,    52,   253,
     254,   592,   254,   590,   589,    52,   197,   320,   336,   344,
     253,   254,   592,   592,   592,   248,   372,   723,   592,   320,
     348,   349,   851,   723,   297,   321,   735,   894,   589,   589,
     592,    79,   589,    79,   703,    79,   589,   589,    79,    79,
     933,   736,    79,   593,   935,   940,    25,    79,   941,   946,
     592,   736,   191,   589,    69,   589,   968,   971,   972,   589,
      18,   690,    80,   660,    78,    52,    52,   804,    52,   106,
      79,    23,   648,   695,   700,   700,   690,    52,   690,   139,
     140,   143,   150,   151,    80,   483,  1015,    18,    34,    54,
      54,    61,    65,    66,    68,    11,    12,    13,    28,    29,
      30,   112,   113,   589,   618,   625,   626,   627,    38,   628,
     629,   629,   631,    23,   596,   608,    52,   625,   628,   631,
     609,    52,   690,    35,   669,    35,   669,    35,   669,    10,
      35,   669,    35,   669,    80,    52,    54,    28,   693,    54,
     590,   590,    79,   813,   592,   830,   829,   826,   591,   616,
     307,   834,    52,   401,   282,   843,   255,   255,   255,   373,
     374,   592,   850,   850,   593,   399,   195,   262,   592,   592,
     895,    79,   897,   885,   885,   878,   881,   932,   931,    79,
     927,   936,   942,    79,   959,   589,   592,    79,    52,   692,
      54,   696,   680,   591,   110,   690,    23,   689,   701,   804,
      52,    52,    53,    53,    53,    52,    53,   593,    52,    10,
     589,    14,    15,   619,    78,    15,    78,   619,   589,    71,
      72,    73,    74,   630,    78,   619,    77,    54,    54,    54,
      54,    78,    10,    54,    54,    54,    78,    53,    54,    10,
      54,    54,    10,    54,   690,    52,   812,   810,   826,    80,
     148,   200,   201,   202,   231,   252,   255,   256,   308,   751,
     752,   754,   755,   756,   827,   593,   304,   835,   590,   590,
     590,   592,   589,   893,   896,    80,   610,   886,   887,    80,
      80,   279,   386,   441,   879,    80,   249,   291,   308,   426,
     427,   428,   751,   882,    80,   482,   483,   486,   487,   488,
     930,   926,   925,   939,   945,   958,   955,   973,    52,   107,
       9,    18,    19,    53,    80,   666,   668,   670,   672,   673,
     675,   677,   698,   700,   700,   690,   690,   690,   690,   589,
     627,   618,   626,   629,   629,    36,   629,   629,    18,    35,
     669,    35,   669,   669,    10,   669,    48,    60,    65,    80,
     191,   253,   254,   257,   290,   291,   292,   308,   751,   811,
     253,   254,   592,    79,   254,   590,   589,   176,   210,   309,
     310,   828,    26,   616,    79,   759,    52,   592,    65,    80,
     249,   253,   254,   257,   258,   284,   291,   296,   303,   308,
     311,   359,   386,   423,   426,   427,   428,   434,   439,   449,
     455,   751,   884,   441,   447,   888,   592,   589,   592,    52,
     589,   589,   176,   309,   437,   589,   323,   223,   589,    52,
     485,   485,   592,   592,   592,    52,    80,    92,   148,   149,
     178,   245,   258,   471,   473,   474,   478,   479,   481,   489,
     490,   921,    80,   485,   491,   937,    80,   485,   492,   943,
      48,    80,   202,   253,   254,   257,   289,   292,   303,   308,
     336,   359,   426,   449,   467,   504,   505,   506,   507,   509,
     513,   751,   956,    80,   517,   518,   523,   974,   696,   661,
     690,    10,    78,   160,   690,    54,    78,    54,    54,    54,
      54,   589,   589,   589,   589,   630,   630,    54,    54,    54,
      78,    54,    53,    54,   589,   297,   293,   294,   589,   295,
      69,    70,   240,   296,   739,   258,   589,   255,   255,   176,
     301,    52,   255,   255,   753,   754,   255,   212,   213,   210,
      51,    86,   165,   203,   209,   229,   757,   429,   430,   431,
     432,   433,   434,   435,   436,   589,   295,    69,   296,   739,
     258,   458,    79,   589,   589,   592,   176,   309,   437,   431,
     360,   589,   592,   589,   323,   223,   589,   336,   456,   589,
     126,   429,    52,   589,    52,   589,   589,   589,   589,   476,
     934,   323,   470,   470,   128,   485,   128,   476,   485,   477,
     470,   592,   475,   262,   480,   297,   307,   922,   307,   923,
      52,   938,   484,   589,   947,   935,    52,   944,   947,   941,
      52,   589,   592,   295,    69,   296,   739,   258,   511,   589,
     262,   592,   176,   212,   437,   512,   957,   593,   360,   262,
     126,   370,   429,   262,   262,   443,   589,   508,   510,   514,
      52,   975,   520,   519,   616,    52,    54,    53,   668,   675,
     661,   699,    52,   690,    52,    52,    52,    52,    36,    36,
     669,   669,   183,   184,   589,   589,   589,   589,   589,   592,
     590,   590,   302,   590,   590,    80,    52,   590,   212,   213,
      25,   615,    51,   203,   589,   615,   210,   211,   217,   218,
     219,   220,   758,    51,   203,    80,   444,   445,   589,   589,
     589,   592,   459,   889,   592,   254,   592,   589,   589,   592,
     592,   589,   592,   494,   948,   948,   262,   589,   255,   255,
     495,   496,   497,   924,   589,   924,   262,   589,   589,   472,
     592,   589,   589,   191,   592,   940,   592,   946,   589,   589,
     589,   589,   592,   592,   589,   254,   592,   590,   589,   589,
     589,   592,   592,   592,   592,   201,   201,   690,   111,    54,
     589,   589,    54,    78,   593,   593,   753,    52,   615,   615,
      52,    52,   212,   213,   214,   215,   216,   212,   213,   214,
     215,   216,    52,   615,   615,   759,   592,    80,   593,   891,
     443,   592,   589,   589,   589,   948,   589,   948,   592,   589,
     443,   616,   616,   696,    52,   669,   757,    52,    52,   757,
     757,   757,    52,    52,   438,   890,    78,   757,   757,   757,
     757,    52,   669,    54
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   580,   585,   585,   586,   586,   587,   587,   588,   589,
     589,   589,   590,   590,   590,   591,   591,   592,   592,   592,
     592,   592,   592,   593,   593,   593,   594,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   603,   604,   604,   605,
     605,   606,   606,   607,   607,   607,   607,   607,   607,   608,
     608,   609,   609,   610,   610,   611,   611,   612,   612,   612,
     612,   612,   613,   614,   614,   615,   616,   616,   617,   617,
     618,   618,   618,   618,   618,   618,   618,   618,   619,   619,
     620,   620,   620,   620,   620,   620,   620,   620,   620,   620,
     621,   622,   623,   624,   624,   625,   625,   625,   625,   626,
     626,   627,   627,   628,   628,   628,   629,   629,   630,   630,
     630,   630,   631,   631,   631,   632,   632,   632,   632,   633,
     633,   633,   633,   633,   634,   634,   635,   635,   636,   637,
     638,   639,   640,   641,   641,   581,   582,   581,   583,   581,
     584,   587,   643,   642,   587,   644,   587,   645,   587,   646,
     587,   647,   648,   648,   648,   648,   648,   648,   648,   648,
     648,   648,   648,   648,   648,   648,   648,   648,   649,   649,
     650,   650,   651,   651,   652,   653,   654,   653,   655,   656,
     587,   658,   659,   657,   660,   660,   662,   661,   663,   663,
     664,   665,   665,   666,   666,   667,   667,   667,   667,   667,
     667,   668,   668,   668,   668,   669,   670,   670,   670,   670,
     670,   670,   670,   670,   670,   670,   671,   671,   671,   671,
     672,   672,   672,   673,   673,   673,   673,   673,   673,   673,
     673,   674,   674,   674,   674,   674,   675,   675,   675,   675,
     675,   676,   676,   677,   677,   678,   678,   678,   678,   679,
     679,   680,   680,   680,   681,   681,   682,   683,   683,   683,
     683,   683,   683,   683,   683,   683,   684,   684,   684,   684,
     684,   684,   684,   684,   684,   684,   684,   685,   685,   685,
     685,   686,   686,   686,   687,   688,   689,   689,   689,   689,
     689,   689,   689,   689,   689,   689,   689,   689,   690,   690,
     690,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     690,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     690,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     690,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     690,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     691,   691,   691,   692,   692,   692,   693,   693,   694,   695,
     695,   696,   696,   696,   697,   698,   699,   696,   696,   696,
     696,   696,   696,   696,   696,   696,   696,   696,   696,   696,
     696,   696,   696,   696,   696,   700,   701,   701,   701,   587,
     702,   702,   703,   703,   703,   703,   587,   704,   587,   705,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     587,   707,   708,   709,   709,   710,   710,   710,   710,   710,
     710,   711,   711,   712,   712,   587,   713,   713,   714,   714,
     714,   714,   715,   715,   715,   715,   715,   715,   715,   715,
     716,   717,   717,   717,   717,   717,   717,   717,   717,   717,
     718,   718,   719,   719,   720,   720,   721,   722,   723,   724,
     724,   724,   724,   725,   725,   725,   725,   725,   726,   726,
     587,   727,   727,   727,   587,   728,   728,   728,   728,   729,
     729,   729,   729,   729,   729,   729,   729,   730,   731,   732,
     732,   733,   733,   734,   735,   735,   736,   737,   738,   739,
     739,   740,   741,   742,   742,   742,   742,   742,   743,   744,
     745,   745,   745,   746,   746,   747,   747,   747,   747,   747,
     747,   748,   748,   748,   749,   749,   750,   750,   751,   752,
     752,   753,   753,   754,   754,   755,   755,   756,   756,   757,
     757,   757,   757,   757,   757,   757,   757,   757,   758,   758,
     758,   758,   758,   758,   758,   758,   758,   758,   758,   758,
     758,   758,   759,   760,   760,   760,   760,   760,   760,   760,
     761,   761,   762,   581,   763,   581,   764,   581,   765,   581,
     766,   767,   767,   581,   768,   581,   769,   581,   770,   771,
     771,   771,   771,   771,   771,   771,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   771,   772,   772,   772,
     772,   772,   772,   772,   772,   773,   773,   773,   773,   774,
     774,   774,   774,   775,   775,   775,   775,   775,   775,   775,
     775,   775,   775,   775,   775,   775,   775,   775,   775,   775,
     775,   775,   775,   776,   581,   777,   778,   778,   778,   778,
     778,   778,   778,   581,   779,   581,   780,   581,   781,   581,
     782,   581,   783,   581,   784,   581,   785,   581,   786,   581,
     787,   581,   788,   581,   789,   790,   790,   790,   791,   791,
     581,   792,   581,   793,   581,   794,   581,   795,   581,   796,
     581,   797,   581,   798,   799,   799,   581,   800,   581,   801,
     802,   802,   802,   803,   803,   803,   804,   740,   819,   820,
     820,   820,   820,   820,   820,   821,   821,   822,   823,   823,
     823,   823,   824,   824,   825,   826,   827,   827,   827,   827,
     827,   827,   827,   827,   828,   828,   828,   828,   828,   828,
     829,   829,   830,   830,   831,   832,   833,   833,   833,   834,
     834,   835,   835,   836,   581,   837,   740,   805,   806,   806,
     806,   806,   807,   807,   808,   809,   810,   811,   811,   811,
     811,   811,   811,   811,   811,   811,   811,   811,   811,   811,
     811,   811,   811,   811,   811,   811,   812,   812,   813,   813,
     814,   804,   581,   815,   581,   816,   581,   817,   581,   818,
     740,   838,   839,   839,   839,   840,   840,   840,   840,   840,
     841,   841,   842,   842,   843,   843,   843,   843,   843,   843,
     843,   843,   843,   844,   844,   844,   844,   844,   845,   845,
     845,   845,   845,   845,   845,   845,   845,   845,   845,   845,
     845,   845,   845,   845,   845,   845,   845,   845,   845,   845,
     845,   845,   845,   845,   845,   845,   845,   845,   845,   845,
     845,   845,   845,   845,   845,   845,   845,   845,   845,   845,
     845,   845,   845,   845,   845,   845,   845,   845,   845,   845,
     845,   845,   845,   845,   845,   845,   845,   845,   845,   845,
     845,   845,   846,   847,   845,   845,   845,   845,   848,   848,
     848,   848,   848,   848,   848,   848,   848,   848,   848,   848,
     849,   850,   850,   850,   851,   851,   851,   852,   852,   852,
     852,   852,   852,   852,   852,   852,   852,   852,   852,   852,
     852,   852,   852,   852,   852,   852,   852,   852,   852,   852,
     852,   852,   853,   853,   854,   854,   855,   856,   804,   804,
     804,   804,   804,   804,   804,   804,   804,   804,   804,   804,
     804,   804,   740,   857,   858,   858,   858,   858,   858,   858,
     858,   858,   859,   859,   860,   581,   861,   862,   862,   862,
     862,   862,   862,   740,   863,   863,   863,   864,   865,   865,
     866,   866,   867,   868,   869,   869,   869,   869,   869,   869,
     869,   869,   869,   869,   869,   869,   869,   869,   869,   870,
     871,   872,   872,   873,   873,   873,   873,   873,   873,   873,
     873,   873,   874,   873,   875,   873,   873,   873,   873,   876,
     876,   877,   878,   878,   879,   879,   879,   880,   880,   881,
     881,   882,   882,   882,   882,   882,   882,   882,   882,   882,
     882,   882,   883,   884,   884,   884,   884,   884,   884,   884,
     884,   884,   884,   884,   884,   884,   884,   884,   884,   884,
     884,   884,   884,   884,   884,   884,   884,   884,   884,   884,
     884,   884,   884,   884,   884,   884,   884,   884,   884,   884,
     884,   884,   885,   885,   886,   887,   888,   888,   888,   889,
     889,   890,   890,   891,   892,   893,   893,   895,   894,   896,
     896,   897,   897,   898,   804,   804,   804,   804,   581,   899,
     581,   900,   581,   901,   581,   902,   581,   903,   581,   904,
     581,   905,   581,   906,   907,   907,   907,   907,   907,   907,
     907,   907,   907,   740,   908,   909,   909,   909,   910,   910,
     910,   910,   910,   910,   910,   910,   910,   910,   740,   912,
     911,   913,   913,   913,   913,   740,   914,   915,   915,   915,
     915,   916,   915,   917,   915,   915,   915,   918,   918,   919,
     920,   921,   921,   921,   921,   921,   921,   921,   921,   921,
     921,   921,   921,   921,   921,   921,   921,   921,   922,   921,
     923,   921,   921,   921,   924,   924,   924,   925,   926,   926,
     927,   927,   928,   929,   930,   930,   930,   930,   930,   931,
     932,   932,   933,   933,   934,   935,   936,   937,   937,   937,
     938,   939,   939,   940,   940,   941,   942,   943,   943,   943,
     944,   945,   945,   946,   946,   947,   947,   948,   948,   804,
     804,   740,   949,   949,   950,   951,   951,   951,   951,   951,
     951,   952,   952,   953,   954,   955,   956,   956,   956,   956,
     956,   956,   956,   956,   956,   956,   956,   956,   956,   956,
     956,   956,   956,   956,   956,   956,   956,   956,   956,   956,
     956,   956,   956,   957,   957,   957,   957,   958,   958,   959,
     959,   960,   804,   804,   581,   961,   581,   962,   740,   963,
     964,   965,   965,   966,   966,   966,   966,   966,   966,   966,
     966,   966,   966,   967,   967,   968,   969,   969,   970,   970,
     971,   972,   973,   973,   974,   974,   974,   975,   740,   976,
     977,   977,   977,   977,   977,   977,   978,   978,   978,   978,
     978,   978,   979,   979,   980,   981,   981,   981,   981,   981,
     981,   981,   981,   981,   982,   983,   983,   984,   984,   581,
     985,   986,   987,   987,   987,   804,   804,   804,   804,   804,
     804,   804,   804,   804,   804,   804,   804,   804,   804,   804,
     804,   804,   804,   804,   804,   804,   804,   804,   804,   804,
     804,   804,   804,   587,   988,   989,   990,   990,   991,   991,
     992,   992,   992,   993,   993,   994,   994,   995,   995,   995,
     995,   995,   995,   995,   995,   995,   587,   996,   996,   587,
     997,   997,   997,   997,   581,   998,   581,   999,   581,  1000,
     581,  1001,   581,  1002,   581,  1003,   581,  1004,   581,  1005,
    1006,  1006,  1007,  1007,  1007,   740,  1008,   986,   986,  1009,
    1009,  1010,  1010,  1010,  1010,  1010,  1010,  1010,   740,  1011,
    1012,  1012,  1013,  1013,  1013,  1014,  1015,  1016,  1016,  1017,
    1017,  1018,   804,   804
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     1,     5,     1,
       3,     1,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     0,     2,     2,     2,
       3,     7,     2,     2,     5,     5,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     2,     2,     1,     1,     1,
       1,     2,     1,     1,     1,     2,     4,     1,     3,     1,
       3,     1,     3,     4,     6,     6,     0,     1,     1,     1,
       1,     1,     2,     4,     4,     2,     2,     2,     2,     2,
       4,     2,     2,     2,     0,     3,     0,     3,     0,     0,
       0,     6,     6,     1,     1,     1,     2,     1,     2,     1,
       2,     1,     0,     4,     1,     2,     1,     4,     1,     6,
       1,     8,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     0,     4,
       2,     5,     0,     4,     1,     1,     0,     2,     2,     4,
       1,     0,     0,     6,     0,     1,     0,     2,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     3,
       1,     1,     3,     1,     1,     1,     5,     7,     5,     7,
       9,     7,     5,     7,     5,    11,     1,     1,     2,     1,
       7,     9,     7,     7,     9,     7,     9,     7,     9,     7,
      15,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       3,     1,     3,     1,     3,     1,     2,     2,     6,     1,
       3,     0,     4,     3,     1,     3,     3,     2,     4,     3,
       4,     2,     2,     2,     2,     0,     1,     1,     1,     1,
       1,     1,     1,     2,     3,     3,     1,     5,     7,     7,
       1,     0,     1,     3,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     4,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     6,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       5,     7,     6,     6,     6,     6,     4,     8,     4,     1,
       1,     1,     1,     0,     1,     3,     0,     2,     4,     2,
       1,     3,     4,     6,     0,     0,     0,     9,     4,     3,
       4,     4,     5,     3,     3,     3,     2,     5,     4,     7,
       7,     7,     7,     7,     9,     0,     1,     1,     1,     1,
       4,     5,     1,     3,     1,     1,     1,     3,     1,     5,
       1,     1,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     0,     1,     2,     2,     4,     4,     3,
       3,     0,     3,     0,     3,     1,     1,     1,     0,     1,
       2,     3,     0,     2,     2,     2,     3,     2,     2,     2,
       1,     2,     2,     2,     3,     3,     3,     2,     4,     3,
       1,     2,     0,     3,     0,     3,     0,     3,     1,     2,
       1,     1,     1,     0,     2,     2,     2,     2,     2,     1,
       1,     3,     3,     3,     1,     1,     1,     1,     1,     2,
       4,     3,     4,     4,     3,     4,     4,     3,     0,     1,
       2,     0,     1,     3,     1,     3,     1,     0,     2,     2,
       2,     2,     2,     3,     3,     3,     3,     5,     0,     3,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     3,     1,     1,     1,     4,
       1,     0,     3,     5,     2,     1,     1,     2,     2,     0,
       5,     5,     5,     5,     4,     4,     4,     4,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     1,     0,     2,     4,     4,     4,     2,     2,     1,
       0,     3,     3,     1,     3,     1,     3,     1,     4,     1,
       5,     1,     0,     1,     3,     1,     4,     1,     4,     0,
       2,     3,     3,     3,     3,     4,     4,     3,     2,     2,
       2,     2,     3,     3,     3,     2,     2,     1,     1,     1,
       1,     2,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     4,     0,     2,     2,     2,
       2,     2,     2,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       4,     1,     3,     1,     4,     1,     1,     3,     0,     1,
       1,     4,     1,     4,     1,     4,     1,     3,     1,     4,
       1,     4,     1,     3,     2,     2,     1,     4,     1,     2,
       1,     1,     1,     1,     0,     1,     1,     1,     2,     1,
       2,     2,     2,     2,     3,     0,     3,     5,     1,     1,
       1,     1,     0,     2,     0,     0,     2,     4,     4,     4,
       2,     2,     2,     1,     1,     1,     2,     2,     3,     3,
       0,     3,     0,     3,     4,     3,     0,     2,     2,     0,
       2,     0,     2,     4,     1,     5,     1,     2,     1,     1,
       2,     4,     0,     3,     5,     0,     0,     0,     2,     2,
       2,     2,     2,     3,     3,     3,     3,     2,     3,     3,
       4,     4,     2,     2,     3,     1,     0,     3,     0,     3,
       4,     1,     1,     6,     1,     6,     1,     6,     1,     6,
       2,     2,     0,     3,     3,     0,     3,     3,     2,     2,
       1,     3,     1,     3,     1,     3,     2,     2,     2,     2,
       2,     2,     3,     1,     1,     1,     1,     1,     3,     3,
       3,     4,     6,     4,     6,     6,     4,     6,     5,     5,
       4,     5,     5,     6,     6,     3,     3,     4,     5,     6,
       5,     5,     5,     5,     5,     5,     5,     5,     5,     5,
       6,     6,     6,     5,     6,     6,     8,     6,     6,     6,
       5,     6,     5,     4,     4,     4,     4,     5,     5,     6,
       5,     6,     5,     5,     6,     7,     7,     7,     5,     5,
       4,     4,     0,     0,     6,     6,     5,     5,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     4,
       4,     4,     2,     3,     2,     2,     2,     2,     3,     5,
       5,     4,     3,     3,     3,     3,     3,     2,     2,     2,
       3,     3,     0,     3,     0,     3,     0,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     2,     2,     2,     1,     2,
       2,     4,     0,     3,     5,     1,     4,     0,     3,     3,
       3,     2,     3,     2,     1,     2,     2,     2,     3,     3,
       0,     1,     2,     3,     1,     1,     2,     2,     3,     3,
       3,     3,     4,     2,     4,     3,     2,     3,     1,     2,
       4,     0,     3,     2,     1,     2,     3,     3,     3,     3,
       2,     3,     0,     5,     0,     5,     2,     2,     1,     4,
       1,     1,     0,     3,     2,     2,     2,     5,     2,     0,
       3,     0,     2,     2,     3,     2,     2,     3,     2,     2,
       2,     1,     3,     2,     2,     2,     2,     2,     2,     3,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     3,
       3,     3,     2,     3,     2,     3,     3,     4,     4,     2,
       2,     2,     3,     3,     3,     2,     3,     3,     3,     4,
       2,     1,     0,     2,     3,     1,     0,     1,     2,     0,
       2,     0,     1,     3,     0,     0,     2,     0,     3,     0,
       3,     0,     3,     3,     1,     1,     1,     1,     1,     4,
       1,     6,     1,     6,     1,     6,     1,     7,     1,     6,
       1,     7,     1,     5,     0,     2,     3,     2,     3,     3,
       2,     3,     2,     2,     2,     3,     3,     3,     1,     3,
       3,     2,     3,     3,     2,     2,     2,     2,     2,     0,
       4,     2,     3,     3,     5,     1,     2,     1,     1,     2,
       2,     0,     3,     0,     3,     2,     3,     0,     3,     5,
       0,     4,     4,     3,     4,     2,     3,     3,     3,     3,
       4,     4,     4,     3,     3,     4,     4,     2,     0,     3,
       0,     3,     3,     3,     1,     1,     1,     0,     0,     3,
       0,     3,     4,     1,     2,     2,     2,     4,     4,     0,
       0,     3,     0,     3,     3,     1,     0,     0,     2,     2,
       0,     0,     3,     1,     5,     1,     0,     0,     2,     2,
       0,     0,     3,     1,     5,     1,     2,     0,     2,     1,
       1,     1,     1,     2,     2,     1,     1,     2,     4,     2,
       2,     0,     3,     5,     0,     0,     2,     2,     2,     2,
       2,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     3,     4,     3,
       2,     2,     1,     1,     1,     1,     1,     0,     3,     0,
       3,     4,     1,     1,     1,     6,     1,     6,     1,     2,
       5,     0,     3,     1,     1,     2,     3,     1,     2,     3,
       3,     3,     4,     0,     1,     2,     1,     1,     2,     6,
       0,     0,     0,     3,     4,     4,     2,     0,     2,     2,
       3,     3,     3,     5,     5,     4,     3,     2,     3,     3,
       3,     3,     1,     2,     2,     2,     3,     5,     1,     2,
       2,     2,     2,     2,     1,     0,     2,     0,     3,     1,
       4,     3,     3,     2,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     5,     2,     0,     0,     2,
       2,     2,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     3,     1,
       3,     4,     3,     3,     1,     4,     1,     5,     1,     3,
       1,     3,     1,     3,     1,     4,     1,     2,     1,     3,
       0,     1,     0,     1,     2,     2,     2,     3,     3,     0,
       2,     1,     1,     2,     3,     2,     3,     4,     2,     2,
       3,     3,     1,     2,     3,     0,     2,     0,     3,     0,
       3,     3,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        YY_LAC_DISCARD ("YYBACKUP");                              \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Given a state stack such that *YYBOTTOM is its bottom, such that
   *YYTOP is either its top or is YYTOP_EMPTY to indicate an empty
   stack, and such that *YYCAPACITY is the maximum number of elements it
   can hold without a reallocation, make sure there is enough room to
   store YYADD more elements.  If not, allocate a new stack using
   YYSTACK_ALLOC, copy the existing elements, and adjust *YYBOTTOM,
   *YYTOP, and *YYCAPACITY to reflect the new capacity and memory
   location.  If *YYBOTTOM != YYBOTTOM_NO_FREE, then free the old stack
   using YYSTACK_FREE.  Return 0 if successful or if no reallocation is
   required.  Return YYENOMEM if memory is exhausted.  */
static int
yy_lac_stack_realloc (YYPTRDIFF_T *yycapacity, YYPTRDIFF_T yyadd,
#if YYDEBUG
                      char const *yydebug_prefix,
                      char const *yydebug_suffix,
#endif
                      yy_state_t **yybottom,
                      yy_state_t *yybottom_no_free,
                      yy_state_t **yytop, yy_state_t *yytop_empty)
{
  YYPTRDIFF_T yysize_old =
    *yytop == yytop_empty ? 0 : *yytop - *yybottom + 1;
  YYPTRDIFF_T yysize_new = yysize_old + yyadd;
  if (*yycapacity < yysize_new)
    {
      YYPTRDIFF_T yyalloc = 2 * yysize_new;
      yy_state_t *yybottom_new;
      /* Use YYMAXDEPTH for maximum stack size given that the stack
         should never need to grow larger than the main state stack
         needs to grow without LAC.  */
      if (YYMAXDEPTH < yysize_new)
        {
          YYDPRINTF ((stderr, "%smax size exceeded%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (YYMAXDEPTH < yyalloc)
        yyalloc = YYMAXDEPTH;
      yybottom_new =
        YY_CAST (yy_state_t *,
                 YYSTACK_ALLOC (YY_CAST (YYSIZE_T,
                                         yyalloc * YYSIZEOF (*yybottom_new))));
      if (!yybottom_new)
        {
          YYDPRINTF ((stderr, "%srealloc failed%s", yydebug_prefix,
                      yydebug_suffix));
          return YYENOMEM;
        }
      if (*yytop != yytop_empty)
        {
          YYCOPY (yybottom_new, *yybottom, yysize_old);
          *yytop = yybottom_new + (yysize_old - 1);
        }
      if (*yybottom != yybottom_no_free)
        YYSTACK_FREE (*yybottom);
      *yybottom = yybottom_new;
      *yycapacity = yyalloc;
    }
  return 0;
}

/* Establish the initial context for the current lookahead if no initial
   context is currently established.

   We define a context as a snapshot of the parser stacks.  We define
   the initial context for a lookahead as the context in which the
   parser initially examines that lookahead in order to select a
   syntactic action.  Thus, if the lookahead eventually proves
   syntactically unacceptable (possibly in a later context reached via a
   series of reductions), the initial context can be used to determine
   the exact set of tokens that would be syntactically acceptable in the
   lookahead's place.  Moreover, it is the context after which any
   further semantic actions would be erroneous because they would be
   determined by a syntactically unacceptable token.

   YY_LAC_ESTABLISH should be invoked when a reduction is about to be
   performed in an inconsistent state (which, for the purposes of LAC,
   includes consistent states that don't know they're consistent because
   their default reductions have been disabled).  Iff there is a
   lookahead token, it should also be invoked before reporting a syntax
   error.  This latter case is for the sake of the debugging output.

   For parse.lac=full, the implementation of YY_LAC_ESTABLISH is as
   follows.  If no initial context is currently established for the
   current lookahead, then check if that lookahead can eventually be
   shifted if syntactic actions continue from the current context.
   Report a syntax error if it cannot.  */
#define YY_LAC_ESTABLISH                                                \
do {                                                                    \
  if (!yy_lac_established)                                              \
    {                                                                   \
      YYDPRINTF ((stderr,                                               \
                  "LAC: initial context established for %s\n",          \
                  yysymbol_name (yytoken)));                            \
      yy_lac_established = 1;                                           \
      switch (yy_lac (yyesa, &yyes, &yyes_capacity, yyssp, yytoken))    \
        {                                                               \
        case YYENOMEM:                                                  \
          YYNOMEM;                                                      \
        case 1:                                                         \
          goto yyerrlab;                                                \
        }                                                               \
    }                                                                   \
} while (0)

/* Discard any previous initial lookahead context because of Event,
   which may be a lookahead change or an invalidation of the currently
   established initial context for the current lookahead.

   The most common example of a lookahead change is a shift.  An example
   of both cases is syntax error recovery.  That is, a syntax error
   occurs when the lookahead is syntactically erroneous for the
   currently established initial context, so error recovery manipulates
   the parser stacks to try to find a new initial context in which the
   current lookahead is syntactically acceptable.  If it fails to find
   such a context, it discards the lookahead.  */
#if YYDEBUG
# define YY_LAC_DISCARD(Event)                                           \
do {                                                                     \
  if (yy_lac_established)                                                \
    {                                                                    \
      YYDPRINTF ((stderr, "LAC: initial context discarded due to "       \
                  Event "\n"));                                          \
      yy_lac_established = 0;                                            \
    }                                                                    \
} while (0)
#else
# define YY_LAC_DISCARD(Event) yy_lac_established = 0
#endif

/* Given the stack whose top is *YYSSP, return 0 iff YYTOKEN can
   eventually (after perhaps some reductions) be shifted, return 1 if
   not, or return YYENOMEM if memory is exhausted.  As preconditions and
   postconditions: *YYES_CAPACITY is the allocated size of the array to
   which *YYES points, and either *YYES = YYESA or *YYES points to an
   array allocated with YYSTACK_ALLOC.  yy_lac may overwrite the
   contents of either array, alter *YYES and *YYES_CAPACITY, and free
   any old *YYES other than YYESA.  */
static int
yy_lac (yy_state_t *yyesa, yy_state_t **yyes,
        YYPTRDIFF_T *yyes_capacity, yy_state_t *yyssp, yysymbol_kind_t yytoken)
{
  yy_state_t *yyes_prev = yyssp;
  yy_state_t *yyesp = yyes_prev;
  /* Reduce until we encounter a shift and thereby accept the token.  */
  YYDPRINTF ((stderr, "LAC: checking lookahead %s:", yysymbol_name (yytoken)));
  if (yytoken == YYSYMBOL_YYUNDEF)
    {
      YYDPRINTF ((stderr, " Always Err\n"));
      return 1;
    }
  while (1)
    {
      int yyrule = yypact[+*yyesp];
      if (yypact_value_is_default (yyrule)
          || (yyrule += yytoken) < 0 || YYLAST < yyrule
          || yycheck[yyrule] != yytoken)
        {
          /* Use the default action.  */
          yyrule = yydefact[+*yyesp];
          if (yyrule == 0)
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
        }
      else
        {
          /* Use the action from yytable.  */
          yyrule = yytable[yyrule];
          if (yytable_value_is_error (yyrule))
            {
              YYDPRINTF ((stderr, " Err\n"));
              return 1;
            }
          if (0 < yyrule)
            {
              YYDPRINTF ((stderr, " S%d\n", yyrule));
              return 0;
            }
          yyrule = -yyrule;
        }
      /* By now we know we have to simulate a reduce.  */
      YYDPRINTF ((stderr, " R%d", yyrule - 1));
      {
        /* Pop the corresponding number of values from the stack.  */
        YYPTRDIFF_T yylen = yyr2[yyrule];
        /* First pop from the LAC stack as many tokens as possible.  */
        if (yyesp != yyes_prev)
          {
            YYPTRDIFF_T yysize = yyesp - *yyes + 1;
            if (yylen < yysize)
              {
                yyesp -= yylen;
                yylen = 0;
              }
            else
              {
                yyesp = yyes_prev;
                yylen -= yysize;
              }
          }
        /* Only afterwards look at the main stack.  */
        if (yylen)
          yyesp = yyes_prev -= yylen;
      }
      /* Push the resulting state of the reduction.  */
      {
        yy_state_fast_t yystate;
        {
          const int yylhs = yyr1[yyrule] - YYNTOKENS;
          const int yyi = yypgoto[yylhs] + *yyesp;
          yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyesp
                     ? yytable[yyi]
                     : yydefgoto[yylhs]);
        }
        if (yyesp == yyes_prev)
          {
            yyesp = *yyes;
            YY_IGNORE_USELESS_CAST_BEGIN
            *yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        else
          {
            if (yy_lac_stack_realloc (yyes_capacity, 1,
#if YYDEBUG
                                      " (", ")",
#endif
                                      yyes, yyesa, &yyesp, yyes_prev))
              {
                YYDPRINTF ((stderr, "\n"));
                return YYENOMEM;
              }
            YY_IGNORE_USELESS_CAST_BEGIN
            *++yyesp = YY_CAST (yy_state_t, yystate);
            YY_IGNORE_USELESS_CAST_END
          }
        YYDPRINTF ((stderr, " G%d", yystate));
      }
    }
}

/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yy_state_t *yyesa;
  yy_state_t **yyes;
  YYPTRDIFF_T *yyes_capacity;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;

  int yyx;
  for (yyx = 0; yyx < YYNTOKENS; ++yyx)
    {
      yysymbol_kind_t yysym = YY_CAST (yysymbol_kind_t, yyx);
      if (yysym != YYSYMBOL_YYerror && yysym != YYSYMBOL_YYUNDEF)
        switch (yy_lac (yyctx->yyesa, yyctx->yyes, yyctx->yyes_capacity, yyctx->yyssp, yysym))
          {
          case YYENOMEM:
            return YYENOMEM;
          case 1:
            continue;
          default:
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = yysym;
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
       In the first two cases, it might appear that the current syntax
       error should have been detected in the previous state when yy_lac
       was invoked.  However, at that time, there might have been a
       different syntax error that discarded a different initial context
       during error recovery, leaving behind the current lookahead.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      YYDPRINTF ((stderr, "Constructing syntax error message\n"));
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else if (yyn == 0)
        YYDPRINTF ((stderr, "No expected tokens.\n"));
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.  In order to see if a particular token T is a
   valid looakhead, invoke yy_lac (YYESA, YYES, YYES_CAPACITY, YYSSP, T).

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store or if
   yy_lac returned YYENOMEM.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    yy_state_t yyesa[20];
    yy_state_t *yyes = yyesa;
    YYPTRDIFF_T yyes_capacity = 20 < YYMAXDEPTH ? 20 : YYMAXDEPTH;

  /* Whether LAC context is established.  A Boolean.  */
  int yy_lac_established = 0;
  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    {
      YY_LAC_ESTABLISH;
      goto yydefault;
    }
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      YY_LAC_ESTABLISH;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  YY_LAC_DISCARD ("shift");
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  {
    int yychar_backup = yychar;
    switch (yyn)
      {
  case 2: /* config: conf_entries END  */
#line 137 "conf/confbase.Y"
                         { return 0; }
#line 6266 "obj/conf/cf-parse.tab.c"
    break;

  case 3: /* config: CLI_MARKER cli_cmd  */
#line 138 "conf/confbase.Y"
                      { return 0; }
#line 6272 "obj/conf/cf-parse.tab.c"
    break;

  case 8: /* definition: DEFINE symbol '=' term ';'  */
#line 154 "conf/confbase.Y"
                              {
     struct f_val *val = cfg_allocz(sizeof(struct f_val));
     if (f_eval(f_linearize((yyvsp[-1].x), 1), cfg_mem, val) > F_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val, val);
   }
#line 6282 "obj/conf/cf-parse.tab.c"
    break;

  case 10: /* expr: '(' term ')'  */
#line 163 "conf/confbase.Y"
                { (yyval.i) = f_eval_int(f_linearize((yyvsp[-1].x), 1)); }
#line 6288 "obj/conf/cf-parse.tab.c"
    break;

  case 11: /* expr: CF_SYM_KNOWN  */
#line 164 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number constant expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 6296 "obj/conf/cf-parse.tab.c"
    break;

  case 12: /* expr_us: expr S  */
#line 170 "conf/confbase.Y"
           { (yyval.time) = (yyvsp[-1].i) S_; }
#line 6302 "obj/conf/cf-parse.tab.c"
    break;

  case 13: /* expr_us: expr MS  */
#line 171 "conf/confbase.Y"
           { (yyval.time) = (yyvsp[-1].i) MS_; }
#line 6308 "obj/conf/cf-parse.tab.c"
    break;

  case 14: /* expr_us: expr US  */
#line 172 "conf/confbase.Y"
           { (yyval.time) = (yyvsp[-1].i) US_; }
#line 6314 "obj/conf/cf-parse.tab.c"
    break;

  case 17: /* bool: expr  */
#line 180 "conf/confbase.Y"
        { (yyval.i) = !!(yyvsp[0].i); }
#line 6320 "obj/conf/cf-parse.tab.c"
    break;

  case 18: /* bool: ON  */
#line 181 "conf/confbase.Y"
      { (yyval.i) = 1; }
#line 6326 "obj/conf/cf-parse.tab.c"
    break;

  case 19: /* bool: YES  */
#line 182 "conf/confbase.Y"
       { (yyval.i) = 1; }
#line 6332 "obj/conf/cf-parse.tab.c"
    break;

  case 20: /* bool: OFF  */
#line 183 "conf/confbase.Y"
       { (yyval.i) = 0; }
#line 6338 "obj/conf/cf-parse.tab.c"
    break;

  case 21: /* bool: NO  */
#line 184 "conf/confbase.Y"
      { (yyval.i) = 0; }
#line 6344 "obj/conf/cf-parse.tab.c"
    break;

  case 22: /* bool: %empty  */
#line 185 "conf/confbase.Y"
                                 { (yyval.i) = 1; }
#line 6350 "obj/conf/cf-parse.tab.c"
    break;

  case 23: /* ipa: IP4  */
#line 192 "conf/confbase.Y"
       { (yyval.a) = ipa_from_ip4((yyvsp[0].ip4)); }
#line 6356 "obj/conf/cf-parse.tab.c"
    break;

  case 24: /* ipa: IP6  */
#line 193 "conf/confbase.Y"
       { (yyval.a) = ipa_from_ip6((yyvsp[0].ip6)); }
#line 6362 "obj/conf/cf-parse.tab.c"
    break;

  case 25: /* ipa: CF_SYM_KNOWN  */
#line 194 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address constant expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).ip;
   }
#line 6371 "obj/conf/cf-parse.tab.c"
    break;

  case 26: /* ipa_scope: %empty  */
#line 201 "conf/confbase.Y"
               { (yyval.iface) = NULL; }
#line 6377 "obj/conf/cf-parse.tab.c"
    break;

  case 27: /* ipa_scope: '%' symbol  */
#line 202 "conf/confbase.Y"
              { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 6383 "obj/conf/cf-parse.tab.c"
    break;

  case 28: /* pxlen4: '/' NUM  */
#line 209 "conf/confbase.Y"
           {
     if ((yyvsp[0].i) > IP4_MAX_PREFIX_LENGTH) cf_error("Invalid prefix length %u", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 6392 "obj/conf/cf-parse.tab.c"
    break;

  case 29: /* net_ip4_: IP4 pxlen4  */
#line 216 "conf/confbase.Y"
{
  net_fill_ip4(&((yyval.net)), (yyvsp[-1].ip4), (yyvsp[0].i));

  net_addr_ip4 *n = (void *) &((yyval.net));
  if (!net_validate_ip4(n))
    cf_error("Invalid IPv4 prefix %I4/%d, maybe you wanted %I4/%d",
	     n->prefix, n->pxlen, ip4_and(n->prefix, ip4_mkmask(n->pxlen)), n->pxlen);
}
#line 6405 "obj/conf/cf-parse.tab.c"
    break;

  case 30: /* net_ip6_: IP6 '/' NUM  */
#line 226 "conf/confbase.Y"
{
  if ((yyvsp[0].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[0].i));

  net_fill_ip6(&((yyval.net)), (yyvsp[-2].ip6), (yyvsp[0].i));

  net_addr_ip6 *n = (void *) &((yyval.net));
  if (!net_validate_ip6(n))
    cf_error("Invalid IPv6 prefix %I6/%d, maybe you wanted %I6/%d",
	     n->prefix, n->pxlen, ip6_and(n->prefix, ip6_mkmask(n->pxlen)), n->pxlen);
}
#line 6421 "obj/conf/cf-parse.tab.c"
    break;

  case 31: /* net_ip6_sadr_: IP6 '/' NUM FROM IP6 '/' NUM  */
#line 239 "conf/confbase.Y"
{
  if ((yyvsp[-4].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[-4].i));

  if ((yyvsp[0].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid prefix length %u", (yyvsp[0].i));

  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_ip6_sadr));
  net_fill_ip6_sadr((yyval.net_ptr), (yyvsp[-6].ip6), (yyvsp[-4].i), (yyvsp[-2].ip6), (yyvsp[0].i));

  net_addr_ip6_sadr *n = (void *) (yyval.net_ptr);
  if (!net_validate_ip6_sadr(n))
    cf_error("Invalid SADR IPv6 prefix %I6/%d from %I6/%d, maybe you wanted %I6/%d from %I6/%d",
	     n->dst_prefix, n->dst_pxlen, n->src_prefix, n->src_pxlen,
	     ip6_and(n->dst_prefix, ip6_mkmask(n->dst_pxlen)), n->dst_pxlen,
	     ip6_and(n->src_prefix, ip6_mkmask(n->src_pxlen)), n->src_pxlen);
}
#line 6443 "obj/conf/cf-parse.tab.c"
    break;

  case 32: /* net_vpn4_: VPN_RD net_ip4_  */
#line 258 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn4));
  net_fill_vpn4((yyval.net_ptr), net4_prefix(&(yyvsp[0].net)), net4_pxlen(&(yyvsp[0].net)), (yyvsp[-1].i64));
}
#line 6452 "obj/conf/cf-parse.tab.c"
    break;

  case 33: /* net_vpn6_: VPN_RD net_ip6_  */
#line 264 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn6));
  net_fill_vpn6((yyval.net_ptr), net6_prefix(&(yyvsp[0].net)), net6_pxlen(&(yyvsp[0].net)), (yyvsp[-1].i64));
}
#line 6461 "obj/conf/cf-parse.tab.c"
    break;

  case 34: /* net_roa4_: net_ip4_ MAX NUM AS NUM  */
#line 270 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa4));
  net_fill_roa4((yyval.net_ptr), net4_prefix(&(yyvsp[-4].net)), net4_pxlen(&(yyvsp[-4].net)), (yyvsp[-2].i), (yyvsp[0].i));
  if ((yyvsp[-2].i) < net4_pxlen(&(yyvsp[-4].net)) || (yyvsp[-2].i) > IP4_MAX_PREFIX_LENGTH)
    cf_error("Invalid max prefix length %u", (yyvsp[-2].i));
}
#line 6472 "obj/conf/cf-parse.tab.c"
    break;

  case 35: /* net_roa6_: net_ip6_ MAX NUM AS NUM  */
#line 278 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa6));
  net_fill_roa6((yyval.net_ptr), net6_prefix(&(yyvsp[-4].net)), net6_pxlen(&(yyvsp[-4].net)), (yyvsp[-2].i), (yyvsp[0].i));
  if ((yyvsp[-2].i) < net6_pxlen(&(yyvsp[-4].net)) || (yyvsp[-2].i) > IP6_MAX_PREFIX_LENGTH)
    cf_error("Invalid max prefix length %u", (yyvsp[-2].i));
}
#line 6483 "obj/conf/cf-parse.tab.c"
    break;

  case 36: /* net_mpls_: MPLS NUM  */
#line 286 "conf/confbase.Y"
{
  (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_roa6));
  net_fill_mpls((yyval.net_ptr), (yyvsp[0].i));
}
#line 6492 "obj/conf/cf-parse.tab.c"
    break;

  case 43: /* net_: net_ip_  */
#line 296 "conf/confbase.Y"
           { (yyval.net_ptr) = cfg_alloc((yyvsp[0].net).length); net_copy((yyval.net_ptr), &((yyvsp[0].net))); }
#line 6498 "obj/conf/cf-parse.tab.c"
    break;

  case 50: /* net_ip4: CF_SYM_KNOWN  */
#line 309 "conf/confbase.Y"
                {
     if (((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET)) || (SYM_VAL((yyvsp[0].s)).net->type != NET_IP4))
       cf_error("IPv4 network constant expected");
     (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
   }
#line 6508 "obj/conf/cf-parse.tab.c"
    break;

  case 52: /* net_ip6: CF_SYM_KNOWN  */
#line 318 "conf/confbase.Y"
                {
     if (((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET)) || (SYM_VAL((yyvsp[0].s)).net->type != NET_IP6))
       cf_error("IPv6 network constant expected");
     (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
   }
#line 6518 "obj/conf/cf-parse.tab.c"
    break;

  case 54: /* net_ip: CF_SYM_KNOWN  */
#line 327 "conf/confbase.Y"
                {
     if (((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET)) || !net_is_ip(SYM_VAL((yyvsp[0].s)).net))
       cf_error("IP network constant expected");
     (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
   }
#line 6528 "obj/conf/cf-parse.tab.c"
    break;

  case 56: /* net_any: CF_SYM_KNOWN  */
#line 336 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_NET))
       cf_error("Network constant expected");
     (yyval.net_ptr) = (net_addr *) SYM_VAL((yyvsp[0].s)).net; /* Avoid const warning */
   }
#line 6538 "obj/conf/cf-parse.tab.c"
    break;

  case 59: /* net_or_ipa: IP4  */
#line 346 "conf/confbase.Y"
       { net_fill_ip4(&((yyval.net)), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH); }
#line 6544 "obj/conf/cf-parse.tab.c"
    break;

  case 60: /* net_or_ipa: IP6  */
#line 347 "conf/confbase.Y"
       { net_fill_ip6(&((yyval.net)), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH); }
#line 6550 "obj/conf/cf-parse.tab.c"
    break;

  case 61: /* net_or_ipa: CF_SYM_KNOWN  */
#line 348 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       net_fill_ip_host(&((yyval.net)), SYM_VAL((yyvsp[0].s)).ip);
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_NET)) && net_is_ip(SYM_VAL((yyvsp[0].s)).net))
       (yyval.net) = * SYM_VAL((yyvsp[0].s)).net;
     else
       cf_error("IP address or network constant expected");
   }
#line 6563 "obj/conf/cf-parse.tab.c"
    break;

  case 62: /* label_stack_start: NUM  */
#line 359 "conf/confbase.Y"
{
  (yyval.mls) = cfg_allocz(sizeof(mpls_label_stack));
  (yyval.mls)->len = 1;
  (yyval.mls)->stack[0] = (yyvsp[0].i);
}
#line 6573 "obj/conf/cf-parse.tab.c"
    break;

  case 64: /* label_stack: label_stack '/' NUM  */
#line 367 "conf/confbase.Y"
                        {
    if ((yyvsp[-2].mls)->len >= MPLS_MAX_LABEL_STACK)
      cf_error("Too many labels in stack");
    (yyvsp[-2].mls)->stack[(yyvsp[-2].mls)->len++] = (yyvsp[0].i);
    (yyval.mls) = (yyvsp[-2].mls);
  }
#line 6584 "obj/conf/cf-parse.tab.c"
    break;

  case 65: /* time: TEXT  */
#line 376 "conf/confbase.Y"
        {
     (yyval.time) = tm_parse_time((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date/time");
   }
#line 6594 "obj/conf/cf-parse.tab.c"
    break;

  case 67: /* text: CF_SYM_KNOWN  */
#line 385 "conf/confbase.Y"
                {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String constant expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 6603 "obj/conf/cf-parse.tab.c"
    break;

  case 69: /* opttext: %empty  */
#line 393 "conf/confbase.Y"
               { (yyval.t) = NULL; }
#line 6609 "obj/conf/cf-parse.tab.c"
    break;

  case 70: /* flow_num_op: TRUE  */
#line 37 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_TRUE; }
#line 6615 "obj/conf/cf-parse.tab.c"
    break;

  case 71: /* flow_num_op: '='  */
#line 38 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_EQ;  }
#line 6621 "obj/conf/cf-parse.tab.c"
    break;

  case 72: /* flow_num_op: NEQ  */
#line 39 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_NEQ; }
#line 6627 "obj/conf/cf-parse.tab.c"
    break;

  case 73: /* flow_num_op: '<'  */
#line 40 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_LT;  }
#line 6633 "obj/conf/cf-parse.tab.c"
    break;

  case 74: /* flow_num_op: LEQ  */
#line 41 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_LEQ; }
#line 6639 "obj/conf/cf-parse.tab.c"
    break;

  case 75: /* flow_num_op: '>'  */
#line 42 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_GT;  }
#line 6645 "obj/conf/cf-parse.tab.c"
    break;

  case 76: /* flow_num_op: GEQ  */
#line 43 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_GEQ; }
#line 6651 "obj/conf/cf-parse.tab.c"
    break;

  case 77: /* flow_num_op: FALSE  */
#line 44 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_FALSE; }
#line 6657 "obj/conf/cf-parse.tab.c"
    break;

  case 78: /* flow_logic_op: OR  */
#line 48 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_OR; }
#line 6663 "obj/conf/cf-parse.tab.c"
    break;

  case 79: /* flow_logic_op: AND  */
#line 49 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_OP_AND; }
#line 6669 "obj/conf/cf-parse.tab.c"
    break;

  case 80: /* flow_num_type_: PROTO  */
#line 53 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_IP_PROTOCOL; }
#line 6675 "obj/conf/cf-parse.tab.c"
    break;

  case 81: /* flow_num_type_: NEXT HEADER  */
#line 54 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_NEXT_HEADER; }
#line 6681 "obj/conf/cf-parse.tab.c"
    break;

  case 82: /* flow_num_type_: PORT  */
#line 55 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_PORT; }
#line 6687 "obj/conf/cf-parse.tab.c"
    break;

  case 83: /* flow_num_type_: DPORT  */
#line 56 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_DST_PORT; }
#line 6693 "obj/conf/cf-parse.tab.c"
    break;

  case 84: /* flow_num_type_: SPORT  */
#line 57 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_SRC_PORT; }
#line 6699 "obj/conf/cf-parse.tab.c"
    break;

  case 85: /* flow_num_type_: ICMP TYPE  */
#line 58 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_ICMP_TYPE; }
#line 6705 "obj/conf/cf-parse.tab.c"
    break;

  case 86: /* flow_num_type_: ICMP CODE  */
#line 59 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_ICMP_CODE; }
#line 6711 "obj/conf/cf-parse.tab.c"
    break;

  case 87: /* flow_num_type_: LENGTH  */
#line 60 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_PACKET_LENGTH; }
#line 6717 "obj/conf/cf-parse.tab.c"
    break;

  case 88: /* flow_num_type_: DSCP  */
#line 61 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_DSCP; }
#line 6723 "obj/conf/cf-parse.tab.c"
    break;

  case 89: /* flow_num_type_: LABEL  */
#line 62 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_LABEL; }
#line 6729 "obj/conf/cf-parse.tab.c"
    break;

  case 90: /* flow_num_type: flow_num_type_  */
#line 65 "conf/flowspec.Y"
                             { flow_builder_set_type(this_flow, (yyvsp[0].i32)); }
#line 6735 "obj/conf/cf-parse.tab.c"
    break;

  case 91: /* flow_flag_type: TCP FLAGS  */
#line 66 "conf/flowspec.Y"
                             { flow_builder_set_type(this_flow, FLOW_TYPE_TCP_FLAGS); }
#line 6741 "obj/conf/cf-parse.tab.c"
    break;

  case 92: /* flow_frag_type: FRAGMENT  */
#line 67 "conf/flowspec.Y"
                             { flow_builder_set_type(this_flow, FLOW_TYPE_FRAGMENT); }
#line 6747 "obj/conf/cf-parse.tab.c"
    break;

  case 93: /* flow_srcdst: DST  */
#line 70 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_DST_PREFIX; }
#line 6753 "obj/conf/cf-parse.tab.c"
    break;

  case 94: /* flow_srcdst: SRC  */
#line 71 "conf/flowspec.Y"
                { (yyval.i32) = FLOW_TYPE_SRC_PREFIX; }
#line 6759 "obj/conf/cf-parse.tab.c"
    break;

  case 95: /* flow_num_opts: flow_num_op expr  */
#line 75 "conf/flowspec.Y"
                    {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, (yyvsp[-1].i32), (yyvsp[0].i));
   }
#line 6768 "obj/conf/cf-parse.tab.c"
    break;

  case 96: /* flow_num_opts: flow_num_opts flow_logic_op flow_num_op expr  */
#line 79 "conf/flowspec.Y"
                                                {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, (yyvsp[-2].i32) | (yyvsp[-1].i32), (yyvsp[0].i));
   }
#line 6777 "obj/conf/cf-parse.tab.c"
    break;

  case 99: /* flow_num_opt_ext_expr: expr  */
#line 88 "conf/flowspec.Y"
        {
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_EQ, (yyvsp[0].i));
   }
#line 6786 "obj/conf/cf-parse.tab.c"
    break;

  case 100: /* flow_num_opt_ext_expr: expr DDOT expr  */
#line 92 "conf/flowspec.Y"
                  {
     flow_check_cf_value_length(this_flow, (yyvsp[-2].i));
     flow_check_cf_value_length(this_flow, (yyvsp[0].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_GEQ, (yyvsp[-2].i));
     flow_builder_add_op_val(this_flow, FLOW_OP_AND | FLOW_OP_LEQ, (yyvsp[0].i));
   }
#line 6797 "obj/conf/cf-parse.tab.c"
    break;

  case 103: /* flow_bmk_opts: flow_neg expr '/' expr  */
#line 106 "conf/flowspec.Y"
                          {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
   }
#line 6806 "obj/conf/cf-parse.tab.c"
    break;

  case 104: /* flow_bmk_opts: flow_bmk_opts flow_logic_op flow_neg expr '/' expr  */
#line 110 "conf/flowspec.Y"
                                                      {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, (yyvsp[-4].i32) | (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
   }
#line 6815 "obj/conf/cf-parse.tab.c"
    break;

  case 105: /* flow_bmk_opts: flow_bmk_opts ',' flow_neg expr '/' expr  */
#line 114 "conf/flowspec.Y"
                                            {
     flow_check_cf_bmk_values(this_flow, (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i));
     flow_builder_add_val_mask(this_flow, 0x40 | (yyvsp[-3].i32), (yyvsp[-2].i), (yyvsp[0].i)); /* AND */
   }
#line 6824 "obj/conf/cf-parse.tab.c"
    break;

  case 106: /* flow_neg: %empty  */
#line 121 "conf/flowspec.Y"
                { (yyval.i32) = 0x00; }
#line 6830 "obj/conf/cf-parse.tab.c"
    break;

  case 107: /* flow_neg: '!'  */
#line 122 "conf/flowspec.Y"
                { (yyval.i32) = 0x02; }
#line 6836 "obj/conf/cf-parse.tab.c"
    break;

  case 108: /* flow_frag_val: DONT_FRAGMENT  */
#line 126 "conf/flowspec.Y"
                  { (yyval.i32) = 1; }
#line 6842 "obj/conf/cf-parse.tab.c"
    break;

  case 109: /* flow_frag_val: IS_FRAGMENT  */
#line 127 "conf/flowspec.Y"
                  { (yyval.i32) = 2; }
#line 6848 "obj/conf/cf-parse.tab.c"
    break;

  case 110: /* flow_frag_val: FIRST_FRAGMENT  */
#line 128 "conf/flowspec.Y"
                  { (yyval.i32) = 4; }
#line 6854 "obj/conf/cf-parse.tab.c"
    break;

  case 111: /* flow_frag_val: LAST_FRAGMENT  */
#line 129 "conf/flowspec.Y"
                  { (yyval.i32) = 8; }
#line 6860 "obj/conf/cf-parse.tab.c"
    break;

  case 112: /* flow_frag_opts: flow_neg flow_frag_val  */
#line 133 "conf/flowspec.Y"
                          {
     flow_builder_add_val_mask(this_flow, 0, ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32));
   }
#line 6868 "obj/conf/cf-parse.tab.c"
    break;

  case 113: /* flow_frag_opts: flow_frag_opts flow_logic_op flow_neg flow_frag_val  */
#line 136 "conf/flowspec.Y"
                                                       {
     flow_builder_add_val_mask(this_flow, (yyvsp[-2].i32), ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32));
   }
#line 6876 "obj/conf/cf-parse.tab.c"
    break;

  case 114: /* flow_frag_opts: flow_frag_opts ',' flow_neg flow_frag_val  */
#line 139 "conf/flowspec.Y"
                                             {
     flow_builder_add_val_mask(this_flow, 0x40, ((yyvsp[-1].i32) ? 0 : (yyvsp[0].i32)), (yyvsp[0].i32)); /* AND */
   }
#line 6884 "obj/conf/cf-parse.tab.c"
    break;

  case 115: /* flow4_item: flow_srcdst net_ip4  */
#line 145 "conf/flowspec.Y"
                       {
     flow_builder_set_type(this_flow, (yyvsp[-1].i32));
     flow_builder4_add_pfx(this_flow, (net_addr_ip4 *) &((yyvsp[0].net)));
   }
#line 6893 "obj/conf/cf-parse.tab.c"
    break;

  case 119: /* flow6_item: flow_srcdst net_ip6  */
#line 155 "conf/flowspec.Y"
                       {
     flow_builder_set_type(this_flow, (yyvsp[-1].i32));
     flow_builder6_add_pfx(this_flow, (net_addr_ip6 *) &((yyvsp[0].net)), 0);
   }
#line 6902 "obj/conf/cf-parse.tab.c"
    break;

  case 120: /* flow6_item: flow_srcdst net_ip6 OFFSET NUM  */
#line 159 "conf/flowspec.Y"
                                  {
     if ((yyvsp[0].i) > (yyvsp[-2].net).pxlen)
       cf_error("Prefix offset is higher than prefix length");
     flow_builder_set_type(this_flow, (yyvsp[-3].i32));
     flow_builder6_add_pfx(this_flow, (net_addr_ip6 *) &((yyvsp[-2].net)), (yyvsp[0].i));
   }
#line 6913 "obj/conf/cf-parse.tab.c"
    break;

  case 128: /* flow_builder_init: %empty  */
#line 181 "conf/flowspec.Y"
{
  if (this_flow == NULL)
    this_flow = flow_builder_init(config_pool);	  /* FIXME: This should be allocated from tmp in future */
  else
    flow_builder_clear(this_flow);
}
#line 6924 "obj/conf/cf-parse.tab.c"
    break;

  case 129: /* flow_builder_set_ipv4: %empty  */
#line 188 "conf/flowspec.Y"
                       { this_flow->ipv6 = 0; }
#line 6930 "obj/conf/cf-parse.tab.c"
    break;

  case 130: /* flow_builder_set_ipv6: %empty  */
#line 189 "conf/flowspec.Y"
                       { this_flow->ipv6 = 1; }
#line 6936 "obj/conf/cf-parse.tab.c"
    break;

  case 131: /* net_flow4_: FLOW4 '{' flow_builder_init flow_builder_set_ipv4 flow4_opts '}'  */
#line 192 "conf/flowspec.Y"
{
  (yyval.net_ptr) = (net_addr *) flow_builder4_finalize(this_flow, cfg_mem);
  flow4_validate_cf((net_addr_flow4 *) (yyval.net_ptr));
}
#line 6945 "obj/conf/cf-parse.tab.c"
    break;

  case 132: /* net_flow6_: FLOW6 '{' flow_builder_init flow_builder_set_ipv6 flow6_opts '}'  */
#line 198 "conf/flowspec.Y"
{
  (yyval.net_ptr) = (net_addr *) flow_builder6_finalize(this_flow, cfg_mem);
  flow6_validate_cf((net_addr_flow6 *) (yyval.net_ptr));
}
#line 6954 "obj/conf/cf-parse.tab.c"
    break;

  case 142: /* $@1: %empty  */
#line 348 "filter/config.Y"
                 { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, filter, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 6960 "obj/conf/cf-parse.tab.c"
    break;

  case 143: /* filter_def: FILTER symbol $@1 filter_body  */
#line 349 "filter/config.Y"
                 {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     *f = (struct filter) { .sym = (yyvsp[-2].s), .root = (yyvsp[0].fl) };
     (yyvsp[-2].s)->filter = f;

     cf_pop_scope();
   }
#line 6972 "obj/conf/cf-parse.tab.c"
    break;

  case 145: /* filter_eval: EVAL term  */
#line 360 "filter/config.Y"
             { f_eval_int(f_linearize((yyvsp[0].x), 1)); }
#line 6978 "obj/conf/cf-parse.tab.c"
    break;

  case 147: /* custom_attr: ATTRIBUTE type symbol ';'  */
#line 364 "filter/config.Y"
                                       {
  cf_define_symbol((yyvsp[-1].s), SYM_ATTRIBUTE, attribute, ca_lookup(new_config->pool, (yyvsp[-1].s)->name, (yyvsp[-2].i))->fda);
}
#line 6986 "obj/conf/cf-parse.tab.c"
    break;

  case 149: /* bt_test_suite: BT_TEST_SUITE '(' CF_SYM_KNOWN ',' text ')'  */
#line 370 "filter/config.Y"
                                             {
  cf_assert_symbol((yyvsp[-3].s), SYM_FUNCTION);
  struct f_bt_test_suite *t = cfg_allocz(sizeof(struct f_bt_test_suite));
  t->fn = (yyvsp[-3].s)->function;
  t->fn_name = (yyvsp[-3].s)->name;
  t->dsc = (yyvsp[-1].t);

  add_tail(&new_config->tests, &t->n);
 }
#line 7000 "obj/conf/cf-parse.tab.c"
    break;

  case 151: /* bt_test_same: BT_TEST_SAME '(' CF_SYM_KNOWN ',' CF_SYM_KNOWN ',' NUM ')'  */
#line 383 "filter/config.Y"
                                                            {
  cf_assert_symbol((yyvsp[-5].s), SYM_FUNCTION);
  cf_assert_symbol((yyvsp[-3].s), SYM_FUNCTION);
  struct f_bt_test_suite *t = cfg_allocz(sizeof(struct f_bt_test_suite));
  t->fn = (yyvsp[-5].s)->function;
  t->cmp = (yyvsp[-3].s)->function;
  t->result = (yyvsp[-1].i);
  t->fn_name = (yyvsp[-5].s)->name;
  t->dsc = (yyvsp[-3].s)->name;
  add_tail(&new_config->tests, &t->n);
 }
#line 7016 "obj/conf/cf-parse.tab.c"
    break;

  case 152: /* type: INT  */
#line 397 "filter/config.Y"
       { (yyval.i) = T_INT; }
#line 7022 "obj/conf/cf-parse.tab.c"
    break;

  case 153: /* type: BOOL  */
#line 398 "filter/config.Y"
        { (yyval.i) = T_BOOL; }
#line 7028 "obj/conf/cf-parse.tab.c"
    break;

  case 154: /* type: IP  */
#line 399 "filter/config.Y"
      { (yyval.i) = T_IP; }
#line 7034 "obj/conf/cf-parse.tab.c"
    break;

  case 155: /* type: RD  */
#line 400 "filter/config.Y"
      { (yyval.i) = T_RD; }
#line 7040 "obj/conf/cf-parse.tab.c"
    break;

  case 156: /* type: PREFIX  */
#line 401 "filter/config.Y"
          { (yyval.i) = T_NET; }
#line 7046 "obj/conf/cf-parse.tab.c"
    break;

  case 157: /* type: PAIR  */
#line 402 "filter/config.Y"
        { (yyval.i) = T_PAIR; }
#line 7052 "obj/conf/cf-parse.tab.c"
    break;

  case 158: /* type: QUAD  */
#line 403 "filter/config.Y"
        { (yyval.i) = T_QUAD; }
#line 7058 "obj/conf/cf-parse.tab.c"
    break;

  case 159: /* type: EC  */
#line 404 "filter/config.Y"
      { (yyval.i) = T_EC; }
#line 7064 "obj/conf/cf-parse.tab.c"
    break;

  case 160: /* type: LC  */
#line 405 "filter/config.Y"
      { (yyval.i) = T_LC; }
#line 7070 "obj/conf/cf-parse.tab.c"
    break;

  case 161: /* type: STRING  */
#line 406 "filter/config.Y"
          { (yyval.i) = T_STRING; }
#line 7076 "obj/conf/cf-parse.tab.c"
    break;

  case 162: /* type: BGPMASK  */
#line 407 "filter/config.Y"
           { (yyval.i) = T_PATH_MASK; }
#line 7082 "obj/conf/cf-parse.tab.c"
    break;

  case 163: /* type: BGPPATH  */
#line 408 "filter/config.Y"
           { (yyval.i) = T_PATH; }
#line 7088 "obj/conf/cf-parse.tab.c"
    break;

  case 164: /* type: CLIST  */
#line 409 "filter/config.Y"
         { (yyval.i) = T_CLIST; }
#line 7094 "obj/conf/cf-parse.tab.c"
    break;

  case 165: /* type: ECLIST  */
#line 410 "filter/config.Y"
          { (yyval.i) = T_ECLIST; }
#line 7100 "obj/conf/cf-parse.tab.c"
    break;

  case 166: /* type: LCLIST  */
#line 411 "filter/config.Y"
          { (yyval.i) = T_LCLIST; }
#line 7106 "obj/conf/cf-parse.tab.c"
    break;

  case 167: /* type: type SET  */
#line 412 "filter/config.Y"
            {
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_RD:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_NET:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 7131 "obj/conf/cf-parse.tab.c"
    break;

  case 168: /* function_argsn: %empty  */
#line 435 "filter/config.Y"
               { (yyval.fa) = NULL; }
#line 7137 "obj/conf/cf-parse.tab.c"
    break;

  case 169: /* function_argsn: function_argsn type symbol ';'  */
#line 436 "filter/config.Y"
                                  {
     if ((yyvsp[-1].s)->scope->slots >= 0xfe) cf_error("Too many declarations, at most 255 allowed");
     (yyval.fa) = cfg_alloc(sizeof(struct f_arg));
     (yyval.fa)->arg = cf_define_symbol((yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, sym_->scope->slots++);
     (yyval.fa)->next = (yyvsp[-3].fa);
   }
#line 7148 "obj/conf/cf-parse.tab.c"
    break;

  case 170: /* function_args: '(' ')'  */
#line 445 "filter/config.Y"
           { (yyval.fa) = NULL; }
#line 7154 "obj/conf/cf-parse.tab.c"
    break;

  case 171: /* function_args: '(' function_argsn type symbol ')'  */
#line 446 "filter/config.Y"
                                      {
     (yyval.fa) = cfg_alloc(sizeof(struct f_arg));
     (yyval.fa)->arg = cf_define_symbol((yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, sym_->scope->slots++);
     (yyval.fa)->next = (yyvsp[-3].fa);
   }
#line 7164 "obj/conf/cf-parse.tab.c"
    break;

  case 172: /* function_vars: %empty  */
#line 454 "filter/config.Y"
               { (yyval.i) = 0; }
#line 7170 "obj/conf/cf-parse.tab.c"
    break;

  case 173: /* function_vars: function_vars type symbol ';'  */
#line 455 "filter/config.Y"
                                 {
     cf_define_symbol((yyvsp[-1].s), SYM_VARIABLE | (yyvsp[-2].i), offset, f_new_var(sym_->scope));
     (yyval.i) = (yyvsp[-3].i) + 1;
   }
#line 7179 "obj/conf/cf-parse.tab.c"
    break;

  case 175: /* filter: CF_SYM_KNOWN  */
#line 464 "filter/config.Y"
                {
     cf_assert_symbol((yyvsp[0].s), SYM_FILTER);
     (yyval.f) = (yyvsp[0].s)->filter;
   }
#line 7188 "obj/conf/cf-parse.tab.c"
    break;

  case 176: /* $@2: %empty  */
#line 468 "filter/config.Y"
   { cf_push_scope(NULL); }
#line 7194 "obj/conf/cf-parse.tab.c"
    break;

  case 177: /* filter: $@2 filter_body  */
#line 468 "filter/config.Y"
                                        {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     *f = (struct filter) { .root = (yyvsp[0].fl) };
     (yyval.f) = f;

     cf_pop_scope();
   }
#line 7206 "obj/conf/cf-parse.tab.c"
    break;

  case 178: /* where_filter: WHERE term  */
#line 478 "filter/config.Y"
              {
     /* Construct 'IF term THEN { ACCEPT; } ELSE { REJECT; }' */
     (yyval.f) = f_new_where((yyvsp[0].x));
   }
#line 7215 "obj/conf/cf-parse.tab.c"
    break;

  case 179: /* function_body: function_vars '{' cmds '}'  */
#line 485 "filter/config.Y"
                              {
     (yyval.fl) = f_linearize((yyvsp[-1].x), 0);
     (yyval.fl)->vars = (yyvsp[-3].i);
   }
#line 7224 "obj/conf/cf-parse.tab.c"
    break;

  case 181: /* $@3: %empty  */
#line 493 "filter/config.Y"
                   {
     DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, function, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 7234 "obj/conf/cf-parse.tab.c"
    break;

  case 182: /* $@4: %empty  */
#line 497 "filter/config.Y"
                   {
     /* Make dummy f_line for storing function prototype */
     struct f_line *dummy = cfg_allocz(sizeof(struct f_line));
     (yyvsp[-2].s)->function = dummy;

     /* Revert the args */
     while ((yyvsp[0].fa)) {
       struct f_arg *tmp = (yyvsp[0].fa);
       (yyvsp[0].fa) = (yyvsp[0].fa)->next;

       tmp->next = dummy->arg_list;
       dummy->arg_list = tmp;
       dummy->args++;
     }
   }
#line 7254 "obj/conf/cf-parse.tab.c"
    break;

  case 183: /* function_def: FUNCTION symbol $@3 function_args $@4 function_body  */
#line 511 "filter/config.Y"
                   {
     (yyvsp[0].fl)->args = (yyvsp[-4].s)->function->args;
     (yyvsp[0].fl)->arg_list = (yyvsp[-4].s)->function->arg_list;
     (yyvsp[-4].s)->function = (yyvsp[0].fl);
     cf_pop_scope();
   }
#line 7265 "obj/conf/cf-parse.tab.c"
    break;

  case 184: /* cmds: %empty  */
#line 521 "filter/config.Y"
                  { (yyval.x) = NULL; }
#line 7271 "obj/conf/cf-parse.tab.c"
    break;

  case 185: /* cmds: cmds_int  */
#line 522 "filter/config.Y"
            { (yyval.x) = (yyvsp[0].xp).begin; }
#line 7277 "obj/conf/cf-parse.tab.c"
    break;

  case 186: /* $@5: %empty  */
#line 525 "filter/config.Y"
             { cf_push_soft_scope(); }
#line 7283 "obj/conf/cf-parse.tab.c"
    break;

  case 187: /* cmds_scoped: $@5 cmds  */
#line 525 "filter/config.Y"
                                            { cf_pop_soft_scope(); (yyval.x) = (yyvsp[0].x); }
#line 7289 "obj/conf/cf-parse.tab.c"
    break;

  case 190: /* cmd_prep: cmd_var  */
#line 529 "filter/config.Y"
                  {
  (yyval.xp).begin = (yyval.xp).end = (yyvsp[0].x);
  if ((yyvsp[0].x))
    while ((yyval.xp).end->next)
      (yyval.xp).end = (yyval.xp).end->next;
}
#line 7300 "obj/conf/cf-parse.tab.c"
    break;

  case 192: /* cmds_int: cmds_int cmd_prep  */
#line 538 "filter/config.Y"
                     {
  if (!(yyvsp[-1].xp).begin)
    (yyval.xp) = (yyvsp[0].xp);
  else if (!(yyvsp[0].xp).begin)
    (yyval.xp) = (yyvsp[-1].xp);
  else {
    (yyval.xp).begin = (yyvsp[-1].xp).begin;
    (yyval.xp).end = (yyvsp[0].xp).end;
    (yyvsp[-1].xp).end->next = (yyvsp[0].xp).begin;
  }
 }
#line 7316 "obj/conf/cf-parse.tab.c"
    break;

  case 193: /* fipa: IP4  */
#line 555 "filter/config.Y"
                          { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip4((yyvsp[0].ip4)); }
#line 7322 "obj/conf/cf-parse.tab.c"
    break;

  case 194: /* fipa: IP6  */
#line 556 "filter/config.Y"
                          { (yyval.v).type = T_IP; (yyval.v).val.ip = ipa_from_ip6((yyvsp[0].ip6)); }
#line 7328 "obj/conf/cf-parse.tab.c"
    break;

  case 195: /* set_atom: NUM  */
#line 569 "filter/config.Y"
          { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 7334 "obj/conf/cf-parse.tab.c"
    break;

  case 196: /* set_atom: fipa  */
#line 570 "filter/config.Y"
          { (yyval.v) = (yyvsp[0].v); }
#line 7340 "obj/conf/cf-parse.tab.c"
    break;

  case 197: /* set_atom: VPN_RD  */
#line 571 "filter/config.Y"
          { (yyval.v).type = T_RD; (yyval.v).val.ec = (yyvsp[0].i64); }
#line 7346 "obj/conf/cf-parse.tab.c"
    break;

  case 198: /* set_atom: ENUM  */
#line 572 "filter/config.Y"
          { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 7352 "obj/conf/cf-parse.tab.c"
    break;

  case 199: /* set_atom: '(' term ')'  */
#line 573 "filter/config.Y"
                {
     if (f_eval(f_linearize((yyvsp[-1].x), 1), cfg_mem, &((yyval.v))) > F_RETURN) cf_error("Runtime error");
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 7361 "obj/conf/cf-parse.tab.c"
    break;

  case 200: /* set_atom: CF_SYM_KNOWN  */
#line 577 "filter/config.Y"
                {
     cf_assert_symbol((yyvsp[0].s), SYM_CONSTANT);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(yyvsp[0].s)->val;
   }
#line 7371 "obj/conf/cf-parse.tab.c"
    break;

  case 201: /* switch_atom: NUM  */
#line 585 "filter/config.Y"
         { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 7377 "obj/conf/cf-parse.tab.c"
    break;

  case 202: /* switch_atom: '(' term ')'  */
#line 586 "filter/config.Y"
                { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int(f_linearize((yyvsp[-1].x), 1)); }
#line 7383 "obj/conf/cf-parse.tab.c"
    break;

  case 203: /* switch_atom: fipa  */
#line 587 "filter/config.Y"
         { (yyval.v) = (yyvsp[0].v); }
#line 7389 "obj/conf/cf-parse.tab.c"
    break;

  case 204: /* switch_atom: ENUM  */
#line 588 "filter/config.Y"
         { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 7395 "obj/conf/cf-parse.tab.c"
    break;

  case 205: /* cnum: term  */
#line 592 "filter/config.Y"
        { (yyval.i32) = f_eval_int(f_linearize((yyvsp[0].x), 1)); }
#line 7401 "obj/conf/cf-parse.tab.c"
    break;

  case 206: /* pair_item: '(' cnum ',' cnum ')'  */
#line 595 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7407 "obj/conf/cf-parse.tab.c"
    break;

  case 207: /* pair_item: '(' cnum ',' cnum DDOT cnum ')'  */
#line 596 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7413 "obj/conf/cf-parse.tab.c"
    break;

  case 208: /* pair_item: '(' cnum ',' '*' ')'  */
#line 597 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 7419 "obj/conf/cf-parse.tab.c"
    break;

  case 209: /* pair_item: '(' cnum DDOT cnum ',' cnum ')'  */
#line 598 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_set((yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7425 "obj/conf/cf-parse.tab.c"
    break;

  case 210: /* pair_item: '(' cnum DDOT cnum ',' cnum DDOT cnum ')'  */
#line 599 "filter/config.Y"
                                             { (yyval.e) = f_new_pair_set((yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7431 "obj/conf/cf-parse.tab.c"
    break;

  case 211: /* pair_item: '(' cnum DDOT cnum ',' '*' ')'  */
#line 600 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 7437 "obj/conf/cf-parse.tab.c"
    break;

  case 212: /* pair_item: '(' '*' ',' cnum ')'  */
#line 601 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7443 "obj/conf/cf-parse.tab.c"
    break;

  case 213: /* pair_item: '(' '*' ',' cnum DDOT cnum ')'  */
#line 602 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7449 "obj/conf/cf-parse.tab.c"
    break;

  case 214: /* pair_item: '(' '*' ',' '*' ')'  */
#line 603 "filter/config.Y"
                                        { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
#line 7455 "obj/conf/cf-parse.tab.c"
    break;

  case 215: /* pair_item: '(' cnum ',' cnum ')' DDOT '(' cnum ',' cnum ')'  */
#line 605 "filter/config.Y"
   { (yyval.e) = f_new_pair_item((yyvsp[-9].i32), (yyvsp[-3].i32), (yyvsp[-7].i32), (yyvsp[-1].i32)); }
#line 7461 "obj/conf/cf-parse.tab.c"
    break;

  case 216: /* ec_kind: RT  */
#line 609 "filter/config.Y"
      { (yyval.ecs) = EC_RT; }
#line 7467 "obj/conf/cf-parse.tab.c"
    break;

  case 217: /* ec_kind: RO  */
#line 610 "filter/config.Y"
      { (yyval.ecs) = EC_RO; }
#line 7473 "obj/conf/cf-parse.tab.c"
    break;

  case 218: /* ec_kind: UNKNOWN NUM  */
#line 611 "filter/config.Y"
               { (yyval.ecs) = (yyvsp[0].i); }
#line 7479 "obj/conf/cf-parse.tab.c"
    break;

  case 219: /* ec_kind: GENERIC  */
#line 612 "filter/config.Y"
           { (yyval.ecs) = EC_GENERIC; }
#line 7485 "obj/conf/cf-parse.tab.c"
    break;

  case 220: /* ec_item: '(' ec_kind ',' cnum ',' cnum ')'  */
#line 616 "filter/config.Y"
                                                { (yyval.e) = f_new_ec_item((yyvsp[-5].ecs), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7491 "obj/conf/cf-parse.tab.c"
    break;

  case 221: /* ec_item: '(' ec_kind ',' cnum ',' cnum DDOT cnum ')'  */
#line 617 "filter/config.Y"
                                                { (yyval.e) = f_new_ec_item((yyvsp[-7].ecs), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7497 "obj/conf/cf-parse.tab.c"
    break;

  case 222: /* ec_item: '(' ec_kind ',' cnum ',' '*' ')'  */
#line 618 "filter/config.Y"
                                                { (yyval.e) = f_new_ec_item((yyvsp[-5].ecs), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 7503 "obj/conf/cf-parse.tab.c"
    break;

  case 223: /* lc_item: '(' cnum ',' cnum ',' cnum ')'  */
#line 622 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 7509 "obj/conf/cf-parse.tab.c"
    break;

  case 224: /* lc_item: '(' cnum ',' cnum ',' cnum DDOT cnum ')'  */
#line 623 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 7515 "obj/conf/cf-parse.tab.c"
    break;

  case 225: /* lc_item: '(' cnum ',' cnum ',' '*' ')'  */
#line 624 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 7521 "obj/conf/cf-parse.tab.c"
    break;

  case 226: /* lc_item: '(' cnum ',' cnum DDOT cnum ',' '*' ')'  */
#line 625 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 7527 "obj/conf/cf-parse.tab.c"
    break;

  case 227: /* lc_item: '(' cnum ',' '*' ',' '*' ')'  */
#line 626 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 7533 "obj/conf/cf-parse.tab.c"
    break;

  case 228: /* lc_item: '(' cnum DDOT cnum ',' '*' ',' '*' ')'  */
#line 627 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 7539 "obj/conf/cf-parse.tab.c"
    break;

  case 229: /* lc_item: '(' '*' ',' '*' ',' '*' ')'  */
#line 628 "filter/config.Y"
                                            { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
#line 7545 "obj/conf/cf-parse.tab.c"
    break;

  case 230: /* lc_item: '(' cnum ',' cnum ',' cnum ')' DDOT '(' cnum ',' cnum ',' cnum ')'  */
#line 630 "filter/config.Y"
   { (yyval.e) = f_new_lc_item((yyvsp[-13].i32), (yyvsp[-5].i32), (yyvsp[-11].i32), (yyvsp[-3].i32), (yyvsp[-9].i32), (yyvsp[-1].i32)); }
#line 7551 "obj/conf/cf-parse.tab.c"
    break;

  case 234: /* set_item: set_atom  */
#line 637 "filter/config.Y"
            { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 7557 "obj/conf/cf-parse.tab.c"
    break;

  case 235: /* set_item: set_atom DDOT set_atom  */
#line 638 "filter/config.Y"
                          { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 7563 "obj/conf/cf-parse.tab.c"
    break;

  case 239: /* switch_item: switch_atom  */
#line 645 "filter/config.Y"
               { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 7569 "obj/conf/cf-parse.tab.c"
    break;

  case 240: /* switch_item: switch_atom DDOT switch_atom  */
#line 646 "filter/config.Y"
                                { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 7575 "obj/conf/cf-parse.tab.c"
    break;

  case 242: /* set_items: set_items ',' set_item  */
#line 651 "filter/config.Y"
                          { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 7581 "obj/conf/cf-parse.tab.c"
    break;

  case 244: /* switch_items: switch_items ',' switch_item  */
#line 656 "filter/config.Y"
                                { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 7587 "obj/conf/cf-parse.tab.c"
    break;

  case 245: /* fprefix: net_ip_  */
#line 660 "filter/config.Y"
                { (yyval.px).net = (yyvsp[0].net); (yyval.px).lo = (yyvsp[0].net).pxlen; (yyval.px).hi = (yyvsp[0].net).pxlen; }
#line 7593 "obj/conf/cf-parse.tab.c"
    break;

  case 246: /* fprefix: net_ip_ '+'  */
#line 661 "filter/config.Y"
                { (yyval.px).net = (yyvsp[-1].net); (yyval.px).lo = (yyvsp[-1].net).pxlen; (yyval.px).hi = net_max_prefix_length[(yyvsp[-1].net).type]; }
#line 7599 "obj/conf/cf-parse.tab.c"
    break;

  case 247: /* fprefix: net_ip_ '-'  */
#line 662 "filter/config.Y"
                { (yyval.px).net = (yyvsp[-1].net); (yyval.px).lo = 0; (yyval.px).hi = (yyvsp[-1].net).pxlen; }
#line 7605 "obj/conf/cf-parse.tab.c"
    break;

  case 248: /* fprefix: net_ip_ '{' NUM ',' NUM '}'  */
#line 663 "filter/config.Y"
                               {
     (yyval.px).net = (yyvsp[-5].net); (yyval.px).lo = (yyvsp[-3].i); (yyval.px).hi = (yyvsp[-1].i);
     if (((yyvsp[-3].i) > (yyvsp[-1].i)) || ((yyvsp[-1].i) > net_max_prefix_length[(yyvsp[-5].net).type]))
       cf_error("Invalid prefix pattern range: {%u, %u}", (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 7615 "obj/conf/cf-parse.tab.c"
    break;

  case 249: /* fprefix_set: fprefix  */
#line 671 "filter/config.Y"
           { (yyval.trie) = f_new_trie(cfg_mem, 0); trie_add_prefix((yyval.trie), &((yyvsp[0].px).net), (yyvsp[0].px).lo, (yyvsp[0].px).hi); }
#line 7621 "obj/conf/cf-parse.tab.c"
    break;

  case 250: /* fprefix_set: fprefix_set ',' fprefix  */
#line 672 "filter/config.Y"
                           { (yyval.trie) = (yyvsp[-2].trie); if (!trie_add_prefix((yyval.trie), &((yyvsp[0].px).net), (yyvsp[0].px).lo, (yyvsp[0].px).hi)) cf_error("Mixed IPv4/IPv6 prefixes in prefix set"); }
#line 7627 "obj/conf/cf-parse.tab.c"
    break;

  case 251: /* switch_body: %empty  */
#line 675 "filter/config.Y"
                         { (yyval.e) = NULL; }
#line 7633 "obj/conf/cf-parse.tab.c"
    break;

  case 252: /* switch_body: switch_body switch_items ':' cmds_scoped  */
#line 676 "filter/config.Y"
                                             {
     /* Fill data fields */
     struct f_tree *t;
     struct f_line *line = f_linearize((yyvsp[0].x), 0);
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = line;
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 7646 "obj/conf/cf-parse.tab.c"
    break;

  case 253: /* switch_body: switch_body ELSECOL cmds_scoped  */
#line 684 "filter/config.Y"
                                   {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = f_linearize((yyvsp[0].x), 0);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 7658 "obj/conf/cf-parse.tab.c"
    break;

  case 254: /* bgp_path_expr: symbol_value  */
#line 694 "filter/config.Y"
                { (yyval.x) = (yyvsp[0].x); }
#line 7664 "obj/conf/cf-parse.tab.c"
    break;

  case 255: /* bgp_path_expr: '(' term ')'  */
#line 695 "filter/config.Y"
                { (yyval.x) = (yyvsp[-1].x); }
#line 7670 "obj/conf/cf-parse.tab.c"
    break;

  case 256: /* bgp_path: PO bgp_path_tail PC  */
#line 699 "filter/config.Y"
                         { (yyval.x) = (yyvsp[-1].x); }
#line 7676 "obj/conf/cf-parse.tab.c"
    break;

  case 257: /* bgp_path_tail: NUM bgp_path_tail  */
#line 703 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .asn = (yyvsp[-1].i), .kind = PM_ASN, }, }); (yyval.x)->next = (yyvsp[0].x);  }
#line 7682 "obj/conf/cf-parse.tab.c"
    break;

  case 258: /* bgp_path_tail: NUM DDOT NUM bgp_path_tail  */
#line 704 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .from = (yyvsp[-3].i), .to = (yyvsp[-1].i), .kind = PM_ASN_RANGE }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7688 "obj/conf/cf-parse.tab.c"
    break;

  case 259: /* bgp_path_tail: '[' ']' bgp_path_tail  */
#line 705 "filter/config.Y"
                         { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .set = NULL, .kind = PM_ASN_SET }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7694 "obj/conf/cf-parse.tab.c"
    break;

  case 260: /* bgp_path_tail: '[' set_items ']' bgp_path_tail  */
#line 706 "filter/config.Y"
                                   {
   if ((yyvsp[-2].e)->from.type != T_INT) cf_error("Only integer sets allowed in path mask");
   (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .set = build_tree((yyvsp[-2].e)), .kind = PM_ASN_SET }, }); (yyval.x)->next = (yyvsp[0].x);
 }
#line 7703 "obj/conf/cf-parse.tab.c"
    break;

  case 261: /* bgp_path_tail: '*' bgp_path_tail  */
#line 710 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .kind = PM_ASTERISK }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7709 "obj/conf/cf-parse.tab.c"
    break;

  case 262: /* bgp_path_tail: '?' bgp_path_tail  */
#line 711 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .kind = PM_QUESTION }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7715 "obj/conf/cf-parse.tab.c"
    break;

  case 263: /* bgp_path_tail: '+' bgp_path_tail  */
#line 712 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PATH_MASK_ITEM, .val.pmi = { .kind = PM_LOOP }, }); (yyval.x)->next = (yyvsp[0].x); }
#line 7721 "obj/conf/cf-parse.tab.c"
    break;

  case 264: /* bgp_path_tail: bgp_path_expr bgp_path_tail  */
#line 713 "filter/config.Y"
                                { (yyval.x) = (yyvsp[-1].x); (yyval.x)->next = (yyvsp[0].x); }
#line 7727 "obj/conf/cf-parse.tab.c"
    break;

  case 265: /* bgp_path_tail: %empty  */
#line 714 "filter/config.Y"
                                { (yyval.x) = NULL; }
#line 7733 "obj/conf/cf-parse.tab.c"
    break;

  case 266: /* constant: NUM  */
#line 718 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_INT, .val.i = (yyvsp[0].i), }); }
#line 7739 "obj/conf/cf-parse.tab.c"
    break;

  case 267: /* constant: TRUE  */
#line 719 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_BOOL, .val.i = 1, }); }
#line 7745 "obj/conf/cf-parse.tab.c"
    break;

  case 268: /* constant: FALSE  */
#line 720 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_BOOL, .val.i = 0, }); }
#line 7751 "obj/conf/cf-parse.tab.c"
    break;

  case 269: /* constant: TEXT  */
#line 721 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_STRING, .val.s = (yyvsp[0].t), }); }
#line 7757 "obj/conf/cf-parse.tab.c"
    break;

  case 270: /* constant: fipa  */
#line 722 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (yyvsp[0].v)); }
#line 7763 "obj/conf/cf-parse.tab.c"
    break;

  case 271: /* constant: VPN_RD  */
#line 723 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_RD, .val.ec = (yyvsp[0].i64), }); }
#line 7769 "obj/conf/cf-parse.tab.c"
    break;

  case 272: /* constant: net_  */
#line 724 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_NET, .val.net = (yyvsp[0].net_ptr), }); }
#line 7775 "obj/conf/cf-parse.tab.c"
    break;

  case 273: /* constant: '[' ']'  */
#line 725 "filter/config.Y"
           { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_SET, .val.t = NULL, }); }
#line 7781 "obj/conf/cf-parse.tab.c"
    break;

  case 274: /* constant: '[' set_items ']'  */
#line 726 "filter/config.Y"
                     {
     DBG( "We've got a set here..." );
     (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_SET, .val.t = build_tree((yyvsp[-1].e)), });
     DBG( "ook\n" );
 }
#line 7791 "obj/conf/cf-parse.tab.c"
    break;

  case 275: /* constant: '[' fprefix_set ']'  */
#line 731 "filter/config.Y"
                       { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = T_PREFIX_SET, .val.ti = (yyvsp[-1].trie), }); }
#line 7797 "obj/conf/cf-parse.tab.c"
    break;

  case 276: /* constant: ENUM  */
#line 732 "filter/config.Y"
          { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { .type = (yyvsp[0].i) >> 16, .val.i = (yyvsp[0].i) & 0xffff, }); }
#line 7803 "obj/conf/cf-parse.tab.c"
    break;

  case 277: /* constructor: '(' term ',' term ')'  */
#line 736 "filter/config.Y"
                         { (yyval.x) = f_new_inst(FI_PAIR_CONSTRUCT, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7809 "obj/conf/cf-parse.tab.c"
    break;

  case 278: /* constructor: '(' ec_kind ',' term ',' term ')'  */
#line 737 "filter/config.Y"
                                     { (yyval.x) = f_new_inst(FI_EC_CONSTRUCT, (yyvsp[-3].x), (yyvsp[-1].x), (yyvsp[-5].ecs)); }
#line 7815 "obj/conf/cf-parse.tab.c"
    break;

  case 279: /* constructor: '(' term ',' term ',' term ')'  */
#line 738 "filter/config.Y"
                                  { (yyval.x) = f_new_inst(FI_LC_CONSTRUCT, (yyvsp[-5].x), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7821 "obj/conf/cf-parse.tab.c"
    break;

  case 280: /* constructor: bgp_path  */
#line 739 "filter/config.Y"
            { (yyval.x) = f_new_inst(FI_PATHMASK_CONSTRUCT, (yyvsp[0].x)); }
#line 7827 "obj/conf/cf-parse.tab.c"
    break;

  case 281: /* var_list: %empty  */
#line 744 "filter/config.Y"
                      { (yyval.x) = NULL; }
#line 7833 "obj/conf/cf-parse.tab.c"
    break;

  case 282: /* var_list: term  */
#line 745 "filter/config.Y"
        { (yyval.x) = (yyvsp[0].x); }
#line 7839 "obj/conf/cf-parse.tab.c"
    break;

  case 283: /* var_list: var_list ',' term  */
#line 746 "filter/config.Y"
                     { (yyval.x) = (yyvsp[0].x); (yyval.x)->next = (yyvsp[-2].x); }
#line 7845 "obj/conf/cf-parse.tab.c"
    break;

  case 284: /* function_call: CF_SYM_KNOWN '(' var_list ')'  */
#line 750 "filter/config.Y"
   {
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");

     /* Revert the var_list */
     struct f_inst *args = NULL;
     while ((yyvsp[-1].x)) {
       struct f_inst *tmp = (yyvsp[-1].x);
       (yyvsp[-1].x) = (yyvsp[-1].x)->next;

       tmp->next = args;
       args = tmp;
     }

     (yyval.x) = f_new_inst(FI_CALL, args, (yyvsp[-3].s));
   }
#line 7866 "obj/conf/cf-parse.tab.c"
    break;

  case 285: /* symbol_value: CF_SYM_KNOWN  */
#line 769 "filter/config.Y"
  {
    switch ((yyvsp[0].s)->class) {
      case SYM_CONSTANT_RANGE:
	(yyval.x) = f_new_inst(FI_CONSTANT, *((yyvsp[0].s)->val));
	break;
      case SYM_VARIABLE_RANGE:
	(yyval.x) = f_new_inst(FI_VAR_GET, (yyvsp[0].s));
	break;
      case SYM_ATTRIBUTE:
	(yyval.x) = f_new_inst(FI_EA_GET, *(yyvsp[0].s)->attribute);
	break;
      default:
	cf_error("Can't get value of symbol %s", (yyvsp[0].s)->name);
    }
  }
#line 7886 "obj/conf/cf-parse.tab.c"
    break;

  case 286: /* static_attr: FROM  */
#line 787 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	0); }
#line 7892 "obj/conf/cf-parse.tab.c"
    break;

  case 287: /* static_attr: GW  */
#line 788 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	0); }
#line 7898 "obj/conf/cf-parse.tab.c"
    break;

  case 288: /* static_attr: NET  */
#line 789 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_NET,	  SA_NET,	1); }
#line 7904 "obj/conf/cf-parse.tab.c"
    break;

  case 289: /* static_attr: PROTO  */
#line 790 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	1); }
#line 7910 "obj/conf/cf-parse.tab.c"
    break;

  case 290: /* static_attr: SOURCE  */
#line 791 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	1); }
#line 7916 "obj/conf/cf-parse.tab.c"
    break;

  case 291: /* static_attr: SCOPE  */
#line 792 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	0); }
#line 7922 "obj/conf/cf-parse.tab.c"
    break;

  case 292: /* static_attr: DEST  */
#line 793 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	0); }
#line 7928 "obj/conf/cf-parse.tab.c"
    break;

  case 293: /* static_attr: IFNAME  */
#line 794 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	0); }
#line 7934 "obj/conf/cf-parse.tab.c"
    break;

  case 294: /* static_attr: IFINDEX  */
#line 795 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	1); }
#line 7940 "obj/conf/cf-parse.tab.c"
    break;

  case 295: /* static_attr: WEIGHT  */
#line 796 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_INT,        SA_WEIGHT,	0); }
#line 7946 "obj/conf/cf-parse.tab.c"
    break;

  case 296: /* static_attr: PREFERENCE  */
#line 797 "filter/config.Y"
              { (yyval.fsa) = f_new_static_attr(T_INT,	  SA_PREF,	0); }
#line 7952 "obj/conf/cf-parse.tab.c"
    break;

  case 297: /* static_attr: GW_MPLS  */
#line 798 "filter/config.Y"
           { (yyval.fsa) = f_new_static_attr(T_INT,        SA_GW_MPLS,	0); }
#line 7958 "obj/conf/cf-parse.tab.c"
    break;

  case 298: /* term: '(' term ')'  */
#line 802 "filter/config.Y"
                        { (yyval.x) = (yyvsp[-1].x); }
#line 7964 "obj/conf/cf-parse.tab.c"
    break;

  case 299: /* term: term '+' term  */
#line 803 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_ADD, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7970 "obj/conf/cf-parse.tab.c"
    break;

  case 300: /* term: term '-' term  */
#line 804 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_SUBTRACT, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7976 "obj/conf/cf-parse.tab.c"
    break;

  case 301: /* term: term '*' term  */
#line 805 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_MULTIPLY, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7982 "obj/conf/cf-parse.tab.c"
    break;

  case 302: /* term: term '/' term  */
#line 806 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_DIVIDE, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7988 "obj/conf/cf-parse.tab.c"
    break;

  case 303: /* term: term AND term  */
#line 807 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_AND, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 7994 "obj/conf/cf-parse.tab.c"
    break;

  case 304: /* term: term OR term  */
#line 808 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_OR, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 8000 "obj/conf/cf-parse.tab.c"
    break;

  case 305: /* term: term '=' term  */
#line 809 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_EQ, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 8006 "obj/conf/cf-parse.tab.c"
    break;

  case 306: /* term: term NEQ term  */
#line 810 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_NEQ, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 8012 "obj/conf/cf-parse.tab.c"
    break;

  case 307: /* term: term '<' term  */
#line 811 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LT, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 8018 "obj/conf/cf-parse.tab.c"
    break;

  case 308: /* term: term LEQ term  */
#line 812 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LTE, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 8024 "obj/conf/cf-parse.tab.c"
    break;

  case 309: /* term: term '>' term  */
#line 813 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LT, (yyvsp[0].x), (yyvsp[-2].x)); }
#line 8030 "obj/conf/cf-parse.tab.c"
    break;

  case 310: /* term: term GEQ term  */
#line 814 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_LTE, (yyvsp[0].x), (yyvsp[-2].x)); }
#line 8036 "obj/conf/cf-parse.tab.c"
    break;

  case 311: /* term: term '~' term  */
#line 815 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_MATCH, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 8042 "obj/conf/cf-parse.tab.c"
    break;

  case 312: /* term: term NMA term  */
#line 816 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_NOT_MATCH, (yyvsp[-2].x), (yyvsp[0].x)); }
#line 8048 "obj/conf/cf-parse.tab.c"
    break;

  case 313: /* term: '!' term  */
#line 817 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_NOT, (yyvsp[0].x)); }
#line 8054 "obj/conf/cf-parse.tab.c"
    break;

  case 314: /* term: DEFINED '(' term ')'  */
#line 818 "filter/config.Y"
                        { (yyval.x) = f_new_inst(FI_DEFINED, (yyvsp[-1].x)); }
#line 8060 "obj/conf/cf-parse.tab.c"
    break;

  case 315: /* term: symbol_value  */
#line 820 "filter/config.Y"
                  { (yyval.x) = (yyvsp[0].x); }
#line 8066 "obj/conf/cf-parse.tab.c"
    break;

  case 316: /* term: constant  */
#line 821 "filter/config.Y"
            { (yyval.x) = (yyvsp[0].x); }
#line 8072 "obj/conf/cf-parse.tab.c"
    break;

  case 317: /* term: constructor  */
#line 822 "filter/config.Y"
               { (yyval.x) = (yyvsp[0].x); }
#line 8078 "obj/conf/cf-parse.tab.c"
    break;

  case 318: /* term: static_attr  */
#line 824 "filter/config.Y"
               { (yyval.x) = f_new_inst(FI_RTA_GET, (yyvsp[0].fsa)); }
#line 8084 "obj/conf/cf-parse.tab.c"
    break;

  case 319: /* term: dynamic_attr  */
#line 826 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_EA_GET, (yyvsp[0].fda)); }
#line 8090 "obj/conf/cf-parse.tab.c"
    break;

  case 320: /* term: term '.' IS_V4  */
#line 828 "filter/config.Y"
                  { (yyval.x) = f_new_inst(FI_IS_V4, (yyvsp[-2].x)); }
#line 8096 "obj/conf/cf-parse.tab.c"
    break;

  case 321: /* term: term '.' TYPE  */
#line 829 "filter/config.Y"
                 { (yyval.x) = f_new_inst(FI_TYPE, (yyvsp[-2].x)); }
#line 8102 "obj/conf/cf-parse.tab.c"
    break;

  case 322: /* term: term '.' IP  */
#line 830 "filter/config.Y"
               { (yyval.x) = f_new_inst(FI_IP, (yyvsp[-2].x)); }
#line 8108 "obj/conf/cf-parse.tab.c"
    break;

  case 323: /* term: term '.' RD  */
#line 831 "filter/config.Y"
               { (yyval.x) = f_new_inst(FI_ROUTE_DISTINGUISHER, (yyvsp[-2].x)); }
#line 8114 "obj/conf/cf-parse.tab.c"
    break;

  case 324: /* term: term '.' LEN  */
#line 832 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_LENGTH, (yyvsp[-2].x)); }
#line 8120 "obj/conf/cf-parse.tab.c"
    break;

  case 325: /* term: term '.' MAXLEN  */
#line 833 "filter/config.Y"
                   { (yyval.x) = f_new_inst(FI_ROA_MAXLEN, (yyvsp[-2].x)); }
#line 8126 "obj/conf/cf-parse.tab.c"
    break;

  case 326: /* term: term '.' ASN  */
#line 834 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_ASN, (yyvsp[-2].x)); }
#line 8132 "obj/conf/cf-parse.tab.c"
    break;

  case 327: /* term: term '.' SRC  */
#line 835 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_NET_SRC, (yyvsp[-2].x)); }
#line 8138 "obj/conf/cf-parse.tab.c"
    break;

  case 328: /* term: term '.' DST  */
#line 836 "filter/config.Y"
                { (yyval.x) = f_new_inst(FI_NET_DST, (yyvsp[-2].x)); }
#line 8144 "obj/conf/cf-parse.tab.c"
    break;

  case 329: /* term: term '.' MASK '(' term ')'  */
#line 837 "filter/config.Y"
                              { (yyval.x) = f_new_inst(FI_IP_MASK, (yyvsp[-5].x), (yyvsp[-1].x)); }
#line 8150 "obj/conf/cf-parse.tab.c"
    break;

  case 330: /* term: term '.' FIRST  */
#line 838 "filter/config.Y"
                  { (yyval.x) = f_new_inst(FI_AS_PATH_FIRST, (yyvsp[-2].x)); }
#line 8156 "obj/conf/cf-parse.tab.c"
    break;

  case 331: /* term: term '.' LAST  */
#line 839 "filter/config.Y"
                  { (yyval.x) = f_new_inst(FI_AS_PATH_LAST, (yyvsp[-2].x)); }
#line 8162 "obj/conf/cf-parse.tab.c"
    break;

  case 332: /* term: term '.' LAST_NONAGGREGATED  */
#line 840 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_AS_PATH_LAST_NAG, (yyvsp[-2].x)); }
#line 8168 "obj/conf/cf-parse.tab.c"
    break;

  case 333: /* term: term '.' DATA  */
#line 841 "filter/config.Y"
                 { (yyval.x) = f_new_inst(FI_PAIR_DATA, (yyvsp[-2].x)); }
#line 8174 "obj/conf/cf-parse.tab.c"
    break;

  case 334: /* term: term '.' DATA1  */
#line 842 "filter/config.Y"
                  { (yyval.x) = f_new_inst(FI_LC_DATA1, (yyvsp[-2].x)); }
#line 8180 "obj/conf/cf-parse.tab.c"
    break;

  case 335: /* term: term '.' DATA2  */
#line 843 "filter/config.Y"
                  { (yyval.x) = f_new_inst(FI_LC_DATA2, (yyvsp[-2].x)); }
#line 8186 "obj/conf/cf-parse.tab.c"
    break;

  case 336: /* term: term '.' MIN  */
#line 844 "filter/config.Y"
                 { (yyval.x) = f_new_inst(FI_MIN, (yyvsp[-2].x)); }
#line 8192 "obj/conf/cf-parse.tab.c"
    break;

  case 337: /* term: term '.' MAX  */
#line 845 "filter/config.Y"
                 { (yyval.x) = f_new_inst(FI_MAX, (yyvsp[-2].x)); }
#line 8198 "obj/conf/cf-parse.tab.c"
    break;

  case 338: /* term: '+' EMPTY '+'  */
#line 855 "filter/config.Y"
                 { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_path); }
#line 8204 "obj/conf/cf-parse.tab.c"
    break;

  case 339: /* term: '-' EMPTY '-'  */
#line 856 "filter/config.Y"
                 { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_clist); }
#line 8210 "obj/conf/cf-parse.tab.c"
    break;

  case 340: /* term: '-' '-' EMPTY '-' '-'  */
#line 857 "filter/config.Y"
                         { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_eclist); }
#line 8216 "obj/conf/cf-parse.tab.c"
    break;

  case 341: /* term: '-' '-' '-' EMPTY '-' '-' '-'  */
#line 858 "filter/config.Y"
                                 { (yyval.x) = f_new_inst(FI_CONSTANT, f_const_empty_lclist); }
#line 8222 "obj/conf/cf-parse.tab.c"
    break;

  case 342: /* term: PREPEND '(' term ',' term ')'  */
#line 859 "filter/config.Y"
                                 { (yyval.x) = f_new_inst(FI_PATH_PREPEND, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 8228 "obj/conf/cf-parse.tab.c"
    break;

  case 343: /* term: ADD '(' term ',' term ')'  */
#line 860 "filter/config.Y"
                             { (yyval.x) = f_new_inst(FI_CLIST_ADD, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 8234 "obj/conf/cf-parse.tab.c"
    break;

  case 344: /* term: DELETE '(' term ',' term ')'  */
#line 861 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CLIST_DEL, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 8240 "obj/conf/cf-parse.tab.c"
    break;

  case 345: /* term: FILTER '(' term ',' term ')'  */
#line 862 "filter/config.Y"
                                { (yyval.x) = f_new_inst(FI_CLIST_FILTER, (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 8246 "obj/conf/cf-parse.tab.c"
    break;

  case 346: /* term: ROA_CHECK '(' rtable ')'  */
#line 864 "filter/config.Y"
                            { (yyval.x) = f_new_inst(FI_ROA_CHECK_IMPLICIT, (yyvsp[-1].r)); }
#line 8252 "obj/conf/cf-parse.tab.c"
    break;

  case 347: /* term: ROA_CHECK '(' rtable ',' term ',' term ')'  */
#line 865 "filter/config.Y"
                                              { (yyval.x) = f_new_inst(FI_ROA_CHECK_EXPLICIT, (yyvsp[-3].x), (yyvsp[-1].x), (yyvsp[-5].r)); }
#line 8258 "obj/conf/cf-parse.tab.c"
    break;

  case 348: /* term: FORMAT '(' term ')'  */
#line 867 "filter/config.Y"
                       {  (yyval.x) = f_new_inst(FI_FORMAT, (yyvsp[-1].x)); }
#line 8264 "obj/conf/cf-parse.tab.c"
    break;

  case 350: /* break_command: ACCEPT  */
#line 875 "filter/config.Y"
          { (yyval.fret) = F_ACCEPT; }
#line 8270 "obj/conf/cf-parse.tab.c"
    break;

  case 351: /* break_command: REJECT  */
#line 876 "filter/config.Y"
          { (yyval.fret) = F_REJECT; }
#line 8276 "obj/conf/cf-parse.tab.c"
    break;

  case 352: /* break_command: ERROR  */
#line 877 "filter/config.Y"
         { (yyval.fret) = F_ERROR; }
#line 8282 "obj/conf/cf-parse.tab.c"
    break;

  case 353: /* print_list: %empty  */
#line 880 "filter/config.Y"
                        { (yyval.x) = NULL; }
#line 8288 "obj/conf/cf-parse.tab.c"
    break;

  case 354: /* print_list: term  */
#line 881 "filter/config.Y"
        { (yyval.x) = (yyvsp[0].x); }
#line 8294 "obj/conf/cf-parse.tab.c"
    break;

  case 355: /* print_list: term ',' print_list  */
#line 882 "filter/config.Y"
                       {
     ASSERT((yyvsp[-2].x));
     ASSERT((yyvsp[-2].x)->next == NULL);
     (yyvsp[-2].x)->next = (yyvsp[0].x);
     (yyval.x) = (yyvsp[-2].x);
   }
#line 8305 "obj/conf/cf-parse.tab.c"
    break;

  case 356: /* var_init: %empty  */
#line 891 "filter/config.Y"
               { (yyval.x) = f_new_inst(FI_CONSTANT, (struct f_val) { }); }
#line 8311 "obj/conf/cf-parse.tab.c"
    break;

  case 357: /* var_init: '=' term  */
#line 892 "filter/config.Y"
            { (yyval.x) = (yyvsp[0].x); }
#line 8317 "obj/conf/cf-parse.tab.c"
    break;

  case 358: /* var: type symbol var_init ';'  */
#line 896 "filter/config.Y"
                            {
     struct symbol *sym = cf_define_symbol((yyvsp[-2].s), SYM_VARIABLE | (yyvsp[-3].i), offset, f_new_var(sym_->scope));
     (yyval.x) = f_new_inst(FI_VAR_INIT, (yyvsp[-1].x), sym);
   }
#line 8326 "obj/conf/cf-parse.tab.c"
    break;

  case 359: /* for_var: type symbol  */
#line 902 "filter/config.Y"
               { (yyval.s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), offset, f_new_var(sym_->scope)); }
#line 8332 "obj/conf/cf-parse.tab.c"
    break;

  case 360: /* for_var: CF_SYM_KNOWN  */
#line 903 "filter/config.Y"
                { (yyval.s) = (yyvsp[0].s); cf_assert_symbol((yyvsp[0].s), SYM_VARIABLE); }
#line 8338 "obj/conf/cf-parse.tab.c"
    break;

  case 361: /* cmd: '{' cmds_scoped '}'  */
#line 907 "filter/config.Y"
                       {
     (yyval.x) = (yyvsp[-1].x);
   }
#line 8346 "obj/conf/cf-parse.tab.c"
    break;

  case 362: /* cmd: IF term THEN cmd  */
#line 910 "filter/config.Y"
                    {
     (yyval.x) = f_new_inst(FI_CONDITION, (yyvsp[-2].x), (yyvsp[0].x), NULL);
   }
#line 8354 "obj/conf/cf-parse.tab.c"
    break;

  case 363: /* cmd: IF term THEN cmd ELSE cmd  */
#line 913 "filter/config.Y"
                             {
     (yyval.x) = f_new_inst(FI_CONDITION, (yyvsp[-4].x), (yyvsp[-2].x), (yyvsp[0].x));
   }
#line 8362 "obj/conf/cf-parse.tab.c"
    break;

  case 364: /* $@6: %empty  */
#line 916 "filter/config.Y"
       {
     /* Reserve space for walk data on stack */
     cf_push_block_scope();
     conf_this_scope->slots += 2;
   }
#line 8372 "obj/conf/cf-parse.tab.c"
    break;

  case 365: /* $@7: %empty  */
#line 922 "filter/config.Y"
   { conf_this_scope->active = 0; }
#line 8378 "obj/conf/cf-parse.tab.c"
    break;

  case 366: /* $@8: %empty  */
#line 922 "filter/config.Y"
                                         { conf_this_scope->active = 1; }
#line 8384 "obj/conf/cf-parse.tab.c"
    break;

  case 367: /* cmd: FOR $@6 for_var IN $@7 term $@8 DO cmd  */
#line 923 "filter/config.Y"
          {
     cf_pop_block_scope();
     (yyval.x) = f_new_inst(FI_FOR_INIT, (yyvsp[-3].x), (yyvsp[-6].s));
     (yyval.x)->next = f_new_inst(FI_FOR_NEXT, (yyvsp[-6].s), (yyvsp[0].x));
   }
#line 8394 "obj/conf/cf-parse.tab.c"
    break;

  case 368: /* cmd: CF_SYM_KNOWN '=' term ';'  */
#line 928 "filter/config.Y"
                             {
     switch ((yyvsp[-3].s)->class) {
       case SYM_VARIABLE_RANGE:
	 (yyval.x) = f_new_inst(FI_VAR_SET, (yyvsp[-1].x), (yyvsp[-3].s));
	 break;
       case SYM_ATTRIBUTE:
	 (yyval.x) = f_new_inst(FI_EA_SET, (yyvsp[-1].x), *(yyvsp[-3].s)->attribute);
	 break;
       default:
	 cf_error("Can't assign to symbol %s", (yyvsp[-3].s)->name);
     }
   }
#line 8411 "obj/conf/cf-parse.tab.c"
    break;

  case 369: /* cmd: RETURN term ';'  */
#line 940 "filter/config.Y"
                   {
     DBG( "Ook, we'll return the value\n" );
     (yyval.x) = f_new_inst(FI_RETURN, (yyvsp[-1].x));
   }
#line 8420 "obj/conf/cf-parse.tab.c"
    break;

  case 370: /* cmd: dynamic_attr '=' term ';'  */
#line 944 "filter/config.Y"
                             {
     (yyval.x) = f_new_inst(FI_EA_SET, (yyvsp[-1].x), (yyvsp[-3].fda));
   }
#line 8428 "obj/conf/cf-parse.tab.c"
    break;

  case 371: /* cmd: static_attr '=' term ';'  */
#line 947 "filter/config.Y"
                            {
     if ((yyvsp[-3].fsa).readonly)
       cf_error( "This static attribute is read-only.");
     (yyval.x) = f_new_inst(FI_RTA_SET, (yyvsp[-1].x), (yyvsp[-3].fsa));
   }
#line 8438 "obj/conf/cf-parse.tab.c"
    break;

  case 372: /* cmd: UNSET '(' dynamic_attr ')' ';'  */
#line 952 "filter/config.Y"
                                  {
     (yyval.x) = f_new_inst(FI_EA_UNSET, (yyvsp[-2].fda));
   }
#line 8446 "obj/conf/cf-parse.tab.c"
    break;

  case 373: /* cmd: break_command print_list ';'  */
#line 955 "filter/config.Y"
                                {
    struct f_inst *breaker = f_new_inst(FI_DIE, (yyvsp[-2].fret));
    if ((yyvsp[-1].x)) {
      struct f_inst *printer = f_new_inst(FI_PRINT, (yyvsp[-1].x));
      struct f_inst *flusher = f_new_inst(FI_FLUSH);
      printer->next = flusher;
      flusher->next = breaker;
      (yyval.x) = printer;
    } else
      (yyval.x) = breaker;
   }
#line 8462 "obj/conf/cf-parse.tab.c"
    break;

  case 374: /* cmd: PRINT print_list ';'  */
#line 966 "filter/config.Y"
                        {
    (yyval.x) = f_new_inst(FI_PRINT, (yyvsp[-1].x));
    (yyval.x)->next = f_new_inst(FI_FLUSH);
   }
#line 8471 "obj/conf/cf-parse.tab.c"
    break;

  case 375: /* cmd: PRINTN print_list ';'  */
#line 970 "filter/config.Y"
                         {
    (yyval.x) = f_new_inst(FI_PRINT, (yyvsp[-1].x));
   }
#line 8479 "obj/conf/cf-parse.tab.c"
    break;

  case 376: /* cmd: function_call ';'  */
#line 973 "filter/config.Y"
                     { (yyval.x) = f_new_inst(FI_DROP_RESULT, (yyvsp[-1].x)); }
#line 8485 "obj/conf/cf-parse.tab.c"
    break;

  case 377: /* cmd: CASE term '{' switch_body '}'  */
#line 974 "filter/config.Y"
                                 {
      (yyval.x) = f_new_inst(FI_SWITCH, (yyvsp[-3].x), build_tree((yyvsp[-1].e)));
   }
#line 8493 "obj/conf/cf-parse.tab.c"
    break;

  case 378: /* cmd: dynamic_attr '.' EMPTY ';'  */
#line 978 "filter/config.Y"
                              { (yyval.x) = f_generate_empty((yyvsp[-3].fda)); }
#line 8499 "obj/conf/cf-parse.tab.c"
    break;

  case 379: /* cmd: dynamic_attr '.' PREPEND '(' term ')' ';'  */
#line 979 "filter/config.Y"
                                               { (yyval.x) = f_generate_complex( FI_PATH_PREPEND, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 8505 "obj/conf/cf-parse.tab.c"
    break;

  case 380: /* cmd: dynamic_attr '.' ADD '(' term ')' ';'  */
#line 980 "filter/config.Y"
                                               { (yyval.x) = f_generate_complex( FI_CLIST_ADD, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 8511 "obj/conf/cf-parse.tab.c"
    break;

  case 381: /* cmd: dynamic_attr '.' DELETE '(' term ')' ';'  */
#line 981 "filter/config.Y"
                                               { (yyval.x) = f_generate_complex( FI_CLIST_DEL, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 8517 "obj/conf/cf-parse.tab.c"
    break;

  case 382: /* cmd: dynamic_attr '.' FILTER '(' term ')' ';'  */
#line 982 "filter/config.Y"
                                               { (yyval.x) = f_generate_complex( FI_CLIST_FILTER, (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 8523 "obj/conf/cf-parse.tab.c"
    break;

  case 383: /* cmd: BT_ASSERT '(' get_cf_position term get_cf_position ')' ';'  */
#line 983 "filter/config.Y"
                                                              { (yyval.x) = assert_done((yyvsp[-3].x), (yyvsp[-4].t) + 1, (yyvsp[-2].t) - 1); }
#line 8529 "obj/conf/cf-parse.tab.c"
    break;

  case 384: /* cmd: BT_CHECK_ASSIGN '(' get_cf_position lvalue get_cf_position ',' term ')' ';'  */
#line 984 "filter/config.Y"
                                                                               { (yyval.x) = assert_assign(&(yyvsp[-5].flv), (yyvsp[-2].x), (yyvsp[-6].t) + 1, (yyvsp[-4].t) - 1); }
#line 8535 "obj/conf/cf-parse.tab.c"
    break;

  case 385: /* get_cf_position: %empty  */
#line 988 "filter/config.Y"
{
  (yyval.t) = cf_text;
}
#line 8543 "obj/conf/cf-parse.tab.c"
    break;

  case 386: /* lvalue: CF_SYM_KNOWN  */
#line 993 "filter/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_VARIABLE); (yyval.flv) = (struct f_lval) { .type = F_LVAL_VARIABLE, .sym = (yyvsp[0].s) }; }
#line 8549 "obj/conf/cf-parse.tab.c"
    break;

  case 387: /* lvalue: static_attr  */
#line 994 "filter/config.Y"
               { (yyval.flv) = (struct f_lval) { .type = F_LVAL_SA, .sa = (yyvsp[0].fsa) }; }
#line 8555 "obj/conf/cf-parse.tab.c"
    break;

  case 388: /* lvalue: dynamic_attr  */
#line 995 "filter/config.Y"
                { (yyval.flv) = (struct f_lval) { .type = F_LVAL_EA, .da = (yyvsp[0].fda) }; }
#line 8561 "obj/conf/cf-parse.tab.c"
    break;

  case 390: /* rtrid: ROUTER ID idval ';'  */
#line 162 "nest/config.Y"
                       { new_config->router_id = (yyvsp[-1].i32); }
#line 8567 "obj/conf/cf-parse.tab.c"
    break;

  case 391: /* rtrid: ROUTER ID FROM iface_patt ';'  */
#line 163 "nest/config.Y"
                                 { new_config->router_id_from = this_ipatt; }
#line 8573 "obj/conf/cf-parse.tab.c"
    break;

  case 392: /* idval: NUM  */
#line 167 "nest/config.Y"
       { (yyval.i32) = (yyvsp[0].i); }
#line 8579 "obj/conf/cf-parse.tab.c"
    break;

  case 393: /* idval: '(' term ')'  */
#line 168 "nest/config.Y"
                { (yyval.i32) = f_eval_int(f_linearize((yyvsp[-1].x), 1)); }
#line 8585 "obj/conf/cf-parse.tab.c"
    break;

  case 394: /* idval: IP4  */
#line 169 "nest/config.Y"
       { (yyval.i32) = ip4_to_u32((yyvsp[0].ip4)); }
#line 8591 "obj/conf/cf-parse.tab.c"
    break;

  case 395: /* idval: CF_SYM_KNOWN  */
#line 170 "nest/config.Y"
                {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP)) && ipa_is_ip4(SYM_VAL((yyvsp[0].s)).ip))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).ip);
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 8604 "obj/conf/cf-parse.tab.c"
    break;

  case 397: /* hostname_override: HOSTNAME text ';'  */
#line 182 "nest/config.Y"
                                     { new_config->hostname = (yyvsp[-1].t); }
#line 8610 "obj/conf/cf-parse.tab.c"
    break;

  case 399: /* gr_opts: GRACEFUL RESTART WAIT expr ';'  */
#line 186 "nest/config.Y"
                                        { new_config->gr_wait = (yyvsp[-1].i); }
#line 8616 "obj/conf/cf-parse.tab.c"
    break;

  case 400: /* net_type: IPV4  */
#line 192 "nest/config.Y"
        { (yyval.i) = NET_IP4; }
#line 8622 "obj/conf/cf-parse.tab.c"
    break;

  case 401: /* net_type: IPV6  */
#line 193 "nest/config.Y"
        { (yyval.i) = NET_IP6; }
#line 8628 "obj/conf/cf-parse.tab.c"
    break;

  case 402: /* net_type: IPV6 SADR  */
#line 194 "nest/config.Y"
             { (yyval.i) = NET_IP6_SADR; }
#line 8634 "obj/conf/cf-parse.tab.c"
    break;

  case 403: /* net_type: VPN4  */
#line 195 "nest/config.Y"
        { (yyval.i) = NET_VPN4; }
#line 8640 "obj/conf/cf-parse.tab.c"
    break;

  case 404: /* net_type: VPN6  */
#line 196 "nest/config.Y"
        { (yyval.i) = NET_VPN6; }
#line 8646 "obj/conf/cf-parse.tab.c"
    break;

  case 405: /* net_type: ROA4  */
#line 197 "nest/config.Y"
        { (yyval.i) = NET_ROA4; }
#line 8652 "obj/conf/cf-parse.tab.c"
    break;

  case 406: /* net_type: ROA6  */
#line 198 "nest/config.Y"
        { (yyval.i) = NET_ROA6; }
#line 8658 "obj/conf/cf-parse.tab.c"
    break;

  case 407: /* net_type: FLOW4  */
#line 199 "nest/config.Y"
        { (yyval.i) = NET_FLOW4; }
#line 8664 "obj/conf/cf-parse.tab.c"
    break;

  case 408: /* net_type: FLOW6  */
#line 200 "nest/config.Y"
        { (yyval.i) = NET_FLOW6; }
#line 8670 "obj/conf/cf-parse.tab.c"
    break;

  case 409: /* net_type: MPLS  */
#line 201 "nest/config.Y"
        { (yyval.i) = NET_MPLS; }
#line 8676 "obj/conf/cf-parse.tab.c"
    break;

  case 412: /* table_start: net_type TABLE symbol  */
#line 213 "nest/config.Y"
                                   {
   this_table = rt_new_table((yyvsp[0].s), (yyvsp[-2].i));
   }
#line 8684 "obj/conf/cf-parse.tab.c"
    break;

  case 414: /* table_sorted: SORTED  */
#line 220 "nest/config.Y"
          { this_table->sorted = 1; }
#line 8690 "obj/conf/cf-parse.tab.c"
    break;

  case 415: /* table_opt: SORTED bool  */
#line 224 "nest/config.Y"
               { this_table->sorted = (yyvsp[0].i); }
#line 8696 "obj/conf/cf-parse.tab.c"
    break;

  case 416: /* table_opt: TRIE bool  */
#line 225 "nest/config.Y"
             {
     if (!net_val_match(this_table->addr_type, NB_IP | NB_VPN | NB_ROA | NB_IP6_SADR))
       cf_error("Trie option not supported for %s table", net_label[this_table->addr_type]);
     this_table->trie_used = (yyvsp[0].i);
   }
#line 8706 "obj/conf/cf-parse.tab.c"
    break;

  case 417: /* table_opt: MIN SETTLE TIME expr_us  */
#line 230 "nest/config.Y"
                           { this_table->min_settle_time = (yyvsp[0].time); }
#line 8712 "obj/conf/cf-parse.tab.c"
    break;

  case 418: /* table_opt: MAX SETTLE TIME expr_us  */
#line 231 "nest/config.Y"
                           { this_table->max_settle_time = (yyvsp[0].time); }
#line 8718 "obj/conf/cf-parse.tab.c"
    break;

  case 419: /* table_opt: GC THRESHOLD expr  */
#line 232 "nest/config.Y"
                     { this_table->gc_threshold = (yyvsp[0].i); }
#line 8724 "obj/conf/cf-parse.tab.c"
    break;

  case 420: /* table_opt: GC PERIOD expr_us  */
#line 233 "nest/config.Y"
                     { this_table->gc_period = (uint) (yyvsp[0].time); if ((yyvsp[0].time) > 3600 S_) cf_error("GC period must be at most 3600 s"); }
#line 8730 "obj/conf/cf-parse.tab.c"
    break;

  case 425: /* conf: proto  */
#line 249 "nest/config.Y"
            { proto_postconfig(); }
#line 8736 "obj/conf/cf-parse.tab.c"
    break;

  case 426: /* proto_start: PROTOCOL  */
#line 252 "nest/config.Y"
            { (yyval.i) = SYM_PROTO; }
#line 8742 "obj/conf/cf-parse.tab.c"
    break;

  case 427: /* proto_start: TEMPLATE  */
#line 253 "nest/config.Y"
            { (yyval.i) = SYM_TEMPLATE; }
#line 8748 "obj/conf/cf-parse.tab.c"
    break;

  case 428: /* proto_name: %empty  */
#line 257 "nest/config.Y"
               {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->proto = this_proto;
     this_proto->name = s->name;
     }
#line 8759 "obj/conf/cf-parse.tab.c"
    break;

  case 429: /* proto_name: symbol  */
#line 263 "nest/config.Y"
          {
     cf_define_symbol((yyvsp[0].s), this_proto->class, proto, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 8768 "obj/conf/cf-parse.tab.c"
    break;

  case 430: /* proto_name: FROM CF_SYM_KNOWN  */
#line 267 "nest/config.Y"
                     {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->proto = this_proto;
     this_proto->name = s->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->proto);
   }
#line 8783 "obj/conf/cf-parse.tab.c"
    break;

  case 431: /* proto_name: symbol FROM CF_SYM_KNOWN  */
#line 277 "nest/config.Y"
                            {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[-2].s), this_proto->class, proto, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->proto);
   }
#line 8796 "obj/conf/cf-parse.tab.c"
    break;

  case 433: /* proto_item: DISABLED bool  */
#line 289 "nest/config.Y"
                 { this_proto->disabled = (yyvsp[0].i); }
#line 8802 "obj/conf/cf-parse.tab.c"
    break;

  case 434: /* proto_item: DEBUG debug_mask  */
#line 290 "nest/config.Y"
                    { this_proto->debug = (yyvsp[0].i); }
#line 8808 "obj/conf/cf-parse.tab.c"
    break;

  case 435: /* proto_item: MRTDUMP mrtdump_mask  */
#line 291 "nest/config.Y"
                        { this_proto->mrtdump = (yyvsp[0].i); }
#line 8814 "obj/conf/cf-parse.tab.c"
    break;

  case 436: /* proto_item: ROUTER ID idval  */
#line 292 "nest/config.Y"
                   { this_proto->router_id = (yyvsp[0].i32); }
#line 8820 "obj/conf/cf-parse.tab.c"
    break;

  case 437: /* proto_item: DESCRIPTION text  */
#line 293 "nest/config.Y"
                    { this_proto->dsc = (yyvsp[0].t); }
#line 8826 "obj/conf/cf-parse.tab.c"
    break;

  case 438: /* proto_item: VRF text  */
#line 294 "nest/config.Y"
            { this_proto->vrf = if_get_by_name((yyvsp[0].t)); this_proto->vrf_set = 1; }
#line 8832 "obj/conf/cf-parse.tab.c"
    break;

  case 439: /* proto_item: VRF DEFAULT  */
#line 295 "nest/config.Y"
               { this_proto->vrf = NULL; this_proto->vrf_set = 1; }
#line 8838 "obj/conf/cf-parse.tab.c"
    break;

  case 440: /* channel_start: net_type  */
#line 300 "nest/config.Y"
{
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[0].i)], (yyvsp[0].i), this_proto);
}
#line 8846 "obj/conf/cf-parse.tab.c"
    break;

  case 441: /* channel_item_: TABLE rtable  */
#line 305 "nest/config.Y"
                {
     if (this_channel->net_type && ((yyvsp[0].r)->addr_type != this_channel->net_type))
       cf_error("Incompatible table type");
     this_channel->table = (yyvsp[0].r);
   }
#line 8856 "obj/conf/cf-parse.tab.c"
    break;

  case 442: /* channel_item_: IMPORT imexport  */
#line 310 "nest/config.Y"
                   { this_channel->in_filter = (yyvsp[0].f); }
#line 8862 "obj/conf/cf-parse.tab.c"
    break;

  case 443: /* channel_item_: EXPORT imexport  */
#line 311 "nest/config.Y"
                   { this_channel->out_filter = (yyvsp[0].f); }
#line 8868 "obj/conf/cf-parse.tab.c"
    break;

  case 444: /* channel_item_: RECEIVE LIMIT limit_spec  */
#line 312 "nest/config.Y"
                            { this_channel->rx_limit = (yyvsp[0].cl); }
#line 8874 "obj/conf/cf-parse.tab.c"
    break;

  case 445: /* channel_item_: IMPORT LIMIT limit_spec  */
#line 313 "nest/config.Y"
                           { this_channel->in_limit = (yyvsp[0].cl); }
#line 8880 "obj/conf/cf-parse.tab.c"
    break;

  case 446: /* channel_item_: EXPORT LIMIT limit_spec  */
#line 314 "nest/config.Y"
                           { this_channel->out_limit = (yyvsp[0].cl); }
#line 8886 "obj/conf/cf-parse.tab.c"
    break;

  case 447: /* channel_item_: PREFERENCE expr  */
#line 315 "nest/config.Y"
                   { this_channel->preference = (yyvsp[0].i); check_u16((yyvsp[0].i)); }
#line 8892 "obj/conf/cf-parse.tab.c"
    break;

  case 448: /* channel_item_: IMPORT KEEP FILTERED bool  */
#line 316 "nest/config.Y"
                             { this_channel->in_keep_filtered = (yyvsp[0].i); }
#line 8898 "obj/conf/cf-parse.tab.c"
    break;

  case 449: /* channel_item_: RPKI RELOAD bool  */
#line 317 "nest/config.Y"
                    { this_channel->rpki_reload = (yyvsp[0].i); }
#line 8904 "obj/conf/cf-parse.tab.c"
    break;

  case 451: /* channel_item: DEBUG debug_mask  */
#line 323 "nest/config.Y"
                    { this_channel->debug = (yyvsp[0].i); }
#line 8910 "obj/conf/cf-parse.tab.c"
    break;

  case 456: /* channel_end: %empty  */
#line 337 "nest/config.Y"
{
  if (!this_channel->table)
    cf_error("Routing table not specified");

  this_channel = NULL;
}
#line 8921 "obj/conf/cf-parse.tab.c"
    break;

  case 458: /* rtable: CF_SYM_KNOWN  */
#line 347 "nest/config.Y"
                     { cf_assert_symbol((yyvsp[0].s), SYM_TABLE); (yyval.r) = (yyvsp[0].s)->table; }
#line 8927 "obj/conf/cf-parse.tab.c"
    break;

  case 459: /* imexport: FILTER filter  */
#line 350 "nest/config.Y"
                 { (yyval.f) = (yyvsp[0].f); }
#line 8933 "obj/conf/cf-parse.tab.c"
    break;

  case 461: /* imexport: ALL  */
#line 352 "nest/config.Y"
       { (yyval.f) = FILTER_ACCEPT; }
#line 8939 "obj/conf/cf-parse.tab.c"
    break;

  case 462: /* imexport: NONE  */
#line 353 "nest/config.Y"
        { (yyval.f) = FILTER_REJECT; }
#line 8945 "obj/conf/cf-parse.tab.c"
    break;

  case 463: /* limit_action: %empty  */
#line 357 "nest/config.Y"
                 { (yyval.i) = PLA_DISABLE; }
#line 8951 "obj/conf/cf-parse.tab.c"
    break;

  case 464: /* limit_action: ACTION WARN  */
#line 358 "nest/config.Y"
               { (yyval.i) = PLA_WARN; }
#line 8957 "obj/conf/cf-parse.tab.c"
    break;

  case 465: /* limit_action: ACTION BLOCK  */
#line 359 "nest/config.Y"
                { (yyval.i) = PLA_BLOCK; }
#line 8963 "obj/conf/cf-parse.tab.c"
    break;

  case 466: /* limit_action: ACTION RESTART  */
#line 360 "nest/config.Y"
                  { (yyval.i) = PLA_RESTART; }
#line 8969 "obj/conf/cf-parse.tab.c"
    break;

  case 467: /* limit_action: ACTION DISABLE  */
#line 361 "nest/config.Y"
                  { (yyval.i) = PLA_DISABLE; }
#line 8975 "obj/conf/cf-parse.tab.c"
    break;

  case 468: /* limit_spec: expr limit_action  */
#line 365 "nest/config.Y"
                     { (yyval.cl) = (struct channel_limit){ .limit = (yyvsp[-1].i), (yyval.cl).action = (yyvsp[0].i) }; }
#line 8981 "obj/conf/cf-parse.tab.c"
    break;

  case 469: /* limit_spec: OFF  */
#line 366 "nest/config.Y"
       { (yyval.cl) = (struct channel_limit){}; }
#line 8987 "obj/conf/cf-parse.tab.c"
    break;

  case 471: /* debug_default: DEBUG PROTOCOLS debug_mask  */
#line 373 "nest/config.Y"
                              { new_config->proto_default_debug = (yyvsp[0].i); }
#line 8993 "obj/conf/cf-parse.tab.c"
    break;

  case 472: /* debug_default: DEBUG CHANNELS debug_mask  */
#line 374 "nest/config.Y"
                             { new_config->channel_default_debug = (yyvsp[0].i); }
#line 8999 "obj/conf/cf-parse.tab.c"
    break;

  case 473: /* debug_default: DEBUG COMMANDS expr  */
#line 375 "nest/config.Y"
                       { new_config->cli_debug = (yyvsp[0].i); }
#line 9005 "obj/conf/cf-parse.tab.c"
    break;

  case 475: /* timeformat_which: ROUTE  */
#line 383 "nest/config.Y"
         { (yyval.tf) = &new_config->tf_route; }
#line 9011 "obj/conf/cf-parse.tab.c"
    break;

  case 476: /* timeformat_which: PROTOCOL  */
#line 384 "nest/config.Y"
            { (yyval.tf) = &new_config->tf_proto; }
#line 9017 "obj/conf/cf-parse.tab.c"
    break;

  case 477: /* timeformat_which: BASE  */
#line 385 "nest/config.Y"
        { (yyval.tf) = &new_config->tf_base; }
#line 9023 "obj/conf/cf-parse.tab.c"
    break;

  case 478: /* timeformat_which: LOG  */
#line 386 "nest/config.Y"
       { (yyval.tf) = &new_config->tf_log; }
#line 9029 "obj/conf/cf-parse.tab.c"
    break;

  case 479: /* timeformat_spec: timeformat_which TEXT  */
#line 390 "nest/config.Y"
                         { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 9035 "obj/conf/cf-parse.tab.c"
    break;

  case 480: /* timeformat_spec: timeformat_which TEXT expr TEXT  */
#line 391 "nest/config.Y"
                                   { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (s64) (yyvsp[-1].i) S_}; }
#line 9041 "obj/conf/cf-parse.tab.c"
    break;

  case 481: /* timeformat_spec: timeformat_which ISO SHORT  */
#line 392 "nest/config.Y"
                                 { *(yyvsp[-2].tf) = TM_ISO_SHORT_S; }
#line 9047 "obj/conf/cf-parse.tab.c"
    break;

  case 482: /* timeformat_spec: timeformat_which ISO SHORT MS  */
#line 393 "nest/config.Y"
                                 { *(yyvsp[-3].tf) = TM_ISO_SHORT_MS; }
#line 9053 "obj/conf/cf-parse.tab.c"
    break;

  case 483: /* timeformat_spec: timeformat_which ISO SHORT US  */
#line 394 "nest/config.Y"
                                 { *(yyvsp[-3].tf) = TM_ISO_SHORT_US; }
#line 9059 "obj/conf/cf-parse.tab.c"
    break;

  case 484: /* timeformat_spec: timeformat_which ISO LONG  */
#line 395 "nest/config.Y"
                                { *(yyvsp[-2].tf) = TM_ISO_LONG_S; }
#line 9065 "obj/conf/cf-parse.tab.c"
    break;

  case 485: /* timeformat_spec: timeformat_which ISO LONG MS  */
#line 396 "nest/config.Y"
                                { *(yyvsp[-3].tf) = TM_ISO_LONG_MS; }
#line 9071 "obj/conf/cf-parse.tab.c"
    break;

  case 486: /* timeformat_spec: timeformat_which ISO LONG US  */
#line 397 "nest/config.Y"
                                { *(yyvsp[-3].tf) = TM_ISO_LONG_US; }
#line 9077 "obj/conf/cf-parse.tab.c"
    break;

  case 488: /* iface_patt_node_init: %empty  */
#line 408 "nest/config.Y"
               {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 9087 "obj/conf/cf-parse.tab.c"
    break;

  case 489: /* iface_patt_node_body: TEXT  */
#line 416 "nest/config.Y"
        { this_ipn->pattern = (yyvsp[0].t); /* this_ipn->prefix stays zero */ }
#line 9093 "obj/conf/cf-parse.tab.c"
    break;

  case 490: /* iface_patt_node_body: opttext net_or_ipa  */
#line 417 "nest/config.Y"
                      { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].net); }
#line 9099 "obj/conf/cf-parse.tab.c"
    break;

  case 491: /* iface_negate: %empty  */
#line 421 "nest/config.Y"
       { this_ipn->positive = 1; }
#line 9105 "obj/conf/cf-parse.tab.c"
    break;

  case 492: /* iface_negate: '-'  */
#line 422 "nest/config.Y"
       { this_ipn->positive = 0; }
#line 9111 "obj/conf/cf-parse.tab.c"
    break;

  case 496: /* iface_patt_list_nopx: iface_patt_list  */
#line 436 "nest/config.Y"
                                      { iface_patt_check(); }
#line 9117 "obj/conf/cf-parse.tab.c"
    break;

  case 497: /* iface_patt_init: %empty  */
#line 438 "nest/config.Y"
                 {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 9127 "obj/conf/cf-parse.tab.c"
    break;

  case 499: /* tos: CLASS expr  */
#line 450 "nest/config.Y"
              { (yyval.i) = (yyvsp[0].i) & 0xfc;        if ((yyvsp[0].i) > 255) cf_error("TX class must be in range 0-255"); }
#line 9133 "obj/conf/cf-parse.tab.c"
    break;

  case 500: /* tos: DSCP expr  */
#line 451 "nest/config.Y"
              { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if ((yyvsp[0].i) > 63)  cf_error("TX DSCP must be in range 0-63"); }
#line 9139 "obj/conf/cf-parse.tab.c"
    break;

  case 502: /* dev_proto_start: proto_start DIRECT  */
#line 458 "nest/config.Y"
                                    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 9148 "obj/conf/cf-parse.tab.c"
    break;

  case 507: /* dev_proto: dev_proto CHECK LINK bool ';'  */
#line 469 "nest/config.Y"
                                 { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 9154 "obj/conf/cf-parse.tab.c"
    break;

  case 508: /* dev_iface_init: %empty  */
#line 473 "nest/config.Y"
               {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 9164 "obj/conf/cf-parse.tab.c"
    break;

  case 510: /* debug_mask: ALL  */
#line 487 "nest/config.Y"
       { (yyval.i) = ~0; }
#line 9170 "obj/conf/cf-parse.tab.c"
    break;

  case 511: /* debug_mask: OFF  */
#line 488 "nest/config.Y"
       { (yyval.i) = 0; }
#line 9176 "obj/conf/cf-parse.tab.c"
    break;

  case 512: /* debug_mask: '{' debug_list '}'  */
#line 489 "nest/config.Y"
                      { (yyval.i) = (yyvsp[-1].i); }
#line 9182 "obj/conf/cf-parse.tab.c"
    break;

  case 514: /* debug_list: debug_list ',' debug_flag  */
#line 494 "nest/config.Y"
                             { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 9188 "obj/conf/cf-parse.tab.c"
    break;

  case 515: /* debug_flag: STATES  */
#line 498 "nest/config.Y"
                { (yyval.i) = D_STATES; }
#line 9194 "obj/conf/cf-parse.tab.c"
    break;

  case 516: /* debug_flag: ROUTES  */
#line 499 "nest/config.Y"
                { (yyval.i) = D_ROUTES; }
#line 9200 "obj/conf/cf-parse.tab.c"
    break;

  case 517: /* debug_flag: FILTERS  */
#line 500 "nest/config.Y"
                { (yyval.i) = D_FILTERS; }
#line 9206 "obj/conf/cf-parse.tab.c"
    break;

  case 518: /* debug_flag: INTERFACES  */
#line 501 "nest/config.Y"
                { (yyval.i) = D_IFACES; }
#line 9212 "obj/conf/cf-parse.tab.c"
    break;

  case 519: /* debug_flag: EVENTS  */
#line 502 "nest/config.Y"
                { (yyval.i) = D_EVENTS; }
#line 9218 "obj/conf/cf-parse.tab.c"
    break;

  case 520: /* debug_flag: PACKETS  */
#line 503 "nest/config.Y"
                { (yyval.i) = D_PACKETS; }
#line 9224 "obj/conf/cf-parse.tab.c"
    break;

  case 521: /* mrtdump_mask: ALL  */
#line 509 "nest/config.Y"
       { (yyval.i) = ~0; }
#line 9230 "obj/conf/cf-parse.tab.c"
    break;

  case 522: /* mrtdump_mask: OFF  */
#line 510 "nest/config.Y"
       { (yyval.i) = 0; }
#line 9236 "obj/conf/cf-parse.tab.c"
    break;

  case 523: /* mrtdump_mask: '{' mrtdump_list '}'  */
#line 511 "nest/config.Y"
                        { (yyval.i) = (yyvsp[-1].i); }
#line 9242 "obj/conf/cf-parse.tab.c"
    break;

  case 525: /* mrtdump_list: mrtdump_list ',' mrtdump_flag  */
#line 516 "nest/config.Y"
                                 { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 9248 "obj/conf/cf-parse.tab.c"
    break;

  case 526: /* mrtdump_flag: STATES  */
#line 520 "nest/config.Y"
                { (yyval.i) = MD_STATES; }
#line 9254 "obj/conf/cf-parse.tab.c"
    break;

  case 527: /* mrtdump_flag: MESSAGES  */
#line 521 "nest/config.Y"
                { (yyval.i) = MD_MESSAGES; }
#line 9260 "obj/conf/cf-parse.tab.c"
    break;

  case 537: /* password_item_begin: pass_key text  */
#line 548 "nest/config.Y"
                  { init_password_list(); init_password((yyvsp[0].t), strlen((yyvsp[0].t)), password_id++); }
#line 9266 "obj/conf/cf-parse.tab.c"
    break;

  case 538: /* password_item_begin: pass_key BYTESTRING  */
#line 549 "nest/config.Y"
                        { init_password_list(); init_password((yyvsp[0].bs)->data, (yyvsp[0].bs)->length, password_id++); }
#line 9272 "obj/conf/cf-parse.tab.c"
    break;

  case 539: /* password_item_params: %empty  */
#line 553 "nest/config.Y"
               { }
#line 9278 "obj/conf/cf-parse.tab.c"
    break;

  case 540: /* password_item_params: GENERATE FROM time ';' password_item_params  */
#line 554 "nest/config.Y"
                                               { this_p_item->genfrom = (yyvsp[-2].time); }
#line 9284 "obj/conf/cf-parse.tab.c"
    break;

  case 541: /* password_item_params: GENERATE TO time ';' password_item_params  */
#line 555 "nest/config.Y"
                                             { this_p_item->gento = (yyvsp[-2].time); }
#line 9290 "obj/conf/cf-parse.tab.c"
    break;

  case 542: /* password_item_params: ACCEPT FROM time ';' password_item_params  */
#line 556 "nest/config.Y"
                                             { this_p_item->accfrom = (yyvsp[-2].time); }
#line 9296 "obj/conf/cf-parse.tab.c"
    break;

  case 543: /* password_item_params: ACCEPT TO time ';' password_item_params  */
#line 557 "nest/config.Y"
                                           { this_p_item->accto = (yyvsp[-2].time); }
#line 9302 "obj/conf/cf-parse.tab.c"
    break;

  case 544: /* password_item_params: FROM time ';' password_item_params  */
#line 558 "nest/config.Y"
                                      { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[-2].time); }
#line 9308 "obj/conf/cf-parse.tab.c"
    break;

  case 545: /* password_item_params: TO time ';' password_item_params  */
#line 559 "nest/config.Y"
                                    { this_p_item->gento = this_p_item->accto = (yyvsp[-2].time); }
#line 9314 "obj/conf/cf-parse.tab.c"
    break;

  case 546: /* password_item_params: ID expr ';' password_item_params  */
#line 560 "nest/config.Y"
                                    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) > 255) cf_error("Password ID must be in range 0-255"); }
#line 9320 "obj/conf/cf-parse.tab.c"
    break;

  case 547: /* password_item_params: ALGORITHM password_algorithm ';' password_item_params  */
#line 561 "nest/config.Y"
                                                         { this_p_item->alg = (yyvsp[-2].i); }
#line 9326 "obj/conf/cf-parse.tab.c"
    break;

  case 548: /* password_algorithm: KEYED MD5  */
#line 565 "nest/config.Y"
                { (yyval.i) = ALG_MD5; }
#line 9332 "obj/conf/cf-parse.tab.c"
    break;

  case 549: /* password_algorithm: KEYED SHA1  */
#line 566 "nest/config.Y"
                { (yyval.i) = ALG_SHA1; }
#line 9338 "obj/conf/cf-parse.tab.c"
    break;

  case 550: /* password_algorithm: KEYED SHA256  */
#line 567 "nest/config.Y"
                { (yyval.i) = ALG_SHA256; }
#line 9344 "obj/conf/cf-parse.tab.c"
    break;

  case 551: /* password_algorithm: KEYED SHA384  */
#line 568 "nest/config.Y"
                { (yyval.i) = ALG_SHA384; }
#line 9350 "obj/conf/cf-parse.tab.c"
    break;

  case 552: /* password_algorithm: KEYED SHA512  */
#line 569 "nest/config.Y"
                { (yyval.i) = ALG_SHA512; }
#line 9356 "obj/conf/cf-parse.tab.c"
    break;

  case 553: /* password_algorithm: HMAC MD5  */
#line 570 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_MD5; }
#line 9362 "obj/conf/cf-parse.tab.c"
    break;

  case 554: /* password_algorithm: HMAC SHA1  */
#line 571 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA1; }
#line 9368 "obj/conf/cf-parse.tab.c"
    break;

  case 555: /* password_algorithm: HMAC SHA256  */
#line 572 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA256; }
#line 9374 "obj/conf/cf-parse.tab.c"
    break;

  case 556: /* password_algorithm: HMAC SHA384  */
#line 573 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA384; }
#line 9380 "obj/conf/cf-parse.tab.c"
    break;

  case 557: /* password_algorithm: HMAC SHA512  */
#line 574 "nest/config.Y"
                { (yyval.i) = ALG_HMAC_SHA512; }
#line 9386 "obj/conf/cf-parse.tab.c"
    break;

  case 558: /* password_algorithm: BLAKE2S128  */
#line 575 "nest/config.Y"
                { (yyval.i) = ALG_BLAKE2S_128; }
#line 9392 "obj/conf/cf-parse.tab.c"
    break;

  case 559: /* password_algorithm: BLAKE2S256  */
#line 576 "nest/config.Y"
                { (yyval.i) = ALG_BLAKE2S_256; }
#line 9398 "obj/conf/cf-parse.tab.c"
    break;

  case 560: /* password_algorithm: BLAKE2B256  */
#line 577 "nest/config.Y"
                { (yyval.i) = ALG_BLAKE2B_256; }
#line 9404 "obj/conf/cf-parse.tab.c"
    break;

  case 561: /* password_algorithm: BLAKE2B512  */
#line 578 "nest/config.Y"
                { (yyval.i) = ALG_BLAKE2B_512; }
#line 9410 "obj/conf/cf-parse.tab.c"
    break;

  case 562: /* password_item_end: %empty  */
#line 582 "nest/config.Y"
{
  password_validate_length(this_p_item);
}
#line 9418 "obj/conf/cf-parse.tab.c"
    break;

  case 563: /* bfd_item: INTERVAL expr_us  */
#line 590 "nest/config.Y"
                    { this_bfd_opts->min_rx_int = this_bfd_opts->min_tx_int = (yyvsp[0].time); }
#line 9424 "obj/conf/cf-parse.tab.c"
    break;

  case 564: /* bfd_item: MIN RX INTERVAL expr_us  */
#line 591 "nest/config.Y"
                           { this_bfd_opts->min_rx_int = (yyvsp[0].time); }
#line 9430 "obj/conf/cf-parse.tab.c"
    break;

  case 565: /* bfd_item: MIN TX INTERVAL expr_us  */
#line 592 "nest/config.Y"
                           { this_bfd_opts->min_tx_int = (yyvsp[0].time); }
#line 9436 "obj/conf/cf-parse.tab.c"
    break;

  case 566: /* bfd_item: IDLE TX INTERVAL expr_us  */
#line 593 "nest/config.Y"
                            { this_bfd_opts->idle_tx_int = (yyvsp[0].time); }
#line 9442 "obj/conf/cf-parse.tab.c"
    break;

  case 567: /* bfd_item: MULTIPLIER expr  */
#line 594 "nest/config.Y"
                   { this_bfd_opts->multiplier = (yyvsp[0].i); }
#line 9448 "obj/conf/cf-parse.tab.c"
    break;

  case 568: /* bfd_item: PASSIVE bool  */
#line 595 "nest/config.Y"
                { this_bfd_opts->passive = (yyvsp[0].i); this_bfd_opts->passive_set = 1; }
#line 9454 "obj/conf/cf-parse.tab.c"
    break;

  case 569: /* bfd_item: GRACEFUL  */
#line 596 "nest/config.Y"
            { this_bfd_opts->mode = BGP_BFD_GRACEFUL; }
#line 9460 "obj/conf/cf-parse.tab.c"
    break;

  case 574: /* cmd_SHOW_STATUS: SHOW STATUS END  */
#line 612 "nest/config.Y"
{ cmd_show_status(); }
#line 9466 "obj/conf/cf-parse.tab.c"
    break;

  case 576: /* cmd_SHOW_MEMORY: SHOW MEMORY END  */
#line 615 "nest/config.Y"
{ cmd_show_memory(); }
#line 9472 "obj/conf/cf-parse.tab.c"
    break;

  case 578: /* cmd_SHOW_PROTOCOLS: SHOW PROTOCOLS proto_patt2 END  */
#line 618 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 9478 "obj/conf/cf-parse.tab.c"
    break;

  case 580: /* cmd_SHOW_PROTOCOLS_ALL: SHOW PROTOCOLS ALL proto_patt2 END  */
#line 621 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 9484 "obj/conf/cf-parse.tab.c"
    break;

  case 581: /* optproto: CF_SYM_KNOWN  */
#line 624 "nest/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.s) = (yyvsp[0].s); }
#line 9490 "obj/conf/cf-parse.tab.c"
    break;

  case 582: /* optproto: %empty  */
#line 625 "nest/config.Y"
               { (yyval.s) = NULL; }
#line 9496 "obj/conf/cf-parse.tab.c"
    break;

  case 584: /* cmd_SHOW_INTERFACES: SHOW INTERFACES END  */
#line 629 "nest/config.Y"
{ if_show(); }
#line 9502 "obj/conf/cf-parse.tab.c"
    break;

  case 586: /* cmd_SHOW_INTERFACES_SUMMARY: SHOW INTERFACES SUMMARY END  */
#line 632 "nest/config.Y"
{ if_show_summary(); }
#line 9508 "obj/conf/cf-parse.tab.c"
    break;

  case 588: /* cmd_SHOW_ROUTE: SHOW ROUTE r_args END  */
#line 636 "nest/config.Y"
{ rt_show((yyvsp[-1].ra)); }
#line 9514 "obj/conf/cf-parse.tab.c"
    break;

  case 589: /* r_args: %empty  */
#line 639 "nest/config.Y"
               {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     init_list(&((yyval.ra)->tables));
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->running_on_config = new_config->fallback;
   }
#line 9525 "obj/conf/cf-parse.tab.c"
    break;

  case 590: /* r_args: r_args net_any  */
#line 645 "nest/config.Y"
                  {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
     (yyval.ra)->addr_mode = RSD_ADDR_EQUAL;
   }
#line 9536 "obj/conf/cf-parse.tab.c"
    break;

  case 591: /* r_args: r_args FOR r_args_for  */
#line 651 "nest/config.Y"
                         {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
     (yyval.ra)->addr_mode = RSD_ADDR_FOR;
   }
#line 9547 "obj/conf/cf-parse.tab.c"
    break;

  case 592: /* r_args: r_args IN net_any  */
#line 657 "nest/config.Y"
                     {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->addr) cf_error("Only one prefix expected");
     if (!net_type_match((yyvsp[0].net_ptr), NB_IP)) cf_error("Only IP networks accepted for 'in' argument");
     (yyval.ra)->addr = (yyvsp[0].net_ptr);
     (yyval.ra)->addr_mode = RSD_ADDR_IN;
   }
#line 9559 "obj/conf/cf-parse.tab.c"
    break;

  case 593: /* r_args: r_args TABLE CF_SYM_KNOWN  */
#line 664 "nest/config.Y"
                            {
     cf_assert_symbol((yyvsp[0].s), SYM_TABLE);
     (yyval.ra) = (yyvsp[-2].ra);
     rt_show_add_table((yyval.ra), (yyvsp[0].s)->table->table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 9570 "obj/conf/cf-parse.tab.c"
    break;

  case 594: /* r_args: r_args TABLE ALL  */
#line 670 "nest/config.Y"
                    {
     struct rtable_config *t;
     (yyval.ra) = (yyvsp[-2].ra);
     WALK_LIST(t, config->tables)
       rt_show_add_table((yyval.ra), t->table);
     (yyval.ra)->tables_defined_by = RSD_TDB_ALL;
   }
#line 9582 "obj/conf/cf-parse.tab.c"
    break;

  case 595: /* r_args: r_args IMPORT TABLE channel_arg  */
#line 677 "nest/config.Y"
                                   {
     if (!(yyvsp[0].c)->in_table) cf_error("No import table in channel %s.%s", (yyvsp[0].c)->proto->name, (yyvsp[0].c)->name);
     rt_show_add_table((yyval.ra), (yyvsp[0].c)->in_table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 9592 "obj/conf/cf-parse.tab.c"
    break;

  case 596: /* r_args: r_args EXPORT TABLE channel_arg  */
#line 682 "nest/config.Y"
                                   {
     if (!(yyvsp[0].c)->out_table) cf_error("No export table in channel %s.%s", (yyvsp[0].c)->proto->name, (yyvsp[0].c)->name);
     rt_show_add_table((yyval.ra), (yyvsp[0].c)->out_table);
     (yyval.ra)->tables_defined_by = RSD_TDB_DIRECT;
   }
#line 9602 "obj/conf/cf-parse.tab.c"
    break;

  case 597: /* r_args: r_args FILTER filter  */
#line 687 "nest/config.Y"
                        {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 9612 "obj/conf/cf-parse.tab.c"
    break;

  case 598: /* r_args: r_args where_filter  */
#line 692 "nest/config.Y"
                       {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 9622 "obj/conf/cf-parse.tab.c"
    break;

  case 599: /* r_args: r_args ALL  */
#line 697 "nest/config.Y"
              {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 9631 "obj/conf/cf-parse.tab.c"
    break;

  case 600: /* r_args: r_args PRIMARY  */
#line 701 "nest/config.Y"
                  {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 9640 "obj/conf/cf-parse.tab.c"
    break;

  case 601: /* r_args: r_args FILTERED  */
#line 705 "nest/config.Y"
                   {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 9649 "obj/conf/cf-parse.tab.c"
    break;

  case 602: /* r_args: r_args export_mode CF_SYM_KNOWN  */
#line 709 "nest/config.Y"
                                   {
     cf_assert_symbol((yyvsp[0].s), SYM_PROTO);
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->proto;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Export specified twice");
     if (!c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 9664 "obj/conf/cf-parse.tab.c"
    break;

  case 603: /* r_args: r_args export_mode channel_arg  */
#line 719 "nest/config.Y"
                                  {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Export specified twice");
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_channel = (yyvsp[0].c);
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 9676 "obj/conf/cf-parse.tab.c"
    break;

  case 604: /* r_args: r_args PROTOCOL CF_SYM_KNOWN  */
#line 726 "nest/config.Y"
                                {
     cf_assert_symbol((yyvsp[0].s), SYM_PROTO);
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->proto;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if (!c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->tables_defined_by = RSD_TDB_INDIRECT;
   }
#line 9690 "obj/conf/cf-parse.tab.c"
    break;

  case 605: /* r_args: r_args STATS  */
#line 735 "nest/config.Y"
                {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 9699 "obj/conf/cf-parse.tab.c"
    break;

  case 606: /* r_args: r_args COUNT  */
#line 739 "nest/config.Y"
                {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 9708 "obj/conf/cf-parse.tab.c"
    break;

  case 607: /* r_args_for: r_args_for_val  */
#line 746 "nest/config.Y"
                 {
    (yyval.net_ptr) = cfg_alloc((yyvsp[0].net).length);
    net_copy((yyval.net_ptr), &(yyvsp[0].net));
  }
#line 9717 "obj/conf/cf-parse.tab.c"
    break;

  case 611: /* r_args_for: VPN_RD IP4  */
#line 753 "nest/config.Y"
              {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn4));
    net_fill_vpn4((yyval.net_ptr), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH, (yyvsp[-1].i64));
  }
#line 9726 "obj/conf/cf-parse.tab.c"
    break;

  case 612: /* r_args_for: VPN_RD IP6  */
#line 757 "nest/config.Y"
              {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_vpn6));
    net_fill_vpn6((yyval.net_ptr), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH, (yyvsp[-1].i64));
  }
#line 9735 "obj/conf/cf-parse.tab.c"
    break;

  case 613: /* r_args_for: IP6 FROM IP6  */
#line 761 "nest/config.Y"
                {
    (yyval.net_ptr) = cfg_alloc(sizeof(net_addr_ip6_sadr));
    net_fill_ip6_sadr((yyval.net_ptr), (yyvsp[-2].ip6), IP6_MAX_PREFIX_LENGTH, (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH);
  }
#line 9744 "obj/conf/cf-parse.tab.c"
    break;

  case 614: /* r_args_for: CF_SYM_KNOWN  */
#line 765 "nest/config.Y"
                {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
     {
       (yyval.net_ptr) = cfg_alloc(ipa_is_ip4(SYM_VAL((yyvsp[0].s)).ip) ? sizeof(net_addr_ip4) : sizeof(net_addr_ip6));
       net_fill_ip_host((yyval.net_ptr), SYM_VAL((yyvsp[0].s)).ip);
     }
     else if (((yyvsp[0].s)->class == (SYM_CONSTANT | T_NET)) && net_type_match(SYM_VAL((yyvsp[0].s)).net, NB_IP | NB_VPN))
       (yyval.net_ptr) = (net_addr *) SYM_VAL((yyvsp[0].s)).net; /* Avoid const warning */
     else
       cf_error("IP address or network constant expected");
   }
#line 9760 "obj/conf/cf-parse.tab.c"
    break;

  case 617: /* r_args_for_val: IP4  */
#line 781 "nest/config.Y"
       { net_fill_ip4(&((yyval.net)), (yyvsp[0].ip4), IP4_MAX_PREFIX_LENGTH); }
#line 9766 "obj/conf/cf-parse.tab.c"
    break;

  case 618: /* r_args_for_val: IP6  */
#line 782 "nest/config.Y"
       { net_fill_ip6(&((yyval.net)), (yyvsp[0].ip6), IP6_MAX_PREFIX_LENGTH); }
#line 9772 "obj/conf/cf-parse.tab.c"
    break;

  case 619: /* export_mode: PREEXPORT  */
#line 785 "nest/config.Y"
                { (yyval.i) = RSEM_PREEXPORT; }
#line 9778 "obj/conf/cf-parse.tab.c"
    break;

  case 620: /* export_mode: EXPORT  */
#line 786 "nest/config.Y"
                { (yyval.i) = RSEM_EXPORT; }
#line 9784 "obj/conf/cf-parse.tab.c"
    break;

  case 621: /* export_mode: NOEXPORT  */
#line 787 "nest/config.Y"
                { (yyval.i) = RSEM_NOEXPORT; }
#line 9790 "obj/conf/cf-parse.tab.c"
    break;

  case 622: /* export_mode: EXPORTED  */
#line 788 "nest/config.Y"
                { (yyval.i) = RSEM_EXPORTED; }
#line 9796 "obj/conf/cf-parse.tab.c"
    break;

  case 623: /* channel_sym: IPV4  */
#line 793 "nest/config.Y"
                { (yyval.t) = "ipv4"; }
#line 9802 "obj/conf/cf-parse.tab.c"
    break;

  case 624: /* channel_sym: IPV4_MC  */
#line 794 "nest/config.Y"
                { (yyval.t) = "ipv4-mc"; }
#line 9808 "obj/conf/cf-parse.tab.c"
    break;

  case 625: /* channel_sym: IPV4_MPLS  */
#line 795 "nest/config.Y"
                { (yyval.t) = "ipv4-mpls"; }
#line 9814 "obj/conf/cf-parse.tab.c"
    break;

  case 626: /* channel_sym: IPV6  */
#line 796 "nest/config.Y"
                { (yyval.t) = "ipv6"; }
#line 9820 "obj/conf/cf-parse.tab.c"
    break;

  case 627: /* channel_sym: IPV6_MC  */
#line 797 "nest/config.Y"
                { (yyval.t) = "ipv6-mc"; }
#line 9826 "obj/conf/cf-parse.tab.c"
    break;

  case 628: /* channel_sym: IPV6_MPLS  */
#line 798 "nest/config.Y"
                { (yyval.t) = "ipv6-mpls"; }
#line 9832 "obj/conf/cf-parse.tab.c"
    break;

  case 629: /* channel_sym: IPV6_SADR  */
#line 799 "nest/config.Y"
                { (yyval.t) = "ipv6-sadr"; }
#line 9838 "obj/conf/cf-parse.tab.c"
    break;

  case 630: /* channel_sym: VPN4  */
#line 800 "nest/config.Y"
                { (yyval.t) = "vpn4"; }
#line 9844 "obj/conf/cf-parse.tab.c"
    break;

  case 631: /* channel_sym: VPN4_MC  */
#line 801 "nest/config.Y"
                { (yyval.t) = "vpn4-mc"; }
#line 9850 "obj/conf/cf-parse.tab.c"
    break;

  case 632: /* channel_sym: VPN4_MPLS  */
#line 802 "nest/config.Y"
                { (yyval.t) = "vpn4-mpls"; }
#line 9856 "obj/conf/cf-parse.tab.c"
    break;

  case 633: /* channel_sym: VPN6  */
#line 803 "nest/config.Y"
                { (yyval.t) = "vpn6"; }
#line 9862 "obj/conf/cf-parse.tab.c"
    break;

  case 634: /* channel_sym: VPN6_MC  */
#line 804 "nest/config.Y"
                { (yyval.t) = "vpn6-mc"; }
#line 9868 "obj/conf/cf-parse.tab.c"
    break;

  case 635: /* channel_sym: VPN6_MPLS  */
#line 805 "nest/config.Y"
                { (yyval.t) = "vpn6-mpls"; }
#line 9874 "obj/conf/cf-parse.tab.c"
    break;

  case 636: /* channel_sym: ROA4  */
#line 806 "nest/config.Y"
                { (yyval.t) = "roa4"; }
#line 9880 "obj/conf/cf-parse.tab.c"
    break;

  case 637: /* channel_sym: ROA6  */
#line 807 "nest/config.Y"
                { (yyval.t) = "roa6"; }
#line 9886 "obj/conf/cf-parse.tab.c"
    break;

  case 638: /* channel_sym: FLOW4  */
#line 808 "nest/config.Y"
                { (yyval.t) = "flow4"; }
#line 9892 "obj/conf/cf-parse.tab.c"
    break;

  case 639: /* channel_sym: FLOW6  */
#line 809 "nest/config.Y"
                { (yyval.t) = "flow6"; }
#line 9898 "obj/conf/cf-parse.tab.c"
    break;

  case 640: /* channel_sym: MPLS  */
#line 810 "nest/config.Y"
                { (yyval.t) = "mpls"; }
#line 9904 "obj/conf/cf-parse.tab.c"
    break;

  case 641: /* channel_sym: PRI  */
#line 811 "nest/config.Y"
                { (yyval.t) = "pri"; }
#line 9910 "obj/conf/cf-parse.tab.c"
    break;

  case 642: /* channel_sym: SEC  */
#line 812 "nest/config.Y"
                { (yyval.t) = "sec"; }
#line 9916 "obj/conf/cf-parse.tab.c"
    break;

  case 643: /* channel_arg: CF_SYM_KNOWN '.' channel_sym  */
#line 816 "nest/config.Y"
                                {
     cf_assert_symbol((yyvsp[-2].s), SYM_PROTO);
     struct proto *p =  (yyvsp[-2].s)->proto->proto;
     if (!p) cf_error("%s is not a protocol", (yyvsp[-2].s)->name);
     (yyval.c) = proto_find_channel_by_name(p, (yyvsp[0].t));
     if (!(yyval.c)) cf_error("Channel %s.%s not found", (yyvsp[-2].s)->name, (yyvsp[0].t));
   }
#line 9928 "obj/conf/cf-parse.tab.c"
    break;

  case 645: /* cmd_SHOW_SYMBOLS: SHOW SYMBOLS sym_args END  */
#line 827 "nest/config.Y"
{ cmd_show_symbols((yyvsp[-1].sd)); }
#line 9934 "obj/conf/cf-parse.tab.c"
    break;

  case 646: /* sym_args: %empty  */
#line 830 "nest/config.Y"
               {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 9942 "obj/conf/cf-parse.tab.c"
    break;

  case 647: /* sym_args: sym_args TABLE  */
#line 833 "nest/config.Y"
                  { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 9948 "obj/conf/cf-parse.tab.c"
    break;

  case 648: /* sym_args: sym_args FUNCTION  */
#line 834 "nest/config.Y"
                     { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 9954 "obj/conf/cf-parse.tab.c"
    break;

  case 649: /* sym_args: sym_args FILTER  */
#line 835 "nest/config.Y"
                   { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 9960 "obj/conf/cf-parse.tab.c"
    break;

  case 650: /* sym_args: sym_args PROTOCOL  */
#line 836 "nest/config.Y"
                     { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 9966 "obj/conf/cf-parse.tab.c"
    break;

  case 651: /* sym_args: sym_args TEMPLATE  */
#line 837 "nest/config.Y"
                     { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 9972 "obj/conf/cf-parse.tab.c"
    break;

  case 652: /* sym_args: sym_args symbol  */
#line 838 "nest/config.Y"
                   { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 9978 "obj/conf/cf-parse.tab.c"
    break;

  case 654: /* cmd_DUMP_RESOURCES: DUMP RESOURCES END  */
#line 844 "nest/config.Y"
{ rdump(&root_pool); cli_msg(0, ""); }
#line 9984 "obj/conf/cf-parse.tab.c"
    break;

  case 656: /* cmd_DUMP_SOCKETS: DUMP SOCKETS END  */
#line 846 "nest/config.Y"
{ sk_dump_all(); cli_msg(0, ""); }
#line 9990 "obj/conf/cf-parse.tab.c"
    break;

  case 658: /* cmd_DUMP_EVENTS: DUMP EVENTS END  */
#line 848 "nest/config.Y"
{ io_log_dump(); cli_msg(0, ""); }
#line 9996 "obj/conf/cf-parse.tab.c"
    break;

  case 660: /* cmd_DUMP_INTERFACES: DUMP INTERFACES END  */
#line 850 "nest/config.Y"
{ if_dump_all(); cli_msg(0, ""); }
#line 10002 "obj/conf/cf-parse.tab.c"
    break;

  case 662: /* cmd_DUMP_NEIGHBORS: DUMP NEIGHBORS END  */
#line 852 "nest/config.Y"
{ neigh_dump_all(); cli_msg(0, ""); }
#line 10008 "obj/conf/cf-parse.tab.c"
    break;

  case 664: /* cmd_DUMP_ATTRIBUTES: DUMP ATTRIBUTES END  */
#line 854 "nest/config.Y"
{ rta_dump_all(); cli_msg(0, ""); }
#line 10014 "obj/conf/cf-parse.tab.c"
    break;

  case 666: /* cmd_DUMP_ROUTES: DUMP ROUTES END  */
#line 856 "nest/config.Y"
{ rt_dump_all(); cli_msg(0, ""); }
#line 10020 "obj/conf/cf-parse.tab.c"
    break;

  case 668: /* cmd_DUMP_PROTOCOLS: DUMP PROTOCOLS END  */
#line 858 "nest/config.Y"
{ protos_dump_all(); cli_msg(0, ""); }
#line 10026 "obj/conf/cf-parse.tab.c"
    break;

  case 670: /* cmd_DUMP_FILTER_ALL: DUMP FILTER ALL END  */
#line 860 "nest/config.Y"
{ filters_dump_all(); cli_msg(0, ""); }
#line 10032 "obj/conf/cf-parse.tab.c"
    break;

  case 672: /* cmd_EVAL: EVAL term END  */
#line 863 "nest/config.Y"
{ cmd_eval(f_linearize((yyvsp[-1].x), 1)); }
#line 10038 "obj/conf/cf-parse.tab.c"
    break;

  case 674: /* cmd_ECHO: ECHO echo_mask echo_size END  */
#line 866 "nest/config.Y"
                                       {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 10047 "obj/conf/cf-parse.tab.c"
    break;

  case 675: /* echo_mask: ALL  */
#line 872 "nest/config.Y"
       { (yyval.i) = ~0; }
#line 10053 "obj/conf/cf-parse.tab.c"
    break;

  case 676: /* echo_mask: OFF  */
#line 873 "nest/config.Y"
       { (yyval.i) = 0; }
#line 10059 "obj/conf/cf-parse.tab.c"
    break;

  case 677: /* echo_mask: '{' log_mask_list '}'  */
#line 874 "nest/config.Y"
                         { (yyval.i) = (yyvsp[-1].i); }
#line 10065 "obj/conf/cf-parse.tab.c"
    break;

  case 678: /* echo_size: %empty  */
#line 878 "nest/config.Y"
               { (yyval.i) = 4096; }
#line 10071 "obj/conf/cf-parse.tab.c"
    break;

  case 679: /* echo_size: NUM  */
#line 879 "nest/config.Y"
       {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 10080 "obj/conf/cf-parse.tab.c"
    break;

  case 681: /* cmd_DISABLE: DISABLE proto_patt opttext END  */
#line 886 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 10086 "obj/conf/cf-parse.tab.c"
    break;

  case 683: /* cmd_ENABLE: ENABLE proto_patt opttext END  */
#line 888 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 10092 "obj/conf/cf-parse.tab.c"
    break;

  case 685: /* cmd_RESTART: RESTART proto_patt opttext END  */
#line 890 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 10098 "obj/conf/cf-parse.tab.c"
    break;

  case 687: /* cmd_RELOAD: RELOAD proto_patt END  */
#line 892 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 10104 "obj/conf/cf-parse.tab.c"
    break;

  case 689: /* cmd_RELOAD_IN: RELOAD IN proto_patt END  */
#line 894 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 10110 "obj/conf/cf-parse.tab.c"
    break;

  case 691: /* cmd_RELOAD_OUT: RELOAD OUT proto_patt END  */
#line 896 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 10116 "obj/conf/cf-parse.tab.c"
    break;

  case 693: /* cmd_DEBUG: DEBUG debug_args END  */
#line 900 "nest/config.Y"
{ /* Done in debug_args */  }
#line 10122 "obj/conf/cf-parse.tab.c"
    break;

  case 694: /* debug_args: proto_patt debug_mask  */
#line 903 "nest/config.Y"
                         { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_debug, 1, (yyvsp[0].i));  }
#line 10128 "obj/conf/cf-parse.tab.c"
    break;

  case 695: /* debug_args: channel_arg debug_mask  */
#line 904 "nest/config.Y"
                          { channel_cmd_debug((yyvsp[-1].c), (yyvsp[0].i)); }
#line 10134 "obj/conf/cf-parse.tab.c"
    break;

  case 697: /* cmd_MRTDUMP: MRTDUMP proto_patt mrtdump_mask END  */
#line 909 "nest/config.Y"
{ proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 10140 "obj/conf/cf-parse.tab.c"
    break;

  case 699: /* cmd_RESTRICT: RESTRICT END  */
#line 912 "nest/config.Y"
{ this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 10146 "obj/conf/cf-parse.tab.c"
    break;

  case 700: /* proto_patt: CF_SYM_KNOWN  */
#line 915 "nest/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 10152 "obj/conf/cf-parse.tab.c"
    break;

  case 701: /* proto_patt: ALL  */
#line 916 "nest/config.Y"
        { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 10158 "obj/conf/cf-parse.tab.c"
    break;

  case 702: /* proto_patt: TEXT  */
#line 917 "nest/config.Y"
        { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 10164 "obj/conf/cf-parse.tab.c"
    break;

  case 703: /* proto_patt2: CF_SYM_KNOWN  */
#line 921 "nest/config.Y"
                { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 10170 "obj/conf/cf-parse.tab.c"
    break;

  case 704: /* proto_patt2: %empty  */
#line 922 "nest/config.Y"
        { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 10176 "obj/conf/cf-parse.tab.c"
    break;

  case 705: /* proto_patt2: TEXT  */
#line 923 "nest/config.Y"
        { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 10182 "obj/conf/cf-parse.tab.c"
    break;

  case 706: /* dynamic_attr: IGP_METRIC  */
#line 926 "nest/config.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 10188 "obj/conf/cf-parse.tab.c"
    break;

  case 708: /* bfd_proto_start: proto_start BFD  */
#line 38 "proto/bfd/config.Y"
{
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);
  BFD_CFG->accept_ipv4 = BFD_CFG->accept_ipv6 = 1;
  BFD_CFG->accept_direct = BFD_CFG->accept_multihop = 1;
}
#line 10200 "obj/conf/cf-parse.tab.c"
    break;

  case 714: /* bfd_proto_item: STRICT BIND bool  */
#line 52 "proto/bfd/config.Y"
                    { BFD_CFG->strict_bind = (yyvsp[0].i); }
#line 10206 "obj/conf/cf-parse.tab.c"
    break;

  case 718: /* bfd_accept_item: IPV4  */
#line 65 "proto/bfd/config.Y"
                        { BFD_CFG->accept_ipv4 = 1;  BFD_CFG->accept_ipv6 = 0; }
#line 10212 "obj/conf/cf-parse.tab.c"
    break;

  case 719: /* bfd_accept_item: IPV6  */
#line 66 "proto/bfd/config.Y"
                        { BFD_CFG->accept_ipv4 = 0;  BFD_CFG->accept_ipv6 = 1; }
#line 10218 "obj/conf/cf-parse.tab.c"
    break;

  case 720: /* bfd_accept_item: DIRECT  */
#line 67 "proto/bfd/config.Y"
                        { BFD_CFG->accept_direct = 1;  BFD_CFG->accept_multihop = 0; }
#line 10224 "obj/conf/cf-parse.tab.c"
    break;

  case 721: /* bfd_accept_item: MULTIHOP  */
#line 68 "proto/bfd/config.Y"
                        { BFD_CFG->accept_direct = 0;  BFD_CFG->accept_multihop = 1; }
#line 10230 "obj/conf/cf-parse.tab.c"
    break;

  case 722: /* bfd_accept: %empty  */
#line 72 "proto/bfd/config.Y"
   {
     BFD_CFG->accept_ipv4 = BFD_CFG->accept_ipv6 = 1;
     BFD_CFG->accept_direct = BFD_CFG->accept_multihop = 1;
   }
#line 10239 "obj/conf/cf-parse.tab.c"
    break;

  case 724: /* bfd_iface_start: %empty  */
#line 80 "proto/bfd/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
#line 10256 "obj/conf/cf-parse.tab.c"
    break;

  case 725: /* bfd_iface_finish: %empty  */
#line 94 "proto/bfd/config.Y"
{
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
#line 10279 "obj/conf/cf-parse.tab.c"
    break;

  case 726: /* bfd_iface_item: INTERVAL expr_us  */
#line 114 "proto/bfd/config.Y"
                    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].time); }
#line 10285 "obj/conf/cf-parse.tab.c"
    break;

  case 727: /* bfd_iface_item: MIN RX INTERVAL expr_us  */
#line 115 "proto/bfd/config.Y"
                           { BFD_IFACE->min_rx_int = (yyvsp[0].time); }
#line 10291 "obj/conf/cf-parse.tab.c"
    break;

  case 728: /* bfd_iface_item: MIN TX INTERVAL expr_us  */
#line 116 "proto/bfd/config.Y"
                           { BFD_IFACE->min_tx_int = (yyvsp[0].time); }
#line 10297 "obj/conf/cf-parse.tab.c"
    break;

  case 729: /* bfd_iface_item: IDLE TX INTERVAL expr_us  */
#line 117 "proto/bfd/config.Y"
                            { BFD_IFACE->idle_tx_int = (yyvsp[0].time); }
#line 10303 "obj/conf/cf-parse.tab.c"
    break;

  case 730: /* bfd_iface_item: MULTIPLIER expr  */
#line 118 "proto/bfd/config.Y"
                   { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 10309 "obj/conf/cf-parse.tab.c"
    break;

  case 731: /* bfd_iface_item: PASSIVE bool  */
#line 119 "proto/bfd/config.Y"
                { BFD_IFACE->passive = (yyvsp[0].i); }
#line 10315 "obj/conf/cf-parse.tab.c"
    break;

  case 732: /* bfd_iface_item: AUTHENTICATION bfd_auth_type  */
#line 120 "proto/bfd/config.Y"
                                { BFD_IFACE->auth_type = (yyvsp[0].i); }
#line 10321 "obj/conf/cf-parse.tab.c"
    break;

  case 733: /* bfd_iface_item: password_list  */
#line 121 "proto/bfd/config.Y"
                 {}
#line 10327 "obj/conf/cf-parse.tab.c"
    break;

  case 734: /* bfd_auth_type: NONE  */
#line 125 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_NONE; }
#line 10333 "obj/conf/cf-parse.tab.c"
    break;

  case 735: /* bfd_auth_type: SIMPLE  */
#line 126 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_SIMPLE; }
#line 10339 "obj/conf/cf-parse.tab.c"
    break;

  case 736: /* bfd_auth_type: KEYED MD5  */
#line 127 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_KEYED_MD5; }
#line 10345 "obj/conf/cf-parse.tab.c"
    break;

  case 737: /* bfd_auth_type: KEYED SHA1  */
#line 128 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
#line 10351 "obj/conf/cf-parse.tab.c"
    break;

  case 738: /* bfd_auth_type: METICULOUS KEYED MD5  */
#line 129 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
#line 10357 "obj/conf/cf-parse.tab.c"
    break;

  case 739: /* bfd_auth_type: METICULOUS KEYED SHA1  */
#line 130 "proto/bfd/config.Y"
                         { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
#line 10363 "obj/conf/cf-parse.tab.c"
    break;

  case 745: /* bfd_multihop: bfd_iface_start bfd_iface_opt_list bfd_iface_finish  */
#line 148 "proto/bfd/config.Y"
{ BFD_CFG->multihop = BFD_IFACE; }
#line 10369 "obj/conf/cf-parse.tab.c"
    break;

  case 746: /* bfd_neigh_iface: %empty  */
#line 152 "proto/bfd/config.Y"
               { (yyval.iface) = NULL; }
#line 10375 "obj/conf/cf-parse.tab.c"
    break;

  case 747: /* bfd_neigh_iface: '%' symbol  */
#line 153 "proto/bfd/config.Y"
              { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 10381 "obj/conf/cf-parse.tab.c"
    break;

  case 748: /* bfd_neigh_iface: DEV text  */
#line 154 "proto/bfd/config.Y"
            { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 10387 "obj/conf/cf-parse.tab.c"
    break;

  case 749: /* bfd_neigh_local: %empty  */
#line 158 "proto/bfd/config.Y"
               { (yyval.a) = IPA_NONE; }
#line 10393 "obj/conf/cf-parse.tab.c"
    break;

  case 750: /* bfd_neigh_local: LOCAL ipa  */
#line 159 "proto/bfd/config.Y"
             { (yyval.a) = (yyvsp[0].a); }
#line 10399 "obj/conf/cf-parse.tab.c"
    break;

  case 751: /* bfd_neigh_multihop: %empty  */
#line 163 "proto/bfd/config.Y"
               { (yyval.i) = 0; }
#line 10405 "obj/conf/cf-parse.tab.c"
    break;

  case 752: /* bfd_neigh_multihop: MULTIHOP bool  */
#line 164 "proto/bfd/config.Y"
                 { (yyval.i) = (yyvsp[0].i); }
#line 10411 "obj/conf/cf-parse.tab.c"
    break;

  case 753: /* bfd_neighbor: ipa bfd_neigh_iface bfd_neigh_local bfd_neigh_multihop  */
#line 168 "proto/bfd/config.Y"
{
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 10431 "obj/conf/cf-parse.tab.c"
    break;

  case 755: /* cmd_SHOW_BFD_SESSIONS: SHOW BFD SESSIONS optproto END  */
#line 187 "proto/bfd/config.Y"
{ PROTO_WALK_CMD((yyvsp[-1].s), &proto_bfd, p) bfd_show_sessions(p); }
#line 10437 "obj/conf/cf-parse.tab.c"
    break;

  case 757: /* babel_proto_start: proto_start BABEL  */
#line 35 "proto/babel/config.Y"
{
  this_proto = proto_config_new(&proto_babel, (yyvsp[-1].i));
  init_list(&BABEL_CFG->iface_list);
  BABEL_CFG->hold_time = 1 S_;
}
#line 10447 "obj/conf/cf-parse.tab.c"
    break;

  case 761: /* babel_proto_item: RANDOMIZE ROUTER ID bool  */
#line 45 "proto/babel/config.Y"
                            { BABEL_CFG->randomize_router_id = (yyvsp[0].i); }
#line 10453 "obj/conf/cf-parse.tab.c"
    break;

  case 765: /* babel_iface_start: %empty  */
#line 58 "proto/babel/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct babel_iface_config));
  add_tail(&BABEL_CFG->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  BABEL_IFACE->port = BABEL_PORT;
  BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED;
  BABEL_IFACE->limit = BABEL_HELLO_LIMIT;
  BABEL_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  BABEL_IFACE->tx_priority = sk_priority_control;
  BABEL_IFACE->check_link = 1;
}
#line 10471 "obj/conf/cf-parse.tab.c"
    break;

  case 766: /* babel_iface_finish: %empty  */
#line 74 "proto/babel/config.Y"
{
  if (BABEL_IFACE->type == BABEL_IFACE_TYPE_WIRELESS)
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRELESS;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRELESS;
  }
  else
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRED;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRED;
  }

  /* Make sure we do not overflow the 16-bit centisec fields */
  if (!BABEL_IFACE->update_interval)
    BABEL_IFACE->update_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_UPDATE_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
  BABEL_IFACE->ihu_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_IHU_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);

  BABEL_CFG->hold_time = MAX_(BABEL_CFG->hold_time, BABEL_IFACE->update_interval*BABEL_HOLD_TIME_FACTOR);

  BABEL_IFACE->passwords = get_passwords();

  if (!BABEL_IFACE->auth_type != !BABEL_IFACE->passwords)
    cf_error("Authentication and password options should be used together");

  if (BABEL_IFACE->passwords)
  {
    struct password_item *pass;
    uint len = 0, i = 0;

    WALK_LIST(pass, *BABEL_IFACE->passwords)
    {
      /* Set default crypto algorithm (HMAC-SHA256) */
      if (!pass->alg)
	pass->alg = ALG_HMAC_SHA256;

      if (!((pass->alg & ALG_HMAC) ||
	    (pass->alg == ALG_BLAKE2S_128) ||
	    (pass->alg == ALG_BLAKE2S_256) ||
	    (pass->alg == ALG_BLAKE2B_256) ||
	    (pass->alg == ALG_BLAKE2B_512)))
	cf_error("Only HMAC and Blake2 algorithms are supported");

      len += mac_type_length(pass->alg);
      i++;
    }

    BABEL_IFACE->mac_num_keys = i;
    BABEL_IFACE->mac_total_len = len;
  }

}
#line 10531 "obj/conf/cf-parse.tab.c"
    break;

  case 768: /* babel_iface_item: PORT expr  */
#line 132 "proto/babel/config.Y"
             { BABEL_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 10537 "obj/conf/cf-parse.tab.c"
    break;

  case 769: /* babel_iface_item: RXCOST expr  */
#line 133 "proto/babel/config.Y"
               { BABEL_IFACE->rxcost = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid rxcost"); }
#line 10543 "obj/conf/cf-parse.tab.c"
    break;

  case 770: /* babel_iface_item: LIMIT expr  */
#line 134 "proto/babel/config.Y"
              { BABEL_IFACE->limit = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>16)) cf_error("Limit must be in range 1-16"); }
#line 10549 "obj/conf/cf-parse.tab.c"
    break;

  case 771: /* babel_iface_item: TYPE WIRED  */
#line 135 "proto/babel/config.Y"
              { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED; }
#line 10555 "obj/conf/cf-parse.tab.c"
    break;

  case 772: /* babel_iface_item: TYPE WIRELESS  */
#line 136 "proto/babel/config.Y"
                 { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRELESS; }
#line 10561 "obj/conf/cf-parse.tab.c"
    break;

  case 773: /* babel_iface_item: HELLO INTERVAL expr_us  */
#line 137 "proto/babel/config.Y"
                          { BABEL_IFACE->hello_interval = (yyvsp[0].time); if (((yyvsp[0].time)<BABEL_MIN_INTERVAL) || ((yyvsp[0].time)>BABEL_MAX_INTERVAL)) cf_error("Hello interval must be in range 10 ms - 655 s"); }
#line 10567 "obj/conf/cf-parse.tab.c"
    break;

  case 774: /* babel_iface_item: UPDATE INTERVAL expr_us  */
#line 138 "proto/babel/config.Y"
                           { BABEL_IFACE->update_interval = (yyvsp[0].time); if (((yyvsp[0].time)<BABEL_MIN_INTERVAL) || ((yyvsp[0].time)>BABEL_MAX_INTERVAL)) cf_error("Update interval must be in range 10 ms - 655 s"); }
#line 10573 "obj/conf/cf-parse.tab.c"
    break;

  case 775: /* babel_iface_item: RX BUFFER expr  */
#line 139 "proto/babel/config.Y"
                  { BABEL_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX buffer must be in range 256-65535"); }
#line 10579 "obj/conf/cf-parse.tab.c"
    break;

  case 776: /* babel_iface_item: TX LENGTH expr  */
#line 140 "proto/babel/config.Y"
                  { BABEL_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 10585 "obj/conf/cf-parse.tab.c"
    break;

  case 777: /* babel_iface_item: TX tos  */
#line 141 "proto/babel/config.Y"
          { BABEL_IFACE->tx_tos = (yyvsp[0].i); }
#line 10591 "obj/conf/cf-parse.tab.c"
    break;

  case 778: /* babel_iface_item: TX PRIORITY expr  */
#line 142 "proto/babel/config.Y"
                    { BABEL_IFACE->tx_priority = (yyvsp[0].i); }
#line 10597 "obj/conf/cf-parse.tab.c"
    break;

  case 779: /* babel_iface_item: CHECK LINK bool  */
#line 143 "proto/babel/config.Y"
                   { BABEL_IFACE->check_link = (yyvsp[0].i); }
#line 10603 "obj/conf/cf-parse.tab.c"
    break;

  case 780: /* babel_iface_item: NEXT HOP IPV4 ipa  */
#line 144 "proto/babel/config.Y"
                     { BABEL_IFACE->next_hop_ip4 = (yyvsp[0].a); if (!ipa_is_ip4((yyvsp[0].a))) cf_error("Must be an IPv4 address"); }
#line 10609 "obj/conf/cf-parse.tab.c"
    break;

  case 781: /* babel_iface_item: NEXT HOP IPV6 ipa  */
#line 145 "proto/babel/config.Y"
                     { BABEL_IFACE->next_hop_ip6 = (yyvsp[0].a); if (!ipa_is_ip6((yyvsp[0].a))) cf_error("Must be an IPv6 address"); }
#line 10615 "obj/conf/cf-parse.tab.c"
    break;

  case 782: /* babel_iface_item: AUTHENTICATION NONE  */
#line 146 "proto/babel/config.Y"
                       { BABEL_IFACE->auth_type = BABEL_AUTH_NONE; }
#line 10621 "obj/conf/cf-parse.tab.c"
    break;

  case 783: /* babel_iface_item: AUTHENTICATION MAC  */
#line 147 "proto/babel/config.Y"
                      { BABEL_IFACE->auth_type = BABEL_AUTH_MAC; BABEL_IFACE->auth_permissive = 0; }
#line 10627 "obj/conf/cf-parse.tab.c"
    break;

  case 784: /* babel_iface_item: AUTHENTICATION MAC PERMISSIVE  */
#line 148 "proto/babel/config.Y"
                                 { BABEL_IFACE->auth_type = BABEL_AUTH_MAC; BABEL_IFACE->auth_permissive = 1; }
#line 10633 "obj/conf/cf-parse.tab.c"
    break;

  case 791: /* dynamic_attr: BABEL_METRIC  */
#line 166 "proto/babel/config.Y"
                           { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_BABEL_METRIC); }
#line 10639 "obj/conf/cf-parse.tab.c"
    break;

  case 793: /* cmd_SHOW_BABEL_INTERFACES: SHOW BABEL INTERFACES optproto opttext END  */
#line 171 "proto/babel/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p) babel_show_interfaces(p, (yyvsp[-1].t)); }
#line 10645 "obj/conf/cf-parse.tab.c"
    break;

  case 795: /* cmd_SHOW_BABEL_NEIGHBORS: SHOW BABEL NEIGHBORS optproto opttext END  */
#line 174 "proto/babel/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p) babel_show_neighbors(p, (yyvsp[-1].t)); }
#line 10651 "obj/conf/cf-parse.tab.c"
    break;

  case 797: /* cmd_SHOW_BABEL_ENTRIES: SHOW BABEL ENTRIES optproto opttext END  */
#line 177 "proto/babel/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p) babel_show_entries(p); }
#line 10657 "obj/conf/cf-parse.tab.c"
    break;

  case 799: /* cmd_SHOW_BABEL_ROUTES: SHOW BABEL ROUTES optproto opttext END  */
#line 180 "proto/babel/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_babel, p)  babel_show_routes(p); }
#line 10663 "obj/conf/cf-parse.tab.c"
    break;

  case 801: /* bgp_proto_start: proto_start BGP  */
#line 50 "proto/bgp/config.Y"
                                 {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->local_port = BGP_PORT;
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->enable_hostname = 0;
     BGP_CFG->capabilities = 2;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->allow_as_sets = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->llgr_mode = -1;
     BGP_CFG->llgr_time = 3600;
     BGP_CFG->setkey = 1;
     BGP_CFG->local_role = BGP_ROLE_UNDEFINED;
     BGP_CFG->dynamic_name = "dynbgp";
     BGP_CFG->check_link = -1;
   }
#line 10698 "obj/conf/cf-parse.tab.c"
    break;

  case 803: /* bgp_loc_opts: bgp_loc_opts PORT expr  */
#line 84 "proto/bgp/config.Y"
                          { BGP_CFG->local_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 10704 "obj/conf/cf-parse.tab.c"
    break;

  case 804: /* bgp_loc_opts: bgp_loc_opts AS expr  */
#line 85 "proto/bgp/config.Y"
                        { BGP_CFG->local_as = (yyvsp[0].i); }
#line 10710 "obj/conf/cf-parse.tab.c"
    break;

  case 806: /* bgp_nbr_opts: bgp_nbr_opts PORT expr  */
#line 90 "proto/bgp/config.Y"
                          { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 10716 "obj/conf/cf-parse.tab.c"
    break;

  case 807: /* bgp_nbr_opts: bgp_nbr_opts AS expr  */
#line 91 "proto/bgp/config.Y"
                        { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 10722 "obj/conf/cf-parse.tab.c"
    break;

  case 808: /* bgp_nbr_opts: bgp_nbr_opts INTERNAL  */
#line 92 "proto/bgp/config.Y"
                         { BGP_CFG->peer_type = BGP_PT_INTERNAL; }
#line 10728 "obj/conf/cf-parse.tab.c"
    break;

  case 809: /* bgp_nbr_opts: bgp_nbr_opts EXTERNAL  */
#line 93 "proto/bgp/config.Y"
                         { BGP_CFG->peer_type = BGP_PT_EXTERNAL; }
#line 10734 "obj/conf/cf-parse.tab.c"
    break;

  case 810: /* bgp_cease_mask: bool  */
#line 98 "proto/bgp/config.Y"
        { (yyval.i) = (yyvsp[0].i) ? ~(1 << 7) : 0; }
#line 10740 "obj/conf/cf-parse.tab.c"
    break;

  case 811: /* bgp_cease_mask: '{' bgp_cease_list '}'  */
#line 99 "proto/bgp/config.Y"
                          { (yyval.i) = (yyvsp[-1].i); }
#line 10746 "obj/conf/cf-parse.tab.c"
    break;

  case 813: /* bgp_cease_list: bgp_cease_list ',' bgp_cease_flag  */
#line 104 "proto/bgp/config.Y"
                                     { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 10752 "obj/conf/cf-parse.tab.c"
    break;

  case 814: /* bgp_cease_flag: CEASE  */
#line 108 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 0; }
#line 10758 "obj/conf/cf-parse.tab.c"
    break;

  case 815: /* bgp_cease_flag: PREFIX LIMIT HIT  */
#line 109 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 1; }
#line 10764 "obj/conf/cf-parse.tab.c"
    break;

  case 816: /* bgp_cease_flag: ADMINISTRATIVE SHUTDOWN  */
#line 110 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 2; }
#line 10770 "obj/conf/cf-parse.tab.c"
    break;

  case 817: /* bgp_cease_flag: PEER DECONFIGURED  */
#line 111 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 3; }
#line 10776 "obj/conf/cf-parse.tab.c"
    break;

  case 818: /* bgp_cease_flag: ADMINISTRATIVE RESET  */
#line 112 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 4; }
#line 10782 "obj/conf/cf-parse.tab.c"
    break;

  case 819: /* bgp_cease_flag: CONNECTION REJECTED  */
#line 113 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 5; }
#line 10788 "obj/conf/cf-parse.tab.c"
    break;

  case 820: /* bgp_cease_flag: CONFIGURATION CHANGE  */
#line 114 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 6; }
#line 10794 "obj/conf/cf-parse.tab.c"
    break;

  case 821: /* bgp_cease_flag: CONNECTION COLLISION  */
#line 115 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 7; }
#line 10800 "obj/conf/cf-parse.tab.c"
    break;

  case 822: /* bgp_cease_flag: OUT OF RESOURCES  */
#line 116 "proto/bgp/config.Y"
                                { (yyval.i) = 1 << 8; }
#line 10806 "obj/conf/cf-parse.tab.c"
    break;

  case 823: /* bgp_role_name: PEER  */
#line 120 "proto/bgp/config.Y"
             { (yyval.i) = BGP_ROLE_PEER; }
#line 10812 "obj/conf/cf-parse.tab.c"
    break;

  case 824: /* bgp_role_name: PROVIDER  */
#line 121 "proto/bgp/config.Y"
             { (yyval.i) = BGP_ROLE_PROVIDER; }
#line 10818 "obj/conf/cf-parse.tab.c"
    break;

  case 825: /* bgp_role_name: CUSTOMER  */
#line 122 "proto/bgp/config.Y"
             { (yyval.i) = BGP_ROLE_CUSTOMER; }
#line 10824 "obj/conf/cf-parse.tab.c"
    break;

  case 826: /* bgp_role_name: RS_SERVER  */
#line 123 "proto/bgp/config.Y"
             { (yyval.i) = BGP_ROLE_RS_SERVER; }
#line 10830 "obj/conf/cf-parse.tab.c"
    break;

  case 827: /* bgp_role_name: RS_CLIENT  */
#line 124 "proto/bgp/config.Y"
             { (yyval.i) = BGP_ROLE_RS_CLIENT; }
#line 10836 "obj/conf/cf-parse.tab.c"
    break;

  case 832: /* bgp_proto: bgp_proto LOCAL ipa ipa_scope bgp_loc_opts ';'  */
#line 132 "proto/bgp/config.Y"
                                                  {
     BGP_CFG->local_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 10845 "obj/conf/cf-parse.tab.c"
    break;

  case 834: /* bgp_proto: bgp_proto NEIGHBOR ipa ipa_scope bgp_nbr_opts ';'  */
#line 137 "proto/bgp/config.Y"
                                                     {
     if (ipa_nonzero(BGP_CFG->remote_ip) || BGP_CFG->remote_range)
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 10856 "obj/conf/cf-parse.tab.c"
    break;

  case 835: /* bgp_proto: bgp_proto NEIGHBOR RANGE net_ip bgp_nbr_opts ';'  */
#line 143 "proto/bgp/config.Y"
                                                    {
     if (ipa_nonzero(BGP_CFG->remote_ip) || BGP_CFG->remote_range)
       cf_error("Only one neighbor per BGP instance is allowed");
     net_addr *n = cfg_alloc((yyvsp[-2].net).length);
     net_copy(n, &((yyvsp[-2].net)));
     BGP_CFG->remote_range = n;
   }
#line 10868 "obj/conf/cf-parse.tab.c"
    break;

  case 836: /* bgp_proto: bgp_proto INTERFACE TEXT ';'  */
#line 150 "proto/bgp/config.Y"
                                { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 10874 "obj/conf/cf-parse.tab.c"
    break;

  case 837: /* bgp_proto: bgp_proto RR CLUSTER ID idval ';'  */
#line 151 "proto/bgp/config.Y"
                                     { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 10880 "obj/conf/cf-parse.tab.c"
    break;

  case 838: /* bgp_proto: bgp_proto RR CLIENT bool ';'  */
#line 152 "proto/bgp/config.Y"
                                { BGP_CFG->rr_client = (yyvsp[-1].i); }
#line 10886 "obj/conf/cf-parse.tab.c"
    break;

  case 839: /* bgp_proto: bgp_proto RS CLIENT bool ';'  */
#line 153 "proto/bgp/config.Y"
                                { BGP_CFG->rs_client = (yyvsp[-1].i); }
#line 10892 "obj/conf/cf-parse.tab.c"
    break;

  case 840: /* bgp_proto: bgp_proto CONFEDERATION expr ';'  */
#line 154 "proto/bgp/config.Y"
                                    { BGP_CFG->confederation = (yyvsp[-1].i); }
#line 10898 "obj/conf/cf-parse.tab.c"
    break;

  case 841: /* bgp_proto: bgp_proto CONFEDERATION MEMBER bool ';'  */
#line 155 "proto/bgp/config.Y"
                                           { BGP_CFG->confederation_member = (yyvsp[-1].i); }
#line 10904 "obj/conf/cf-parse.tab.c"
    break;

  case 842: /* bgp_proto: bgp_proto HOLD TIME expr ';'  */
#line 156 "proto/bgp/config.Y"
                                { BGP_CFG->hold_time = (yyvsp[-1].i); if (((yyvsp[-1].i) && (yyvsp[-1].i)<3) || ((yyvsp[-1].i)>65535)) cf_error("Hold time must be in range 3-65535 or zero"); }
#line 10910 "obj/conf/cf-parse.tab.c"
    break;

  case 843: /* bgp_proto: bgp_proto MIN HOLD TIME expr ';'  */
#line 157 "proto/bgp/config.Y"
                                    { BGP_CFG->min_hold_time = (yyvsp[-1].i); }
#line 10916 "obj/conf/cf-parse.tab.c"
    break;

  case 844: /* bgp_proto: bgp_proto STARTUP HOLD TIME expr ';'  */
#line 158 "proto/bgp/config.Y"
                                        { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 10922 "obj/conf/cf-parse.tab.c"
    break;

  case 845: /* bgp_proto: bgp_proto DIRECT ';'  */
#line 159 "proto/bgp/config.Y"
                        { BGP_CFG->multihop = 0; }
#line 10928 "obj/conf/cf-parse.tab.c"
    break;

  case 846: /* bgp_proto: bgp_proto MULTIHOP ';'  */
#line 160 "proto/bgp/config.Y"
                          { BGP_CFG->multihop = 64; }
#line 10934 "obj/conf/cf-parse.tab.c"
    break;

  case 847: /* bgp_proto: bgp_proto MULTIHOP expr ';'  */
#line 161 "proto/bgp/config.Y"
                               { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 10940 "obj/conf/cf-parse.tab.c"
    break;

  case 848: /* bgp_proto: bgp_proto DYNAMIC NAME text ';'  */
#line 162 "proto/bgp/config.Y"
                                   {
     if (strchr((yyvsp[-1].t), '%')) cf_error("Forbidden character '%%' in dynamic name");
     if (strlen((yyvsp[-1].t)) > (SYM_MAX_LEN - 16)) cf_error("Dynamic name too long");
     BGP_CFG->dynamic_name = (yyvsp[-1].t);
   }
#line 10950 "obj/conf/cf-parse.tab.c"
    break;

  case 849: /* bgp_proto: bgp_proto DYNAMIC NAME DIGITS expr ';'  */
#line 167 "proto/bgp/config.Y"
                                          { BGP_CFG->dynamic_name_digits = (yyvsp[-1].i); if ((yyvsp[-1].i)>10) cf_error("Dynamic name digits must be at most 10"); }
#line 10956 "obj/conf/cf-parse.tab.c"
    break;

  case 850: /* bgp_proto: bgp_proto STRICT BIND bool ';'  */
#line 168 "proto/bgp/config.Y"
                                  { BGP_CFG->strict_bind = (yyvsp[-1].i); }
#line 10962 "obj/conf/cf-parse.tab.c"
    break;

  case 851: /* bgp_proto: bgp_proto FREE BIND bool ';'  */
#line 169 "proto/bgp/config.Y"
                                { BGP_CFG->free_bind = (yyvsp[-1].i); }
#line 10968 "obj/conf/cf-parse.tab.c"
    break;

  case 852: /* bgp_proto: bgp_proto PATH METRIC bool ';'  */
#line 170 "proto/bgp/config.Y"
                                  { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 10974 "obj/conf/cf-parse.tab.c"
    break;

  case 853: /* bgp_proto: bgp_proto MED METRIC bool ';'  */
#line 171 "proto/bgp/config.Y"
                                 { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 10980 "obj/conf/cf-parse.tab.c"
    break;

  case 854: /* bgp_proto: bgp_proto IGP METRIC bool ';'  */
#line 172 "proto/bgp/config.Y"
                                 { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 10986 "obj/conf/cf-parse.tab.c"
    break;

  case 855: /* bgp_proto: bgp_proto PREFER OLDER bool ';'  */
#line 173 "proto/bgp/config.Y"
                                   { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 10992 "obj/conf/cf-parse.tab.c"
    break;

  case 856: /* bgp_proto: bgp_proto DETERMINISTIC MED bool ';'  */
#line 174 "proto/bgp/config.Y"
                                        { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 10998 "obj/conf/cf-parse.tab.c"
    break;

  case 857: /* bgp_proto: bgp_proto DEFAULT BGP_MED expr ';'  */
#line 175 "proto/bgp/config.Y"
                                      { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 11004 "obj/conf/cf-parse.tab.c"
    break;

  case 858: /* bgp_proto: bgp_proto DEFAULT BGP_LOCAL_PREF expr ';'  */
#line 176 "proto/bgp/config.Y"
                                             { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 11010 "obj/conf/cf-parse.tab.c"
    break;

  case 859: /* bgp_proto: bgp_proto SOURCE ADDRESS ipa ';'  */
#line 177 "proto/bgp/config.Y"
                                    { BGP_CFG->local_ip = (yyvsp[-1].a); }
#line 11016 "obj/conf/cf-parse.tab.c"
    break;

  case 860: /* bgp_proto: bgp_proto START DELAY TIME expr ';'  */
#line 178 "proto/bgp/config.Y"
                                       { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 11022 "obj/conf/cf-parse.tab.c"
    break;

  case 861: /* bgp_proto: bgp_proto CONNECT DELAY TIME expr ';'  */
#line 179 "proto/bgp/config.Y"
                                         { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 11028 "obj/conf/cf-parse.tab.c"
    break;

  case 862: /* bgp_proto: bgp_proto CONNECT RETRY TIME expr ';'  */
#line 180 "proto/bgp/config.Y"
                                         { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 11034 "obj/conf/cf-parse.tab.c"
    break;

  case 863: /* bgp_proto: bgp_proto KEEPALIVE TIME expr ';'  */
#line 181 "proto/bgp/config.Y"
                                     { BGP_CFG->keepalive_time = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>65535)) cf_error("Keepalive time must be in range 1-65535"); }
#line 11040 "obj/conf/cf-parse.tab.c"
    break;

  case 864: /* bgp_proto: bgp_proto MIN KEEPALIVE TIME expr ';'  */
#line 182 "proto/bgp/config.Y"
                                         { BGP_CFG->min_keepalive_time = (yyvsp[-1].i); }
#line 11046 "obj/conf/cf-parse.tab.c"
    break;

  case 865: /* bgp_proto: bgp_proto ERROR FORGET TIME expr ';'  */
#line 183 "proto/bgp/config.Y"
                                        { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 11052 "obj/conf/cf-parse.tab.c"
    break;

  case 866: /* bgp_proto: bgp_proto ERROR WAIT TIME expr ',' expr ';'  */
#line 184 "proto/bgp/config.Y"
                                               { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 11058 "obj/conf/cf-parse.tab.c"
    break;

  case 867: /* bgp_proto: bgp_proto DISABLE AFTER ERROR bool ';'  */
#line 185 "proto/bgp/config.Y"
                                          { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 11064 "obj/conf/cf-parse.tab.c"
    break;

  case 868: /* bgp_proto: bgp_proto DISABLE AFTER CEASE bgp_cease_mask ';'  */
#line 186 "proto/bgp/config.Y"
                                                    { BGP_CFG->disable_after_cease = (yyvsp[-1].i); }
#line 11070 "obj/conf/cf-parse.tab.c"
    break;

  case 869: /* bgp_proto: bgp_proto ENABLE ROUTE REFRESH bool ';'  */
#line 187 "proto/bgp/config.Y"
                                           { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 11076 "obj/conf/cf-parse.tab.c"
    break;

  case 870: /* bgp_proto: bgp_proto ENABLE AS4 bool ';'  */
#line 188 "proto/bgp/config.Y"
                                 { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 11082 "obj/conf/cf-parse.tab.c"
    break;

  case 871: /* bgp_proto: bgp_proto ENABLE EXTENDED MESSAGES bool ';'  */
#line 189 "proto/bgp/config.Y"
                                               { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 11088 "obj/conf/cf-parse.tab.c"
    break;

  case 872: /* bgp_proto: bgp_proto ADVERTISE HOSTNAME bool ';'  */
#line 190 "proto/bgp/config.Y"
                                         { BGP_CFG->enable_hostname = (yyvsp[-1].i); }
#line 11094 "obj/conf/cf-parse.tab.c"
    break;

  case 873: /* bgp_proto: bgp_proto CAPABILITIES bool ';'  */
#line 191 "proto/bgp/config.Y"
                                   { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 11100 "obj/conf/cf-parse.tab.c"
    break;

  case 874: /* bgp_proto: bgp_proto PASSWORD text ';'  */
#line 192 "proto/bgp/config.Y"
                               { BGP_CFG->password = (yyvsp[-1].t); }
#line 11106 "obj/conf/cf-parse.tab.c"
    break;

  case 875: /* bgp_proto: bgp_proto SETKEY bool ';'  */
#line 193 "proto/bgp/config.Y"
                             { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 11112 "obj/conf/cf-parse.tab.c"
    break;

  case 876: /* bgp_proto: bgp_proto PASSIVE bool ';'  */
#line 194 "proto/bgp/config.Y"
                              { BGP_CFG->passive = (yyvsp[-1].i); }
#line 11118 "obj/conf/cf-parse.tab.c"
    break;

  case 877: /* bgp_proto: bgp_proto INTERPRET COMMUNITIES bool ';'  */
#line 195 "proto/bgp/config.Y"
                                            { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 11124 "obj/conf/cf-parse.tab.c"
    break;

  case 878: /* bgp_proto: bgp_proto ALLOW LOCAL AS ';'  */
#line 196 "proto/bgp/config.Y"
                                { BGP_CFG->allow_local_as = -1; }
#line 11130 "obj/conf/cf-parse.tab.c"
    break;

  case 879: /* bgp_proto: bgp_proto ALLOW LOCAL AS expr ';'  */
#line 197 "proto/bgp/config.Y"
                                     { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 11136 "obj/conf/cf-parse.tab.c"
    break;

  case 880: /* bgp_proto: bgp_proto ALLOW BGP_LOCAL_PREF bool ';'  */
#line 198 "proto/bgp/config.Y"
                                           { BGP_CFG->allow_local_pref = (yyvsp[-1].i); }
#line 11142 "obj/conf/cf-parse.tab.c"
    break;

  case 881: /* bgp_proto: bgp_proto ALLOW AS SETS bool ';'  */
#line 199 "proto/bgp/config.Y"
                                    { BGP_CFG->allow_as_sets = (yyvsp[-1].i); }
#line 11148 "obj/conf/cf-parse.tab.c"
    break;

  case 882: /* bgp_proto: bgp_proto GRACEFUL RESTART bool ';'  */
#line 200 "proto/bgp/config.Y"
                                       { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 11154 "obj/conf/cf-parse.tab.c"
    break;

  case 883: /* bgp_proto: bgp_proto GRACEFUL RESTART AWARE ';'  */
#line 201 "proto/bgp/config.Y"
                                        { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 11160 "obj/conf/cf-parse.tab.c"
    break;

  case 884: /* bgp_proto: bgp_proto GRACEFUL RESTART TIME expr ';'  */
#line 202 "proto/bgp/config.Y"
                                            { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 11166 "obj/conf/cf-parse.tab.c"
    break;

  case 885: /* bgp_proto: bgp_proto LONG LIVED GRACEFUL RESTART bool ';'  */
#line 203 "proto/bgp/config.Y"
                                                  { BGP_CFG->llgr_mode = (yyvsp[-1].i); }
#line 11172 "obj/conf/cf-parse.tab.c"
    break;

  case 886: /* bgp_proto: bgp_proto LONG LIVED GRACEFUL RESTART AWARE ';'  */
#line 204 "proto/bgp/config.Y"
                                                   { BGP_CFG->llgr_mode = BGP_LLGR_AWARE; }
#line 11178 "obj/conf/cf-parse.tab.c"
    break;

  case 887: /* bgp_proto: bgp_proto LONG LIVED STALE TIME expr ';'  */
#line 205 "proto/bgp/config.Y"
                                            { BGP_CFG->llgr_time = (yyvsp[-1].i); }
#line 11184 "obj/conf/cf-parse.tab.c"
    break;

  case 888: /* bgp_proto: bgp_proto TTL SECURITY bool ';'  */
#line 206 "proto/bgp/config.Y"
                                   { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 11190 "obj/conf/cf-parse.tab.c"
    break;

  case 889: /* bgp_proto: bgp_proto CHECK LINK bool ';'  */
#line 207 "proto/bgp/config.Y"
                                 { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 11196 "obj/conf/cf-parse.tab.c"
    break;

  case 890: /* bgp_proto: bgp_proto BFD bool ';'  */
#line 208 "proto/bgp/config.Y"
                          { if ((yyvsp[-1].i)) init_bfd_opts(&BGP_CFG->bfd); else BGP_CFG->bfd = NULL; }
#line 11202 "obj/conf/cf-parse.tab.c"
    break;

  case 891: /* bgp_proto: bgp_proto BFD GRACEFUL ';'  */
#line 209 "proto/bgp/config.Y"
                              { init_bfd_opts(&BGP_CFG->bfd); BGP_CFG->bfd->mode = BGP_BFD_GRACEFUL; }
#line 11208 "obj/conf/cf-parse.tab.c"
    break;

  case 892: /* $@9: %empty  */
#line 210 "proto/bgp/config.Y"
                 { open_bfd_opts(&BGP_CFG->bfd); }
#line 11214 "obj/conf/cf-parse.tab.c"
    break;

  case 893: /* $@10: %empty  */
#line 210 "proto/bgp/config.Y"
                                                            { close_bfd_opts(); }
#line 11220 "obj/conf/cf-parse.tab.c"
    break;

  case 895: /* bgp_proto: bgp_proto ENFORCE FIRST AS bool ';'  */
#line 211 "proto/bgp/config.Y"
                                       { BGP_CFG->enforce_first_as = (yyvsp[-1].i); }
#line 11226 "obj/conf/cf-parse.tab.c"
    break;

  case 896: /* bgp_proto: bgp_proto LOCAL ROLE bgp_role_name ';'  */
#line 212 "proto/bgp/config.Y"
                                          { BGP_CFG->local_role = (yyvsp[-1].i); }
#line 11232 "obj/conf/cf-parse.tab.c"
    break;

  case 897: /* bgp_proto: bgp_proto REQUIRE ROLES bool ';'  */
#line 213 "proto/bgp/config.Y"
                                    { BGP_CFG->require_roles = (yyvsp[-1].i); }
#line 11238 "obj/conf/cf-parse.tab.c"
    break;

  case 898: /* bgp_afi: IPV4  */
#line 217 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV4; }
#line 11244 "obj/conf/cf-parse.tab.c"
    break;

  case 899: /* bgp_afi: IPV6  */
#line 218 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV6; }
#line 11250 "obj/conf/cf-parse.tab.c"
    break;

  case 900: /* bgp_afi: IPV4 MULTICAST  */
#line 219 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV4_MC; }
#line 11256 "obj/conf/cf-parse.tab.c"
    break;

  case 901: /* bgp_afi: IPV6 MULTICAST  */
#line 220 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV6_MC; }
#line 11262 "obj/conf/cf-parse.tab.c"
    break;

  case 902: /* bgp_afi: IPV4 MPLS  */
#line 221 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV4_MPLS; }
#line 11268 "obj/conf/cf-parse.tab.c"
    break;

  case 903: /* bgp_afi: IPV6 MPLS  */
#line 222 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_IPV6_MPLS; }
#line 11274 "obj/conf/cf-parse.tab.c"
    break;

  case 904: /* bgp_afi: VPN4 MPLS  */
#line 223 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN4_MPLS; }
#line 11280 "obj/conf/cf-parse.tab.c"
    break;

  case 905: /* bgp_afi: VPN6 MPLS  */
#line 224 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN6_MPLS; }
#line 11286 "obj/conf/cf-parse.tab.c"
    break;

  case 906: /* bgp_afi: VPN4 MULTICAST  */
#line 225 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN4_MC; }
#line 11292 "obj/conf/cf-parse.tab.c"
    break;

  case 907: /* bgp_afi: VPN6 MULTICAST  */
#line 226 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_VPN6_MC; }
#line 11298 "obj/conf/cf-parse.tab.c"
    break;

  case 908: /* bgp_afi: FLOW4  */
#line 227 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_FLOW4; }
#line 11304 "obj/conf/cf-parse.tab.c"
    break;

  case 909: /* bgp_afi: FLOW6  */
#line 228 "proto/bgp/config.Y"
                        { (yyval.i32) = BGP_AF_FLOW6; }
#line 11310 "obj/conf/cf-parse.tab.c"
    break;

  case 910: /* bgp_channel_start: bgp_afi  */
#line 232 "proto/bgp/config.Y"
{
  const struct bgp_af_desc *desc = bgp_get_af_desc((yyvsp[0].i32));

  if (!desc)
    cf_error("Unknown AFI/SAFI");

  this_channel = channel_config_get(&channel_bgp, desc->name, desc->net, this_proto);

  /* New channel */
  if (!BGP_CC->desc)
  {
    BGP_CC->c.in_filter = FILTER_UNDEF;
    BGP_CC->c.out_filter = FILTER_UNDEF;
    BGP_CC->c.ra_mode = RA_UNDEF;
    BGP_CC->afi = (yyvsp[0].i32);
    BGP_CC->desc = desc;
    BGP_CC->next_hop_keep = 0xff; /* undefined */
    BGP_CC->gr_able = 0xff;	/* undefined */
    BGP_CC->llgr_able = 0xff;	/* undefined */
    BGP_CC->llgr_time = ~0U;	/* undefined */
    BGP_CC->aigp = 0xff;	/* undefined */
  }
}
#line 11338 "obj/conf/cf-parse.tab.c"
    break;

  case 911: /* bgp_nh: bool  */
#line 257 "proto/bgp/config.Y"
        { (yyval.i) = (yyvsp[0].i); }
#line 11344 "obj/conf/cf-parse.tab.c"
    break;

  case 912: /* bgp_nh: IBGP  */
#line 258 "proto/bgp/config.Y"
        { (yyval.i) = NH_IBGP; }
#line 11350 "obj/conf/cf-parse.tab.c"
    break;

  case 913: /* bgp_nh: EBGP  */
#line 259 "proto/bgp/config.Y"
        { (yyval.i) = NH_EBGP; }
#line 11356 "obj/conf/cf-parse.tab.c"
    break;

  case 918: /* bgp_channel_item: NEXT HOP ADDRESS ipa  */
#line 265 "proto/bgp/config.Y"
                        { BGP_CC->next_hop_addr = (yyvsp[0].a); }
#line 11362 "obj/conf/cf-parse.tab.c"
    break;

  case 919: /* bgp_channel_item: NEXT HOP SELF bgp_nh  */
#line 266 "proto/bgp/config.Y"
                        { BGP_CC->next_hop_self = (yyvsp[0].i); }
#line 11368 "obj/conf/cf-parse.tab.c"
    break;

  case 920: /* bgp_channel_item: NEXT HOP KEEP bgp_nh  */
#line 267 "proto/bgp/config.Y"
                        { BGP_CC->next_hop_keep = (yyvsp[0].i); }
#line 11374 "obj/conf/cf-parse.tab.c"
    break;

  case 921: /* bgp_channel_item: NEXT HOP PREFER GLOBAL  */
#line 268 "proto/bgp/config.Y"
                          { BGP_CC->next_hop_prefer = NHP_GLOBAL; }
#line 11380 "obj/conf/cf-parse.tab.c"
    break;

  case 922: /* bgp_channel_item: MANDATORY bool  */
#line 269 "proto/bgp/config.Y"
                  { BGP_CC->mandatory = (yyvsp[0].i); }
#line 11386 "obj/conf/cf-parse.tab.c"
    break;

  case 923: /* bgp_channel_item: MISSING LLADDR bgp_lladdr  */
#line 270 "proto/bgp/config.Y"
                             { log(L_WARN "%s.%s: Missing lladdr option is deprecated and ignored, remove it", this_proto->name, this_channel->name); }
#line 11392 "obj/conf/cf-parse.tab.c"
    break;

  case 924: /* bgp_channel_item: GATEWAY DIRECT  */
#line 271 "proto/bgp/config.Y"
                  { BGP_CC->gw_mode = GW_DIRECT; }
#line 11398 "obj/conf/cf-parse.tab.c"
    break;

  case 925: /* bgp_channel_item: GATEWAY RECURSIVE  */
#line 272 "proto/bgp/config.Y"
                     { BGP_CC->gw_mode = GW_RECURSIVE; }
#line 11404 "obj/conf/cf-parse.tab.c"
    break;

  case 926: /* bgp_channel_item: SECONDARY bool  */
#line 273 "proto/bgp/config.Y"
                  { BGP_CC->secondary = (yyvsp[0].i); }
#line 11410 "obj/conf/cf-parse.tab.c"
    break;

  case 927: /* bgp_channel_item: VALIDATE bool  */
#line 274 "proto/bgp/config.Y"
                 {
    BGP_CC->validate = (yyvsp[0].i);
    if (BGP_SAFI(BGP_CC->afi) != BGP_SAFI_FLOW)
      cf_error("Validate option limited to flowspec channels");
   }
#line 11420 "obj/conf/cf-parse.tab.c"
    break;

  case 928: /* bgp_channel_item: GRACEFUL RESTART bool  */
#line 279 "proto/bgp/config.Y"
                         { BGP_CC->gr_able = (yyvsp[0].i); }
#line 11426 "obj/conf/cf-parse.tab.c"
    break;

  case 929: /* bgp_channel_item: LONG LIVED GRACEFUL RESTART bool  */
#line 280 "proto/bgp/config.Y"
                                    { BGP_CC->llgr_able = (yyvsp[0].i); }
#line 11432 "obj/conf/cf-parse.tab.c"
    break;

  case 930: /* bgp_channel_item: LONG LIVED STALE TIME expr  */
#line 281 "proto/bgp/config.Y"
                              { BGP_CC->llgr_time = (yyvsp[0].i); }
#line 11438 "obj/conf/cf-parse.tab.c"
    break;

  case 931: /* bgp_channel_item: EXTENDED NEXT HOP bool  */
#line 282 "proto/bgp/config.Y"
                          { BGP_CC->ext_next_hop = (yyvsp[0].i); }
#line 11444 "obj/conf/cf-parse.tab.c"
    break;

  case 932: /* bgp_channel_item: ADD PATHS RX  */
#line 283 "proto/bgp/config.Y"
                { BGP_CC->add_path = BGP_ADD_PATH_RX; }
#line 11450 "obj/conf/cf-parse.tab.c"
    break;

  case 933: /* bgp_channel_item: ADD PATHS TX  */
#line 284 "proto/bgp/config.Y"
                { BGP_CC->add_path = BGP_ADD_PATH_TX; }
#line 11456 "obj/conf/cf-parse.tab.c"
    break;

  case 934: /* bgp_channel_item: ADD PATHS bool  */
#line 285 "proto/bgp/config.Y"
                  { BGP_CC->add_path = (yyvsp[0].i) ? BGP_ADD_PATH_FULL : 0; }
#line 11462 "obj/conf/cf-parse.tab.c"
    break;

  case 935: /* bgp_channel_item: IMPORT TABLE bool  */
#line 286 "proto/bgp/config.Y"
                     { BGP_CC->import_table = (yyvsp[0].i); }
#line 11468 "obj/conf/cf-parse.tab.c"
    break;

  case 936: /* bgp_channel_item: EXPORT TABLE bool  */
#line 287 "proto/bgp/config.Y"
                     { BGP_CC->export_table = (yyvsp[0].i); }
#line 11474 "obj/conf/cf-parse.tab.c"
    break;

  case 937: /* bgp_channel_item: AIGP bool  */
#line 288 "proto/bgp/config.Y"
             { BGP_CC->aigp = (yyvsp[0].i); BGP_CC->aigp_originate = 0; }
#line 11480 "obj/conf/cf-parse.tab.c"
    break;

  case 938: /* bgp_channel_item: AIGP ORIGINATE  */
#line 289 "proto/bgp/config.Y"
                  { BGP_CC->aigp = 1; BGP_CC->aigp_originate = 1; }
#line 11486 "obj/conf/cf-parse.tab.c"
    break;

  case 939: /* bgp_channel_item: COST expr  */
#line 290 "proto/bgp/config.Y"
             { BGP_CC->cost = (yyvsp[0].i); if ((yyvsp[0].i) < 1) cf_error("Cost must be positive"); }
#line 11492 "obj/conf/cf-parse.tab.c"
    break;

  case 940: /* bgp_channel_item: IGP TABLE rtable  */
#line 291 "proto/bgp/config.Y"
                    {
    if (BGP_CC->desc->no_igp)
      cf_error("IGP table not allowed here");

    if ((yyvsp[0].r)->addr_type == NET_IP4)
      BGP_CC->igp_table_ip4 = (yyvsp[0].r);
    else if ((yyvsp[0].r)->addr_type == NET_IP6)
      BGP_CC->igp_table_ip6 = (yyvsp[0].r);
    else
      cf_error("Mismatched IGP table type");
   }
#line 11508 "obj/conf/cf-parse.tab.c"
    break;

  case 941: /* bgp_channel_item: BASE TABLE rtable  */
#line 302 "proto/bgp/config.Y"
                     {
    if (BGP_SAFI(BGP_CC->afi) != BGP_SAFI_FLOW)
      cf_error("Base table option limited to flowspec channels");

    if (((BGP_CC->afi == BGP_AF_FLOW4) && ((yyvsp[0].r)->addr_type == NET_IP4)) ||
        ((BGP_CC->afi == BGP_AF_FLOW6) && ((yyvsp[0].r)->addr_type == NET_IP6)))
      BGP_CC->base_table = (yyvsp[0].r);
    else
      cf_error("Mismatched base table type");
   }
#line 11523 "obj/conf/cf-parse.tab.c"
    break;

  case 946: /* bgp_channel_end: %empty  */
#line 325 "proto/bgp/config.Y"
{
  if (!this_channel->table)
    cf_error("Routing table not specified");

  this_channel = NULL;
}
#line 11534 "obj/conf/cf-parse.tab.c"
    break;

  case 948: /* dynamic_attr: BGP_ORIGIN  */
#line 336 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(PROTOCOL_BGP, BA_ORIGIN)); }
#line 11540 "obj/conf/cf-parse.tab.c"
    break;

  case 949: /* dynamic_attr: BGP_PATH  */
#line 338 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(PROTOCOL_BGP, BA_AS_PATH)); }
#line 11546 "obj/conf/cf-parse.tab.c"
    break;

  case 950: /* dynamic_attr: BGP_NEXT_HOP  */
#line 340 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(PROTOCOL_BGP, BA_NEXT_HOP)); }
#line 11552 "obj/conf/cf-parse.tab.c"
    break;

  case 951: /* dynamic_attr: BGP_MED  */
#line 342 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_MULTI_EXIT_DISC)); }
#line 11558 "obj/conf/cf-parse.tab.c"
    break;

  case 952: /* dynamic_attr: BGP_LOCAL_PREF  */
#line 344 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_LOCAL_PREF)); }
#line 11564 "obj/conf/cf-parse.tab.c"
    break;

  case 953: /* dynamic_attr: BGP_ATOMIC_AGGR  */
#line 346 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_ATOMIC_AGGR)); }
#line 11570 "obj/conf/cf-parse.tab.c"
    break;

  case 954: /* dynamic_attr: BGP_AGGREGATOR  */
#line 348 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_AGGREGATOR)); }
#line 11576 "obj/conf/cf-parse.tab.c"
    break;

  case 955: /* dynamic_attr: BGP_COMMUNITY  */
#line 350 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(PROTOCOL_BGP, BA_COMMUNITY)); }
#line 11582 "obj/conf/cf-parse.tab.c"
    break;

  case 956: /* dynamic_attr: BGP_ORIGINATOR_ID  */
#line 352 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(PROTOCOL_BGP, BA_ORIGINATOR_ID)); }
#line 11588 "obj/conf/cf-parse.tab.c"
    break;

  case 957: /* dynamic_attr: BGP_CLUSTER_LIST  */
#line 354 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(PROTOCOL_BGP, BA_CLUSTER_LIST)); }
#line 11594 "obj/conf/cf-parse.tab.c"
    break;

  case 958: /* dynamic_attr: BGP_EXT_COMMUNITY  */
#line 356 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(PROTOCOL_BGP, BA_EXT_COMMUNITY)); }
#line 11600 "obj/conf/cf-parse.tab.c"
    break;

  case 959: /* dynamic_attr: BGP_AIGP  */
#line 358 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(PROTOCOL_BGP, BA_AIGP)); }
#line 11606 "obj/conf/cf-parse.tab.c"
    break;

  case 960: /* dynamic_attr: BGP_LARGE_COMMUNITY  */
#line 360 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(PROTOCOL_BGP, BA_LARGE_COMMUNITY)); }
#line 11612 "obj/conf/cf-parse.tab.c"
    break;

  case 961: /* dynamic_attr: BGP_OTC  */
#line 362 "proto/bgp/config.Y"
        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(PROTOCOL_BGP, BA_ONLY_TO_CUSTOMER)); }
#line 11618 "obj/conf/cf-parse.tab.c"
    break;

  case 963: /* mrt_proto_start: proto_start MRT  */
#line 29 "proto/mrt/config.Y"
{
  this_proto = proto_config_new(&proto_mrt, (yyvsp[-1].i));
}
#line 11626 "obj/conf/cf-parse.tab.c"
    break;

  case 965: /* mrt_proto_item: TABLE rtable  */
#line 35 "proto/mrt/config.Y"
                        { MRT_CFG->table_cf = (yyvsp[0].r); }
#line 11632 "obj/conf/cf-parse.tab.c"
    break;

  case 966: /* mrt_proto_item: TABLE TEXT  */
#line 36 "proto/mrt/config.Y"
                        { MRT_CFG->table_expr = (yyvsp[0].t); }
#line 11638 "obj/conf/cf-parse.tab.c"
    break;

  case 967: /* mrt_proto_item: FILTER filter  */
#line 37 "proto/mrt/config.Y"
                        { MRT_CFG->filter = (yyvsp[0].f); }
#line 11644 "obj/conf/cf-parse.tab.c"
    break;

  case 968: /* mrt_proto_item: where_filter  */
#line 38 "proto/mrt/config.Y"
                        { MRT_CFG->filter = (yyvsp[0].f); }
#line 11650 "obj/conf/cf-parse.tab.c"
    break;

  case 969: /* mrt_proto_item: FILENAME text  */
#line 39 "proto/mrt/config.Y"
                        { MRT_CFG->filename = (yyvsp[0].t); }
#line 11656 "obj/conf/cf-parse.tab.c"
    break;

  case 970: /* mrt_proto_item: PERIOD expr  */
#line 40 "proto/mrt/config.Y"
                        { MRT_CFG->period = (yyvsp[0].i); }
#line 11662 "obj/conf/cf-parse.tab.c"
    break;

  case 971: /* mrt_proto_item: ALWAYS ADD PATH bool  */
#line 41 "proto/mrt/config.Y"
                        { MRT_CFG->always_add_path = (yyvsp[0].i); }
#line 11668 "obj/conf/cf-parse.tab.c"
    break;

  case 974: /* mrt_proto: mrt_proto_start proto_name '{' mrt_proto_opts '}'  */
#line 50 "proto/mrt/config.Y"
                                                     { mrt_check_config(this_proto); }
#line 11674 "obj/conf/cf-parse.tab.c"
    break;

  case 976: /* cmd_MRT_DUMP: MRT DUMP mrt_dump_args END  */
#line 54 "proto/mrt/config.Y"
{ mrt_dump_cmd((yyvsp[-1].md)); }
#line 11680 "obj/conf/cf-parse.tab.c"
    break;

  case 977: /* mrt_dump_args: %empty  */
#line 57 "proto/mrt/config.Y"
               { (yyval.md) = cfg_allocz(sizeof(struct mrt_dump_data)); }
#line 11686 "obj/conf/cf-parse.tab.c"
    break;

  case 978: /* mrt_dump_args: mrt_dump_args TABLE rtable  */
#line 58 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_ptr = (yyvsp[0].r)->table; }
#line 11692 "obj/conf/cf-parse.tab.c"
    break;

  case 979: /* mrt_dump_args: mrt_dump_args TABLE TEXT  */
#line 59 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_expr = (yyvsp[0].t); }
#line 11698 "obj/conf/cf-parse.tab.c"
    break;

  case 980: /* mrt_dump_args: mrt_dump_args FILTER filter  */
#line 60 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 11704 "obj/conf/cf-parse.tab.c"
    break;

  case 981: /* mrt_dump_args: mrt_dump_args where_filter  */
#line 61 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-1].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 11710 "obj/conf/cf-parse.tab.c"
    break;

  case 982: /* mrt_dump_args: mrt_dump_args TO text  */
#line 62 "proto/mrt/config.Y"
                                { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filename = (yyvsp[0].t); }
#line 11716 "obj/conf/cf-parse.tab.c"
    break;

  case 983: /* proto: ospf_proto '}'  */
#line 211 "proto/ospf/config.Y"
                      { ospf_proto_finish(); }
#line 11722 "obj/conf/cf-parse.tab.c"
    break;

  case 984: /* ospf_variant: OSPF  */
#line 214 "proto/ospf/config.Y"
           { (yyval.i) = 1; }
#line 11728 "obj/conf/cf-parse.tab.c"
    break;

  case 985: /* ospf_variant: OSPF V2  */
#line 215 "proto/ospf/config.Y"
           { (yyval.i) = 1; }
#line 11734 "obj/conf/cf-parse.tab.c"
    break;

  case 986: /* ospf_variant: OSPF V3  */
#line 216 "proto/ospf/config.Y"
           { (yyval.i) = 0; }
#line 11740 "obj/conf/cf-parse.tab.c"
    break;

  case 987: /* ospf_proto_start: proto_start ospf_variant  */
#line 220 "proto/ospf/config.Y"
{
  this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
  this_proto->net_type = (yyvsp[0].i) ? NET_IP4 : 0;

  init_list(&OSPF_CFG->area_list);
  init_list(&OSPF_CFG->vlink_list);
  OSPF_CFG->ecmp = rt_default_ecmp;
  OSPF_CFG->tick = OSPF_DEFAULT_TICK;
  OSPF_CFG->ospf2 = (yyvsp[0].i);
  OSPF_CFG->af_ext = !(yyvsp[0].i);
  OSPF_CFG->gr_mode = OSPF_GR_AWARE;
  OSPF_CFG->gr_time = OSPF_DEFAULT_GR_TIME;
}
#line 11758 "obj/conf/cf-parse.tab.c"
    break;

  case 990: /* ospf_af_mc: %empty  */
#line 240 "proto/ospf/config.Y"
             { (yyval.i) = 0; }
#line 11764 "obj/conf/cf-parse.tab.c"
    break;

  case 991: /* ospf_af_mc: MULTICAST  */
#line 241 "proto/ospf/config.Y"
             { (yyval.i) = 1; }
#line 11770 "obj/conf/cf-parse.tab.c"
    break;

  case 992: /* ospf_channel_start: net_type ospf_af_mc  */
#line 246 "proto/ospf/config.Y"
{
  /* TODO: change name for multicast channels */
  (yyval.cc) = this_channel = channel_config_get(NULL, net_label[(yyvsp[-1].i)], (yyvsp[-1].i), this_proto);

  /* Save the multicast flag */
  OSPF_CFG->af_mc = (yyvsp[0].i);
}
#line 11782 "obj/conf/cf-parse.tab.c"
    break;

  case 995: /* ospf_proto_item: ospf_channel  */
#line 258 "proto/ospf/config.Y"
                { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 11788 "obj/conf/cf-parse.tab.c"
    break;

  case 996: /* ospf_proto_item: RFC1583COMPAT bool  */
#line 259 "proto/ospf/config.Y"
                      { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 11794 "obj/conf/cf-parse.tab.c"
    break;

  case 997: /* ospf_proto_item: RFC5838 bool  */
#line 260 "proto/ospf/config.Y"
                { OSPF_CFG->af_ext = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("RFC5838 option requires OSPFv3"); }
#line 11800 "obj/conf/cf-parse.tab.c"
    break;

  case 998: /* ospf_proto_item: VPN PE bool  */
#line 261 "proto/ospf/config.Y"
               { OSPF_CFG->vpn_pe = (yyvsp[0].i); }
#line 11806 "obj/conf/cf-parse.tab.c"
    break;

  case 999: /* ospf_proto_item: STUB ROUTER bool  */
#line 262 "proto/ospf/config.Y"
                    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 11812 "obj/conf/cf-parse.tab.c"
    break;

  case 1000: /* ospf_proto_item: GRACEFUL RESTART bool  */
#line 263 "proto/ospf/config.Y"
                         { OSPF_CFG->gr_mode = (yyvsp[0].i); }
#line 11818 "obj/conf/cf-parse.tab.c"
    break;

  case 1001: /* ospf_proto_item: GRACEFUL RESTART AWARE  */
#line 264 "proto/ospf/config.Y"
                          { OSPF_CFG->gr_mode = OSPF_GR_AWARE; }
#line 11824 "obj/conf/cf-parse.tab.c"
    break;

  case 1002: /* ospf_proto_item: GRACEFUL RESTART TIME expr  */
#line 265 "proto/ospf/config.Y"
                              { OSPF_CFG->gr_time = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 1800)) cf_error("Graceful restart time must be in range 1-1800"); }
#line 11830 "obj/conf/cf-parse.tab.c"
    break;

  case 1003: /* ospf_proto_item: ECMP bool  */
#line 266 "proto/ospf/config.Y"
             { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 11836 "obj/conf/cf-parse.tab.c"
    break;

  case 1004: /* ospf_proto_item: ECMP bool LIMIT expr  */
#line 267 "proto/ospf/config.Y"
                        { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; }
#line 11842 "obj/conf/cf-parse.tab.c"
    break;

  case 1005: /* ospf_proto_item: MERGE EXTERNAL bool  */
#line 268 "proto/ospf/config.Y"
                       { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 11848 "obj/conf/cf-parse.tab.c"
    break;

  case 1006: /* ospf_proto_item: TICK expr  */
#line 269 "proto/ospf/config.Y"
             { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i) <= 0) cf_error("Tick must be greater than zero"); }
#line 11854 "obj/conf/cf-parse.tab.c"
    break;

  case 1007: /* ospf_proto_item: INSTANCE ID expr  */
#line 270 "proto/ospf/config.Y"
                    { OSPF_CFG->instance_id = (yyvsp[0].i); OSPF_CFG->instance_id_set = 1; if ((yyvsp[0].i) > 255) cf_error("Instance ID must be in range 0-255"); }
#line 11860 "obj/conf/cf-parse.tab.c"
    break;

  case 1009: /* ospf_area_start: AREA idval  */
#line 274 "proto/ospf/config.Y"
                            {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 11878 "obj/conf/cf-parse.tab.c"
    break;

  case 1010: /* ospf_area: ospf_area_start '{' ospf_area_opts '}'  */
#line 289 "proto/ospf/config.Y"
                                                  { ospf_area_finish(); }
#line 11884 "obj/conf/cf-parse.tab.c"
    break;

  case 1013: /* ospf_area_item: STUB bool  */
#line 298 "proto/ospf/config.Y"
             { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 11890 "obj/conf/cf-parse.tab.c"
    break;

  case 1014: /* ospf_area_item: NSSA  */
#line 299 "proto/ospf/config.Y"
        { this_area->type = OPT_N; }
#line 11896 "obj/conf/cf-parse.tab.c"
    break;

  case 1015: /* ospf_area_item: SUMMARY bool  */
#line 300 "proto/ospf/config.Y"
                { this_area->summary = (yyvsp[0].i); }
#line 11902 "obj/conf/cf-parse.tab.c"
    break;

  case 1016: /* ospf_area_item: DEFAULT NSSA bool  */
#line 301 "proto/ospf/config.Y"
                     { this_area->default_nssa = (yyvsp[0].i); }
#line 11908 "obj/conf/cf-parse.tab.c"
    break;

  case 1017: /* ospf_area_item: DEFAULT COST expr  */
#line 302 "proto/ospf/config.Y"
                     { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 11914 "obj/conf/cf-parse.tab.c"
    break;

  case 1018: /* ospf_area_item: DEFAULT COST2 expr  */
#line 303 "proto/ospf/config.Y"
                      { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 11920 "obj/conf/cf-parse.tab.c"
    break;

  case 1019: /* ospf_area_item: STUB COST expr  */
#line 304 "proto/ospf/config.Y"
                  { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 11926 "obj/conf/cf-parse.tab.c"
    break;

  case 1020: /* ospf_area_item: TRANSLATOR bool  */
#line 305 "proto/ospf/config.Y"
                   { this_area->translator = (yyvsp[0].i); }
#line 11932 "obj/conf/cf-parse.tab.c"
    break;

  case 1021: /* ospf_area_item: TRANSLATOR STABILITY expr  */
#line 306 "proto/ospf/config.Y"
                             { this_area->transint = (yyvsp[0].i); }
#line 11938 "obj/conf/cf-parse.tab.c"
    break;

  case 1022: /* $@11: %empty  */
#line 307 "proto/ospf/config.Y"
            { this_nets = &this_area->net_list; }
#line 11944 "obj/conf/cf-parse.tab.c"
    break;

  case 1024: /* $@12: %empty  */
#line 308 "proto/ospf/config.Y"
            { this_nets = &this_area->enet_list; }
#line 11950 "obj/conf/cf-parse.tab.c"
    break;

  case 1031: /* ospf_stubnet_start: net_ip  */
#line 320 "proto/ospf/config.Y"
          {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->prefix = (yyvsp[0].net);
     this_stubnet->cost = COST_D;
   }
#line 11961 "obj/conf/cf-parse.tab.c"
    break;

  case 1034: /* ospf_stubnet_item: HIDDEN bool  */
#line 334 "proto/ospf/config.Y"
               { this_stubnet->hidden = (yyvsp[0].i); }
#line 11967 "obj/conf/cf-parse.tab.c"
    break;

  case 1035: /* ospf_stubnet_item: SUMMARY bool  */
#line 335 "proto/ospf/config.Y"
                { this_stubnet->summary = (yyvsp[0].i); }
#line 11973 "obj/conf/cf-parse.tab.c"
    break;

  case 1036: /* ospf_stubnet_item: COST expr  */
#line 336 "proto/ospf/config.Y"
             { this_stubnet->cost = (yyvsp[0].i); }
#line 11979 "obj/conf/cf-parse.tab.c"
    break;

  case 1037: /* ospf_vlink: ospf_vlink_start ospf_instance_id '{' ospf_vlink_opts '}'  */
#line 340 "proto/ospf/config.Y"
                                                             { ospf_iface_finish(); }
#line 11985 "obj/conf/cf-parse.tab.c"
    break;

  case 1038: /* ospf_vlink: ospf_vlink_start ospf_instance_id  */
#line 341 "proto/ospf/config.Y"
                                     { ospf_iface_finish(); }
#line 11991 "obj/conf/cf-parse.tab.c"
    break;

  case 1042: /* ospf_vlink_item: HELLO expr  */
#line 350 "proto/ospf/config.Y"
              { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 11997 "obj/conf/cf-parse.tab.c"
    break;

  case 1043: /* ospf_vlink_item: RETRANSMIT expr  */
#line 351 "proto/ospf/config.Y"
                   { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 12003 "obj/conf/cf-parse.tab.c"
    break;

  case 1044: /* ospf_vlink_item: TRANSMIT DELAY expr  */
#line 352 "proto/ospf/config.Y"
                       { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 12009 "obj/conf/cf-parse.tab.c"
    break;

  case 1045: /* ospf_vlink_item: WAIT expr  */
#line 353 "proto/ospf/config.Y"
             { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 12015 "obj/conf/cf-parse.tab.c"
    break;

  case 1046: /* ospf_vlink_item: DEAD expr  */
#line 354 "proto/ospf/config.Y"
             { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 12021 "obj/conf/cf-parse.tab.c"
    break;

  case 1047: /* ospf_vlink_item: DEAD COUNT expr  */
#line 355 "proto/ospf/config.Y"
                   { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 12027 "obj/conf/cf-parse.tab.c"
    break;

  case 1048: /* ospf_vlink_item: AUTHENTICATION NONE  */
#line 356 "proto/ospf/config.Y"
                       { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 12033 "obj/conf/cf-parse.tab.c"
    break;

  case 1049: /* ospf_vlink_item: AUTHENTICATION SIMPLE  */
#line 357 "proto/ospf/config.Y"
                         { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 12039 "obj/conf/cf-parse.tab.c"
    break;

  case 1050: /* ospf_vlink_item: AUTHENTICATION CRYPTOGRAPHIC  */
#line 358 "proto/ospf/config.Y"
                                { OSPF_PATT->autype = OSPF_AUTH_CRYPT; }
#line 12045 "obj/conf/cf-parse.tab.c"
    break;

  case 1052: /* ospf_vlink_start: VIRTUAL LINK idval  */
#line 363 "proto/ospf/config.Y"
 {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 12065 "obj/conf/cf-parse.tab.c"
    break;

  case 1053: /* ospf_iface_item: COST expr  */
#line 381 "proto/ospf/config.Y"
             { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 12071 "obj/conf/cf-parse.tab.c"
    break;

  case 1054: /* ospf_iface_item: HELLO expr  */
#line 382 "proto/ospf/config.Y"
              { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 12077 "obj/conf/cf-parse.tab.c"
    break;

  case 1055: /* ospf_iface_item: POLL expr  */
#line 383 "proto/ospf/config.Y"
             { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 12083 "obj/conf/cf-parse.tab.c"
    break;

  case 1056: /* ospf_iface_item: RETRANSMIT expr  */
#line 384 "proto/ospf/config.Y"
                   { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 12089 "obj/conf/cf-parse.tab.c"
    break;

  case 1057: /* ospf_iface_item: WAIT expr  */
#line 385 "proto/ospf/config.Y"
             { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 12095 "obj/conf/cf-parse.tab.c"
    break;

  case 1058: /* ospf_iface_item: DEAD expr  */
#line 386 "proto/ospf/config.Y"
             { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 12101 "obj/conf/cf-parse.tab.c"
    break;

  case 1059: /* ospf_iface_item: DEAD COUNT expr  */
#line 387 "proto/ospf/config.Y"
                   { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 12107 "obj/conf/cf-parse.tab.c"
    break;

  case 1060: /* ospf_iface_item: TYPE BROADCAST  */
#line 388 "proto/ospf/config.Y"
                  { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 12113 "obj/conf/cf-parse.tab.c"
    break;

  case 1061: /* ospf_iface_item: TYPE BCAST  */
#line 389 "proto/ospf/config.Y"
              { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 12119 "obj/conf/cf-parse.tab.c"
    break;

  case 1062: /* ospf_iface_item: TYPE NONBROADCAST  */
#line 390 "proto/ospf/config.Y"
                     { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 12125 "obj/conf/cf-parse.tab.c"
    break;

  case 1063: /* ospf_iface_item: TYPE NBMA  */
#line 391 "proto/ospf/config.Y"
             { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 12131 "obj/conf/cf-parse.tab.c"
    break;

  case 1064: /* ospf_iface_item: TYPE POINTOPOINT  */
#line 392 "proto/ospf/config.Y"
                    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 12137 "obj/conf/cf-parse.tab.c"
    break;

  case 1065: /* ospf_iface_item: TYPE PTP  */
#line 393 "proto/ospf/config.Y"
            { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 12143 "obj/conf/cf-parse.tab.c"
    break;

  case 1066: /* ospf_iface_item: TYPE POINTOMULTIPOINT  */
#line 394 "proto/ospf/config.Y"
                         { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 12149 "obj/conf/cf-parse.tab.c"
    break;

  case 1067: /* ospf_iface_item: TYPE PTMP  */
#line 395 "proto/ospf/config.Y"
             { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 12155 "obj/conf/cf-parse.tab.c"
    break;

  case 1068: /* ospf_iface_item: REAL BROADCAST bool  */
#line 396 "proto/ospf/config.Y"
                       { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 12161 "obj/conf/cf-parse.tab.c"
    break;

  case 1069: /* ospf_iface_item: PTP NETMASK bool  */
#line 397 "proto/ospf/config.Y"
                    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 12167 "obj/conf/cf-parse.tab.c"
    break;

  case 1070: /* ospf_iface_item: PTP ADDRESS bool  */
#line 398 "proto/ospf/config.Y"
                    { OSPF_PATT->ptp_address = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP address option requires OSPFv2"); }
#line 12173 "obj/conf/cf-parse.tab.c"
    break;

  case 1071: /* ospf_iface_item: TRANSMIT DELAY expr  */
#line 399 "proto/ospf/config.Y"
                       { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 12179 "obj/conf/cf-parse.tab.c"
    break;

  case 1072: /* ospf_iface_item: PRIORITY expr  */
#line 400 "proto/ospf/config.Y"
                 { OSPF_PATT->priority = (yyvsp[0].i) ; if ((yyvsp[0].i)>255) cf_error("Priority must be in range 0-255"); }
#line 12185 "obj/conf/cf-parse.tab.c"
    break;

  case 1073: /* ospf_iface_item: STRICT NONBROADCAST bool  */
#line 401 "proto/ospf/config.Y"
                            { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 12191 "obj/conf/cf-parse.tab.c"
    break;

  case 1074: /* ospf_iface_item: STUB bool  */
#line 402 "proto/ospf/config.Y"
             { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 12197 "obj/conf/cf-parse.tab.c"
    break;

  case 1075: /* ospf_iface_item: CHECK LINK bool  */
#line 403 "proto/ospf/config.Y"
                   { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 12203 "obj/conf/cf-parse.tab.c"
    break;

  case 1076: /* ospf_iface_item: ECMP WEIGHT expr  */
#line 404 "proto/ospf/config.Y"
                    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 12209 "obj/conf/cf-parse.tab.c"
    break;

  case 1077: /* ospf_iface_item: LINK LSA SUPPRESSION bool  */
#line 405 "proto/ospf/config.Y"
                             { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 12215 "obj/conf/cf-parse.tab.c"
    break;

  case 1079: /* ospf_iface_item: AUTHENTICATION NONE  */
#line 407 "proto/ospf/config.Y"
                       { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 12221 "obj/conf/cf-parse.tab.c"
    break;

  case 1080: /* ospf_iface_item: AUTHENTICATION SIMPLE  */
#line 408 "proto/ospf/config.Y"
                         { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 12227 "obj/conf/cf-parse.tab.c"
    break;

  case 1081: /* ospf_iface_item: AUTHENTICATION CRYPTOGRAPHIC  */
#line 409 "proto/ospf/config.Y"
                                { OSPF_PATT->autype = OSPF_AUTH_CRYPT; }
#line 12233 "obj/conf/cf-parse.tab.c"
    break;

  case 1082: /* ospf_iface_item: RX BUFFER NORMAL  */
#line 410 "proto/ospf/config.Y"
                    { OSPF_PATT->rx_buffer = 0; }
#line 12239 "obj/conf/cf-parse.tab.c"
    break;

  case 1083: /* ospf_iface_item: RX BUFFER LARGE  */
#line 411 "proto/ospf/config.Y"
                   { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 12245 "obj/conf/cf-parse.tab.c"
    break;

  case 1084: /* ospf_iface_item: RX BUFFER expr  */
#line 412 "proto/ospf/config.Y"
                  { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 12251 "obj/conf/cf-parse.tab.c"
    break;

  case 1085: /* ospf_iface_item: TX tos  */
#line 413 "proto/ospf/config.Y"
          { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 12257 "obj/conf/cf-parse.tab.c"
    break;

  case 1086: /* ospf_iface_item: TX PRIORITY expr  */
#line 414 "proto/ospf/config.Y"
                    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 12263 "obj/conf/cf-parse.tab.c"
    break;

  case 1087: /* ospf_iface_item: TX LENGTH expr  */
#line 415 "proto/ospf/config.Y"
                  { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 12269 "obj/conf/cf-parse.tab.c"
    break;

  case 1088: /* ospf_iface_item: TTL SECURITY bool  */
#line 416 "proto/ospf/config.Y"
                     { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 12275 "obj/conf/cf-parse.tab.c"
    break;

  case 1089: /* ospf_iface_item: TTL SECURITY TX ONLY  */
#line 417 "proto/ospf/config.Y"
                        { OSPF_PATT->ttl_security = 2; }
#line 12281 "obj/conf/cf-parse.tab.c"
    break;

  case 1090: /* ospf_iface_item: BFD bool  */
#line 418 "proto/ospf/config.Y"
            { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 12287 "obj/conf/cf-parse.tab.c"
    break;

  case 1095: /* pref_base: net_ip  */
#line 430 "proto/ospf/config.Y"
 {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->prefix = (yyvsp[0].net);
 }
#line 12297 "obj/conf/cf-parse.tab.c"
    break;

  case 1097: /* pref_opt: HIDDEN  */
#line 439 "proto/ospf/config.Y"
          { this_pref->hidden = 1; }
#line 12303 "obj/conf/cf-parse.tab.c"
    break;

  case 1098: /* pref_opt: TAG expr  */
#line 440 "proto/ospf/config.Y"
            { this_pref->tag = (yyvsp[0].i); }
#line 12309 "obj/conf/cf-parse.tab.c"
    break;

  case 1101: /* nbma_eligible: %empty  */
#line 449 "proto/ospf/config.Y"
             { (yyval.i) = 0; }
#line 12315 "obj/conf/cf-parse.tab.c"
    break;

  case 1102: /* nbma_eligible: ELIGIBLE  */
#line 450 "proto/ospf/config.Y"
            { (yyval.i) = 1; }
#line 12321 "obj/conf/cf-parse.tab.c"
    break;

  case 1103: /* nbma_item: ipa nbma_eligible ';'  */
#line 454 "proto/ospf/config.Y"
 {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 12332 "obj/conf/cf-parse.tab.c"
    break;

  case 1104: /* ospf_iface_start: %empty  */
#line 463 "proto/ospf/config.Y"
 {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->check_link = 1;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->ptp_address = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 12357 "obj/conf/cf-parse.tab.c"
    break;

  case 1106: /* ospf_instance_id: INSTANCE expr  */
#line 487 "proto/ospf/config.Y"
                 { OSPF_PATT->instance_id = (yyvsp[0].i); OSPF_PATT->instance_id_set = 1; if ((yyvsp[0].i) > 255) cf_error("Instance ID must be in range 0-255"); }
#line 12363 "obj/conf/cf-parse.tab.c"
    break;

  case 1107: /* $@13: %empty  */
#line 491 "proto/ospf/config.Y"
                   { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 12369 "obj/conf/cf-parse.tab.c"
    break;

  case 1113: /* ospf_iface: ospf_iface_start ospf_iface_patt_list ospf_iface_opt_list  */
#line 505 "proto/ospf/config.Y"
                                                            { ospf_iface_finish(); }
#line 12375 "obj/conf/cf-parse.tab.c"
    break;

  case 1114: /* dynamic_attr: OSPF_METRIC1  */
#line 508 "proto/ospf/config.Y"
                           { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_METRIC1); }
#line 12381 "obj/conf/cf-parse.tab.c"
    break;

  case 1115: /* dynamic_attr: OSPF_METRIC2  */
#line 509 "proto/ospf/config.Y"
                           { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_METRIC2); }
#line 12387 "obj/conf/cf-parse.tab.c"
    break;

  case 1116: /* dynamic_attr: OSPF_TAG  */
#line 510 "proto/ospf/config.Y"
                       { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_OSPF_TAG); }
#line 12393 "obj/conf/cf-parse.tab.c"
    break;

  case 1117: /* dynamic_attr: OSPF_ROUTER_ID  */
#line 511 "proto/ospf/config.Y"
                             { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 12399 "obj/conf/cf-parse.tab.c"
    break;

  case 1119: /* cmd_SHOW_OSPF: SHOW OSPF optproto END  */
#line 515 "proto/ospf/config.Y"
{ PROTO_WALK_CMD((yyvsp[-1].s), &proto_ospf, p) ospf_sh(p); }
#line 12405 "obj/conf/cf-parse.tab.c"
    break;

  case 1121: /* cmd_SHOW_OSPF_NEIGHBORS: SHOW OSPF NEIGHBORS optproto opttext END  */
#line 518 "proto/ospf/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_ospf, p) ospf_sh_neigh(p, (yyvsp[-1].t)); }
#line 12411 "obj/conf/cf-parse.tab.c"
    break;

  case 1123: /* cmd_SHOW_OSPF_INTERFACE: SHOW OSPF INTERFACE optproto opttext END  */
#line 521 "proto/ospf/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_ospf, p) ospf_sh_iface(p, (yyvsp[-1].t)); }
#line 12417 "obj/conf/cf-parse.tab.c"
    break;

  case 1125: /* cmd_SHOW_OSPF_TOPOLOGY: SHOW OSPF TOPOLOGY optproto opttext END  */
#line 526 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 12423 "obj/conf/cf-parse.tab.c"
    break;

  case 1127: /* cmd_SHOW_OSPF_TOPOLOGY_ALL: SHOW OSPF TOPOLOGY ALL optproto opttext END  */
#line 529 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 12429 "obj/conf/cf-parse.tab.c"
    break;

  case 1129: /* cmd_SHOW_OSPF_STATE: SHOW OSPF STATE optproto opttext END  */
#line 534 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 12435 "obj/conf/cf-parse.tab.c"
    break;

  case 1131: /* cmd_SHOW_OSPF_STATE_ALL: SHOW OSPF STATE ALL optproto opttext END  */
#line 537 "proto/ospf/config.Y"
{ ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 12441 "obj/conf/cf-parse.tab.c"
    break;

  case 1133: /* cmd_SHOW_OSPF_LSADB: SHOW OSPF LSADB lsadb_args END  */
#line 541 "proto/ospf/config.Y"
{
  if (!(yyvsp[-1].ld)->proto)
    (yyvsp[-1].ld)->proto = (struct ospf_proto *) proto_get_named(NULL, &proto_ospf);

  ospf_sh_lsadb((yyvsp[-1].ld));
}
#line 12452 "obj/conf/cf-parse.tab.c"
    break;

  case 1134: /* lsadb_args: %empty  */
#line 549 "proto/ospf/config.Y"
               {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 12460 "obj/conf/cf-parse.tab.c"
    break;

  case 1135: /* lsadb_args: lsadb_args GLOBAL  */
#line 552 "proto/ospf/config.Y"
                     { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 12466 "obj/conf/cf-parse.tab.c"
    break;

  case 1136: /* lsadb_args: lsadb_args AREA idval  */
#line 553 "proto/ospf/config.Y"
                         { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 12472 "obj/conf/cf-parse.tab.c"
    break;

  case 1137: /* lsadb_args: lsadb_args LINK  */
#line 554 "proto/ospf/config.Y"
                   { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 12478 "obj/conf/cf-parse.tab.c"
    break;

  case 1138: /* lsadb_args: lsadb_args TYPE NUM  */
#line 555 "proto/ospf/config.Y"
                       { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 12484 "obj/conf/cf-parse.tab.c"
    break;

  case 1139: /* lsadb_args: lsadb_args LSID idval  */
#line 556 "proto/ospf/config.Y"
                         { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 12490 "obj/conf/cf-parse.tab.c"
    break;

  case 1140: /* lsadb_args: lsadb_args SELF  */
#line 557 "proto/ospf/config.Y"
                   { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 12496 "obj/conf/cf-parse.tab.c"
    break;

  case 1141: /* lsadb_args: lsadb_args ROUTER idval  */
#line 558 "proto/ospf/config.Y"
                           { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 12502 "obj/conf/cf-parse.tab.c"
    break;

  case 1142: /* lsadb_args: lsadb_args CF_SYM_KNOWN  */
#line 559 "proto/ospf/config.Y"
                           { cf_assert_symbol((yyvsp[0].s), SYM_PROTO); (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->proto = (struct ospf_proto *) proto_get_named((yyvsp[0].s), &proto_ospf); }
#line 12508 "obj/conf/cf-parse.tab.c"
    break;

  case 1144: /* perf_proto_start: proto_start PERF  */
#line 27 "proto/perf/config.Y"
{
  this_proto = proto_config_new(&proto_perf, (yyvsp[-1].i));
  PERF_CFG->from = 10;
  PERF_CFG->to = 20;
  PERF_CFG->repeat = 4;
  PERF_CFG->threshold_max = 500 MS_;
  PERF_CFG->threshold_min = 1 MS_;
  PERF_CFG->attrs_per_rte = 0;
  PERF_CFG->keep = 0;
  PERF_CFG->mode = PERF_MODE_IMPORT;
}
#line 12524 "obj/conf/cf-parse.tab.c"
    break;

  case 1148: /* perf_proto_item: proto_channel  */
#line 46 "proto/perf/config.Y"
                 { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 12530 "obj/conf/cf-parse.tab.c"
    break;

  case 1149: /* perf_proto_item: EXP FROM NUM  */
#line 47 "proto/perf/config.Y"
                { PERF_CFG->from = (yyvsp[0].i); }
#line 12536 "obj/conf/cf-parse.tab.c"
    break;

  case 1150: /* perf_proto_item: EXP TO NUM  */
#line 48 "proto/perf/config.Y"
              { PERF_CFG->to = (yyvsp[0].i); }
#line 12542 "obj/conf/cf-parse.tab.c"
    break;

  case 1151: /* perf_proto_item: REPEAT NUM  */
#line 49 "proto/perf/config.Y"
              { PERF_CFG->repeat = (yyvsp[0].i); }
#line 12548 "obj/conf/cf-parse.tab.c"
    break;

  case 1152: /* perf_proto_item: THRESHOLD MIN expr_us  */
#line 50 "proto/perf/config.Y"
                         { PERF_CFG->threshold_min = (yyvsp[0].time); }
#line 12554 "obj/conf/cf-parse.tab.c"
    break;

  case 1153: /* perf_proto_item: THRESHOLD MAX expr_us  */
#line 51 "proto/perf/config.Y"
                         { PERF_CFG->threshold_max = (yyvsp[0].time); }
#line 12560 "obj/conf/cf-parse.tab.c"
    break;

  case 1154: /* perf_proto_item: ATTRIBUTES NUM  */
#line 52 "proto/perf/config.Y"
                  { PERF_CFG->attrs_per_rte = (yyvsp[0].i); }
#line 12566 "obj/conf/cf-parse.tab.c"
    break;

  case 1155: /* perf_proto_item: KEEP bool  */
#line 53 "proto/perf/config.Y"
             { PERF_CFG->keep = (yyvsp[0].i); }
#line 12572 "obj/conf/cf-parse.tab.c"
    break;

  case 1156: /* perf_proto_item: MODE IMPORT  */
#line 54 "proto/perf/config.Y"
               { PERF_CFG->mode = PERF_MODE_IMPORT; }
#line 12578 "obj/conf/cf-parse.tab.c"
    break;

  case 1157: /* perf_proto_item: MODE EXPORT  */
#line 55 "proto/perf/config.Y"
               { PERF_CFG->mode = PERF_MODE_EXPORT; }
#line 12584 "obj/conf/cf-parse.tab.c"
    break;

  case 1158: /* proto: pipe_proto '}'  */
#line 23 "proto/pipe/config.Y"
                      { this_channel = NULL; }
#line 12590 "obj/conf/cf-parse.tab.c"
    break;

  case 1159: /* $@14: %empty  */
#line 26 "proto/pipe/config.Y"
{
  this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
}
#line 12598 "obj/conf/cf-parse.tab.c"
    break;

  case 1160: /* pipe_proto_start: proto_start PIPE $@14 proto_name  */
#line 30 "proto/pipe/config.Y"
{
  this_channel = proto_cf_main_channel(this_proto);
  if (!this_channel) {
    this_channel = channel_config_new(NULL, NULL, 0, this_proto);
    this_channel->in_filter = FILTER_ACCEPT;
    this_channel->out_filter = FILTER_ACCEPT;
  }
}
#line 12611 "obj/conf/cf-parse.tab.c"
    break;

  case 1164: /* pipe_proto: pipe_proto PEER TABLE rtable ';'  */
#line 43 "proto/pipe/config.Y"
                                    { PIPE_CFG->peer = (yyvsp[-1].r); }
#line 12617 "obj/conf/cf-parse.tab.c"
    break;

  case 1166: /* radv_proto_start: proto_start RADV  */
#line 47 "proto/radv/config.Y"
{
  this_proto = proto_config_new(&proto_radv, (yyvsp[-1].i));
  this_proto->net_type = NET_IP6;

  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
#line 12631 "obj/conf/cf-parse.tab.c"
    break;

  case 1170: /* radv_proto_item: PREFIX radv_prefix  */
#line 61 "proto/radv/config.Y"
                      { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
#line 12637 "obj/conf/cf-parse.tab.c"
    break;

  case 1171: /* $@15: %empty  */
#line 62 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 12643 "obj/conf/cf-parse.tab.c"
    break;

  case 1172: /* radv_proto_item: RDNSS $@15 radv_rdnss  */
#line 62 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
#line 12649 "obj/conf/cf-parse.tab.c"
    break;

  case 1173: /* $@16: %empty  */
#line 63 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 12655 "obj/conf/cf-parse.tab.c"
    break;

  case 1174: /* radv_proto_item: DNSSL $@16 radv_dnssl  */
#line 63 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
#line 12661 "obj/conf/cf-parse.tab.c"
    break;

  case 1175: /* radv_proto_item: TRIGGER net_ip6  */
#line 64 "proto/radv/config.Y"
                   { RADV_CFG->trigger = (yyvsp[0].net); }
#line 12667 "obj/conf/cf-parse.tab.c"
    break;

  case 1176: /* radv_proto_item: PROPAGATE ROUTES bool  */
#line 65 "proto/radv/config.Y"
                         { RADV_CFG->propagate_routes = (yyvsp[0].i); }
#line 12673 "obj/conf/cf-parse.tab.c"
    break;

  case 1180: /* radv_iface_start: %empty  */
#line 78 "proto/radv/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = (u32) -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->prefix_linger_time = (u32) -1;
  RADV_IFACE->route_linger_time = (u32) -1;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = (u32) -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
  RADV_IFACE->route_lifetime = (u32) -1;
  RADV_IFACE->route_lifetime_sensitive = 0;
  RADV_IFACE->route_preference = RA_PREF_MEDIUM;
}
#line 12699 "obj/conf/cf-parse.tab.c"
    break;

  case 1181: /* radv_iface_item: MIN RA INTERVAL expr  */
#line 101 "proto/radv/config.Y"
                        { RADV_IFACE->min_ra_int = (yyvsp[0].i); if ((yyvsp[0].i) < 3) cf_error("Min RA interval must be at least 3"); }
#line 12705 "obj/conf/cf-parse.tab.c"
    break;

  case 1182: /* radv_iface_item: MAX RA INTERVAL expr  */
#line 102 "proto/radv/config.Y"
                        { RADV_IFACE->max_ra_int = (yyvsp[0].i); if (((yyvsp[0].i) < 4) || ((yyvsp[0].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
#line 12711 "obj/conf/cf-parse.tab.c"
    break;

  case 1183: /* radv_iface_item: MIN DELAY expr  */
#line 103 "proto/radv/config.Y"
                  { RADV_IFACE->min_delay = (yyvsp[0].i); if ((yyvsp[0].i) <= 0) cf_error("Min delay must be positive"); }
#line 12717 "obj/conf/cf-parse.tab.c"
    break;

  case 1184: /* radv_iface_item: SOLICITED RA UNICAST bool  */
#line 104 "proto/radv/config.Y"
                             { RADV_IFACE->solicited_ra_unicast = (yyvsp[0].i); }
#line 12723 "obj/conf/cf-parse.tab.c"
    break;

  case 1185: /* radv_iface_item: MANAGED bool  */
#line 105 "proto/radv/config.Y"
                { RADV_IFACE->managed = (yyvsp[0].i); }
#line 12729 "obj/conf/cf-parse.tab.c"
    break;

  case 1186: /* radv_iface_item: OTHER CONFIG bool  */
#line 106 "proto/radv/config.Y"
                     { RADV_IFACE->other_config = (yyvsp[0].i); }
#line 12735 "obj/conf/cf-parse.tab.c"
    break;

  case 1187: /* radv_iface_item: LINK MTU expr  */
#line 107 "proto/radv/config.Y"
                 { RADV_IFACE->link_mtu = (yyvsp[0].i); }
#line 12741 "obj/conf/cf-parse.tab.c"
    break;

  case 1188: /* radv_iface_item: REACHABLE TIME expr  */
#line 108 "proto/radv/config.Y"
                       { RADV_IFACE->reachable_time = (yyvsp[0].i); if ((yyvsp[0].i) > 3600000) cf_error("Reachable time must be in range 0-3600000"); }
#line 12747 "obj/conf/cf-parse.tab.c"
    break;

  case 1189: /* radv_iface_item: RETRANS TIMER expr  */
#line 109 "proto/radv/config.Y"
                      { RADV_IFACE->retrans_timer = (yyvsp[0].i); }
#line 12753 "obj/conf/cf-parse.tab.c"
    break;

  case 1190: /* radv_iface_item: CURRENT HOP LIMIT expr  */
#line 110 "proto/radv/config.Y"
                          { RADV_IFACE->current_hop_limit = (yyvsp[0].i); if ((yyvsp[0].i) > 255) cf_error("Current hop limit must be in range 0-255"); }
#line 12759 "obj/conf/cf-parse.tab.c"
    break;

  case 1191: /* radv_iface_item: DEFAULT LIFETIME expr radv_sensitive  */
#line 111 "proto/radv/config.Y"
                                        {
     RADV_IFACE->default_lifetime = (yyvsp[-1].i);
     if ((yyvsp[-1].i) > 9000)  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[0].i) != (uint) -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12769 "obj/conf/cf-parse.tab.c"
    break;

  case 1192: /* radv_iface_item: ROUTE LIFETIME expr radv_sensitive  */
#line 116 "proto/radv/config.Y"
                                      {
     RADV_IFACE->route_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_IFACE->route_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12778 "obj/conf/cf-parse.tab.c"
    break;

  case 1193: /* radv_iface_item: DEFAULT PREFERENCE radv_preference  */
#line 120 "proto/radv/config.Y"
                                      { RADV_IFACE->default_preference = (yyvsp[0].i); }
#line 12784 "obj/conf/cf-parse.tab.c"
    break;

  case 1194: /* radv_iface_item: ROUTE PREFERENCE radv_preference  */
#line 121 "proto/radv/config.Y"
                                    { RADV_IFACE->route_preference = (yyvsp[0].i); }
#line 12790 "obj/conf/cf-parse.tab.c"
    break;

  case 1195: /* radv_iface_item: PREFIX LINGER TIME expr  */
#line 122 "proto/radv/config.Y"
                           { RADV_IFACE->prefix_linger_time = (yyvsp[0].i); }
#line 12796 "obj/conf/cf-parse.tab.c"
    break;

  case 1196: /* radv_iface_item: ROUTE LINGER TIME expr  */
#line 123 "proto/radv/config.Y"
                          { RADV_IFACE->route_linger_time = (yyvsp[0].i); }
#line 12802 "obj/conf/cf-parse.tab.c"
    break;

  case 1197: /* radv_iface_item: PREFIX radv_prefix  */
#line 124 "proto/radv/config.Y"
                      { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
#line 12808 "obj/conf/cf-parse.tab.c"
    break;

  case 1198: /* $@17: %empty  */
#line 125 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 12814 "obj/conf/cf-parse.tab.c"
    break;

  case 1199: /* radv_iface_item: RDNSS $@17 radv_rdnss  */
#line 125 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
#line 12820 "obj/conf/cf-parse.tab.c"
    break;

  case 1200: /* $@18: %empty  */
#line 126 "proto/radv/config.Y"
         { init_list(&radv_dns_list); }
#line 12826 "obj/conf/cf-parse.tab.c"
    break;

  case 1201: /* radv_iface_item: DNSSL $@18 radv_dnssl  */
#line 126 "proto/radv/config.Y"
                                                   { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
#line 12832 "obj/conf/cf-parse.tab.c"
    break;

  case 1202: /* radv_iface_item: RDNSS LOCAL bool  */
#line 127 "proto/radv/config.Y"
                    { RADV_IFACE->rdnss_local = (yyvsp[0].i); }
#line 12838 "obj/conf/cf-parse.tab.c"
    break;

  case 1203: /* radv_iface_item: DNSSL LOCAL bool  */
#line 128 "proto/radv/config.Y"
                    { RADV_IFACE->dnssl_local = (yyvsp[0].i); }
#line 12844 "obj/conf/cf-parse.tab.c"
    break;

  case 1204: /* radv_preference: LOW  */
#line 132 "proto/radv/config.Y"
       { (yyval.i) = RA_PREF_LOW; }
#line 12850 "obj/conf/cf-parse.tab.c"
    break;

  case 1205: /* radv_preference: MEDIUM  */
#line 133 "proto/radv/config.Y"
          { (yyval.i) = RA_PREF_MEDIUM; }
#line 12856 "obj/conf/cf-parse.tab.c"
    break;

  case 1206: /* radv_preference: HIGH  */
#line 134 "proto/radv/config.Y"
        { (yyval.i) = RA_PREF_HIGH; }
#line 12862 "obj/conf/cf-parse.tab.c"
    break;

  case 1207: /* radv_iface_finish: %empty  */
#line 137 "proto/radv/config.Y"
{
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if (ic->route_lifetime == (u32) -1)
    ic->route_lifetime = 3 * ic->max_ra_int;

  if (ic->prefix_linger_time == (u32) -1)
    ic->prefix_linger_time = 3 * ic->max_ra_int;

  if (ic->route_linger_time == (u32) -1)
    ic->route_linger_time = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval");

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");

  if ((ic->route_lifetime > 0) && (ic->route_lifetime < ic->max_ra_int))
    cf_error("Route lifetime must be either 0 or at least Max RA interval");

  if ((ic->prefix_linger_time > 0) && (ic->prefix_linger_time < ic->max_ra_int))
    cf_error("Prefix linger time must be either 0 or at least Max RA interval");

  if ((ic->route_linger_time > 0) && (ic->route_linger_time < ic->max_ra_int))
    cf_error("Route linger time must be either 0 or at least Max RA interval");

  RADV_CFG->max_linger_time = MAX_(RADV_CFG->max_linger_time, ic->route_linger_time);
}
#line 12903 "obj/conf/cf-parse.tab.c"
    break;

  case 1213: /* radv_prefix_start: net_ip6  */
#line 190 "proto/radv/config.Y"
{
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = *(net_addr_ip6 *) &((yyvsp[0].net));

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
#line 12917 "obj/conf/cf-parse.tab.c"
    break;

  case 1214: /* radv_prefix_item: SKIP bool  */
#line 201 "proto/radv/config.Y"
             { RADV_PREFIX->skip = (yyvsp[0].i); }
#line 12923 "obj/conf/cf-parse.tab.c"
    break;

  case 1215: /* radv_prefix_item: ONLINK bool  */
#line 202 "proto/radv/config.Y"
               { RADV_PREFIX->onlink = (yyvsp[0].i); }
#line 12929 "obj/conf/cf-parse.tab.c"
    break;

  case 1216: /* radv_prefix_item: AUTONOMOUS bool  */
#line 203 "proto/radv/config.Y"
                   { RADV_PREFIX->autonomous = (yyvsp[0].i); }
#line 12935 "obj/conf/cf-parse.tab.c"
    break;

  case 1217: /* radv_prefix_item: VALID LIFETIME expr radv_sensitive  */
#line 204 "proto/radv/config.Y"
                                      {
     RADV_PREFIX->valid_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12944 "obj/conf/cf-parse.tab.c"
    break;

  case 1218: /* radv_prefix_item: PREFERRED LIFETIME expr radv_sensitive  */
#line 208 "proto/radv/config.Y"
                                          {
     RADV_PREFIX->preferred_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != (uint) -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[0].i);
   }
#line 12953 "obj/conf/cf-parse.tab.c"
    break;

  case 1219: /* radv_prefix_finish: %empty  */
#line 215 "proto/radv/config.Y"
{
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
#line 12965 "obj/conf/cf-parse.tab.c"
    break;

  case 1225: /* radv_rdnss_node: ipa  */
#line 239 "proto/radv/config.Y"
{
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[0].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 12977 "obj/conf/cf-parse.tab.c"
    break;

  case 1226: /* radv_rdnss_start: %empty  */
#line 248 "proto/radv/config.Y"
{
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 12986 "obj/conf/cf-parse.tab.c"
    break;

  case 1229: /* radv_rdnss_item: LIFETIME radv_mult  */
#line 255 "proto/radv/config.Y"
                      { RADV_RDNSS->lifetime = (yyvsp[0].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
#line 12992 "obj/conf/cf-parse.tab.c"
    break;

  case 1230: /* radv_rdnss_finish: %empty  */
#line 259 "proto/radv/config.Y"
{
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
#line 13008 "obj/conf/cf-parse.tab.c"
    break;

  case 1235: /* radv_dnssl_node: TEXT  */
#line 283 "proto/radv/config.Y"
{
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[0].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
#line 13023 "obj/conf/cf-parse.tab.c"
    break;

  case 1236: /* radv_dnssl_start: %empty  */
#line 295 "proto/radv/config.Y"
{
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 13032 "obj/conf/cf-parse.tab.c"
    break;

  case 1239: /* radv_dnssl_item: LIFETIME radv_mult  */
#line 302 "proto/radv/config.Y"
                      { RADV_DNSSL->lifetime = (yyvsp[0].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
#line 13038 "obj/conf/cf-parse.tab.c"
    break;

  case 1240: /* radv_dnssl_finish: %empty  */
#line 306 "proto/radv/config.Y"
{
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
#line 13054 "obj/conf/cf-parse.tab.c"
    break;

  case 1245: /* radv_mult: expr  */
#line 330 "proto/radv/config.Y"
        { (yyval.i) = (yyvsp[0].i); radv_mult_val = 0; }
#line 13060 "obj/conf/cf-parse.tab.c"
    break;

  case 1246: /* radv_mult: MULT expr  */
#line 331 "proto/radv/config.Y"
             { (yyval.i) = 0; radv_mult_val = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
#line 13066 "obj/conf/cf-parse.tab.c"
    break;

  case 1247: /* radv_sensitive: %empty  */
#line 335 "proto/radv/config.Y"
               { (yyval.i) = (uint) -1; }
#line 13072 "obj/conf/cf-parse.tab.c"
    break;

  case 1248: /* radv_sensitive: SENSITIVE bool  */
#line 336 "proto/radv/config.Y"
                  { (yyval.i) = (yyvsp[0].i); }
#line 13078 "obj/conf/cf-parse.tab.c"
    break;

  case 1249: /* dynamic_attr: RA_PREFERENCE  */
#line 339 "proto/radv/config.Y"
                            { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_RA_PREFERENCE, EA_RA_PREFERENCE); }
#line 13084 "obj/conf/cf-parse.tab.c"
    break;

  case 1250: /* dynamic_attr: RA_LIFETIME  */
#line 340 "proto/radv/config.Y"
                          { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RA_LIFETIME); }
#line 13090 "obj/conf/cf-parse.tab.c"
    break;

  case 1252: /* rip_variant: RIP  */
#line 49 "proto/rip/config.Y"
          { (yyval.i) = 1; }
#line 13096 "obj/conf/cf-parse.tab.c"
    break;

  case 1253: /* rip_variant: RIP NG  */
#line 50 "proto/rip/config.Y"
          { (yyval.i) = 0; }
#line 13102 "obj/conf/cf-parse.tab.c"
    break;

  case 1254: /* rip_proto_start: proto_start rip_variant  */
#line 54 "proto/rip/config.Y"
{
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  this_proto->net_type = (yyvsp[0].i) ? NET_IP4 : NET_IP6;

  init_list(&RIP_CFG->patt_list);
  RIP_CFG->rip2 = (yyvsp[0].i);
  RIP_CFG->ecmp = rt_default_ecmp;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;
  RIP_CFG->min_timeout_time = 60 S_;
  RIP_CFG->max_garbage_time = 60 S_;
}
#line 13118 "obj/conf/cf-parse.tab.c"
    break;

  case 1257: /* rip_proto_item: ECMP bool  */
#line 69 "proto/rip/config.Y"
                        { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 13124 "obj/conf/cf-parse.tab.c"
    break;

  case 1258: /* rip_proto_item: ECMP bool LIMIT expr  */
#line 70 "proto/rip/config.Y"
                        { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; }
#line 13130 "obj/conf/cf-parse.tab.c"
    break;

  case 1259: /* rip_proto_item: INFINITY expr  */
#line 71 "proto/rip/config.Y"
                        { RIP_CFG->infinity = (yyvsp[0].i); }
#line 13136 "obj/conf/cf-parse.tab.c"
    break;

  case 1264: /* rip_iface_start: %empty  */
#line 85 "proto/rip/config.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->check_link = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
  RIP_IFACE->rxmt_time = RIP_DEFAULT_RXMT_TIME;
}
#line 13164 "obj/conf/cf-parse.tab.c"
    break;

  case 1265: /* rip_iface_finish: %empty  */
#line 110 "proto/rip/config.Y"
{
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 13197 "obj/conf/cf-parse.tab.c"
    break;

  case 1266: /* rip_iface_item: METRIC expr  */
#line 140 "proto/rip/config.Y"
                        { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 13203 "obj/conf/cf-parse.tab.c"
    break;

  case 1267: /* rip_iface_item: MODE MULTICAST  */
#line 141 "proto/rip/config.Y"
                        { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 13209 "obj/conf/cf-parse.tab.c"
    break;

  case 1268: /* rip_iface_item: MODE BROADCAST  */
#line 142 "proto/rip/config.Y"
                        { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 13215 "obj/conf/cf-parse.tab.c"
    break;

  case 1269: /* rip_iface_item: PASSIVE bool  */
#line 143 "proto/rip/config.Y"
                        { RIP_IFACE->passive = (yyvsp[0].i); }
#line 13221 "obj/conf/cf-parse.tab.c"
    break;

  case 1270: /* rip_iface_item: ADDRESS ipa  */
#line 144 "proto/rip/config.Y"
                        { RIP_IFACE->address = (yyvsp[0].a); if (ipa_is_ip4((yyvsp[0].a)) != rip_cfg_is_v2()) cf_error("IP address version mismatch"); }
#line 13227 "obj/conf/cf-parse.tab.c"
    break;

  case 1271: /* rip_iface_item: PORT expr  */
#line 145 "proto/rip/config.Y"
                        { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 13233 "obj/conf/cf-parse.tab.c"
    break;

  case 1272: /* rip_iface_item: VERSION expr  */
#line 146 "proto/rip/config.Y"
                        { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 13242 "obj/conf/cf-parse.tab.c"
    break;

  case 1273: /* rip_iface_item: VERSION ONLY bool  */
#line 150 "proto/rip/config.Y"
                        { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 13248 "obj/conf/cf-parse.tab.c"
    break;

  case 1274: /* rip_iface_item: SPLIT HORIZON bool  */
#line 151 "proto/rip/config.Y"
                        { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 13254 "obj/conf/cf-parse.tab.c"
    break;

  case 1275: /* rip_iface_item: POISON REVERSE bool  */
#line 152 "proto/rip/config.Y"
                        { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 13260 "obj/conf/cf-parse.tab.c"
    break;

  case 1276: /* rip_iface_item: CHECK ZERO bool  */
#line 153 "proto/rip/config.Y"
                        { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 13266 "obj/conf/cf-parse.tab.c"
    break;

  case 1277: /* rip_iface_item: DEMAND CIRCUIT bool  */
#line 154 "proto/rip/config.Y"
                        { RIP_IFACE->demand_circuit = (yyvsp[0].i); }
#line 13272 "obj/conf/cf-parse.tab.c"
    break;

  case 1278: /* rip_iface_item: UPDATE TIME expr  */
#line 155 "proto/rip/config.Y"
                        { RIP_IFACE->update_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 13278 "obj/conf/cf-parse.tab.c"
    break;

  case 1279: /* rip_iface_item: TIMEOUT TIME expr  */
#line 156 "proto/rip/config.Y"
                        { RIP_IFACE->timeout_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 13284 "obj/conf/cf-parse.tab.c"
    break;

  case 1280: /* rip_iface_item: GARBAGE TIME expr  */
#line 157 "proto/rip/config.Y"
                        { RIP_IFACE->garbage_time = (yyvsp[0].i) S_; if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 13290 "obj/conf/cf-parse.tab.c"
    break;

  case 1281: /* rip_iface_item: RETRANSMIT TIME expr_us  */
#line 158 "proto/rip/config.Y"
                           { RIP_IFACE->rxmt_time = (yyvsp[0].time); if ((yyvsp[0].time)<=0) cf_error("Retransmit time must be positive"); }
#line 13296 "obj/conf/cf-parse.tab.c"
    break;

  case 1282: /* rip_iface_item: ECMP WEIGHT expr  */
#line 159 "proto/rip/config.Y"
                        { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 13302 "obj/conf/cf-parse.tab.c"
    break;

  case 1283: /* rip_iface_item: RX BUFFER expr  */
#line 160 "proto/rip/config.Y"
                        { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 13308 "obj/conf/cf-parse.tab.c"
    break;

  case 1284: /* rip_iface_item: TX LENGTH expr  */
#line 161 "proto/rip/config.Y"
                        { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 13314 "obj/conf/cf-parse.tab.c"
    break;

  case 1285: /* rip_iface_item: TX tos  */
#line 162 "proto/rip/config.Y"
                        { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 13320 "obj/conf/cf-parse.tab.c"
    break;

  case 1286: /* rip_iface_item: TX PRIORITY expr  */
#line 163 "proto/rip/config.Y"
                        { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 13326 "obj/conf/cf-parse.tab.c"
    break;

  case 1287: /* rip_iface_item: TTL SECURITY bool  */
#line 164 "proto/rip/config.Y"
                        { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 13332 "obj/conf/cf-parse.tab.c"
    break;

  case 1288: /* rip_iface_item: TTL SECURITY TX ONLY  */
#line 165 "proto/rip/config.Y"
                        { RIP_IFACE->ttl_security = 2; }
#line 13338 "obj/conf/cf-parse.tab.c"
    break;

  case 1289: /* rip_iface_item: CHECK LINK bool  */
#line 166 "proto/rip/config.Y"
                        { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 13344 "obj/conf/cf-parse.tab.c"
    break;

  case 1290: /* rip_iface_item: BFD bool  */
#line 167 "proto/rip/config.Y"
                        { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 13350 "obj/conf/cf-parse.tab.c"
    break;

  case 1291: /* rip_iface_item: AUTHENTICATION rip_auth  */
#line 168 "proto/rip/config.Y"
                           { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 13356 "obj/conf/cf-parse.tab.c"
    break;

  case 1292: /* rip_iface_item: password_list  */
#line 169 "proto/rip/config.Y"
                        { rip_check_auth(); }
#line 13362 "obj/conf/cf-parse.tab.c"
    break;

  case 1293: /* rip_auth: NONE  */
#line 173 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_NONE; }
#line 13368 "obj/conf/cf-parse.tab.c"
    break;

  case 1294: /* rip_auth: PLAINTEXT  */
#line 174 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_PLAIN; }
#line 13374 "obj/conf/cf-parse.tab.c"
    break;

  case 1295: /* rip_auth: CRYPTOGRAPHIC  */
#line 175 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 13380 "obj/conf/cf-parse.tab.c"
    break;

  case 1296: /* rip_auth: MD5  */
#line 176 "proto/rip/config.Y"
                        { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 13386 "obj/conf/cf-parse.tab.c"
    break;

  case 1302: /* dynamic_attr: RIP_METRIC  */
#line 193 "proto/rip/config.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RIP_METRIC); }
#line 13392 "obj/conf/cf-parse.tab.c"
    break;

  case 1303: /* dynamic_attr: RIP_TAG  */
#line 194 "proto/rip/config.Y"
                      { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RIP_TAG); }
#line 13398 "obj/conf/cf-parse.tab.c"
    break;

  case 1305: /* cmd_SHOW_RIP_INTERFACES: SHOW RIP INTERFACES optproto opttext END  */
#line 199 "proto/rip/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_rip, p) rip_show_interfaces(p, (yyvsp[-1].t)); }
#line 13404 "obj/conf/cf-parse.tab.c"
    break;

  case 1307: /* cmd_SHOW_RIP_NEIGHBORS: SHOW RIP NEIGHBORS optproto opttext END  */
#line 202 "proto/rip/config.Y"
{ PROTO_WALK_CMD((yyvsp[-2].s), &proto_rip, p) rip_show_neighbors(p, (yyvsp[-1].t)); }
#line 13410 "obj/conf/cf-parse.tab.c"
    break;

  case 1309: /* rpki_proto_start: proto_start RPKI  */
#line 43 "proto/rpki/config.Y"
                                   {
  this_proto = proto_config_new(&proto_rpki, (yyvsp[-1].i));
  RPKI_CFG->retry_interval = RPKI_RETRY_INTERVAL;
  RPKI_CFG->refresh_interval = RPKI_REFRESH_INTERVAL;
  RPKI_CFG->expire_interval = RPKI_EXPIRE_INTERVAL;
}
#line 13421 "obj/conf/cf-parse.tab.c"
    break;

  case 1310: /* rpki_proto: rpki_proto_start proto_name '{' rpki_proto_opts '}'  */
#line 50 "proto/rpki/config.Y"
                                                                { rpki_check_config(RPKI_CFG); }
#line 13427 "obj/conf/cf-parse.tab.c"
    break;

  case 1319: /* rpki_proto_item: REFRESH rpki_keep_interval expr  */
#line 64 "proto/rpki/config.Y"
                                   {
     if (rpki_check_refresh_interval((yyvsp[0].i)))
       cf_error(rpki_check_refresh_interval((yyvsp[0].i)));
     RPKI_CFG->refresh_interval = (yyvsp[0].i);
     RPKI_CFG->keep_refresh_interval = (yyvsp[-1].i);
   }
#line 13438 "obj/conf/cf-parse.tab.c"
    break;

  case 1320: /* rpki_proto_item: RETRY rpki_keep_interval expr  */
#line 70 "proto/rpki/config.Y"
                                 {
     if (rpki_check_retry_interval((yyvsp[0].i)))
       cf_error(rpki_check_retry_interval((yyvsp[0].i)));
     RPKI_CFG->retry_interval = (yyvsp[0].i);
     RPKI_CFG->keep_retry_interval = (yyvsp[-1].i);
   }
#line 13449 "obj/conf/cf-parse.tab.c"
    break;

  case 1321: /* rpki_proto_item: EXPIRE rpki_keep_interval expr  */
#line 76 "proto/rpki/config.Y"
                                  {
     if (rpki_check_expire_interval((yyvsp[0].i)))
       cf_error(rpki_check_expire_interval((yyvsp[0].i)));
     RPKI_CFG->expire_interval = (yyvsp[0].i);
     RPKI_CFG->keep_expire_interval = (yyvsp[-1].i);
   }
#line 13460 "obj/conf/cf-parse.tab.c"
    break;

  case 1322: /* rpki_proto_item: IGNORE MAX LENGTH bool  */
#line 82 "proto/rpki/config.Y"
                          { RPKI_CFG->ignore_max_length = (yyvsp[0].i); }
#line 13466 "obj/conf/cf-parse.tab.c"
    break;

  case 1323: /* rpki_keep_interval: %empty  */
#line 86 "proto/rpki/config.Y"
             { (yyval.i) = 0; }
#line 13472 "obj/conf/cf-parse.tab.c"
    break;

  case 1324: /* rpki_keep_interval: KEEP  */
#line 87 "proto/rpki/config.Y"
        { (yyval.i) = 1; }
#line 13478 "obj/conf/cf-parse.tab.c"
    break;

  case 1325: /* rpki_proto_item_port: PORT expr  */
#line 90 "proto/rpki/config.Y"
                                { check_u16((yyvsp[0].i)); RPKI_CFG->port = (yyvsp[0].i); }
#line 13484 "obj/conf/cf-parse.tab.c"
    break;

  case 1326: /* rpki_cache_addr: text  */
#line 93 "proto/rpki/config.Y"
        {
     rpki_check_unused_hostname();
     RPKI_CFG->hostname = (yyvsp[0].t);
   }
#line 13493 "obj/conf/cf-parse.tab.c"
    break;

  case 1327: /* rpki_cache_addr: ipa  */
#line 97 "proto/rpki/config.Y"
       {
     rpki_check_unused_hostname();
     RPKI_CFG->ip = (yyvsp[0].a);
     /* Ensure hostname is filled */
     char *hostname = cfg_allocz(INET6_ADDRSTRLEN + 1);
     bsnprintf(hostname, INET6_ADDRSTRLEN+1, "%I", RPKI_CFG->ip);
     RPKI_CFG->hostname = hostname;
   }
#line 13506 "obj/conf/cf-parse.tab.c"
    break;

  case 1330: /* rpki_transport_tcp_init: %empty  */
#line 113 "proto/rpki/config.Y"
{
  rpki_check_unused_transport();
  RPKI_CFG->tr_config.spec = cfg_allocz(sizeof(struct rpki_tr_tcp_config));
  RPKI_CFG->tr_config.type = RPKI_TR_TCP;
}
#line 13516 "obj/conf/cf-parse.tab.c"
    break;

  case 1331: /* rpki_transport_ssh_init: %empty  */
#line 120 "proto/rpki/config.Y"
{
#if HAVE_LIBSSH
  rpki_check_unused_transport();
  RPKI_CFG->tr_config.spec = cfg_allocz(sizeof(struct rpki_tr_ssh_config));
  RPKI_CFG->tr_config.type = RPKI_TR_SSH;
#else
  cf_error("This build doesn't support SSH");
#endif
}
#line 13530 "obj/conf/cf-parse.tab.c"
    break;

  case 1334: /* rpki_transport_ssh_item: BIRD PRIVATE KEY text  */
#line 136 "proto/rpki/config.Y"
                          { RPKI_TR_SSH_CFG->bird_private_key = (yyvsp[0].t); }
#line 13536 "obj/conf/cf-parse.tab.c"
    break;

  case 1335: /* rpki_transport_ssh_item: REMOTE PUBLIC KEY text  */
#line 137 "proto/rpki/config.Y"
                          { RPKI_TR_SSH_CFG->cache_public_key = (yyvsp[0].t); }
#line 13542 "obj/conf/cf-parse.tab.c"
    break;

  case 1336: /* rpki_transport_ssh_item: USER text  */
#line 138 "proto/rpki/config.Y"
                          { RPKI_TR_SSH_CFG->user = (yyvsp[0].t); }
#line 13548 "obj/conf/cf-parse.tab.c"
    break;

  case 1337: /* rpki_transport_ssh_check: %empty  */
#line 142 "proto/rpki/config.Y"
{
  if (RPKI_TR_SSH_CFG->user == NULL)
    cf_error("User must be set");
}
#line 13557 "obj/conf/cf-parse.tab.c"
    break;

  case 1339: /* static_proto_start: proto_start STATIC  */
#line 57 "proto/static/config.Y"
{
  this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
  init_list(&STATIC_CFG->routes);
}
#line 13566 "obj/conf/cf-parse.tab.c"
    break;

  case 1342: /* static_proto: static_proto proto_channel ';'  */
#line 65 "proto/static/config.Y"
                                  { this_proto->net_type = (yyvsp[-1].cc)->net_type; }
#line 13572 "obj/conf/cf-parse.tab.c"
    break;

  case 1343: /* static_proto: static_proto CHECK LINK bool ';'  */
#line 66 "proto/static/config.Y"
                                    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 13578 "obj/conf/cf-parse.tab.c"
    break;

  case 1344: /* static_proto: static_proto IGP TABLE rtable ';'  */
#line 67 "proto/static/config.Y"
                                     {
    if ((yyvsp[-1].r)->addr_type == NET_IP4)
      STATIC_CFG->igp_table_ip4 = (yyvsp[-1].r);
    else if ((yyvsp[-1].r)->addr_type == NET_IP6)
      STATIC_CFG->igp_table_ip6 = (yyvsp[-1].r);
    else
      cf_error("Incompatible IGP table type");
   }
#line 13591 "obj/conf/cf-parse.tab.c"
    break;

  case 1345: /* static_proto: static_proto stat_route stat_route_opt_list ';'  */
#line 75 "proto/static/config.Y"
                                                   { static_route_finish(); }
#line 13597 "obj/conf/cf-parse.tab.c"
    break;

  case 1346: /* stat_nexthop: VIA ipa ipa_scope  */
#line 79 "proto/static/config.Y"
                      {
      this_snh = static_nexthop_new();
      this_snh->via = (yyvsp[-1].a);
      this_snh->iface = (yyvsp[0].iface);
    }
#line 13607 "obj/conf/cf-parse.tab.c"
    break;

  case 1347: /* stat_nexthop: VIA TEXT  */
#line 84 "proto/static/config.Y"
             {
      this_snh = static_nexthop_new();
      this_snh->via = IPA_NONE;
      this_snh->iface = if_get_by_name((yyvsp[0].t));
    }
#line 13617 "obj/conf/cf-parse.tab.c"
    break;

  case 1348: /* stat_nexthop: stat_nexthop MPLS label_stack  */
#line 89 "proto/static/config.Y"
                                  {
    this_snh->mls = (yyvsp[0].mls);
  }
#line 13625 "obj/conf/cf-parse.tab.c"
    break;

  case 1349: /* stat_nexthop: stat_nexthop ONLINK bool  */
#line 92 "proto/static/config.Y"
                             {
    this_snh->onlink = (yyvsp[0].i);
  }
#line 13633 "obj/conf/cf-parse.tab.c"
    break;

  case 1350: /* stat_nexthop: stat_nexthop WEIGHT expr  */
#line 95 "proto/static/config.Y"
                             {
    this_snh->weight = (yyvsp[0].i) - 1;
    if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256");
  }
#line 13642 "obj/conf/cf-parse.tab.c"
    break;

  case 1351: /* stat_nexthop: stat_nexthop BFD bool  */
#line 99 "proto/static/config.Y"
                          {
    this_snh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
  }
#line 13650 "obj/conf/cf-parse.tab.c"
    break;

  case 1354: /* stat_route0: ROUTE net_any  */
#line 109 "proto/static/config.Y"
                           {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->routes, &this_srt->n);
     this_srt->net = (yyvsp[0].net_ptr);
     this_srt_cmds = NULL;
     this_srt_last_cmd = NULL;
     this_srt->mp_next = NULL;
     this_snh = NULL;
  }
#line 13664 "obj/conf/cf-parse.tab.c"
    break;

  case 1356: /* stat_route: stat_route0 RECURSIVE ipa  */
#line 122 "proto/static/config.Y"
                             {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 13673 "obj/conf/cf-parse.tab.c"
    break;

  case 1357: /* stat_route: stat_route0 RECURSIVE ipa MPLS label_stack  */
#line 126 "proto/static/config.Y"
                                              {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[-2].a);
      this_srt->mls = (yyvsp[0].mls);
   }
#line 13683 "obj/conf/cf-parse.tab.c"
    break;

  case 1358: /* stat_route: stat_route0  */
#line 131 "proto/static/config.Y"
                                { this_srt->dest = RTD_NONE; }
#line 13689 "obj/conf/cf-parse.tab.c"
    break;

  case 1359: /* stat_route: stat_route0 DROP  */
#line 132 "proto/static/config.Y"
                                { this_srt->dest = RTD_BLACKHOLE; }
#line 13695 "obj/conf/cf-parse.tab.c"
    break;

  case 1360: /* stat_route: stat_route0 REJECT  */
#line 133 "proto/static/config.Y"
                                { this_srt->dest = RTD_UNREACHABLE; }
#line 13701 "obj/conf/cf-parse.tab.c"
    break;

  case 1361: /* stat_route: stat_route0 BLACKHOLE  */
#line 134 "proto/static/config.Y"
                                { this_srt->dest = RTD_BLACKHOLE; }
#line 13707 "obj/conf/cf-parse.tab.c"
    break;

  case 1362: /* stat_route: stat_route0 UNREACHABLE  */
#line 135 "proto/static/config.Y"
                                { this_srt->dest = RTD_UNREACHABLE; }
#line 13713 "obj/conf/cf-parse.tab.c"
    break;

  case 1363: /* stat_route: stat_route0 PROHIBIT  */
#line 136 "proto/static/config.Y"
                                { this_srt->dest = RTD_PROHIBIT; }
#line 13719 "obj/conf/cf-parse.tab.c"
    break;

  case 1364: /* stat_route_item: cmd  */
#line 140 "proto/static/config.Y"
       {
     if (this_srt_last_cmd)
       this_srt_last_cmd->next = (yyvsp[0].x);
     else
       this_srt_cmds = (yyvsp[0].x);
     this_srt_last_cmd = (yyvsp[0].x);
   }
#line 13731 "obj/conf/cf-parse.tab.c"
    break;

  case 1370: /* cmd_SHOW_STATIC: SHOW STATIC optproto END  */
#line 161 "proto/static/config.Y"
{ PROTO_WALK_CMD((yyvsp[-1].s), &proto_static, p) static_show(p); }
#line 13737 "obj/conf/cf-parse.tab.c"
    break;

  case 1372: /* kern_sys_item: KERNEL TABLE expr  */
#line 26 "sysdep/linux/netlink.Y"
                     { THIS_KRT->sys.table_id = (yyvsp[0].i); }
#line 13743 "obj/conf/cf-parse.tab.c"
    break;

  case 1373: /* kern_sys_item: METRIC expr  */
#line 27 "sysdep/linux/netlink.Y"
               { THIS_KRT->sys.metric = (yyvsp[0].i); }
#line 13749 "obj/conf/cf-parse.tab.c"
    break;

  case 1374: /* kern_sys_item: NETLINK RX BUFFER expr  */
#line 28 "sysdep/linux/netlink.Y"
                          { THIS_KRT->sys.netlink_rx_buffer = (yyvsp[0].i); }
#line 13755 "obj/conf/cf-parse.tab.c"
    break;

  case 1375: /* dynamic_attr: KRT_PREFSRC  */
#line 31 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 13761 "obj/conf/cf-parse.tab.c"
    break;

  case 1376: /* dynamic_attr: KRT_REALM  */
#line 32 "sysdep/linux/netlink.Y"
                        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 13767 "obj/conf/cf-parse.tab.c"
    break;

  case 1377: /* dynamic_attr: KRT_SCOPE  */
#line 33 "sysdep/linux/netlink.Y"
                        { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
#line 13773 "obj/conf/cf-parse.tab.c"
    break;

  case 1378: /* dynamic_attr: KRT_MTU  */
#line 35 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 13779 "obj/conf/cf-parse.tab.c"
    break;

  case 1379: /* dynamic_attr: KRT_WINDOW  */
#line 36 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 13785 "obj/conf/cf-parse.tab.c"
    break;

  case 1380: /* dynamic_attr: KRT_RTT  */
#line 37 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 13791 "obj/conf/cf-parse.tab.c"
    break;

  case 1381: /* dynamic_attr: KRT_RTTVAR  */
#line 38 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 13797 "obj/conf/cf-parse.tab.c"
    break;

  case 1382: /* dynamic_attr: KRT_SSTRESH  */
#line 39 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
#line 13803 "obj/conf/cf-parse.tab.c"
    break;

  case 1383: /* dynamic_attr: KRT_CWND  */
#line 40 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 13809 "obj/conf/cf-parse.tab.c"
    break;

  case 1384: /* dynamic_attr: KRT_ADVMSS  */
#line 41 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 13815 "obj/conf/cf-parse.tab.c"
    break;

  case 1385: /* dynamic_attr: KRT_REORDERING  */
#line 42 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 13821 "obj/conf/cf-parse.tab.c"
    break;

  case 1386: /* dynamic_attr: KRT_HOPLIMIT  */
#line 43 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 13827 "obj/conf/cf-parse.tab.c"
    break;

  case 1387: /* dynamic_attr: KRT_INITCWND  */
#line 44 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 13833 "obj/conf/cf-parse.tab.c"
    break;

  case 1388: /* dynamic_attr: KRT_RTO_MIN  */
#line 45 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 13839 "obj/conf/cf-parse.tab.c"
    break;

  case 1389: /* dynamic_attr: KRT_INITRWND  */
#line 46 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 13845 "obj/conf/cf-parse.tab.c"
    break;

  case 1390: /* dynamic_attr: KRT_QUICKACK  */
#line 47 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 13851 "obj/conf/cf-parse.tab.c"
    break;

  case 1391: /* dynamic_attr: KRT_LOCK_MTU  */
#line 51 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(2, T_BOOL, EA_KRT_LOCK); }
#line 13857 "obj/conf/cf-parse.tab.c"
    break;

  case 1392: /* dynamic_attr: KRT_LOCK_WINDOW  */
#line 52 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(3, T_BOOL, EA_KRT_LOCK); }
#line 13863 "obj/conf/cf-parse.tab.c"
    break;

  case 1393: /* dynamic_attr: KRT_LOCK_RTT  */
#line 53 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(4, T_BOOL, EA_KRT_LOCK); }
#line 13869 "obj/conf/cf-parse.tab.c"
    break;

  case 1394: /* dynamic_attr: KRT_LOCK_RTTVAR  */
#line 54 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(5, T_BOOL, EA_KRT_LOCK); }
#line 13875 "obj/conf/cf-parse.tab.c"
    break;

  case 1395: /* dynamic_attr: KRT_LOCK_SSTRESH  */
#line 55 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(6, T_BOOL, EA_KRT_LOCK); }
#line 13881 "obj/conf/cf-parse.tab.c"
    break;

  case 1396: /* dynamic_attr: KRT_LOCK_CWND  */
#line 56 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(7, T_BOOL, EA_KRT_LOCK); }
#line 13887 "obj/conf/cf-parse.tab.c"
    break;

  case 1397: /* dynamic_attr: KRT_LOCK_ADVMSS  */
#line 57 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(8, T_BOOL, EA_KRT_LOCK); }
#line 13893 "obj/conf/cf-parse.tab.c"
    break;

  case 1398: /* dynamic_attr: KRT_LOCK_REORDERING  */
#line 58 "sysdep/linux/netlink.Y"
                                  { (yyval.fda) = f_new_dynamic_attr_bit(9, T_BOOL, EA_KRT_LOCK); }
#line 13899 "obj/conf/cf-parse.tab.c"
    break;

  case 1399: /* dynamic_attr: KRT_LOCK_HOPLIMIT  */
#line 59 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(10, T_BOOL, EA_KRT_LOCK); }
#line 13905 "obj/conf/cf-parse.tab.c"
    break;

  case 1400: /* dynamic_attr: KRT_LOCK_RTO_MIN  */
#line 60 "sysdep/linux/netlink.Y"
                               { (yyval.fda) = f_new_dynamic_attr_bit(13, T_BOOL, EA_KRT_LOCK); }
#line 13911 "obj/conf/cf-parse.tab.c"
    break;

  case 1401: /* dynamic_attr: KRT_FEATURE_ECN  */
#line 62 "sysdep/linux/netlink.Y"
                                { (yyval.fda) = f_new_dynamic_attr_bit(0, T_BOOL, EA_KRT_FEATURES); }
#line 13917 "obj/conf/cf-parse.tab.c"
    break;

  case 1402: /* dynamic_attr: KRT_FEATURE_ALLFRAG  */
#line 63 "sysdep/linux/netlink.Y"
                                  { (yyval.fda) = f_new_dynamic_attr(3, T_BOOL, EA_KRT_FEATURES); }
#line 13923 "obj/conf/cf-parse.tab.c"
    break;

  case 1404: /* log_begin: %empty  */
#line 33 "sysdep/unix/config.Y"
           { this_log = cfg_allocz(sizeof(struct log_config)); }
#line 13929 "obj/conf/cf-parse.tab.c"
    break;

  case 1405: /* log_config: LOG log_begin log_file log_mask ';'  */
#line 35 "sysdep/unix/config.Y"
                                                {
    this_log->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &this_log->n);
  }
#line 13938 "obj/conf/cf-parse.tab.c"
    break;

  case 1406: /* syslog_name: NAME text  */
#line 42 "sysdep/unix/config.Y"
             { (yyval.t) = (yyvsp[0].t); }
#line 13944 "obj/conf/cf-parse.tab.c"
    break;

  case 1407: /* syslog_name: %empty  */
#line 43 "sysdep/unix/config.Y"
   { (yyval.t) = bird_name; }
#line 13950 "obj/conf/cf-parse.tab.c"
    break;

  case 1409: /* log_limit: expr text  */
#line 48 "sysdep/unix/config.Y"
             { this_log->limit = (yyvsp[-1].i); this_log->backup = (yyvsp[0].t); }
#line 13956 "obj/conf/cf-parse.tab.c"
    break;

  case 1410: /* log_file: text log_limit  */
#line 52 "sysdep/unix/config.Y"
                  {
     if (!parse_and_exit)
     {
       this_log->rf = rf_open(new_config->pool, (yyvsp[-1].t), "a");
       if (!this_log->rf) cf_error("Unable to open log file '%s': %m", (yyvsp[-1].t));
       this_log->fh = rf_file(this_log->rf);
     }
     this_log->pos = -1;
     this_log->filename = (yyvsp[-1].t);
   }
#line 13971 "obj/conf/cf-parse.tab.c"
    break;

  case 1411: /* log_file: SYSLOG syslog_name  */
#line 62 "sysdep/unix/config.Y"
                      { this_log->fh = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 13977 "obj/conf/cf-parse.tab.c"
    break;

  case 1412: /* log_file: STDERR  */
#line 63 "sysdep/unix/config.Y"
          { this_log->fh = stderr; }
#line 13983 "obj/conf/cf-parse.tab.c"
    break;

  case 1413: /* log_mask: ALL  */
#line 67 "sysdep/unix/config.Y"
       { (yyval.i) = ~0; }
#line 13989 "obj/conf/cf-parse.tab.c"
    break;

  case 1414: /* log_mask: '{' log_mask_list '}'  */
#line 68 "sysdep/unix/config.Y"
                         { (yyval.i) = (yyvsp[-1].i); }
#line 13995 "obj/conf/cf-parse.tab.c"
    break;

  case 1415: /* log_mask_list: log_cat  */
#line 72 "sysdep/unix/config.Y"
           { (yyval.i) = 1 << (yyvsp[0].i); }
#line 14001 "obj/conf/cf-parse.tab.c"
    break;

  case 1416: /* log_mask_list: log_mask_list ',' log_cat  */
#line 73 "sysdep/unix/config.Y"
                             { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 14007 "obj/conf/cf-parse.tab.c"
    break;

  case 1417: /* log_cat: DEBUG  */
#line 77 "sysdep/unix/config.Y"
         { (yyval.i) = L_DEBUG[0]; }
#line 14013 "obj/conf/cf-parse.tab.c"
    break;

  case 1418: /* log_cat: TRACE  */
#line 78 "sysdep/unix/config.Y"
         { (yyval.i) = L_TRACE[0]; }
#line 14019 "obj/conf/cf-parse.tab.c"
    break;

  case 1419: /* log_cat: INFO  */
#line 79 "sysdep/unix/config.Y"
        { (yyval.i) = L_INFO[0]; }
#line 14025 "obj/conf/cf-parse.tab.c"
    break;

  case 1420: /* log_cat: REMOTE  */
#line 80 "sysdep/unix/config.Y"
          { (yyval.i) = L_REMOTE[0]; }
#line 14031 "obj/conf/cf-parse.tab.c"
    break;

  case 1421: /* log_cat: WARNING  */
#line 81 "sysdep/unix/config.Y"
           { (yyval.i) = L_WARN[0]; }
#line 14037 "obj/conf/cf-parse.tab.c"
    break;

  case 1422: /* log_cat: ERROR  */
#line 82 "sysdep/unix/config.Y"
         { (yyval.i) = L_ERR[0]; }
#line 14043 "obj/conf/cf-parse.tab.c"
    break;

  case 1423: /* log_cat: AUTH  */
#line 83 "sysdep/unix/config.Y"
        { (yyval.i) = L_AUTH[0]; }
#line 14049 "obj/conf/cf-parse.tab.c"
    break;

  case 1424: /* log_cat: FATAL  */
#line 84 "sysdep/unix/config.Y"
         { (yyval.i) = L_FATAL[0]; }
#line 14055 "obj/conf/cf-parse.tab.c"
    break;

  case 1425: /* log_cat: BUG  */
#line 85 "sysdep/unix/config.Y"
       { (yyval.i) = L_BUG[0]; }
#line 14061 "obj/conf/cf-parse.tab.c"
    break;

  case 1427: /* mrtdump_base: MRTDUMP PROTOCOLS mrtdump_mask ';'  */
#line 92 "sysdep/unix/config.Y"
                                      { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 14067 "obj/conf/cf-parse.tab.c"
    break;

  case 1428: /* mrtdump_base: MRTDUMP text ';'  */
#line 93 "sysdep/unix/config.Y"
                    {
     if (!parse_and_exit)
     {
       struct rfile *f = rf_open(new_config->pool, (yyvsp[-1].t), "a");
       if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
       new_config->mrtdump_file = rf_fileno(f);
     }
   }
#line 14080 "obj/conf/cf-parse.tab.c"
    break;

  case 1430: /* debug_unix: DEBUG LATENCY bool  */
#line 107 "sysdep/unix/config.Y"
                      { new_config->latency_debug = (yyvsp[0].i); }
#line 14086 "obj/conf/cf-parse.tab.c"
    break;

  case 1431: /* debug_unix: DEBUG LATENCY LIMIT expr_us  */
#line 108 "sysdep/unix/config.Y"
                               { new_config->latency_limit = (yyvsp[0].time); }
#line 14092 "obj/conf/cf-parse.tab.c"
    break;

  case 1432: /* debug_unix: WATCHDOG WARNING expr_us  */
#line 109 "sysdep/unix/config.Y"
                            { new_config->watchdog_warning = (yyvsp[0].time); }
#line 14098 "obj/conf/cf-parse.tab.c"
    break;

  case 1433: /* debug_unix: WATCHDOG TIMEOUT expr_us  */
#line 110 "sysdep/unix/config.Y"
                            { new_config->watchdog_timeout = ((yyvsp[0].time) + 999999) TO_S; }
#line 14104 "obj/conf/cf-parse.tab.c"
    break;

  case 1435: /* cmd_CONFIGURE: CONFIGURE cfg_name cfg_timeout END  */
#line 119 "sysdep/unix/config.Y"
{ cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 14110 "obj/conf/cf-parse.tab.c"
    break;

  case 1437: /* cmd_CONFIGURE_SOFT: CONFIGURE SOFT cfg_name cfg_timeout END  */
#line 122 "sysdep/unix/config.Y"
{ cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 14116 "obj/conf/cf-parse.tab.c"
    break;

  case 1439: /* cmd_CONFIGURE_CONFIRM: CONFIGURE CONFIRM END  */
#line 129 "sysdep/unix/config.Y"
{ cmd_reconfig_confirm(); }
#line 14122 "obj/conf/cf-parse.tab.c"
    break;

  case 1441: /* cmd_CONFIGURE_UNDO: CONFIGURE UNDO END  */
#line 132 "sysdep/unix/config.Y"
{ cmd_reconfig_undo(); }
#line 14128 "obj/conf/cf-parse.tab.c"
    break;

  case 1443: /* cmd_CONFIGURE_STATUS: CONFIGURE STATUS END  */
#line 135 "sysdep/unix/config.Y"
{ cmd_reconfig_status(); }
#line 14134 "obj/conf/cf-parse.tab.c"
    break;

  case 1445: /* cmd_CONFIGURE_CHECK: CONFIGURE CHECK cfg_name END  */
#line 138 "sysdep/unix/config.Y"
{ cmd_check_config((yyvsp[-1].t)); }
#line 14140 "obj/conf/cf-parse.tab.c"
    break;

  case 1447: /* cmd_DOWN: DOWN END  */
#line 141 "sysdep/unix/config.Y"
{ cmd_shutdown(); }
#line 14146 "obj/conf/cf-parse.tab.c"
    break;

  case 1449: /* cmd_GRACEFUL_RESTART: GRACEFUL RESTART END  */
#line 146 "sysdep/unix/config.Y"
{ cmd_graceful_restart(); }
#line 14152 "obj/conf/cf-parse.tab.c"
    break;

  case 1450: /* cfg_name: %empty  */
#line 150 "sysdep/unix/config.Y"
               { (yyval.t) = NULL; }
#line 14158 "obj/conf/cf-parse.tab.c"
    break;

  case 1452: /* cfg_timeout: %empty  */
#line 155 "sysdep/unix/config.Y"
               { (yyval.i) = 0; }
#line 14164 "obj/conf/cf-parse.tab.c"
    break;

  case 1453: /* cfg_timeout: TIMEOUT  */
#line 156 "sysdep/unix/config.Y"
           { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 14170 "obj/conf/cf-parse.tab.c"
    break;

  case 1454: /* cfg_timeout: TIMEOUT expr  */
#line 157 "sysdep/unix/config.Y"
                { (yyval.i) = (yyvsp[0].i); }
#line 14176 "obj/conf/cf-parse.tab.c"
    break;

  case 1456: /* kern_proto_start: proto_start KERNEL  */
#line 43 "sysdep/unix/krt.Y"
                                     {
     this_proto = krt_init_config((yyvsp[-1].i));
}
#line 14184 "obj/conf/cf-parse.tab.c"
    break;

  case 1459: /* kern_mp_limit: %empty  */
#line 52 "sysdep/unix/krt.Y"
               { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
#line 14190 "obj/conf/cf-parse.tab.c"
    break;

  case 1460: /* kern_mp_limit: LIMIT expr  */
#line 53 "sysdep/unix/krt.Y"
               { (yyval.i) = (yyvsp[0].i); if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 14196 "obj/conf/cf-parse.tab.c"
    break;

  case 1462: /* kern_item: proto_channel  */
#line 58 "sysdep/unix/krt.Y"
                 { this_proto->net_type = (yyvsp[0].cc)->net_type; }
#line 14202 "obj/conf/cf-parse.tab.c"
    break;

  case 1463: /* kern_item: PERSIST bool  */
#line 59 "sysdep/unix/krt.Y"
                { THIS_KRT->persist = (yyvsp[0].i); }
#line 14208 "obj/conf/cf-parse.tab.c"
    break;

  case 1464: /* kern_item: SCAN TIME expr  */
#line 60 "sysdep/unix/krt.Y"
                  {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i) S_;
   }
#line 14217 "obj/conf/cf-parse.tab.c"
    break;

  case 1465: /* kern_item: LEARN bool  */
#line 64 "sysdep/unix/krt.Y"
              {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
#line 14229 "obj/conf/cf-parse.tab.c"
    break;

  case 1466: /* kern_item: GRACEFUL RESTART bool  */
#line 71 "sysdep/unix/krt.Y"
                         { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 14235 "obj/conf/cf-parse.tab.c"
    break;

  case 1467: /* kern_item: MERGE PATHS bool kern_mp_limit  */
#line 72 "sysdep/unix/krt.Y"
                                  {
      THIS_KRT->merge_paths = (yyvsp[-1].i) ? (yyvsp[0].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[-1].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
#line 14247 "obj/conf/cf-parse.tab.c"
    break;

  case 1469: /* kif_proto_start: proto_start DEVICE  */
#line 85 "sysdep/unix/krt.Y"
                                    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 14253 "obj/conf/cf-parse.tab.c"
    break;

  case 1474: /* kif_item: SCAN TIME expr  */
#line 94 "sysdep/unix/krt.Y"
                  {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i) S_;
   }
#line 14262 "obj/conf/cf-parse.tab.c"
    break;

  case 1475: /* kif_iface_start: %empty  */
#line 101 "sysdep/unix/krt.Y"
{
  this_ipatt = cfg_allocz(sizeof(struct kif_iface_config));
  add_tail(&THIS_KIF->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
}
#line 14272 "obj/conf/cf-parse.tab.c"
    break;

  case 1476: /* kif_iface_item: PREFERRED ipa  */
#line 108 "sysdep/unix/krt.Y"
                 { kif_set_preferred((yyvsp[0].a)); }
#line 14278 "obj/conf/cf-parse.tab.c"
    break;

  case 1482: /* dynamic_attr: KRT_SOURCE  */
#line 125 "sysdep/unix/krt.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SOURCE); }
#line 14284 "obj/conf/cf-parse.tab.c"
    break;

  case 1483: /* dynamic_attr: KRT_METRIC  */
#line 126 "sysdep/unix/krt.Y"
                         { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_METRIC); }
#line 14290 "obj/conf/cf-parse.tab.c"
    break;


#line 14294 "obj/conf/cf-parse.tab.c"

        default: break;
      }
    if (yychar_backup != yychar)
      YY_LAC_DISCARD ("yychar change");
  }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yyesa, &yyes, &yyes_capacity, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        if (yychar != YYEMPTY)
          YY_LAC_ESTABLISH;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  /* If the stack popping above didn't lose the initial context for the
     current lookahead token, the shift below will for sure.  */
  YY_LAC_DISCARD ("error recovery");

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yyes != yyesa)
    YYSTACK_FREE (yyes);
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 50 "conf/gen_parser.m4"

#line 397 "conf/confbase.Y"
/* C Code from conf/confbase.Y */

#line 206 "conf/flowspec.Y"
/* C Code from conf/flowspec.Y */

#line 929 "nest/config.Y"
/* C Code from nest/config.Y */

#line 189 "proto/bfd/config.Y"
/* C Code from proto/bfd/config.Y */

#line 182 "proto/babel/config.Y"
/* C Code from proto/babel/config.Y */

#line 368 "proto/bgp/config.Y"
/* C Code from proto/bgp/config.Y */

#line 66 "proto/mrt/config.Y"
/* C Code from proto/mrt/config.Y */

#line 562 "proto/ospf/config.Y"
/* C Code from proto/ospf/config.Y */

#line 59 "proto/perf/config.Y"
/* C Code from proto/perf/config.Y */

#line 46 "proto/pipe/config.Y"
/* C Code from proto/pipe/config.Y */

#line 342 "proto/radv/config.Y"
/* C Code from proto/radv/config.Y */

#line 205 "proto/rip/config.Y"
/* C Code from proto/rip/config.Y */

#line 147 "proto/rpki/config.Y"
/* C Code from proto/rpki/config.Y */

#line 163 "proto/static/config.Y"
/* C Code from proto/static/config.Y */

#line 66 "sysdep/linux/netlink.Y"
/* C Code from sysdep/linux/netlink.Y */

#line 160 "sysdep/unix/config.Y"
/* C Code from sysdep/unix/config.Y */

#line 128 "sysdep/unix/krt.Y"
/* C Code from sysdep/unix/krt.Y */

